<?php

// vim: fdm=marker

/***************************
*  Allgemeine Funktionen   *
*  Andy Geiss 2007 - 2010  *
*  Tabulatorweite: 4       *
***************************/

// Version
$g_version = '101123';

/* {{{ Globale PHP-Variablen und Includes */
$cfg_file = 'config.inc.php';

if(!isset($line_break)){
    $line_break = "\r\n";
}

if(!file_exists($cfg_file)){
    save_cfg($cfg_file, $line_break);
}
include($cfg_file);

if(!isset($ini_filename)){
    $ini_filename = 'Fliess.ini';
}
if(!isset($img_path)){
    $img_path = 'images';
}
// Wenn INI-Pfad nicht gesetzt, wird Image-Pfad bernommen
if(!isset($ini_path)){
    $ini_path = $img_path;
}

if(!isset($sv_user)){
    $sv_user = '';
}
if(!isset($sv_pwd)){
    $sv_pwd = '';
}
if(!isset($sv_host)){
    $sv_host = 'localhost';
}
if(!isset($sv_port)){
    $sv_port = 1024;
}

if(!isset($lang_id)){
    $lang_id = 'en';
}
if(!isset($TwipsPerPixelX)){
    $TwipsPerPixelX = 15;
}
if(!isset($TwipsPerPixelY)){
    $TwipsPerPixelY = 15;
}
/* }}} */

/* {{{ Ergnzende Scalarvis-Klassendefinition fr den Start aus SV@Web heraus */
class scalarvis{
    var $fe_img_path = '';
    var $fe_ini_path = '';
}
/* }}} */

/* {{{ Globale PHP-Variablen 2 */
if(isset($_POST['session_name'])){
    $svweb_session_name = $_POST['session_name'];
}
else if(isset($_GET['session_name'])){
    $svweb_session_name = $_GET['session_name'];
}

// Scalarvis@Web Release 2
if(isset($svweb_session_name) && strlen(trim($svweb_session_name))){
    $session_url_param1 = '?session_name='.$svweb_session_name;
    $session_url_param2 = '&session_name='.$svweb_session_name;
    $session_hidden_input = '<input type="hidden" name="session_name" value="'.$svweb_session_name.'">';
    $sv_short_class_def = '';
}
// Scalarvis@Web Release 1
else{
    $session_url_param1 = '';
    $session_url_param2 = '';
    $session_hidden_input = '';
    // Hinweis: In der Konfiguration muss $fci_inc muss auf die korrekte Scalarvis-Version zeigen (Pfad)
    $sv_short_class_def = '
    class sv_short_class{
        var $user;            //Benutzername
        var $port;            //Server Port
        var $host;            //Server Adresse
        var $pwd;             //Benutzer Passwort
        var $time_start;      //Variablen zur Speicherung des berechneten Zeitfensters
        var $time_end;
        var $USER_CONFIG = array(); //HIDE_NEG_AXIS wird bentigt, DIAG_BZG_INTERVALL wird von scalarvis_meter_graph() bentigt
        var $bzg_limit;       //wird nur von scalarvis_meter_graph() bentigt
        var $tagauswahl = array();    //"1","2","3","4","5","6"Array, da die 6 Tags enthlt, die der Benutzer ausgewhlt hat
        var $BackColor = -1;  //Hintergrundfarbe fr Grafik
    }';
}
/* }}} */

/* {{{ Start aus SV@Web heraus */
if(!isset($no_session_required) || !$no_session_required){
    if(isset($svweb_session_name) && strlen(trim($svweb_session_name))){
        start_session($sv, $svweb_session_name);
    }
    else{
        start_session($sv);
    }

    // Exit, wenn SV-Session erforderlich, aber nicht gltig
    if(!isset($sv->user)){
        exit; 
    }
    if(isset($_GET['img_path']) && strlen(trim($_GET['img_path']))){
        $sv->fe_img_path = trim($_GET['img_path']);
        if(isset($_GET['ini_path']) && strlen(trim($_GET['ini_path']))){
            $sv->fe_ini_path = trim($_GET['ini_path']);
        }
        else{
            $sv->fe_ini_path = $sv->fe_img_path;
        }
    }
    //print_r_formatted($sv); exit;
    // Relevante Config-Werte aus Session bernehmen
    $img_path = $sv->fe_img_path;
    $ini_path = $sv->fe_ini_path;
    $sv_user = $sv->user;
    $sv_pwd = $sv->pwd;
    $sv_host = $sv->host;
    $sv_port = $sv->port;
}
/* }}} */

$ini_filename = $ini_path.'/'.$ini_filename;

/* {{{ PHP-Funktion create_ini_string_from_ini_array() - INI-File-Inhalt aus INI-Array erstellen */
function create_ini_string_from_ini_array($ini_array, $line_break, &$valid_data){
    $ini_string = '';
    $valid_data = true;
    
    if(isset($ini_array) && count($ini_array)){
        $ini_array_keys = array_keys($ini_array);
        //print_r_formatted($ini_array_keys);
        foreach($ini_array_keys as $object_section){
            // Sections
            $ini_string .= $object_section.$line_break;
            foreach($ini_array[$object_section] as $key => $value){
                //echo '<br>',$object_section,': ',$key, ' - ',$value;
                if($key == 'TagTyp' && !strlen(trim($value))){
                    $valid_data = false;
                }
                // Attribute
                $ini_string .= $key.'='.$value.$line_break;
            }
        }
    }
    
    return $ini_string;
}
/* }}} */

/* {{{ PHP-Funktion convert_cfg_value() - Konfigurationswert datentypkonform gestalten */
function convert_cfg_value($cfg_value){
    // Bei numerischen Werten und Variablen -> ohne Anfhrungszeichen ... 
    if(is_numeric($cfg_value) || substr($cfg_value, 0, 1) == '$'){
        $retval = $cfg_value;
    }
    // ... bei Escape-Sequenzen -> mit doppelten Anfhrungszeichen ...
    else if(strpos($cfg_value, '\\') !== false){
        $retval = '"'.$cfg_value.'"';
    }
    // ... ansonsten -> einfache Anfhrungszeichen
    else{
        $retval = "'".$cfg_value."'";
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion copy_register() - Register kopieren */
function copy_register($ini_filename, $line_break){
    $ini_string = '';
    $new_register_no = -1;
    $old_register_no = -1;
    $crit_str_reg = '[Register';
    $crit_len_reg = strlen($crit_str_reg);
    $crit_str_obj = '[Objekt';
    $crit_len_obj = strlen($crit_str_obj);
    //print_r_formatted($_POST);

    if(isset($_POST['register_no_load']) 
    && is_numeric($_POST['register_no_load'])){
        $old_register_no = (int) $_POST['register_no_load'];
    }
    else{
        return false;
    }

    // File in $ini_array einlesen, falls vorhanden
    $ini_array = load_ini($ini_filename, false);
    $regno_array = get_regnos_from_ini_array($ini_array);
    if(!$ini_array){
        $ini_array = array();
    }

    // Vorhandenes Register in neues kopieren
    if(is_numeric($old_register_no) && $old_register_no >= 0){
        $_POST['register_no_load'] = $new_register_no = get_max_regno_from_regno_array($regno_array) + 1;
        $old_register_digits = fill_zeros($old_register_no);
        $new_register_digits = fill_zeros($new_register_no);
        $old_section = $crit_str_reg.$old_register_digits.']';
        $new_section = $crit_str_reg.$new_register_digits.']';
        $ini_array[$new_section] = $ini_array[$old_section];

        // Objekt-Schleife zum Register
        foreach($ini_array as $section => $attribute){
            if(substr($section, 0, $crit_len_obj + strlen($old_register_digits)) == $crit_str_obj.$old_register_digits){
                $new_object_section = $crit_str_obj.$new_register_digits.'.'.substr($section, 11, 3).']';
                $ini_array[$new_object_section] = $ini_array[$section];
            }
        }
    }
    //print_r_formatted($ini_array);

    // INI-File-Inhalt aus INI-Array erstellen
    $ini_string = create_ini_string_from_ini_array($ini_array, $line_break, $valid_data);
    //echo $ini_string;

    // Datei schreiben
    if($valid_data && $ini_fp = fopen($ini_filename, 'w')){
        fwrite($ini_fp, $ini_string);
        fclose($ini_fp);
        return true;
    }
    else{
        return false;
    }
}
/* }}} */

/* {{{ PHP-Funktion delete_register_from_ini() - Register aus INI-Datei lschen */
function delete_register_from_ini($ini_filename, $line_break){
    $ini_string = '';
    //print_r_formatted($_POST);
    
    if(isset($_POST['register_no_delete']) 
    && is_numeric($_POST['register_no_delete'])){
        $register_digits_delete = fill_zeros($_POST['register_no_delete']);
    }
    else{
        return false;
    }
    
    // File in $ini_array einlesen, falls vorhanden
    $ini_array = load_ini($ini_filename, false);
    if(!$ini_array){
        $ini_array = array();
    }
    //print_r_formatted($ini_array);
    
    $crit_reg_str = '[Register'.$register_digits_delete.']';
    $crit_obj_str = '[Objekt'.$register_digits_delete;
    $crit_obj_len = strlen($crit_obj_str);
    foreach($ini_array as $section => $attribute){
        // Betreffende Register-Section lschen
        if($section == $crit_reg_str){
            unset($ini_array[$section]);
        }
        // Betreffende Objekt-Sections lschen
        if(substr($section, 0, $crit_obj_len) == $crit_obj_str){
            unset($ini_array[$section]);
        }
    }    
    
    // INI-File-Inhalt aus INI-Array erstellen
    $ini_string = create_ini_string_from_ini_array($ini_array, $line_break, $valid_data);
    //echo $ini_string;
    
    // Datei schreiben
    if($valid_data && $ini_fp = fopen($ini_filename, 'w')){
        fwrite($ini_fp, $ini_string);
        fclose($ini_fp);
        return true;
    }
    else{
        return false;
    }
}
/* }}} */

/* {{{ PHP-Funktion extractTagType() - TagTyp aus Item-Namen extrahieren */
function extractTagType($item_name){
    $retval = substr($item_name, 2, 3);
    $retval = trim_zeros($retval);
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion fill_zeros() - Fhrende Nullen ergnzen */
function fill_zeros($number, $digits = 3){
    $retval = '';
    $number = trim($number);
    
    if(!is_numeric($number)){
        $number = 0;
    }
    
    $strlen_number = strlen($number);
    if($strlen_number < $digits){
        $diff = $digits - $strlen_number;
        for($i = 0; $i < $diff; $i++){
            $retval .= '0';
        }
        $retval .= $number;
    }
    else{
        $retval = $number;
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_max_regno_from_regno_array() - Grte Registernummer aus Registernummern-Array ermitteln */
function get_max_regno_from_regno_array($regno_array){
    $retval = -1;
    
    foreach($regno_array as $register_digits){
        $register_no = trim_zeros($register_digits);
        if($register_no > $retval){
            $retval = $register_no;
        }
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_min_regno_from_regno_array() - Kleinste Registernummer aus Registernummern-Array ermitteln */
function get_min_regno_from_regno_array($regno_array){
    $retval = $initretval = 1000;
    
    foreach($regno_array as $register_digits){
        $register_no = trim_zeros($register_digits);
        if($register_no < $retval){
            $retval = $register_no;
        }
    }
    
    if($retval == $initretval){
        $retval = 0;
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_regnos_from_ini_array() - Registernummern aus INI-Array ermitteln */
function get_regnos_from_ini_array($ini_array, $digits = 3){
    $retarray = array();
    
    $crit_str = '[Register';
    $crit_len = strlen($crit_str);
    if(is_array($ini_array) && count($ini_array)){
        foreach($ini_array as $section => $attribute){
            if(substr($section, 0, $crit_len) == $crit_str){
                $register_digits = substr($section, $crit_len, $digits);
                if(is_numeric($register_digits)){
                    array_push($retarray, $register_digits);
                }
            }
        }
    }
    
    return $retarray;
}
/* }}} */

/* {{{ PHP-Funktion is_imagefile_in_dir() - Prft, ob sich mindestens eine Bilddatei im Verzeichnis befindet */
function is_imagefile_in_dir($dir){
    $retval = false;

    if(!empty($dir) && is_dir($dir)){
        $handle = opendir($dir);
        while($file = readdir($handle)){
            if(is_file($dir.'/'.$file)){
                $tmp_ext = strtolower(substr($file, strlen($file) - 4, 4));
                if($tmp_ext == ".jpg" || $tmp_ext == ".png" || $tmp_ext == ".gif"){
                    $retval = true;
                    break;
                } 
            }
        }
        closedir($handle);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion is_tag_types_limited() - Prfen, ob das Attribut nur fr bestimmte TagTypen relevant ist */
function is_tag_types_limited($attribute_name){
    global $tag_types_limited_array;
    
    if(isset($tag_types_limited_array[$attribute_name]) 
    && is_array($tag_types_limited_array[$attribute_name])
    && count($tag_types_limited_array[$attribute_name])){
        $tag_types_limited = true;
    }
    else{
        $tag_types_limited = false;
    }
    
    return $tag_types_limited;
}
/* }}} */

/* {{{ PHP-Funktion is_tag_types_limited_value() - Pruefen, ob Tag-Typ im Attribut vorhanden */
function is_tag_types_limited_value($attribute_name, $tag_type_search){
    global $tag_types_limited_array;
    
	$tag_types_limited_value = -1;
	natsort($tag_types_limited_array[$attribute_name]);
	$tag_types_limited_value = array_search($tag_type_search, $tag_types_limited_array[$attribute_name]);
	if( (is_null($tag_types_limited_value)) || (!is_numeric($tag_types_limited_value) ))
	{
		$tag_types_limited_value = -1;
	}
	return 	$tag_types_limited_value;
}
/* }}} */

/* {{{ PHP-Funktion js_attribute_class_definition() - Attribut-Objekt-Array erstellen */
function js_attribute_class_definition(){
    global $attribute_array;
    
    // Attribut-Klasse
    echo '
    // js_attribute_class_definition
    function attribute()
    {';
    foreach($attribute_array as $attribute){
        echo '
        this.name = \'\';
        this.value = \'\';';
        foreach($attribute as $attribute_property => $property_value){
            echo '
            this.',$attribute_property,' = ';
            if(is_numeric($property_value)){
                echo '0;';
            }
            else{
                echo '\'\';';
            }
        }
        break; // Nur erstes Attribut als Vorlage verwenden
    }
    echo '
    }';
}
/* }}} */

/* {{{ PHP-Funktion js_create_attributes_object_array() - Attribut-Objekt-Array erstellen in workspace*/
function js_create_attributes_object_array_ws($d_p, $tagtype){
    global $attribute_array;
    
    echo '
    // js_create_attributes_object_array';
    // Attribut-Relevanz
    foreach($attribute_array as $attribute_name => $attribute){
        if(isset($attribute['DefaultValue']) && strlen(trim($attribute['DefaultValue']))){
            $DefaultValue = trim($attribute['DefaultValue']);
        }
        else{
            $DefaultValue = '';
        }
        $tag_types_limited = is_tag_types_limited($attribute_name);
		$tag_types_limited_value = -1;
		if($tag_types_limited)
		{
			//ist Attribut fuer diesen TagTyp relevant
			$tag_types_limited_value = is_tag_types_limited_value($attribute_name, $tagtype);
		}
		if((!$tag_types_limited))
		{// normales Attribut
			echo '
			if(!',$d_p,'.attributes.',$attribute_name,'){
				',$d_p,'.attributes.',$attribute_name,' = new attribute();
			}
			',$d_p,'.attributes.',$attribute_name,'.name = \'',$attribute_name,'\';
			',$d_p,'.attributes.',$attribute_name,'.value = \'',$DefaultValue,'\';
			';
			foreach($attribute as $attribute_property => $property_value){
				switch($attribute_property){
					// Numerische Werte casten
					case 'InputSize':
					case 'InputMaxlength':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.',$attribute_property,' = ',(int) $property_value,';';
					break;
					default:
						echo '
						',$d_p,'.attributes.',$attribute_name,'.',$attribute_property,' = \'',$property_value,'\';';
					break;
				}
			}
		}
		 //|| (($tag_types_limited) && (!$tag_types_limited_value))
		//else
		else if (($tag_types_limited) && ($tag_types_limited_value >= 0))
		{//TagTyp ist relevant
			js_if_tag_types_limited_begin($tag_types_limited, $attribute_name);
			echo '
			if(!',$d_p,'.attributes.',$attribute_name,'){
				',$d_p,'.attributes.',$attribute_name,' = new attribute();
			}
			',$d_p,'.attributes.',$attribute_name,'.name = \'',$attribute_name,'\';';

			// Standardbilder als DefaultValue verwenden
			switch($attribute_name){
				case 'Picture':
					echo '
					switch(TagTyp){
						case 2:
							',$d_p,'.attributes.',$attribute_name,'.value = \'indicator.png\';
						break;
						case 20:
							',$d_p,'.attributes.',$attribute_name,'.value = \'windrose.png\';
						break;
						default:
							',$d_p,'.attributes.',$attribute_name,'.value = \'',$DefaultValue,'\';
						break;
					}';
				break;
				case 'TxtErr':
				case 'TxtFalse':
				case 'TxtTrue':
					echo '
					switch(TagTyp){
						case 8:
							',$d_p,'.attributes.',$attribute_name,'.value = \'',$attribute_name,'\';
						break;
						case 9:
							',$d_p,'.attributes.',$attribute_name,'.value = \'',($attribute_name == 'TxtErr'?'picture.png':''),'\';
						break;
						default:
							',$d_p,'.attributes.',$attribute_name,'.value = \'',$DefaultValue,'\';
						break;
					}';
				break;
				default:
					echo '
					',$d_p,'.attributes.',$attribute_name,'.value = \'',$DefaultValue,'\';';
				break;
			}

			foreach($attribute as $attribute_property => $property_value){
				switch($attribute_property){
					// Numerische Werte casten
					case 'InputSize':
					case 'InputMaxlength':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.',$attribute_property,' = ',(int) $property_value,';';
					break;
					default:
						echo '
						',$d_p,'.attributes.',$attribute_name,'.',$attribute_property,' = \'',$property_value,'\';';
					break;
				}
			}
			js_if_tag_types_limited_end($tag_types_limited);
		}
    }
}
/* }}} */

/* {{{ PHP-Funktion js_create_attributes_object_array() - Attribut-Objekt-Array erstellen */
function js_create_attributes_object_array($d_p){
    global $attribute_array;
    
    echo '
    // js_create_attributes_object_array';
    // Attribut-Relevanz
    foreach($attribute_array as $attribute_name => $attribute){
        if(isset($attribute['DefaultValue']) && strlen(trim($attribute['DefaultValue']))){
            $DefaultValue = trim($attribute['DefaultValue']);
        }
        else{
            $DefaultValue = '';
        }
        $tag_types_limited = is_tag_types_limited($attribute_name);
        js_if_tag_types_limited_begin($tag_types_limited, $attribute_name);
        echo '
        if(!',$d_p,'.attributes.',$attribute_name,'){
            ',$d_p,'.attributes.',$attribute_name,' = new attribute();
        }
        ',$d_p,'.attributes.',$attribute_name,'.name = \'',$attribute_name,'\';';

        // Standardbilder als DefaultValue verwenden
        switch($attribute_name){
            case 'Picture':
                echo '
                switch(TagTyp){
                    case 2:
                        ',$d_p,'.attributes.',$attribute_name,'.value = \'indicator.png\';
                    break;
                    case 20:
                        ',$d_p,'.attributes.',$attribute_name,'.value = \'windrose.png\';
                    break;
                    default:
                        ',$d_p,'.attributes.',$attribute_name,'.value = \'',$DefaultValue,'\';
                    break;
                }';
            break;
            case 'TxtErr':
            case 'TxtFalse':
            case 'TxtTrue':
                echo '
                switch(TagTyp){
                    case 8:
                        ',$d_p,'.attributes.',$attribute_name,'.value = \'',$attribute_name,'\';
                    break;
                    case 9:
                        ',$d_p,'.attributes.',$attribute_name,'.value = \'',($attribute_name == 'TxtErr'?'picture.png':''),'\';
                    break;
                    default:
                        ',$d_p,'.attributes.',$attribute_name,'.value = \'',$DefaultValue,'\';
                    break;
                }';
            break;
            default:
                echo '
                ',$d_p,'.attributes.',$attribute_name,'.value = \'',$DefaultValue,'\';';
            break;
        }

        foreach($attribute as $attribute_property => $property_value){
            switch($attribute_property){
                // Numerische Werte casten
                case 'InputSize':
                case 'InputMaxlength':
                    echo '
                    ',$d_p,'.attributes.',$attribute_name,'.',$attribute_property,' = ',(int) $property_value,';';
                break;
                default:
                    echo '
                    ',$d_p,'.attributes.',$attribute_name,'.',$attribute_property,' = \'',$property_value,'\';';
                break;
            }
        }
        js_if_tag_types_limited_end($tag_types_limited);
    }
}
/* }}} */

/* {{{ PHP-Funktion js_if_tag_types_limited_else() - JavaScript-Else fr nach Tag-Typ beschrnkte Attribute */
function js_if_tag_types_limited_else($tag_types_limited){
    if($tag_types_limited){
        echo '
        }
        else{';
    }
}
/* }}} */

/* {{{ PHP-Funktion js_if_tag_types_limited_begin() - JavaScript-If-Anfang fr nach Tag-Typ beschrnkte Attribute */
function js_if_tag_types_limited_begin($tag_types_limited, $attribute_name){
    global $tag_types_limited_array;
    
    if($tag_types_limited){
        echo '
        if('; 
        $i = 0;
        foreach($tag_types_limited_array[$attribute_name] as $relevant_tag_type){
            if($i){
                echo ' || ';
            }
            echo 'TagTyp == ',$relevant_tag_type;
            $i++;
        }
        echo '){';
    }
}
/* }}} */

/* {{{ PHP-Funktion js_if_tag_types_limited_end() - JavaScript-If-Ende fr nach Tag-Typ beschrnkte Attribute */
function js_if_tag_types_limited_end($tag_types_limited){
    if($tag_types_limited){
        echo '
        }';
    }
}
/* }}} */

/* {{{ PHP-Funktion js_set_attributes_object_values() - Values des Attribut-Objekt-Arrays setzen in workspace*/
// vor Aufruf der Funktion muss JavaScript-evt gesetzt sein
function js_set_attributes_object_values_ws($d_p, $fillAttributesForm = false, $TagTypDef = false, $ini_attribute = null, $tagtype = -1){
    global $attribute_array;
    global $TwipsPerPixelX;
    global $TwipsPerPixelY;
    
    echo '
    // js_set_attributes_object_values';
    // TagTyp aus Item-Namen extrahieren, wenn noch nicht gesetzt
    if(!$TagTypDef){
        echo '
        var TagTyp = extractTagType(',$d_p,'.',$attribute_array['TagTyp']['DDObjProperty'],');';
    }
    if($fillAttributesForm){
        // Anhand vom ForeColor-Eingabefeld testen, ob Formular bezglich 
        // DDObjProperty-unabhngigen Werten leer ist
        echo '
        var FillDDObjPropertyIndependentFormValues = true;
        if(evt == "DRAG" && document.attributes_form.ForeColor.value != \'\'){
            FillDDObjPropertyIndependentFormValues = false;
        }
        var FillDDObjPropertyIndependentFormValuesHidden = true;
        if(evt == "DRAG" && document.getElementById("id_TagTyp").innerHTML != \'\'){
            FillDDObjPropertyIndependentFormValuesHidden = false;
        }';
    }
    // Attribut-Relevanz
    foreach($attribute_array as $attribute_name => $attribute){
        if(strlen(trim($attribute['DDObjProperty']))){
            $isDDObjProperty = true;
        }
        else{
            $isDDObjProperty = false;
        }
        $tag_types_limited = is_tag_types_limited($attribute_name);
		$tag_types_limited_value = -1;
		if($tag_types_limited)
		{
			//ist Attribut fuer diesen TagTyp relevant
			$tag_types_limited_value = is_tag_types_limited_value($attribute_name, $tagtype);
		}
		if((!$tag_types_limited))
		{// normales Attribut
			echo '
			if(evt == "SUBMIT"){
				// Pfad-Kompatibilitts-Relevanz
				',$d_p,'.attributes.',$attribute_name,'.value = "',(isset($_POST[$attribute_name])?trim(addslashes($_POST[$attribute_name])):''),'";
			}';
			if($isDDObjProperty){
				switch($attribute_name){
					// TagTyp aus gesetzter Variable bernehmen 
					case 'TagTyp':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = TagTyp;';
					break;
					// Pos-Werte in Twips umrechnen
					case 'PosLeft':
					case 'PosWidth':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = pixels2twips(',$d_p,'.',$attribute['DDObjProperty'],', ',$TwipsPerPixelX,');';
					break;
					case 'PosTop':
					case 'PosHeight':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = pixels2twips(',$d_p,'.',$attribute['DDObjProperty'],', ',$TwipsPerPixelY,');';
					break;
					default:
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = ',$d_p,'.',$attribute['DDObjProperty'],';';
					break;
				}
			}
			// Bei Attributen ohne DDObjProperty den Wert direkt aus INI holen (Ladevorgang)
			else if(isset($ini_attribute) && count($ini_attribute)){
				if(isset($ini_attribute[$attribute_name])){
					// Pfad-Kompatibilitts-Relevanz
					echo '
					',$d_p,'.attributes.',$attribute_name,'.value = "',trim(addslashes($ini_attribute[$attribute_name])),'";';
				}
			}
		
			if($fillAttributesForm){
				// Beim DRAG-Event Form-Value nur zuweisen, wenns ein DDObjProperty betrifft, also grafisch nderbar ist
				if(!$isDDObjProperty){
					echo '
					if(FillDDObjPropertyIndependentFormValues){';
				}
				echo '
				if(document.attributes_form.',$attribute_name,'.type == "text"
				|| document.attributes_form.',$attribute_name,'.type == "select-one"){
					if(',$d_p,'.attributes.',$attribute_name,'.value == 0
					|| document.attributes_form.',$attribute_name,'.value != ',$d_p,'.attributes.',$attribute_name,'.value){
						document.attributes_form.',$attribute_name,'.value = ',$d_p,'.attributes.',$attribute_name,'.value;
					}
				}
				else{
					if(FillDDObjPropertyIndependentFormValuesHidden
					&& document.attributes_form.',$attribute_name,'.type == "hidden"){
						if(',$d_p,'.attributes.',$attribute_name,'.value == 0
						|| document.getElementById("id_',$attribute_name,'").innerHTML != ',$d_p,'.attributes.',$attribute_name,'.value){
							document.attributes_form.',$attribute_name,'.value = ',$d_p,'.attributes.',$attribute_name,'.value;
							document.getElementById("id_',$attribute_name,'").innerHTML = ',$d_p,'.attributes.',$attribute_name,'.value;
						}
					}
				}';
				if(!$isDDObjProperty){
					echo '
					}';
				}
				js_if_tag_types_limited_else($tag_types_limited);
				if(!$isDDObjProperty){
					echo '
					if(FillDDObjPropertyIndependentFormValues){';
				}
				if($tag_types_limited){
					echo '
					if(document.attributes_form.',$attribute_name,'.type != "hidden"){
						document.attributes_form.',$attribute_name,'.value = "";
					}
					else{
						document.getElementById("id_',$attribute_name,'").innerHTML = "";
					}';
				}
				if(!$isDDObjProperty){
					echo '
					}';
				}
			}
		}
		else if (($tag_types_limited) && ($tag_types_limited_value >= 0))
		{//TagTyp ist relevant
			js_if_tag_types_limited_begin($tag_types_limited, $attribute_name);
			echo '
			if(evt == "SUBMIT"){
				// Pfad-Kompatibilitts-Relevanz
				',$d_p,'.attributes.',$attribute_name,'.value = "',(isset($_POST[$attribute_name])?trim(addslashes($_POST[$attribute_name])):''),'";
			}';
			if($isDDObjProperty){
				switch($attribute_name){
					// TagTyp aus gesetzter Variable bernehmen 
					case 'TagTyp':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = TagTyp;';
					break;
					// Pos-Werte in Twips umrechnen
					case 'PosLeft':
					case 'PosWidth':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = pixels2twips(',$d_p,'.',$attribute['DDObjProperty'],', ',$TwipsPerPixelX,');';
					break;
					case 'PosTop':
					case 'PosHeight':
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = pixels2twips(',$d_p,'.',$attribute['DDObjProperty'],', ',$TwipsPerPixelY,');';
					break;
					default:
						echo '
						',$d_p,'.attributes.',$attribute_name,'.value = ',$d_p,'.',$attribute['DDObjProperty'],';';
					break;
				}
			}
			// Bei Attributen ohne DDObjProperty den Wert direkt aus INI holen (Ladevorgang)
			else if(isset($ini_attribute) && count($ini_attribute)){
				if(isset($ini_attribute[$attribute_name])){
					// Pfad-Kompatibilitts-Relevanz
					echo '
					',$d_p,'.attributes.',$attribute_name,'.value = "',trim(addslashes($ini_attribute[$attribute_name])),'";';
				}
			}
			if($fillAttributesForm){
				// Beim DRAG-Event Form-Value nur zuweisen, wenns ein DDObjProperty betrifft, also grafisch nderbar ist
				if(!$isDDObjProperty){
					echo '
					if(FillDDObjPropertyIndependentFormValues){';
				}
				echo '
				if(document.attributes_form.',$attribute_name,'.type == "text"
				|| document.attributes_form.',$attribute_name,'.type == "select-one"){
					if(',$d_p,'.attributes.',$attribute_name,'.value == 0
					|| document.attributes_form.',$attribute_name,'.value != ',$d_p,'.attributes.',$attribute_name,'.value){
						document.attributes_form.',$attribute_name,'.value = ',$d_p,'.attributes.',$attribute_name,'.value;
					}
				}
				else{
					if(FillDDObjPropertyIndependentFormValuesHidden
					&& document.attributes_form.',$attribute_name,'.type == "hidden"){
						if(',$d_p,'.attributes.',$attribute_name,'.value == 0
						|| document.getElementById("id_',$attribute_name,'").innerHTML != ',$d_p,'.attributes.',$attribute_name,'.value){
							document.attributes_form.',$attribute_name,'.value = ',$d_p,'.attributes.',$attribute_name,'.value;
							document.getElementById("id_',$attribute_name,'").innerHTML = ',$d_p,'.attributes.',$attribute_name,'.value;
						}
					}
				}';
				if(!$isDDObjProperty){
					echo '
					}';
				}
				js_if_tag_types_limited_else($tag_types_limited);
				if(!$isDDObjProperty){
					echo '
					if(FillDDObjPropertyIndependentFormValues){';
				}
				if($tag_types_limited){
					echo '
					if(document.attributes_form.',$attribute_name,'.type != "hidden"){
						document.attributes_form.',$attribute_name,'.value = "";
					}
					else{
						document.getElementById("id_',$attribute_name,'").innerHTML = "";
					}';
				}
				if(!$isDDObjProperty){
					echo '
					}';
				}
			}
			js_if_tag_types_limited_end($tag_types_limited);
		}
    }
}
/* }}} */

/* {{{ PHP-Funktion js_set_attributes_object_values() - Values des Attribut-Objekt-Arrays setzen */
// vor Aufruf der Funktion muss JavaScript-evt gesetzt sein
function js_set_attributes_object_values($d_p, $fillAttributesForm = false, $TagTypDef = false, $ini_attribute = null){
    global $attribute_array;
    global $TwipsPerPixelX;
    global $TwipsPerPixelY;
    
    echo '
    // js_set_attributes_object_values';
    // TagTyp aus Item-Namen extrahieren, wenn noch nicht gesetzt
    if(!$TagTypDef){
        echo '
        var TagTyp = extractTagType(',$d_p,'.',$attribute_array['TagTyp']['DDObjProperty'],');';
    }
    if($fillAttributesForm){
        // Anhand vom ForeColor-Eingabefeld testen, ob Formular bezglich 
        // DDObjProperty-unabhngigen Werten leer ist
        echo '
        var FillDDObjPropertyIndependentFormValues = true;
        if(evt == "DRAG" && document.attributes_form.ForeColor.value != \'\'){
            FillDDObjPropertyIndependentFormValues = false;
        }
        var FillDDObjPropertyIndependentFormValuesHidden = true;
        if(evt == "DRAG" && document.getElementById("id_TagTyp").innerHTML != \'\'){
            FillDDObjPropertyIndependentFormValuesHidden = false;
        }';
    }
    // Attribut-Relevanz
    foreach($attribute_array as $attribute_name => $attribute){
        if(strlen(trim($attribute['DDObjProperty']))){
            $isDDObjProperty = true;
        }
        else{
            $isDDObjProperty = false;
        }
        $tag_types_limited = is_tag_types_limited($attribute_name);
        js_if_tag_types_limited_begin($tag_types_limited, $attribute_name);
        echo '
        if(evt == "SUBMIT"){
            // Pfad-Kompatibilitts-Relevanz
            ',$d_p,'.attributes.',$attribute_name,'.value = "',(isset($_POST[$attribute_name])?trim(addslashes($_POST[$attribute_name])):''),'";
        }';
        if($isDDObjProperty){
            switch($attribute_name){
                // TagTyp aus gesetzter Variable bernehmen 
                case 'TagTyp':
                    echo '
                    ',$d_p,'.attributes.',$attribute_name,'.value = TagTyp;';
                break;
                // Pos-Werte in Twips umrechnen
                case 'PosLeft':
                case 'PosWidth':
                    echo '
                    ',$d_p,'.attributes.',$attribute_name,'.value = pixels2twips(',$d_p,'.',$attribute['DDObjProperty'],', ',$TwipsPerPixelX,');';
                break;
                case 'PosTop':
                case 'PosHeight':
                    echo '
                    ',$d_p,'.attributes.',$attribute_name,'.value = pixels2twips(',$d_p,'.',$attribute['DDObjProperty'],', ',$TwipsPerPixelY,');';
                break;
                default:
                    echo '
                    ',$d_p,'.attributes.',$attribute_name,'.value = ',$d_p,'.',$attribute['DDObjProperty'],';';
                break;
            }
        }
        // Bei Attributen ohne DDObjProperty den Wert direkt aus INI holen (Ladevorgang)
        else if(isset($ini_attribute) && count($ini_attribute)){
            if(isset($ini_attribute[$attribute_name])){
                // Pfad-Kompatibilitts-Relevanz
                echo '
                ',$d_p,'.attributes.',$attribute_name,'.value = "',trim(addslashes($ini_attribute[$attribute_name])),'";';
            }
        }
        if($fillAttributesForm){
            // Beim DRAG-Event Form-Value nur zuweisen, wenns ein DDObjProperty betrifft, also grafisch nderbar ist
            if(!$isDDObjProperty){
                echo '
                if(FillDDObjPropertyIndependentFormValues){';
            }
            echo '
            if(document.attributes_form.',$attribute_name,'.type == "text"
            || document.attributes_form.',$attribute_name,'.type == "select-one"){
                if(',$d_p,'.attributes.',$attribute_name,'.value == 0
                || document.attributes_form.',$attribute_name,'.value != ',$d_p,'.attributes.',$attribute_name,'.value){
                    document.attributes_form.',$attribute_name,'.value = ',$d_p,'.attributes.',$attribute_name,'.value;
                }
            }
            else{
                if(FillDDObjPropertyIndependentFormValuesHidden
                && document.attributes_form.',$attribute_name,'.type == "hidden"){
                    if(',$d_p,'.attributes.',$attribute_name,'.value == 0
                    || document.getElementById("id_',$attribute_name,'").innerHTML != ',$d_p,'.attributes.',$attribute_name,'.value){
                        document.attributes_form.',$attribute_name,'.value = ',$d_p,'.attributes.',$attribute_name,'.value;
                        document.getElementById("id_',$attribute_name,'").innerHTML = ',$d_p,'.attributes.',$attribute_name,'.value;
                    }
                }
            }';
            if(!$isDDObjProperty){
                echo '
                }';
            }
            js_if_tag_types_limited_else($tag_types_limited);
            if(!$isDDObjProperty){
                echo '
                if(FillDDObjPropertyIndependentFormValues){';
            }
            if($tag_types_limited){
                echo '
                if(document.attributes_form.',$attribute_name,'.type != "hidden"){
                    document.attributes_form.',$attribute_name,'.value = "";
                }
                else{
                    document.getElementById("id_',$attribute_name,'").innerHTML = "";
                }';
            }
            if(!$isDDObjProperty){
                echo '
                }';
            }
        }
        js_if_tag_types_limited_end($tag_types_limited);
    }
}
/* }}} */

/* {{{ PHP-Funktion lang_text() - Mehrsprachentext anhand Textarray */
function lang_text($key){
    global $lang_id;
    global $text_array;
    
    if(!isset($lang_id)){
        $lang_id = 'en';
    }
    
    if(isset($text_array[$lang_id][$key]) 
    && strlen(trim($text_array[$lang_id][$key]))){
        $retval = $text_array[$lang_id][$key];
    }
    else{
        $retval = '-?- '.$key.' -?-';
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion load_cfg() - Konfigurations-INC-Datei laden */
function load_cfg($inc_filename){
    $inc_array = array();
    
    // Datei lesen
    if(file_exists($inc_filename)){
        if($inc_fp = fopen($inc_filename, 'r')){
            while(!feof($inc_fp)){
                $buffer = trim(fgets($inc_fp));
                if(!strlen($buffer) || !stristr($buffer, '=')){
                    continue;
                }
                $explode_array = explode('=', $buffer, 2);
                if(isset($explode_array[1])){
                    list($key, $value) = $explode_array;
                    $key = trim($key);
                    $sub_explode_array = explode(';', $value, 2);
                    $value = StripQuotes(trim($sub_explode_array[0]));
                    $inc_array[$key] = $value;
                }
            }
            fclose($inc_fp);
        }
    }
    
    return $inc_array;
}
/* }}} */

/* {{{ PHP-Funktion load_ini() - INI-Datei laden */
function load_ini($ini_filename, $WithItemName = true){
    // Datei lesen
    if(file_exists($ini_filename)){
        if($ini_fp = fopen($ini_filename, 'r')){
            $object_section = '[]';
            while (!feof($ini_fp)) {
                $buffer = fgets($ini_fp);
                $buffer = trim($buffer);
                //echo '<br>',$buffer;
                if(!strlen($buffer)){
                    continue;
                }
                
                if(substr($buffer, 0, 1) == '['){
                    $object_section = $buffer;
                }
                else{
                    $explode_array = explode('=', $buffer, 2);
                    if(isset($explode_array[1])){
                        list($attribute, $value) = $explode_array;
                        //echo '<br>',$attribute,': ',$value;
                        $ini_array[$object_section][$attribute] = $value;
                        // Aus TagTyp ItemName generieren
                        if($WithItemName && $attribute == 'TagTyp'){
                            $ini_array[$object_section]['ItemName'] = 'TT'.fill_zeros($value).'_';
                        }
                    }
                }
            }
            fclose($ini_fp);
        }
    }
    //print_r_formatted($ini_array);
    
    if(isset($ini_array) && count($ini_array)){
        return $ini_array;
    }
    else{
        return false;
    }
}
/* }}} */

/* {{{ PHP-Funktion print_r_formatted() - Formatiertes print_r */
function print_r_formatted($var){
    echo '<pre>';
    $retval = print_r($var);
    echo '</pre>';
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion pv_get_ini_array() - INI-Datei fr Preview in ein strukturiertes assoziatives Array einlesen */
function pv_get_ini_array($ini_filename, $buffer_len=1024){
    $ini_array = array();
    $current_section = '';
    
    $fp = fopen($ini_filename, "r");
    if($fp){
        while(!feof($fp)){
            $buffer = trim(fgets($fp, $buffer_len));
            $buffer_strlen = strlen($buffer);
            // Wenn die Zeile einen Section-Beginn darstellt
            if($buffer_strlen && substr($buffer, 0, 1) == '[' && substr($buffer, $buffer_strlen - 1, 1) == ']'){
                $current_section = substr($buffer, 1, $buffer_strlen - 2);
            }
            else if($buffer_strlen && strlen($current_section)){
                $buffer_explode = explode('=', $buffer, 2);
                $ini_array_index = trim($buffer_explode[0]);
                if(isset($buffer_explode[1])){
                    $ini_array_value = trim($buffer_explode[1]);
                }
                else{
                    $ini_array_value = '';
                }
                $ini_array[$current_section][$ini_array_index] = $ini_array_value;
            }
        }
        fclose($fp);
    }
    
    return $ini_array;
}
/* }}} */

/* {{{ PHP-Funktion save_cfg() - Konfigurations-INC-Datei speichern */
function save_cfg($inc_filename, $line_break){
    $retval = false;
    $inc_string = '';
    $inc_string_new = '';
    
    $cfg_var_array = array('$ini_filename',
                           '$def_path',
                           '$img_path',
                           '$ini_path',
                           '$sv_user',
                           '$sv_pwd',
                           '$sv_host',
                           '$sv_port',
                           '$fci_inc',
                           '$tz_index',
                           '$time_is_gmt_only',
                           '$show_admin_button',
                           '$no_session_required',
                           '$lang_id',
                           '$line_break',
                           '$TwipsPerPixelX',
                           '$TwipsPerPixelY');
    $cfg_var_found_array = array();
    
    // INC-File zeilenweise auslesen, betreffende Zeile ndern und wieder speichern
    if(file_exists($inc_filename)){
        if($inc_fp = fopen($inc_filename, 'r')){
            while(!feof($inc_fp)){
                $buffer = trim(fgets($inc_fp));
                $explode_array = explode('=', $buffer, 2);
                $key = trim($explode_array[0]);
                if(isset($explode_array[1]) && in_array($key, $cfg_var_array)){
                    array_push($cfg_var_found_array, $key);
                    if(isset($_POST[$key])){
                        // Kommentar hinter dem Eintrag merken
                        $sub_explode_array = explode(';', $explode_array[1], 2);
                        if(isset($sub_explode_array[1])){
                            $comment = $sub_explode_array[1];
                        }
                        $tmp_value = trim($_POST[$key]);
                        switch($key){
                            case '$ini_filename':
                            case '$sv_user':
                            case '$sv_pwd':
                            case '$fci_inc':
                                $value = "'".$tmp_value."'";
                            break;
                            default:
                                $value = convert_cfg_value($tmp_value); 
                            break;
                        }
                        $buffer = $key.' = '.$value.';'.$comment;
                    }
                }
                $inc_string .= $buffer.$line_break;
            }
            fclose($inc_fp);
        }
    }
    // File (Grundstruktur) erstellen, wenn nicht vorhanden
    else{
        $inc_string .= '<?php'.$line_break.$line_break;
        $inc_string .= '/***************************'.$line_break;
        $inc_string .= '*  Andy Geiss 2007 - 2010  *'.$line_break;
        $inc_string .= '*  Tabulatorweite: 4       *'.$line_break;
        $inc_string .= '***************************/'.$line_break;
        $inc_string .= $line_break.'?>'.$line_break;
    }
    
    // Wenn nicht gefunden, Zeile erstellen (aus $_POST oder Standardwert)
    foreach($cfg_var_array as $key){
        if(!in_array($key, $cfg_var_found_array)){
            unset($value);
            // Wenn bergeben ...
            if(isset($_POST[$key])){
                $tmp_value = trim($_POST[$key]);
                switch($key){
                    case '$ini_filename':
                    case '$sv_user':
                    case '$sv_pwd':
                    case '$fci_inc':
                        $value = "'".$tmp_value."'";
                    break;
                    default:
                        $value = convert_cfg_value($tmp_value); 
                    break;
                }
            }
            // ... ansonsten Standardwert
            else{
                switch($key){
                    case '$ini_filename':
                        $value = "'Fliess.ini'";
                    break;
                    case '$def_path':
//                        $value = "'../SCALARVIS@WEB/FLOWCHART/default'";
                        $value = "'../SVWEB/FLOWCHART/default'";
                    break;
                    case '$img_path':
//                        $value = "'../SCALARVIS@WEB/FLOWCHART/Gast'";
                        $value = "'../SVWEB/FLOWCHART/Gast'";
                    break;
                    case '$ini_path':
                        $value = '$img_path';
                    break;
                    case '$sv_user':
                        $inc_string_new .= $line_break;
                        $value = "''";
                    break;
                    case '$sv_pwd':
                        $value = "''";
                    break;
                    case '$sv_host':
                        $value = "'localhost'";
                    break;
                    case '$sv_port':
                        $value = 1024;
                    break;
                    case '$fci_inc':
//                        $value = "'../SCALARVIS@WEB/FLOWCHART/flowchartimage.inc.php'";
                        $value = "'../SVWEB/FLOWCHART/flowchartimage.inc.php'";
                    break;
                    case '$tz_index':
                        $value = -1;
                    break;
                    case '$time_is_gmt_only':
                        $value = 0;
                    break;
                    case '$show_admin_button':
                        $inc_string_new .= $line_break;
                        $value = 1;
                    break;
                    case '$no_session_required':
                        $value = 0;
                    break;
                    case '$lang_id':
                        $inc_string_new .= $line_break;
                        $value = "'de'";
                    break;
                    case '$line_break':
                        $value = '"\r\n"';
                    break;
                    case '$TwipsPerPixelX':
                        $value = 15;
                    break;
                    case '$TwipsPerPixelY':
                        $value = 15;
                    break;
                }
            }
            if(isset($value)){
                $buffer = $key.' = '.$value.';';
                $inc_string_new .= $buffer.$line_break;
            }
        }
    }
    
    // $inc_string mit $inc_string_new mergen
    if(!empty($inc_string_new)){
        $end_pos = strpos($inc_string, '?>');
        if($end_pos !== false){ 
            $inc_string = substr($inc_string, 0, $end_pos);
        }
        $inc_string .= $inc_string_new;
        $inc_string .= $line_break.'?>'.$line_break;
    }
    
    // Datei schreiben
    if($inc_fp = fopen($inc_filename, 'w')){
        $inc_string = trim($inc_string).$line_break;
        if(fwrite($inc_fp, $inc_string)){
            $retval = true;
        }
        fclose($inc_fp);
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion save_ini() - INI-Datei speichern */
function save_ini($ini_filename, $line_break){
    $ini_string = '';
    //print_r_formatted($_POST);
    
    // File in $ini_array einlesen, falls vorhanden und nur betreffende Passagen ndern
    $ini_array = load_ini($ini_filename, false);
    if(!$ini_array){
        $ini_array = array();
    }
    $new_ini_array = array();
    
    // INI-Array bearbeiten ("attr000name" etc. zerlegen)
    if(isset($_POST) && count($_POST)){
        foreach($_POST as $key => $value){
            //echo '<br>',$key,': ',$value;
            // Header-Attribute
            if(substr($key, 0, 4) == 'head'){
                $key_explode_array = explode('_', $key, 3);
                //print_r_formatted($key_explode_array);
                $header_section = '['.$key_explode_array[1].']';
                $header_attribute = $key_explode_array[2];
                $new_ini_array[$header_section][$header_attribute] = $value;
            }
            
            // Register-Attribute
            if(substr($key, 0, 4) == 'reat'){
                $register_digits = substr($key, 4, 3);
                $register_section = '[Register'.$register_digits.']';
                $register_attribute = substr($key, 7);
                $new_ini_array[$register_section][$register_attribute] = $value;
            }
            
            // Element-Attribute fr Objekt-Sections
            if(substr($key, 0, 4) == 'attr'){
                $object_section = '[Objekt'.$register_digits.'.'.substr($key, 4, 3).']';
                $attribute = substr($key, 7);
                $new_ini_array[$object_section][$attribute] = $value;
            } 
        }
    }
    //print_r_formatted($new_ini_array);
    //print_r_formatted($ini_array);
    
    // Aktuell nicht vorhandene Objekt-Sections des aktuellen Registers verschwinden lassen 
    // -> auf Objekt-Nr. und Tag-Typ prfen
    if(isset($register_digits)){
        $crit_str = '[Objekt'.$register_digits;
        $crit_len = strlen($crit_str);
        foreach($ini_array as $section => $attribute){
            if(substr($section, 0, $crit_len) == $crit_str){
                //echo '<br>',$section,' TagTyp: ',$attribute['TagTyp'];
                if(!isset($new_ini_array[$section]) 
                || $new_ini_array[$section]['TagTyp'] != $attribute['TagTyp']){
                        unset($ini_array[$section]);
                }
            }
        }
    }

    // Merge $new_ini_array mit $ini_array
    foreach($new_ini_array as $section => $attribute){
        foreach($attribute as $attribute_name => $value){
            //echo '<br>',$section,': ',$attribute_name,' - ',$value;
            $ini_array[$section][$attribute_name] = $value;
        }
    }
    $ini_array = sort_ini_array($ini_array);
    //print_r_formatted($ini_array);
    
    // INI-File-Inhalt aus INI-Array erstellen
    $ini_string = create_ini_string_from_ini_array($ini_array, $line_break, $valid_data);
    //echo $ini_string;
    
    // Datei schreiben
    if($valid_data && $ini_fp = fopen($ini_filename, 'w')){
        fwrite($ini_fp, $ini_string);
        fclose($ini_fp);
        return true;
    }
    else{
        return false;
    }
}
/* }}} */

/* {{{ PHP-Funktion sort_ini() - INI-Datei sortieren */
function sort_ini($ini_filename, $line_break){
    $ini_string = '';
    $new_register_no = -1;
    $old_register_no = -1;
    $crit_str_reg = '[Register';
    $crit_len_reg = strlen($crit_str_reg);
    $crit_str_obj = '[Objekt';
    $crit_len_obj = strlen($crit_str_obj);
    //print_r_formatted($_POST);

    // File in $ini_array einlesen, falls vorhanden und nur betreffende Passagen ndern
    $ini_array = load_ini($ini_filename, false);
    if(!$ini_array){
        $ini_array = array();
    }
    $new_ini_array = array();

    foreach($ini_array as $section => $attribute){
        // Wenn weder Register- noch Objekt-Sektion, direkt bernehmen
        if(substr($section, 0, $crit_len_reg) != $crit_str_reg
        && substr($section, 0, $crit_len_obj) != $crit_str_obj){
            $new_ini_array[$section] = $ini_array[$section];
        }
    }

    // INI-Array bearbeiten ("regno0" etc. zerlegen)
    if(isset($_POST) && count($_POST)){
        foreach($_POST as $key => $value){
            if(substr($key, 0, 5) == 'regno'){
                //echo '<br />',$key,': ',$value;
                $old_register_no = substr($key, 5);
                if(is_numeric($old_register_no) && $old_register_no >= 0){
                    $new_register_no++;
                    $old_register_digits = fill_zeros($old_register_no);
                    $new_register_digits = fill_zeros($new_register_no);
                    $old_section = $crit_str_reg.$old_register_digits.']';
                    $new_section = $crit_str_reg.$new_register_digits.']';
                    $new_ini_array[$new_section] = $ini_array[$old_section];

                    // Objekt-Schleife zum Register
                    foreach($ini_array as $section => $attribute){
                        if(substr($section, 0, $crit_len_obj + strlen($old_register_digits)) == $crit_str_obj.$old_register_digits){
                            $new_object_section = $crit_str_obj.$new_register_digits.'.'.substr($section, 11, 3).']';
                            $new_ini_array[$new_object_section] = $ini_array[$section];
                        }
                    }
                }
            }
        }
    }
    //print_r_formatted($new_ini_array);
    //print_r_formatted($ini_array);

    // INI-File-Inhalt aus INI-Array erstellen
    $ini_string = create_ini_string_from_ini_array($new_ini_array, $line_break, $valid_data);
    //echo $ini_string;

    // Datei schreiben
    if($valid_data && $ini_fp = fopen($ini_filename, 'w')){
        fwrite($ini_fp, $ini_string);
        fclose($ini_fp);
        return true;
    }
    else{
        return false;
    }
}
/* }}} */

/* {{{ PHP-Funktion sort_ini_array() - INI-Array-Sections sortieren */
function sort_ini_array($ini_array, $digits = 3){
    $ret_array = array();
    $register_array = array();
    $object_array = array();
    
    $crit_str_reg = '[Register';
    $crit_len_reg = strlen($crit_str_reg);
    $crit_str_obj = '[Objekt';
    $crit_len_obj = strlen($crit_str_obj);
    foreach($ini_array as $section => $attribute){
        if(substr($section, 0, $crit_len_reg) == $crit_str_reg){
            $register_array[$section] = $attribute;
        }
        else if(substr($section, 0, $crit_len_obj) == $crit_str_obj){
            $object_array[$section] = $attribute;
        }
        else{
            $ret_array[$section] = $attribute;
        }
    }
    ksort($register_array, SORT_STRING);
    ksort($object_array, SORT_STRING);
    foreach($register_array as $section => $attribute){
        $ret_array[$section] = $attribute;
        // Objekte zum Register zuweisen
        $register_digits = substr($section, $crit_len_reg, $digits);
        $crit_str_obj = '[Objekt'.$register_digits;
        $crit_len_obj = strlen($crit_str_obj);
        foreach($object_array as $section => $attribute){
            if(substr($section, 0, $crit_len_obj) == $crit_str_obj){
                $ret_array[$section] = $attribute;
            }
        }
    }
    
    return $ret_array;
}
/* }}} */

/* {{{ PHP-Funktion start_session() - Startet eine bestehende Session einer SV@Web-Instanz */
function start_session(&$object, $svweb_session_name = ''){
    $retval = false;

    if(strlen(trim($svweb_session_name))){
        session_name($svweb_session_name);  // Session-Namen festlegen
    }

    if(@session_start()){
        if(isset($_SESSION["sv"])){
            $object = $_SESSION["sv"];
            $retval = true;
        }
        else if(isset($_SESSION["svweb"])){
            $object = $_SESSION["svweb"];
            $retval = true;
        }
        else{
            echo '<br>SV object not found!';
        }
    }
    else{ 
        echo '<br>session_start error!';
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion StripQuotes() - Anfhrungszeichen entfernen */
function StripQuotes($text){
    $retval = '';
    
    $strlen_text = strlen($text);
    for($pos = 0; $pos < $strlen_text; $pos++){
        $letter = substr($text, $pos, 1);
        if($letter != '"' && $letter != "'"){
            break;
        }
    }
    $tmpval = substr($text, $pos);
    $strlen_tmpval = strlen($tmpval);
    for($pos = $strlen_tmpval - 1; $pos >= 0; $pos--){
        $letter = substr($tmpval, $pos, 1);
        if($letter != '"' && $letter != "'"){
            break;
        }
    }
    $retval = substr($tmpval, 0, $pos + 1);
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion sv_connect() - Scalarvis-Socket-Connect */
function sv_connect($user, $pwd, $host, $port, &$fp = null, &$sysinfo = null){
    $socket_errorstr = '';
    
    if(empty($user)){
        $socket_errorstr = 'Socket error: No user specified!'; 
        return $socket_errorstr;
    }
    if(empty($host)){
        $socket_errorstr = 'Socket error: No host specified!'; 
        return $socket_errorstr;
    }
    if(empty($port)){
        $socket_errorstr = 'Socket error: No port specified!'; 
        return $socket_errorstr;
    }
    
    if(!extension_loaded('sockets') && !dl('php_sockets.dll')){
        $socket_errorstr = 'Socket error: Socket extension not available!';
        return $socket_errorstr;
    }
    
    $fp = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
    if(!$fp){
        $socket_errorstr = 'Socket error: '.socket_last_error();
        return $socket_errorstr;
    }
    error_reporting(0);
    if(!socket_connect($fp, $host, $port)){
        $socket_errorstr = 'Socket error: '.socket_last_error($fp);
        socket_close($fp);
        return $socket_errorstr;
    }
    error_reporting(E_ALL);
    
    $in = 'SYSTAGNR,'.$user.','.sv_encrypt($pwd);
    socket_write($fp, $in, strlen($in));
    $socket_string = socket_read($fp, 512);
    if(!strlen($socket_string) || stristr($socket_string, "ERROR")){          // Prfen ob die Serververbindung steht
        $socket_errorstr = 'Socket error: Please check your access data!';
        socket_close($fp);
        return $socket_errorstr;
    }
    else{
        list($sysinfo['tag_anzahl'],
             $sysinfo['intervall'],
             $sysinfo['refresh'],
             $sysinfo['bezeichnung'],
             $sysinfo['kurven_anzahl'],
             $sysinfo['stoer_intervall'],
             $sysinfo['rohkanal_anzahl'],
             $sysinfo['version']) = explode(",", $socket_string);
        $sysinfo['bezeichnung'] = trim($sysinfo['bezeichnung']);
    }
    return 0;
}
/* }}} */

/* {{{ PHP-Funktion sv_check_tag_for_search() - Prfen, ob die Tag-Nr. dem Suchkriterium entspricht */
function sv_check_tag_for_search($fp, $sysinfo, $tag_nr, $search){
    $retval = false;
    $tagarray = array();

    if(isset($sysinfo['tag_anzahl']) && is_numeric($sysinfo['tag_anzahl']) 
        && $sysinfo['tag_anzahl'] > 0 && is_numeric($tag_nr) 
        && $tag_nr > 0 && $tag_nr <= $sysinfo['tag_anzahl'] + 1){
        $tag_start = $tag_nr - 1;
        // Wenn die erste ermittelte Tag-Nr. der zu prfenden Tag-Nr. entspricht
        if(sv_get_next_searched_tag($fp, $sysinfo, $tag_start, $search, $tagarray) 
            && $tagarray['nummer'] == $tag_nr){
            $retval = true;
        }
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion sv_encrypt() - Scalarvis-Encrypt (Passwort-Verschleierung) */
function sv_encrypt($input){
    if(strlen($input)){
        $a = -1;
        $output = "";
        do{
            $a++;
            if(($a % 2) == 0){
                $byte = $input{$a / 2};
                $byte = ord($byte); // String to ASCII
                $work = ($byte & 0xAA) >> 1; // Bitmaske
            }
            else{
                $work = ($byte & 0x55); // Bitmaske
            }
            do{
                srand((double) microtime() * 1000000); //Zufallsgenerator einstellen
                $work = ($work & 0x55) | (rand() & 0x2A);
            }
            while(($work <= 0x21) || ($work >= 0x7E) || ($work == 58) || ($work == 44)); // Abbruchbedingung 1 und 2 Darstellbarer ASCII- Wert, 3 = nicht ":" , 4 = nicht ","
            $output{$a} = $work;
            $output{$a} = sprintf("%c", $output{$a});
        }
        while($a < (strlen($input) * 2) - 1);
        $output = join("", $output);
        return $output;
    }
    else{
        return $input;
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_format_taginfo() - Taginfo formatieren */
function sv_format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $status, $info, &$tagarray){
    $tagname = '';
    $einheit = '';
    $dba = doubleval($dba);
    $dbe = doubleval($dbe);
    $wert= doubleval($wert);
    
    if($tag_nr < 1){
        return 0;
    }
    
    if(($length = strlen($name)) > 0){              // Die letzten 8 Zeichen bilden die Einheit
        $einheit = trim(substr($name, $length - 8));
        $tagname = trim(substr($name, 0, $length - 8));
    }
    $info = trim($info);
    if(ord($info) == 255){                          // Filter fr undefinierte Bezeichnungen
        $info = '';
    }
    if(($tagname == '........................' &&   // Ist das Tag ungltig
        $einheit == '........' &&
        $dba == '-1E+038' &&
        $dbe == '-1E+038' &&
        $wert == '-1E+038') || ($tag_nr == -1)){
        return 0;
    }
    else{
        $dba = ($dba == '-1E+038'?'':$dba);
        $dbe = ($dbe == '-1E+038'?'':$dbe);
        $wert = ($wert == '-1E+038'?'':$wert);
        $tagarray = array('nummer' => $tag_nr,
                          'name' => $tagname,
                          'einheit' => $einheit,
                          'info' => $info,
                          'dba' => $dba,
                          'dbe' => $dbe,
                          'wert' => $wert,
                          'fkt' => $fkt,
                          'status' => $status);
        return 1;
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_get_next_searched_tag() - Nchstes Tag bezglich Suchbegriff ermitteln */
function sv_get_next_searched_tag($fp, $sysinfo, $tag_start, $search, &$tagarray){
    $out = '';
    $out = sprintf('SEAR,%d,%s', $tag_start, $search);
    $explode_array = array();
    
    socket_write($fp, $out, strlen($out));
    $string = socket_read($fp, 8096);
    if(strstr($string, '00,~~~,NOT FOUND')
    || strstr($string, '00,~~~,PARM ERR')){
        return 0;
    }
    else{
        $name = substr($string, 0, 32);
        $string = substr($string, 33);
        // RS0090717
		//$explode_array = explode(',', $string);
        $explode_array = explode(',', $string, 7);
        list($tag_nr, $wert, $dba, $dbe, $fkt, $status, $info) = $explode_array;
        $tag_nr = intval($tag_nr);
        return sv_format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $status, $info, $tagarray);
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_get_next_tag() - Nchstes Tag ermitteln */
function sv_get_next_tag($fp, $sysinfo, $tag_start, &$tagarray){
    if($tag_start < 0 || $tag_start > $sysinfo['tag_anzahl']){
        return 0;
    }
    else{
        $out = '';
        $out = sprintf('NEXTINF,%d', $tag_start);
        socket_write($fp, $out, strlen($out));
        $string = socket_read($fp, 8096);
        $name = substr($string, 0, 32);
        $string = substr($string, 33);
        // RS0090717
        //list($tag_nr, $wert, $dba, $dbe, $fkt, $status, $info) = explode(',', $string);
        list($tag_nr, $wert, $dba, $dbe, $fkt, $status, $info) = explode(',', $string, 7);
        $tag_nr = intval($tag_nr);
        return sv_format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $status, $info, $tagarray);
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_get_prev_searched_tag() - Vorheriges Tag bezglich Suchbegriff ermitteln */
function sv_get_prev_searched_tag($fp, $sysinfo, $tag_start, $search, &$tagarray){
    $out = '';
    $out = sprintf('SEARB,%d,%s', $tag_start, $search);
    $explode_array = array();
    
    socket_write($fp, $out, strlen($out));
    $string = socket_read($fp, 8096);
    if(strstr($string, '00,~~~,NOT FOUND')
    || strstr($string, '00,~~~,PARM ERR')){
        return 0;
    }
    else{
        $name = substr($string, 0, 32);
        $string = substr($string, 33);
        // RS0090717
        //$explode_array = explode(',', $string);
        $explode_array = explode(',', $string, 7);
        list($tag_nr, $wert, $dba, $dbe, $fkt, $status, $info) = $explode_array;
        $tag_nr = intval($tag_nr);
        return sv_format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $status, $info, $tagarray);
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_get_prev_tag() - Vorheriges Tag ermitteln */
function sv_get_prev_tag($fp, $sysinfo, $tag_start, &$tagarray){
    if($tag_start < 0 || $tag_start > $sysinfo['tag_anzahl']){
        return 0;
    }
    else{
        $out= '';
        $out = sprintf('PREVINF,%d', $tag_start);
        socket_write($fp, $out, strlen($out));
        $string = socket_read($fp, 8096);
        $name = substr($string, 0, 32);
        $string = substr($string, 33);
        // RS0090717
        //list($tag_nr, $wert, $dba, $dbe, $fkt, $status, $info) = explode(',', $string);
        list($tag_nr, $wert, $dba, $dbe, $fkt, $status, $info) = explode(',', $string, 7);
        $tag_nr = intval($tag_nr);
        return sv_format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $status, $info, $tagarray);
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_get_tag_info() - Liefert zur Tagnummer alle Informationen */
function sv_get_tag_info($fp, $sysinfo, $tag_nr, &$tagarray){
    if($tag_nr < 0 || $tag_nr > $sysinfo['tag_anzahl']){
        return 0;
    }
    else{
        $out= '';
        $out = sprintf('N,%d', $tag_nr);
        socket_write($fp, $out, strlen($out));
        $string = socket_read($fp, 512);
        $name = substr($string, 0, 32);
        $string = substr($string, 33);
        list($wert, $dba, $dbe, $fkt, $status, $info) = explode(',', $string, 6);
        return sv_format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $status, $info, $tagarray);
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_get_tag_info_array() - Liefert zur Tagnummer alle Informationen und speichert sie in ein Array */
function sv_get_tag_info_array($fp, $tag_nr, $sysinfo, &$tag_info_array){
    if($tag_nr < 0 || $tag_nr > $sysinfo['tag_anzahl']){
        return false;
    }
    else{
        $out = '';
        $out = sprintf('N,%d', $tag_nr);
        socket_write($fp, $out, strlen($out));
        $socket_string = socket_read($fp, 512);
        $name = substr($socket_string, 0, 32);
        $socket_string = substr($socket_string, 33);
        list($wert, $dba, $dbe, $fkt, $status, $info) = explode(',', $socket_string, 6);
        $tag_info_array['tag_nr'] = $tag_nr;
        $tag_info_array['name'] = $name;
        $tag_info_array['wert'] = $wert;
        $tag_info_array['dba'] = $dba;
        $tag_info_array['dbe'] = $dbe;
        $tag_info_array['fkt'] = $fkt;
        $tag_info_array['status'] = $status;
        $tag_info_array['info'] = $info;
        return true;
    }
}
/* }}} */

/* {{{ PHP-Funktion sv_get_taglist() - Tagliste holen */
function sv_get_taglist($fp, 
                        $sysinfo, 
                        $tag_start, 
                        $list_max, 
                        &$tag_list_forward, 
                        &$tag_list_reverse, 
                        &$tagliste, 
                        $direction = 'up', 
                        $search = 'undefined'){
    $tagarray = array();
    $tagliste = array();

    if(isset($sysinfo['tag_anzahl']) && is_numeric($sysinfo['tag_anzahl']) 
    && $sysinfo['tag_anzahl'] > 0){
        $tag_anzahl = $sysinfo['tag_anzahl'];
    }
    else{
        $tag_anzahl = 0;
    }
    
    if(!strlen(trim($search))){
        $search = 'undefined';
    }
    
    if(!is_numeric($tag_start) || $tag_start < 1){
        $tag_nr = 1;
        $direction = 'up';
    }
    else if($tag_start > $tag_anzahl){
        $tag_nr = $tag_anzahl;
        $direction = 'down';
    }
    else{
        $tag_nr = $tag_start;
    }

    // Erste/letzte (up/down) $tag_nr bei $search individuell ermitteln, 
    // wenn $tag_nr nicht dem Suchkriterium entspricht
    if($search != 'undefined' && !sv_check_tag_for_search($fp, $sysinfo, $tag_nr, $search)){
        if($direction == 'down'){
            if(!sv_get_prev_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                return false;
            }
            $tag_nr = $tagarray['nummer'];
        }
        else{
            if(!sv_get_next_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                return false;
            }
            $tag_nr = $tagarray['nummer'];
        }
    }

    $i = 0;
    //echo 'Test: ',$direction,' - ',$tag_nr;
    if(!sv_get_tag_info($fp, $sysinfo, $tag_nr, $tagarray)){            // Prfen ob die Startnummer ungltig ist
        //echo '<br>Invalid Tag';
        if($direction == 'down'){
            if($search == 'undefined'){
                if(!sv_get_prev_tag($fp, $sysinfo, $tag_nr, $tagarray)){
                    $direction = 'up';
                    if(!sv_get_next_tag($fp, $sysinfo, $tag_nr, $tagarray)){
                        return 0;
                    }
                }
            }
            else{
                if(!sv_get_prev_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                    $direction = 'up';
                    if(!sv_get_next_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                        return 0;
                    }
                }
            }
        }
        else{
            if($search == 'undefined'){
                if(!sv_get_next_tag($fp, $sysinfo, $tag_nr, $tagarray)){
                    $direction = 'down';
                    if(!sv_get_prev_tag($fp, $sysinfo, $tag_nr, $tagarray)){
                        return 0;
                    }
                }
            }
            else{
                if(!sv_get_next_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                    $direction = 'down';
                    if(!sv_get_prev_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                        return 0;
                    }
                }
            }
        }
    }
    array_push($tagliste, $tagarray);                   // Gefundenes Tag in die Liste bernehmen
    $tag_nr = $tagliste[$i]['nummer'];                  // Startwert fr die nchste Abfrage bernehmen    
    
    while($i < $list_max - 1){
        if($direction == 'down'){
            if($search == 'undefined'){
                if(sv_get_prev_tag($fp, $sysinfo, $tag_nr, $tagarray)){
                    $i++;
                    array_push($tagliste, $tagarray);
                    $tag_nr = $tagliste[$i]['nummer'];
                }
                else{
                    break;
                }
            }
            else{
                if(sv_get_prev_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                    $i++;
                    array_push($tagliste, $tagarray);
                    $tag_nr = $tagliste[$i]['nummer'];
                }
                else{
                     break;
                }
            }
        }
        else{
            if($search == 'undefined'){
                if(sv_get_next_tag($fp, $sysinfo, $tag_nr, $tagarray)){
                    $i++;
                    array_push($tagliste, $tagarray);
                    $tag_nr = $tagliste[$i]['nummer'];
                }
                else{
                    break;
                }
            }
            else{
                if(sv_get_next_searched_tag($fp, $sysinfo, $tag_nr, $search, $tagarray)){
                    $i++;
                    array_push($tagliste, $tagarray);
                    $tag_nr = $tagliste[$i]['nummer'];
                }
                else{
                     break;
                }
            }
        }
    }
    
    // Prfen ob es noch ein weiteres gltiges Tag gibt, fr Weiter- bzw. Zurck-Button
    $tag_list_forward = 0;
    $tag_list_reverse = 0;
    
    if($direction == 'down'){
        $tmp_tag_nr_next = $tag_start;
        $tmp_tag_nr_prev = $tag_nr;
    }
    else{
        $tmp_tag_nr_next = $tag_nr;
        $tmp_tag_nr_prev = $tag_start;        
    }
    
    if($search == 'undefined'){
        if(sv_get_next_tag($fp, $sysinfo, $tmp_tag_nr_next, $tagarray)){
            $tag_list_forward = 1;
        }
        if(sv_get_prev_tag($fp, $sysinfo, $tmp_tag_nr_prev, $tagarray)){
            $tag_list_reverse = 1;
        }
    }
    else{
        if(sv_get_next_searched_tag($fp, $sysinfo, $tmp_tag_nr_next, $search, $tagarray)){
            $tag_list_forward = 1;
        }
        if(sv_get_prev_searched_tag($fp, $sysinfo, $tmp_tag_nr_prev, $search, $tagarray)){
            $tag_list_reverse = 1;
        }
    }
    if($direction == 'down'){
        $tagliste = array_reverse($tagliste);
    }
    return 1;
}
/* }}} */

/* {{{ PHP-Funktion trim_zeros() - Fhrende Nullen entfernen */
function trim_zeros($number){
    $retval = -1;
    $number = trim($number);
    
    if(is_numeric($number)){
        $retval = (int) $number;
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion twips2pixels() - Twips in Pixel umrechnen */
function twips2pixels($TwipValue, $TwipsPerPixel = 15){
    $retval = 0;
    
    if(is_numeric($TwipValue) 
    && is_numeric($TwipsPerPixel) && $TwipsPerPixel > 0){
        $retval = (int) round($TwipValue / $TwipsPerPixel);
    }
    
    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion write_logfile() - Erstellt Log-Files und -Eintrge */
function write_logfile($action, $user, $host, $port, $status, $codebase=''){
    global $g_line_break;
    global $g_path_separator;

    $log_dir = 'logfiles';
    $log_filename = 'sv'.date('Ymd').'.log';
    $separator_string = "\t";
    $head_string = $log_filename.$g_line_break;

    // Wenn es das Logfiles-Verzeichnis nicht gibt, anlegen
    if(!is_dir($codebase.$log_dir)){
        mkdir($codebase.$log_dir);
    }

    if(isset($_SERVER['REMOTE_ADDR']) && strlen(trim($_SERVER['REMOTE_ADDR']))){
        $remote_ip = $_SERVER['REMOTE_ADDR'];
    }
    else if(isset($_SERVER['REMOTE_HOST']) && strlen(trim($_SERVER['REMOTE_HOST']))){
        $remote_ip = $_SERVER['REMOTE_HOST'];
    }
    else{
        $remote_ip = '';
    }

    $act_sid = session_id();

    $log_string = date('H:i:s').$separator_string.$remote_ip.$separator_string.$act_sid
        .$separator_string.$action.$separator_string.$user.$separator_string.$host
        .$separator_string.$port.$separator_string.trim($status).$g_line_break;

    if(is_file($codebase.$log_dir.$g_path_separator.$log_filename)){
        $new_file = false;
    }
    else{
        $new_file = true;
    }
    if($log_fp = fopen($codebase.$log_dir.$g_path_separator.$log_filename,'a')){
        if($new_file){
            fwrite($log_fp, $head_string);
        }
        fwrite($log_fp, $log_string);
        fclose($log_fp);
    }
}
/* }}} */

/* {{{ PHP-Funktion write_logfile() - Erstellt Log-Files und -Eintrge */
function write_logfile_rs($action, $user, $host, $port, $status, $codebase=''){
    global $g_line_break;
    global $g_path_separator;

    $log_dir = 'logfiles';
    $log_filename = 'sv'.date('Ymd').'.log';
    $separator_string = "\t";
    $head_string = $log_filename.$g_line_break;

    // Wenn es das Logfiles-Verzeichnis nicht gibt, anlegen
    if(!is_dir($codebase.$log_dir)){
        mkdir($codebase.$log_dir);
    }

    $log_string = date('H:i:s').$separator_string.$action.$separator_string.trim($status).$g_line_break;

    if(is_file($codebase.$log_dir.$g_path_separator.$log_filename)){
        $new_file = false;
    }
    else{
        $new_file = true;
    }
    if($log_fp = fopen($codebase.$log_dir.$g_path_separator.$log_filename,'a')){
        if($new_file){
            fwrite($log_fp, $head_string);
        }
        fwrite($log_fp, $log_string);
        fclose($log_fp);
    }
}
/* }}} */

?>
