/***************************
*  JavaScript-Funktionen   *
*  Andy Geiss 2007 - 2008  *
*  Tabulatorweite: 4       *
***************************/

var digits = 3;     // Anzahl Gesamtstellen bezglich zu fllende Nullen

// TagTyp aus Item-Namen extrahieren
function extractTagType(ItemName){
    var retval = '';
    
    ItemName = String(ItemName);
    
    retval = ItemName.substr(2, 3);
    retval = trim_zeros(retval);
    
    return retval;
}

// Fhrende Nullen ergnzen
function fill_zeros(number, digits){
    var retval = '';
    
    if(!digits){
        digits = 3;
    }
    number = String(number);
    strlen_number = number.length;
    
    if(strlen_number < digits){
        var diff = digits - strlen_number;
        for(i = 0; i < diff; i++){
            retval += '0';
        }
        retval += number;
    }
    else{
        retval = number;
    }
    
    return retval;
}

// Font-Klasse
function Font(){
    this.FontFamily = '';
    this.FontSize = 0;
    this.FontBold = false;
    this.FontItalic = false;
    this.FontUnderline = false;
    this.FontStrike = false;
}
Font.prototype.getStringFromFont = function(){
    var retval = '';
    var separator = ';';
    
    if(!this.FontFamily || trim(this.FontFamily) == ''){
        this.FontFamily = 'Arial';
    }
    
    retval += this.FontFamily;
    retval += separator + this.FontSize;
    
    if(this.FontBold){
        retval += separator + 'True';
    }
    else{
        retval += separator + 'False';
    }
    
    if(this.FontItalic){
        retval += separator + 'True';
    }
    else{
        retval += separator + 'False';
    }
    
    if(this.FontUnderline){
        retval += separator + 'True';
    }
    else{
        retval += separator + 'False';
    }
    
    if(this.FontStrike){
        retval += separator + 'True';
    }
    else{
        retval += separator + 'False';
    }
    
    return retval;
};
Font.prototype.setFontFromString = function(FontString){
    var FontStyleArray = Array();
    var TmpString;
    
    FontString = String(FontString);
    FontStyleArray = FontString.split(';');
    
    this.FontFamily = FontStyleArray[0];
    
    if(!isNaN(FontStyleArray[1]) && FontStyleArray[1] > 0){
        this.FontSize = parseInt(FontStyleArray[1]);
    }
    else{
        this.FontSize = 0;
    }
    
    TmpString = String(FontStyleArray[2]);
    if(TmpString.toLowerCase() == 'true'){
        this.FontBold = true;
    }
    else{
        this.FontBold = false;
    }
    
    TmpString = String(FontStyleArray[3]);
    if(TmpString.toLowerCase() == 'true'){
        this.FontItalic = true;
    }
    else{
        this.FontItalic = false;
    }
    
    TmpString = String(FontStyleArray[4]);
    if(TmpString.toLowerCase() == 'true'){
        this.FontUnderline = true;
    }
    else{
        this.FontUnderline = false;
    }
        
    TmpString = String(FontStyleArray[5]);
    if(TmpString.toLowerCase() == 'true'){
        this.FontStrike = true;
    }
    else{
        this.FontStrike = false;
    }
};
Font.prototype.setStyle = function(fd_p){
    if(fd_p){
        // Font-Family und -Styles darstellen
        if(!this.FontFamily || trim(this.FontFamily) == ''){
            fd_p.style.fontFamily = '';
        }
        else{
            fd_p.style.fontFamily = this.FontFamily + ', Arial';
        }
        
        if(this.FontSize){
            fd_p.style.fontSize = this.FontSize + 'pt';
        }
        
        if(this.FontBold){
            fd_p.style.fontWeight = 'bold';
        }
        else{
            fd_p.style.fontWeight = 'normal';
        }
        
        if(this.FontItalic){
            fd_p.style.fontStyle = 'italic';
        }
        else{
            fd_p.style.fontStyle = 'normal';
        }
        
        if(this.FontUnderline){
            fd_p.style.textDecoration = 'underline';
        }
        if(this.FontStrike){
            fd_p.style.textDecoration = 'line-through';
        }
        if(!this.FontUnderline && !this.FontStrike){
            fd_p.style.textDecoration = 'none';
        }
        
        if(!this.FontFamily || trim(this.FontFamily) == ''){
            fd_p.innerHTML = '';
        }
        else{
            fd_p.innerHTML = this.FontFamily;
        }
    }
};

// Komplementrfarbe aus Hex-Farbcode ermitteln
function getComplementaryColorFromHex(HexColor){
    var HexDigits = 6;
    var retval;
    
    HexColor = String(HexColor);
    
    if(HexColor.substr(0, 1) == '#'){
        HexColor = HexColor.substr(1, HexDigits);
    }
    else{
        HexColor = HexColor.substr(0, HexDigits);
    }
    
    retval = getComplementaryShadeFromHex(HexColor.substr(0, 2));
    retval += getComplementaryShadeFromHex(HexColor.substr(2, 2));
    retval += getComplementaryShadeFromHex(HexColor.substr(4, 2));
    
    return retval;
}

// Komplementrfarbanteil aus 2-stelligem Hex-Code (R, G oder B) ermitteln
function getComplementaryShadeFromHex(HexShade){
    var HexDigits = 2;
    var MaxDec = 255;
    var retval, diff, i;
    
    HexShade = String(HexShade);
    
    if(HexShade.substr(0, 1) == '#'){
        HexShade = HexShade.substr(1, HexDigits);
    }
    else{
        HexShade = HexShade.substr(0, HexDigits);
    }
    
    retval = parseInt(HexShade.substr(0, HexDigits), 16);
    retval = MaxDec - retval;
    retval = retval.toString(16);
    if(retval.length < HexDigits)
    {
        diff = HexDigits - retval.length;
        for(i = 0; i < diff; i++)
        {
            retval = '0' + retval;
        }
    }
    
    return retval;
}

// Hex-Farbcode aus Integerwert extrahieren
function getHexColorFromInt(IntColor){
    var HexDigits = 6;
    var retval = '000000';
    var diff, i, HexCode;
    
    if(isNaN(IntColor) || IntColor < 0 || IntColor > 16777215){
        return retval;
    }
    else{
        IntColor = parseInt(IntColor);
    }
    
    retval = IntColor.toString(16);
    if(retval.length < HexDigits){
        diff = HexDigits - retval.length;
        for(i = 0; i < diff; i++){
            retval = '0' + retval;
        }
    }
    
    // RGB umdrehen
    HexCode = retval;
    retval = HexCode.substr(4, 2);
    retval += HexCode.substr(2, 2);
    retval += HexCode.substr(0, 2);
    
    return retval;
}

// 2-stelligen Hex-Code aus Integerwert (R, G oder B) erstellen
function getHexShadeFromInt(IntShade){
    var HexDigits = 2;
    var retval = '00';
    var diff, i;
    
    if(isNaN(IntShade) || IntShade > 255){
        return retval;
    }
    else{
        IntShade = parseInt(IntShade);
    }
    
    retval = IntShade.toString(16);
    if(retval.length < HexDigits){
        diff = HexDigits - retval.length;
        for(i = 0; i < diff; i++){
            retval = '0' + retval;
        }
    }
    
    return retval;    
}

// Integerwert aus Hex-Farbcode erstellen
function getIntColorFromHex(HexColor){
    var HexDigits = 6;
    var retval;
    
    HexColor = String(HexColor);
    
    if(HexColor.substr(0, 1) == '#'){
        HexColor = HexColor.substr(1, HexDigits);
    }
    else{
        HexColor = HexColor.substr(0, HexDigits);
    }

    // RGB umdrehen
    retval = HexColor.substr(4, 2);
    retval += HexColor.substr(2, 2);
    retval += HexColor.substr(0, 2);
    
    retval = parseInt(retval, 16);
    
    return retval;
}

// Integerwert aus 2-stelligem Hex-Code (R, G oder B) erstellen
function getIntShadeFromHex(HexShade){
    var HexDigits = 2;
    var retval;
    
    HexShade = String(HexShade);
    
    if(HexShade.substr(0, 1) == '#'){
        HexShade = HexShade.substr(1, HexDigits);
    }
    else{
        HexShade = HexShade.substr(0, HexDigits);
    }
    
    retval = parseInt(HexShade, 16);
    
    return retval;
}

// INI-Header-Klasse (beinhaltet Array mit ini_header_section-Instanzen)
function ini_header(){
    this.name = '';
    this.SerializedSnap = '';
    this.header_sections = new Array();
}
ini_header.prototype.getSerializedValues = function(){
    var retval = '';
    var valarray = this.header_sections;
    var valsubarray;
    for(var j in valarray){
        eval('retval += serialize(valarray.' + j + ') + ";";');
        // In Sections reinkrabbeln
        eval('valsubarray = valarray.' + j + '.header_attributes;');
        for(var i in valsubarray){
            eval('retval += serialize(valsubarray.' + i + ') + ";";');
        }
    }
    return retval;
};
ini_header.prototype.setSerializedSnap = function(){
    this.SerializedSnap = this.getSerializedValues();
};

// INI-Header-Attribut-Klasse
function ini_header_attribute(){
    this.name = '';
    this.value = '';
}

// INI-Header-Section-Klasse (beinhaltet Array mit ini_header_attribute-Instanzen)
function ini_header_section(){
    this.name = '';
    this.header_attributes = new Array();
}

// INI-Register-Klasse (beinhaltet Array mit ini_register_section-Instanzen)
function ini_register(){
    this.name = '';
    this.register_no_active = 0;
    this.register_sections = new Array();
}
ini_register.prototype.getActiveRegisterSectionName = function(){
    var retval = 'Register' + fill_zeros(this.register_no_active, digits);
    return retval;
};

// INI-Register-Attribut-Klasse
function ini_register_attribute(){
    this.name = '';
    this.value = '';
}

// INI-Register-Section-Klasse (beinhaltet Array mit ini_register_attribute-Instanzen)
function ini_register_section(){
    this.name = '';
    this.SerializedSnap = '';
    this.register_attributes = new Array();
}
ini_register_section.prototype.getSerializedValues = function(){
    var retval = '';
    var valarray = this.register_attributes;
    for(var i in valarray){
        eval('retval += serialize(valarray.' + i + ') + ";";');
    }
    return retval;
};
ini_register_section.prototype.setSerializedSnap = function(){
    this.SerializedSnap = this.getSerializedValues();
};

// Pixel in Twips umrechnen
function pixels2twips(PixelValue, TwipsPerPixel){
    var retval = 0;
    
    if(!TwipsPerPixel){
        TwipsPerPixel = 15;
    }
    
    if(!isNaN(PixelValue)){
        retval = PixelValue * TwipsPerPixel;
    }
    
    return retval;
}

// Serialize
function serialize(input_param){
    var input = input_param;
    if(typeof input != 'object'){ 
        return false;
    }
    if(typeof retval == 'undefined'){ 
        var retval = new String();
    }
    retval = retval + 'a:' + (input.length?input.length:0) + ':{';
    for(var pos in input){
        if(typeof pos == 'object'){ 
            serialize(pos);
        }
        else{
            if(typeof pos == 'string'){ 
                retval = retval + 's' + ':' + pos.length + ':"' + pos + '";';
            }
            if(typeof pos == 'number'){ 
                retval = retval + 'i:' + pos + ';';
            }
            if(typeof input[pos] == 'string'){ 
                retval = retval + 's' + ':' + input[pos].length + ':"' + input[pos] + '";';
            }
            if(typeof input[pos] == 'number'){ 
                retval = retval + 'i:' + input[pos] + ';';
            }
            // Nicht PHP-serialize-kompatible Datentypen
            if(typeof pos == 'boolean'){ 
                retval = retval + 'b:' + pos + ';';
            }
            /*
            if(typeof pos == 'function'){ 
                retval = retval + 'f:' + pos + ';';
            }
            if(typeof pos == 'object'){ 
                retval = retval + 'o:' + pos + ';';
            }
            */
            if(typeof pos == 'undefined'){ 
                retval = retval + 'u:' + pos + ';';
            }
            if(typeof input[pos] == 'boolean'){ 
                retval = retval + 'b:' + input[pos] + ';';
            }
            /*
            if(typeof input[pos] == 'function'){ 
                retval = retval + 'f:' + input[pos] + ';';
            }
            if(typeof input[pos] == 'object'){ 
                retval = retval + 'o:' + input[pos] + ';';
            }
            */
            if(typeof input[pos] == 'undefined'){ 
                retval = retval + 'u:' + input[pos] + ';';
            }
        }
    }
    retval = retval + '}';
    return retval;
}

// Pfad-Kompatibilitts-Relevanz
// Pfad entfernen
function stripPath(url){
    var pos = -1;
    var retval = url;
    
    retval = String(retval);
    
    // Pfadangabe entfernen
    pos = retval.lastIndexOf('\\');
    if(pos > -1){
        retval = retval.substr(pos + 1);
    }
    pos = retval.lastIndexOf('/');
    if(pos > -1){
        retval = retval.substr(pos + 1); 
    }
    
    return retval; 
}

// Trim
function trim(s){
    s = String(s);
    
    while(s.substring(0, 1) == ' '){
        s = s.substring(1, s.length);
    }
    
    while(s.substring(s.length - 1, s.length) == ' '){
        s = s.substring(0, s.length - 1);
    }
    
    return s;
}

// Fhrende Nullen entfernen
function trim_zeros(number){
    var retval = -1;
    number = trim(number);
    
    if(!isNaN(number)){
        while(number.substring(0, 1) == '0' && number.length > 1){
            number = number.substring(1, number.length);
        }
        retval = parseInt(number);
    }
    
    return retval;
}

// Pixel in Twips umrechnen
function twips2pixels(TwipsValue, TwipsPerPixel){
    var retval = 0;
    
    if(!TwipsPerPixel){
        TwipsPerPixel = 15;
    }
    
    if(!isNaN(TwipsValue)){
        retval = parseInt(TwipsValue / TwipsPerPixel);
    }
    
    return retval;
}

function debugDummy(){
    var i;
    i = 1;
    return i;
}
