<?php

/***************************
*  Andy Geiss 2007 - 2010  *
*  Tabulatorweite: 4       *
***************************/

error_reporting(E_ALL);

$attribute_array = array();
$header_array = array();
$regno_array = array();
$error_msg = '';
$script_name = $_SERVER["SCRIPT_NAME"];

ob_start();
require('functions.inc');
include('texts.inc');
include('attributes.inc');
include('headerattributes.inc');
ob_end_clean();
//print_r_formatted($_POST);

// L TODO: ErstesRegister-Eingabe in headerform per Pulldownmen

// Standardbilder im $img_path kopieren, falls nicht bereits vorhanden
copy_std_image('windrose.png');
copy_std_image('picture.png');
copy_std_image('indicator.png');
copy_std_image('picselection.gif');

// Kodierungskonvertierung (Workaround -> IE postet per document.write pauschaul nur in UTF-8)
if(isset($_POST['charset']) && $_POST['charset'] == 'unicode'){
    foreach($_POST as $key => $value){
        $tmp_value = iconv("UTF-8", "ISO-8859-1", $value);
        if($tmp_value){
            $_POST[$key] = $tmp_value;
        }
    }
}

//print_r_formatted($_POST);
// Submit-Action belegen
if(isset($_POST['submit_action'])){
    $submit_action = $_POST['submit_action'];
}
else if(isset($_GET['submit_action'])){
    $submit_action = $_GET['submit_action'];
}
else{
    $submit_action = '';
}

// Speichervorgang
if($submit_action == 'save_ini' || $submit_action == 'save_ini_register_new'
|| $submit_action == 'save_ini_register_copy'){
    if(!save_ini($ini_filename, $line_break)){
        $error_msg = 'Error: File not saved!';
    }
}

// Kopiervorgang
if($submit_action == 'load_ini_register_copy'
|| $submit_action == 'save_ini_register_copy'){
    if(!copy_register($ini_filename, $line_break)){
        $error_msg = 'Error: File not saved! Register not copied!';
    }
}

// Sortiervorgang
if($submit_action == 'sort_ini'){
    if(!sort_ini($ini_filename, $line_break)){
        $error_msg = 'Error: File not saved! Register not sorted!';
    }
}

// Register-Lschvorgang
if($submit_action == 'delete_register_from_ini'){
    if(!delete_register_from_ini($ini_filename, $line_break)){
        $error_msg = 'Error: File not saved! Register not deleted!';
    }
}

$ini_array = load_ini($ini_filename);
$regno_array = get_regnos_from_ini_array($ini_array);

// Zu ladende Registernummer belegen
if(isset($_POST['register_no_load']) && is_numeric($_POST['register_no_load'])){
    $register_no_load = $_POST['register_no_load'];
}
else if(isset($_GET['register_no_load']) && is_numeric($_GET['register_no_load'])){
    $register_no_load = $_GET['register_no_load'];
}
else{
    $register_no_load = get_min_regno_from_regno_array($regno_array);
}
if(!in_array($register_no_load, $regno_array)){
    if($submit_action == 'load_ini_register_new' || $submit_action == 'save_ini_register_new'){
        array_push($regno_array, fill_zeros($register_no_load));
    }
    else{
        $register_no_load = get_min_regno_from_regno_array($regno_array);
    }
}

if(!count($regno_array)){
    $regno_array[0] = '000';
}

echo '
<!-- Andy Geiss 2007 - 2010 -->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- DOCTYPE html -->

<html>
<head>
<meta http-equiv="expires" content="0">
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<meta http-equiv="imagetoolbar" content="no">
<title>Flowchart Edit</title>
<link rel="stylesheet" type="text/css" href="flowchartedit.css">
<script type="text/javascript" src="functions.js"></script>

<script language="JavaScript">
<!--
//alert("',$_SERVER["SCRIPT_NAME"],'");
function key_down_event(event){
    var keyCode;
    if(!event){
        event = window.event;
    }
    if(event.which){
        keyCode = event.which;
    }
    else{
        if(event.keyCode){
            keyCode = event.keyCode;
        }
    }
    //alert("Taste mit Dezimalwert " + keyCode + " gedrckt");
}
document.onkeydown = key_down_event;';

// Title der Top-Location belegen
if(isset($ini_filename) && strlen(trim($ini_filename))){
    echo '
    top.document.title = "Flowchart Edit - ',$ini_filename,'";';
}
else{
    echo '
    top.document.title = "Flowchart Edit";';
}

echo '
// ini_header-Instanz erstellen und mit Standardwerten belegen
var ini_header = new ini_header();
ini_header.name = \'ini_header\';
var hs_p;';
foreach($header_array as $header_section => $header_attribute_array){
    echo '
    ini_header.header_sections.',$header_section,' = new ini_header_section();
    hs_p = ini_header.header_sections.',$header_section,';
    hs_p.name = \'',$header_section,'\';';
    foreach($header_attribute_array as $header_attribute_name => $header_attribute){
        if(isset($header_attribute['DefaultValue']) && strlen(trim($header_attribute['DefaultValue']))){
            $DefaultValue = trim($header_attribute['DefaultValue']);
        }
        else{
            $DefaultValue = '';
        }
        echo '
        hs_p.header_attributes.',$header_attribute_name,' = new ini_header_attribute();
        hs_p.header_attributes.',$header_attribute_name,'.name = \'',$header_attribute_name,'\';
        hs_p.header_attributes.',$header_attribute_name,'.value = \'',$DefaultValue,'\';';
    }
}

echo '

// ini_register-Instanz erstellen und mit Standardwerten belegen
var ini_register = new ini_register();
ini_register.name = \'ini_register\';
// Nach Speichern vorher verwendetes Register wieder anwhlen (nur wenn Speichern nicht aufgrund Registerwechsel ausgefhrt wurde -> neues Register verwenden)
ini_register.register_no_active = ',$register_no_load,';
var ActiveRegisterSectionName = ini_register.getActiveRegisterSectionName();
ini_register.register_sections[ActiveRegisterSectionName] = new ini_register_section();
var rs_p = ini_register.register_sections[ActiveRegisterSectionName];
rs_p.name = ActiveRegisterSectionName;
rs_p.register_attributes.Caption = new ini_register_attribute();
rs_p.register_attributes.Caption.name = \'Caption\';
rs_p.register_attributes.Caption.value = \'\';';

// Header-Werte von $ini_array in ini_header laden
foreach($header_array as $header_section => $header_attribute_array){
    echo '
    hs_p = ini_header.header_sections.',$header_section,';';
    foreach($header_attribute_array as $header_attribute_name => $header_attribute){
        if(isset($ini_array['['.$header_section.']'][$header_attribute_name])){
            echo '
            hs_p.header_attributes.',$header_attribute_name,'.value = "',trim($ini_array['['.$header_section.']'][$header_attribute_name]),'";';
        }
    }
}

if(isset($ini_array['[Register'.fill_zeros($register_no_load).']']['Caption'])
&& strlen(trim($ini_array['[Register'.fill_zeros($register_no_load).']']['Caption']))){
    $register_attributes_caption_value = trim($ini_array['[Register'.fill_zeros($register_no_load).']']['Caption']);
}
else{
    $register_attributes_caption_value = '';
}
echo '
rs_p.register_attributes.Caption.value = "',$register_attributes_caption_value,'";

// Workspace mit Ladevorgang aufrufen
parent.workspace.location.replace(\'workspace.php?register_no_load=',$register_no_load,$session_url_param2,'\');

function load_ini(register_no_load, submit_action){
    if(!submit_action){
        submit_action = \'load_ini\';
    }
    document.charset = \'ISO-8859-1\';
    document.load_form.register_no_load.value = register_no_load;
    document.load_form.charset.value = document.charset;
    document.load_form.submit_action.value = submit_action;
    document.load_form.submit();
}

function save_ini(register_no_load, submit_action){
    if(!submit_action){
        submit_action = \'save_ini\';
    }

    // Header ermitteln
    var i = 0;
    var header_input_name = Array();
    var header_input_value = Array();';
    //print_r_formatted($header_array);
    foreach($header_array as $header_section => $header_attribute_array){
        echo '
        hs_p = ini_header.header_sections.',$header_section,';';
        foreach($header_attribute_array as $header_attribute_name => $header_attribute){
            echo '
            header_input_name[i] = \'head_',$header_section,'_',$header_attribute_name,'\';
            header_input_value[i] = hs_p.header_attributes.',$header_attribute_name,'.value;
            i++;';
        }
    }
    echo '
    // Register ermitteln
    var register_input_name = Array();
    var register_input_value = Array();
    register_input_name[0] = \'reat\' + fill_zeros(ini_register.register_no_active) + \'Caption\';
    register_input_value[0] = rs_p.register_attributes.Caption.value;
    register_input_name[1] = \'register_no_active\';
    register_input_value[1] = ini_register.register_no_active;
    // Objekt-Sections/-Attribute ermitteln
    i = 0;
    var object_no = 0;
    var ObjNamesSortedByZ = Array();
    var attribute_input_name = Array();
    var attribute_input_value = Array();
    var d_p;
    var TagTyp;
    ObjNamesSortedByZ = parent.workspace.dd.getObjNamesSortedByZ();
    for(var on_i = 0; on_i < ObjNamesSortedByZ.length; on_i++){
        d_p = parent.workspace.dd.elements[ObjNamesSortedByZ[on_i]];

        if(d_p.relevant){
            TagTyp = extractTagType(d_p.',$attribute_array['TagTyp']['DDObjProperty'],');';
            // Attribut-Relevanz?
            foreach($attribute_array as $attribute_name => $attribute){
                $tag_types_limited = is_tag_types_limited($attribute_name);
                js_if_tag_types_limited_begin($tag_types_limited, $attribute_name);
                echo '
                attribute_input_name[i] = \'attr\' + fill_zeros(object_no) + \'',$attribute_name,'\';
                attribute_input_value[i] = d_p.attributes.',$attribute_name,'.value;
                i++;';
                js_if_tag_types_limited_end($tag_types_limited);
            }
            echo '
            object_no++;
        }
    }

    document.charset = \'ISO-8859-1\';
    document.save_form.register_no_load.value = register_no_load;
    document.save_form.charset.value = document.charset;
    document.save_form.submit_action.value = submit_action;
    // Header bermitteln
    for(i = 0; i < header_input_name.length; i++){
        var newInput = document.createElement("input");
        newInput.setAttribute("type", "hidden");
        newInput.setAttribute("name", header_input_name[i]);
        newInput.setAttribute("value", header_input_value[i]);
        document.save_form.appendChild(newInput);
    }
    // Register bermitteln
    for(i = 0; i < register_input_name.length; i++){
        var newInput = document.createElement("input");
        newInput.setAttribute("type", "hidden");
        newInput.setAttribute("name", register_input_name[i]);
        newInput.setAttribute("value", register_input_value[i]);
        document.save_form.appendChild(newInput);
    }
    // Objekt-Sections/-Attribute bermitteln
    for(i = 0; i < attribute_input_name.length; i++){
        var newInput = document.createElement("input");
        newInput.setAttribute("type", "hidden");
        newInput.setAttribute("name", attribute_input_name[i]);
        newInput.setAttribute("value", attribute_input_value[i]);
        document.save_form.appendChild(newInput);
    }
    document.save_form.submit();
}

function delete_register_from_ini(register_no_load, submit_action){
    if(!submit_action){
        submit_action = \'delete_register_from_ini\';
    }

    document.delete_register_form.register_no_delete.value = ini_register.register_no_active;
    document.delete_register_form.register_no_load.value = register_no_load;
    document.delete_register_form.charset.value = document.charset;
    document.delete_register_form.submit_action.value = submit_action;
    document.delete_register_form.submit();
}

function createSortFormHiddenInput(name, value){
    var newInput = document.createElement("input");
    newInput.setAttribute("type", "hidden");
    newInput.setAttribute("name", name);
    newInput.setAttribute("value", value);
    document.sort_form.appendChild(newInput);
}

function submitSortForm(submit_action, register_no_load){
    if(!submit_action){
        submit_action = \'sort_ini\';
    }
    if(!register_no_load && register_no_load != 0){
        register_no_load = ini_register.register_no_active;
    }
    document.charset = \'ISO-8859-1\';
    document.sort_form.register_no_load.value = register_no_load;
    document.sort_form.charset.value = document.charset;
    document.sort_form.submit_action.value = submit_action;
    document.sort_form.submit();
}

function open_headerform(){
    var wwidth = 600;
    var wheight = 380;
    var wleft = (screen.availWidth - wwidth) / 2;
    var wtop = (screen.availHeight - wheight) / 2;
    var wlayout = "location=no, menubar=no, resizable=yes, scrollbars=yes";
    wlayout += ", status=yes, toolbar=no, left=" + wleft + ", top=" + wtop;
    wlayout += ", width=" + wwidth + ", height=" + wheight;
    wndHeaderForm = window.open("headerform.php',$session_url_param1,'", "wndHeaderForm", wlayout);
    wndHeaderForm.focus();
}

function open_preview(register_no){
    var register = fill_zeros(register_no);
    var wwidth = 1050;
    var wheight = 750;
    var wleft = (screen.availWidth - wwidth) / 2;
    var wtop = (screen.availHeight - wheight) / 2;
    var wlayout = "location=no, menubar=no, resizable=yes, scrollbars=yes";
    wlayout += ", status=yes, toolbar=no, left=" + wleft + ", top=" + wtop;
    wlayout += ", width=" + wwidth + ", height=" + wheight;
    wndPreview = window.open("preview.php?register=" + register + "',$session_url_param2,'", "wndPreview", wlayout);
    wndPreview.focus();
}

function open_registersortform(register_no){
    var wwidth = 450;
    var wheight = 170;
    var wleft = (screen.availWidth - wwidth) / 2;
    var wtop = (screen.availHeight - wheight) / 2;
    var wlayout = "location=no, menubar=no, resizable=yes, scrollbars=yes";
    wlayout += ", status=yes, toolbar=no, left=" + wleft + ", top=" + wtop;
    wlayout += ", width=" + wwidth + ", height=" + wheight;

    if(register_change_confirm()){
        save_ini(document.menu_form.register_no.value);
    }

    wndRegisterSortForm = window.open("registersortform.php?regno=" + register_no + "',$session_url_param2,'", "wndRegisterSortForm", wlayout);
    wndRegisterSortForm.focus();
}

function open_adminform(){
    var wwidth = 600;';
    // Bei Sessionbetrieb Fensterhhe gem den ausgeblendeten Eingabefeldern entsprechen kleiner gestalten
    if(!isset($sv->user) || !strlen(trim($sv->user))){
        echo '
        var wheight = 440;';
    }
    else{
        echo '
        var wheight = 330;';
    }
    echo '
    var wleft = (screen.availWidth - wwidth) / 2;
    var wtop = (screen.availHeight - wheight) / 2;
    var wlayout = "location=no, menubar=no, resizable=yes, scrollbars=yes";
    wlayout += ", status=yes, toolbar=no, left=" + wleft + ", top=" + wtop;
    wlayout += ", width=" + wwidth + ", height=" + wheight;
    wndAdminForm = window.open("adminform.php',$session_url_param1,'", "wndAdminForm", wlayout);
    wndAdminForm.focus();
}

function register_change(){
    if(register_change_confirm()){
        save_ini(document.menu_form.register_no.value);
    }
    else{
        load_ini(document.menu_form.register_no.value);
    }
}

function register_change_confirm(){
    var check = false;

    // Confirm nur, wenn sich SerializedSnap gendert hat ...
    if(isActiveRegisterDirty()){
        check = confirm("',lang_text('register_change_confirm'),'");
        if(check){
            return true;
        }
        else{
            return false;
        }
    }
    // ... ansonsten ist kein Speichern ntig
    else{
        return false;
    }
}

function register_delete_confirm(){
    var check = false;

    check = confirm("',lang_text('register_delete_confirm'),'");
    if(check){
        return true;
    }
    else{
        return false;
    }
}

function register_new(){
    var register_no_load = ',get_max_regno_from_regno_array($regno_array),' + 1;
    if(register_change_confirm()){
        save_ini(register_no_load, \'save_ini_register_new\');
    }
    else{
        load_ini(register_no_load, \'load_ini_register_new\');
    }
}

function register_copy(){
    var register_no_load = document.menu_form.register_no.value;
    if(register_change_confirm()){
        save_ini(register_no_load, \'save_ini_register_copy\');
    }
    else{
        load_ini(register_no_load, \'load_ini_register_copy\');
    }
}

function register_set_caption(){
    rs_p.register_attributes.Caption.value = document.menu_form.register_caption.value;
}

function register_delete(){
    var register_no_load = ',($register_no_load > 0?$register_no_load - 1:0),';
    if(register_delete_confirm()){
        delete_register_from_ini(register_no_load, \'delete_register_from_ini\');
    }
}

// Prfen ob SerializedSnap des aktiven Registers oder des Workspace gendert wurde
function isActiveRegisterDirty(){
    var retval = false;

    // Header
    if(ini_header.SerializedSnap != ini_header.getSerializedValues()){
        retval = true;
    }

    // Register
    if(rs_p.SerializedSnap != rs_p.getSerializedValues()){
        retval = true;
    }

    // Workspace
    var dd_p = parent.workspace.dd;
    if(dd_p.SerializedSnap != dd_p.getSerializedValues()){
        retval = true;
    }

    return retval;
}

// Init-SerializedSnap/Loading-SerializedSnap bezglich Register erstellen
ini_header.setSerializedSnap();
//alert(ini_header.SerializedSnap);
rs_p.setSerializedSnap();
//alert(rs_p.SerializedSnap);

//-->
</script>

</head>

<body>

<table border="0" cellpadding="0" cellspacing="4">
<tr>
    <form name="menu_form" action="',$script_name,'" method="POST"
        onSubmit="register_set_caption(); return false;">
    <td>
    <input class="button_width" type="button" value="',lang_text('load'),'"
        onclick="load_ini(ini_register.register_no_active)">
    </td>
    <td>
    <input class="button_width" type="button" value="',lang_text('save'),'"
        onclick="save_ini(ini_register.register_no_active)">
    </td>
    <td>&nbsp;&nbsp;</td>
    <td>
    <input class="button_width" type="button" value="',lang_text('header'),'"
        onclick="open_headerform()">',
    '&nbsp;&nbsp;</td>';
    if(!empty($sv_user)){
        echo '
        <td>
        <input class="button_width" type="button" value="',lang_text('preview'),'"
            onclick="open_preview(ini_register.register_no_active)">',
        '&nbsp;&nbsp;</td>';
    }
    echo '
    <td class="stripline_left">&nbsp;&nbsp;',lang_text('register'),':&nbsp;</td>
    <td>
    <select name="register_no" onchange="register_change()">';
    foreach($regno_array as $register_digits){
        $tmp_regno = trim_zeros($register_digits);
        echo '
        <option value="',$tmp_regno,'"';
        if($tmp_regno == $register_no_load){
            echo ' selected';
        }
        $tmp_register_index = '[Register'.$register_digits.']';
        if(isset($ini_array[$tmp_register_index]['Caption'])
        && strlen(trim($ini_array[$tmp_register_index]['Caption']))){
            $tmp_caption = $ini_array[$tmp_register_index]['Caption'];
        }
        else{
            $tmp_caption = '';
        }
        echo '>',$register_digits,' - ',$tmp_caption,'</option>';
    }
    echo '
    </select>
    </td>
    <td>
    <input class="button_width" type="button" value="',lang_text('new'),'"
        onclick="register_new()">
    </td>
    <td>
    <input class="button_width" type="button" value="',lang_text('copy'),'"
        onclick="register_copy()">
    </td>
    <td>
    <input class="button_width" type="button" value="',lang_text('sort'),'"
        onclick="open_registersortform(ini_register.register_no_active)">
    </td>
    <td>
    <input class="button_width" type="button" value="',lang_text('delete'),'"
        onclick="register_delete()">
    </td>
    <td>
    <input type="text" name="register_caption" size="20" maxlength="50"
        onblur="register_set_caption()">
    <script language="JavaScript">
    <!--
    document.menu_form.register_caption.value = rs_p.register_attributes.Caption.value;
    //-->
    </script>
    </td>';
    if(!empty($show_admin_button)){
        echo '
        <td>&nbsp;</td>
        <td class="stripline_left">&nbsp;&nbsp;',
        '<input class="button_width" type="button" value="',lang_text('admin'),'" onclick="open_adminform()">
        </td>';
    }
    echo '
    <td>
    &nbsp;';
    // Fehlermeldung ausgeben, falls vorhanden
    if(strlen(trim($error_msg))){
        echo '<span class="error_msg">',$error_msg,'</span>';
    }
    echo $session_hidden_input,'
    </td>
    </form>
</tr>
</table>

<form name="load_form" action="',$script_name,'" method="POST" accept-charset="ISO-8859-1" style="display:none">
<input name="register_no_load" type="hidden">
<input name="charset" type="hidden">
',$session_hidden_input,'
<input name="submit_action" type="hidden">
</form>

<form name="save_form" action="',$script_name,'" method="POST" accept-charset="ISO-8859-1" style="display:none">
<input name="register_no_load" type="hidden">
<input name="charset" type="hidden">
',$session_hidden_input,'
<input name="submit_action" type="hidden">
</form>

<form name="delete_register_form" action="',$script_name,'" method="POST" accept-charset="ISO-8859-1" style="display:none">
<input name="register_no_delete" type="hidden">
<input name="register_no_load" type="hidden">
<input name="charset" type="hidden">
',$session_hidden_input,'
<input name="submit_action" type="hidden">
</form>

<form name="sort_form" action="',$script_name,'" method="POST" accept-charset="ISO-8859-1" style="display:none">
<input name="register_no_load" type="hidden">
<input name="charset" type="hidden">
',$session_hidden_input,'
<input name="submit_action" type="hidden">
</form>

</body>
</html>';

function copy_std_image($filename){
    global $img_path;

    if(is_dir($img_path)){
        if(is_file($filename) && !is_file($img_path.'/'.$filename)){
            copy($filename, $img_path.'/'.$filename);
        }
    }
}

?>
