<?php

// vim: fdm=marker

/***************************
*  Andy Geiss 2008 - 2010  *
*  Tabulatorweite: 4       *
***************************/


error_reporting(E_ALL);

ob_start();
require('functions.inc');
include('texts.inc');
require($fci_inc);
eval($sv_short_class_def);
ob_end_clean();

/* {{{ Variablen belegen */
$MarginTop = 20;
$MarginLeft = 0;
$MarginTop .= 'px';
$MarginLeft .= 'px';

$fp = null;
$sysinfo = array();
$transparentpixel_file = 'transparentpixel.gif';

if(isset($_GET['register']) && strlen($_GET['register'])){
    $register = $_GET['register'];
}
else{
    $register = '000';
}

if(isset($ini_path)){
    $flowchart_dir = $ini_path.'/';
}
if(isset($img_path)){
    $flowchart_dir = $img_path.'/';
}
else{
    $flowchart_dir = '';
}
$flowchart_ini_file = $ini_filename;
/* }}} */

/* {{{ Scalarvis Connect */
$socket_errorstr = sv_connect($sv_user, $sv_pwd, $sv_host, $sv_port, $fp, $sysinfo);
if(!empty($socket_errorstr)){
    echo $socket_errorstr;
    exit;
}
/* }}} */

/* {{{ Flow Chart INI-File einlesen */
if(is_file($flowchart_ini_file)){
    $ini_array = pv_get_ini_array($flowchart_ini_file);
}
else{
    echo 'File '.$flowchart_ini_file.' not found!';
    exit;
}

// Objekt-Array zum Register ermitteln
$object_array = get_object_array($ini_array, $register);
/* }}} */

/* {{{ Overlay-Objekte bestimmen */
// Attribut-Relevanz
$giffile_array = array();
$giffile_array_index = 0;
foreach($object_array as $object_no => $object_value_array){
    // Overlay-Objekte
    // Erstes Objekt eines Registers muss immer das grundlegende Hintergrundbild sein,
    // deshalb wird dieses in dieser Schleife ausgeschlossen
    if($object_no != '000'){
        // Attribut-Relevanz
        // Tag-Typ-Unterscheidung
        switch($object_value_array['TagTyp']){
            case 9:
                $giffile_err = GetGIFFile($object_value_array['TxtErr'], $flowchart_dir);
                $giffile_false = GetGIFFile($object_value_array['TxtFalse'], $flowchart_dir);
                $giffile_true = GetGIFFile($object_value_array['TxtTrue'], $flowchart_dir);

                if($object_value_array['TagNummer'] != 0){
                    if(sv_get_tag_info_array($fp, $object_value_array['TagNummer'], $sysinfo, $tmp_tag_info_array)){
                        $tmp_value = $tmp_tag_info_array['wert'];
                        if($tmp_value == -1.0e38){
                            $giffile = $giffile_err;
                        }
                        else if($tmp_value == 0.0){
                            $giffile = $giffile_false;
                        }
                        else{
                            $giffile = $giffile_true;
                        }
                    }
                }
                else{
                    $giffile = $giffile_err;
                }

                if((strlen(trim($giffile_err)) || strlen(trim($giffile_false)) || strlen(trim($giffile_true)))
                && is_numeric($object_value_array['PosLeft'])
                && is_numeric($object_value_array['PosTop'])
                && is_numeric($object_value_array['PosWidth'])
                && is_numeric($object_value_array['PosHeight'])){
                    $giffile_array[$giffile_array_index]['ObjectNo'] = $object_no;
                    $giffile_array[$giffile_array_index]['TagNummer'] = $object_value_array['TagNummer'];
                    $giffile_array[$giffile_array_index]['FileName'] = $giffile;
                    $giffile_array[$giffile_array_index]['TxtErr'] = $giffile_err;
                    $giffile_array[$giffile_array_index]['TxtFalse'] = $giffile_false;
                    $giffile_array[$giffile_array_index]['TxtTrue'] = $giffile_true;
                    $giffile_array[$giffile_array_index]['PosLeftPixel'] = twips2pixels($object_value_array['PosLeft'], $TwipsPerPixelX);
                    $giffile_array[$giffile_array_index]['PosTopPixel'] = twips2pixels($object_value_array['PosTop'], $TwipsPerPixelX);
                    $giffile_array[$giffile_array_index]['PosWidthPixel'] = twips2pixels($object_value_array['PosWidth'], $TwipsPerPixelX);
                    $giffile_array[$giffile_array_index]['PosHeightPixel'] = twips2pixels($object_value_array['PosHeight'], $TwipsPerPixelX);
                    $giffile_array_index++;
                }
            break;
        }
    }
}
/* }}} */

echo '
<!-- Andy Geiss 2008 - 2010 -->
<html>

<head>
<meta http-equiv="expires" content="0">
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<meta http-equiv="imagetoolbar" content="no">
<title>',lang_text('preview'),'</title>';

/* {{{ CSS-Definitionen */
echo '
<link rel="stylesheet" type="text/css" href="flowchartedit.css">

<style type="text/css">
<!--
html, body{
    background-color: #d0d0d0;
}
#refresh_button{
    position: absolute;
    left: 10px; 
    top: 10px; 
    width: 180px; 
}';

foreach($giffile_array as $giffile){
    echo '
#gif',$giffile['ObjectNo'],'{
    position: absolute;
    left: ',$giffile['PosLeftPixel'] + $MarginLeft,'px; 
    top: ',$giffile['PosTopPixel'] + $MarginTop,'px; 
    width: ',$giffile['PosWidthPixel'],'px; 
    height: ',$giffile['PosHeightPixel'],'px;
}';
}

echo '
//-->
</style>';
/* }}} */

echo '
<script language="JavaScript">
<!--
self.focus();

function key_down_event(event){
    var keyCode;
    if(!event){
        event = window.event;
    }
    if(event.which){
        keyCode = event.which;
    }
    else{
        if(event.keyCode){
            keyCode = event.keyCode;
        }
    }
    //alert("Taste mit Dezimalwert " + keyCode + " gedrckt");
    
    // Esc
    if(keyCode == 27){
        window.close();
    }
}
document.onkeydown = key_down_event;';

// Title der Top-Location belegen, wenn gltige Session vorhanden
if(isset($sv->user) && strlen(trim($sv->user))){
    echo '
    top.document.title = "',lang_text('preview'),' - ',$sv->user,' - ',$sv->host,' - ',$sv->port,'";';
}

echo '
//-->
</script>
</head>

<body style="margin-top: ',$MarginTop,'; margin-left: ',$MarginLeft,';">

<!-- iFrame nur zum Testen -->
<!--iframe src="flowchartimage.php?register=',$register,$session_url_param2,'" width="1024" height="684"-->
<img src="flowchartimage.php?register=',$register,$session_url_param2,'">';

foreach($giffile_array as $giffile){
    if(strlen(trim($giffile['FileName']))){
        $imageSrc = $flowchart_dir.$giffile['FileName'];
    }
    else{
        $imageSrc = $transparentpixel_file;
    }

    echo '
<img name="gif',$giffile['ObjectNo'],'" id="gif',$giffile['ObjectNo'],'" alt="',$giffile['FileName'],'" 
    border="0" src="',$imageSrc,'">';
}

echo '
<input id="refresh_button" type="button" value="',lang_text('refresh'),'" onclick="location.reload()">

</body>
</html>';

if(!empty($fp)){
    socket_close($fp);
}

?>
