<?php

// vim: fdm=marker

/**********************
*  Andy Geiss 2010    *
*  Tabulatorweite: 4  *
**********************/

error_reporting(E_ALL);

ob_start();
require('functions.inc');
include('texts.inc');
ob_end_clean();

/* {{{ Variablen und Arrays belegen */
if(isset($_GET['regno']) && is_numeric($_GET['regno']) && $_GET['regno'] >= 0){
    $register_no = $_GET['regno'];
}
else{
    $register_no = 0;
}

$ini_array = load_ini($ini_filename);
$regno_array = get_regnos_from_ini_array($ini_array);
/* }}} */

echo '
<!-- Andy Geiss 2010 -->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>

<head>
<meta http-equiv="expires" content="0">
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
<meta http-equiv="imagetoolbar" content="no">
<title>',lang_text('register_sort'),'</title>';

/* {{{ CSS-Definitionen */
echo '
<link rel="stylesheet" type="text/css" href="flowchartedit.css">

<style type="text/css">
<!--
input, button{
    font-size: 12px;
}
td{
    font-size: 12px;
}
.register_select_size{
    height: 100px;
    width: 300px;
}
//-->
</style>';
/* }}} */

/* {{{ JavaScript-Funktionen */
echo '
<script type="text/javascript" src="functions.js"></script>

<script type="text/javascript">
<!--
self.focus();

function key_down_event(event){
    var keyCode;
    if(!event){
        event = window.event;
    }
    if(event.which){
        keyCode = event.which;
    }
    else{
        if(event.keyCode){
            keyCode = event.keyCode;
        }
    }
    //alert("Taste mit Dezimalwert " + keyCode + " gedrckt");

    // Esc
    if(keyCode == 27){
        cancel();
    }
}
document.onkeydown = key_down_event;

function save(){
    var register_no_load = Number.NaN;
    var register_select = document.sort_form.register_select;

    for(var i = 0; i < register_select.length; i++){
        opener.createSortFormHiddenInput(register_select.options[i].value, register_select.options[i].text);

        // Neue Registernummer der ursprnglich bergebenen ermitteln
        if(register_select.options[i].value == "regno',(int) $register_no,'"){
            register_no_load = i;
        }
    }

    if(isNaN(register_no_load)){
        opener.submitSortForm("sort_ini");
    }
    else{
        opener.submitSortForm("sort_ini", register_no_load);
    }

    window.close();
}

function cancel(){
    window.close();
}

// N TODO?: setRegisterTop()
function setRegisterUp(){
    var optSelected;
    var optTarget;
    var register_select = document.sort_form.register_select;
    var selectedIndex = register_select.selectedIndex;
    var targetIndex = register_select.selectedIndex - 1;

    if(selectedIndex >= 0 && targetIndex >= 0 && register_select.options[targetIndex]){
        optTarget = new Option(register_select.options[targetIndex].text, register_select.options[targetIndex].value);
        optSelected = new Option(register_select.options[selectedIndex].text, register_select.options[selectedIndex].value);
        register_select.options[selectedIndex] = optTarget;
        register_select.options[targetIndex] = optSelected;
        register_select.options[targetIndex].selected = true;
    }
}

function setRegisterDown(){
    var optSelected;
    var optTarget;
    var register_select = document.sort_form.register_select;
    var selectedIndex = register_select.selectedIndex;
    var targetIndex = register_select.selectedIndex + 1;

    if(selectedIndex >= 0 && targetIndex >= 0 && register_select.options[targetIndex]){
        optTarget = new Option(register_select.options[targetIndex].text, register_select.options[targetIndex].value);
        optSelected = new Option(register_select.options[selectedIndex].text, register_select.options[selectedIndex].value);
        register_select.options[selectedIndex] = optTarget;
        register_select.options[targetIndex] = optSelected;
        register_select.options[targetIndex].selected = true;
    }
}
// N TODO?: setRegisterBottom()
//-->
</script>';
/* }}} */

echo '
</head>

<body style="margin-top: 10px;">

<div align="center">
<form name="sort_form" action="',$_SERVER["SCRIPT_NAME"],'" method="POST">
<table border="0" cellpadding="1" cellspacing="0" summary="Form Table">
<tr>
    <td align="right" valign="top">';

    /* {{{ ListBox */
    echo '
    <select size="2" class="register_select_size" name="register_select">';
    foreach($regno_array as $register_digits){
        $tmp_regno = trim_zeros($register_digits);
        echo '
        <option value="regno',$tmp_regno,'"';
        if($tmp_regno == $register_no){
            echo ' selected';
        }
        $tmp_register_index = '[Register'.$register_digits.']';
        if(isset($ini_array[$tmp_register_index]['Caption']) 
        && strlen(trim($ini_array[$tmp_register_index]['Caption']))){
            $tmp_caption = $ini_array[$tmp_register_index]['Caption'];
        }
        else{
            $tmp_caption = '';
        }
        echo '>',$tmp_caption,'</option>';
    }
    echo '
    </select>';
    /* }}} */

    echo '
    </td><td align="left" valign="top">';

    /* {{{ Auf-/Ab-Buttons */
    echo '
    <table border="0" cellpadding="2" cellspacing="0" summary="Button Table">
    <tr>
        <td>
        <button name="btUp" type="button" title="',lang_text('up'),'"
            onclick="setRegisterUp()">
        <img name="imgUp" alt="',lang_text('up'),'" title="',lang_text('up'),'" 
            src="layer_up.gif" width="15" height="15">
        </button>
        </td>
    </tr><tr>
        <td>
        <button name="btDown" type="button" title="',lang_text('down'),'"
            onclick="setRegisterDown()">
        <img name="imgDown" alt="',lang_text('down'),'" title="',lang_text('down'),'" 
            src="layer_down.gif" width="15" height="15">
        </button>
        </td>
    </tr>
    </table>';
    /* }}} */

    echo '
    </td>
</tr><tr>
    <td colspan="2" align="center">';
    
    /* {{{ OK und Abrechen */
    echo '
    <table border="0" cellpadding="2" cellspacing="0" width="100%" summary="Button Table 2">
    <tr>
        <td align="right">
        <input type="button" name="submit_button" style="width: 100px;" value="',lang_text('save'),'" 
            onclick="save()">
        </td><td align="left">
        <input type="button" name="cancel_button" style="width: 100px;" value="',lang_text('cancel'),'"
            onclick="cancel()">
        </td>
    </tr>
    </table>';
    /* }}} */

    echo '
    ',$session_hidden_input,'
    </td>
</tr>
</table>
</form>
</div>

<script type="text/javascript">
<!--
if(document.sort_form.register_select.selectedIndex == -1
&& document.sort_form.register_select.length){
    document.sort_form.register_select.options[0].selected = true;
}
//-->
</script>

</body>
</html>';

?>
