<?php

// vim: fdm=marker

/**********************
*  Andy Geiss 2009    *
*  Tabulatorweite: 4  *
**********************/


/* {{{ Variablen belegen */
$error = '';
// Wenn Sprache bergeben -> bercksichtigen
$lang_id = get_var_from_post_or_get('lang');
// Ansonsten Browsersprache verwenden
if(empty($lang_id) && !empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])){
    $lang_id = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
}
$lang_id = trim(strtolower($lang_id));
if(!in_array($lang_id, array_keys($text_array))){
    $lang_id = 'en';
}

if(isset($STANDARD_CONFIG['STARTUP_ASK_FOR_SERVER']) && $STANDARD_CONFIG['STARTUP_ASK_FOR_SERVER'] == 1){
    $startup_ask_for_server = true;
}
else{
    $_POST['host'] = $_GET['host'] = $STANDARD_CONFIG['HOST'];
    $_POST['port'] = $_GET['port'] = $STANDARD_CONFIG['PORT'];
    $startup_ask_for_server = false;
}

// Wenn mindestens einer der Zugangsparameter angegeben wurde,
// werden keine Zugangsdaten aus der config.inc.php gelesen,
// bei fehlenden Angaben hpft der Cursor in das betreffende Eingabefeld
if(isset($_GET['host']) || isset($_GET['port']) || isset($_GET['user']) || isset($_GET['pwd'])){
    $get_url_param = true;
}
else{
    $get_url_param = false;
}

// Wenn alle erforderlichen Zugangsparameter angegeben wurden,
// werden diese unmittelbar an $_POST fr $svadmin->connect bergeben
// und $_POST['login'] wird gesetzt, damit $svadmin->connect sofort
// durchgefhrt wird
if(isset($_GET['host']) && isset($_GET['port']) && isset($_GET['user'])
&& (isset($_GET['cpwd']) || isset($_GET['pwd']))){
    if(isset($_GET['lang'])){
        $_POST['lang'] = $_GET['lang'];
    }
    $_POST['host'] = $_GET['host'];
    $_POST['port'] = $_GET['port'];
    $_POST['user'] = $_GET['user'];
    if(isset($_GET['cpwd'])){
        $_POST['cpwd'] = convert_spaces_to_plus($_GET['cpwd']);
    }
    if(isset($_GET['pwd'])){
        $_POST['pwd'] = $_GET['pwd'];
    }
    $_POST['login'] = 1;
}

$user = get_var_from_post_or_get('user');
if(empty($user) && !$get_url_param){
    $user = $STANDARD_CONFIG['USER'];
}
$host = get_var_from_post_or_get('host');
if(empty($host) && !$get_url_param){
    $host = $STANDARD_CONFIG['HOST'];
}
$port = get_var_from_post_or_get('port');
if(empty($port) && !$get_url_param){
    $port = $STANDARD_CONFIG['PORT'];
}
$pwd = get_var_from_post_or_get('pwd');
if(empty($pwd) && !$get_url_param){
    $pwd = $STANDARD_CONFIG['PWD'];
}
if(isset($_POST['login']) && $_POST['login'] == 1){
    $login_submitted = true;
}
else{
    $login_submitted = false;
}
/* }}} */

/* {{{ Login */
// Wenn Login-Button gedrckt wurde oder alle erforderlichen
// Zugangsparameter angegeben wurden
if($login_submitted){
    destroy_session();
    start_session($svadmin, false, 'scalarvis_admin');
    $svadmin->lang_id = $lang_id;

    if(!$svadmin->connect()){
        destroy_session();
        $error = get_sv_socket_errorstr_from_errno($svadmin->lang_id, $svadmin->get_socket_errno(), $svadmin->get_socket_last_error());
    }
    else{
        $svadmin->load_user_properties();
        store_session($svadmin);
        $href_string = 'index.php?content=admin&session_name='.$svweb_session_name;
        echo '
        <script type="text/javascript">
        <!--
        location.href="',$href_string,'";
        //-->
        </script>';
    }

    if($STANDARD_CONFIG['WRITE_LOGFILES']){
        if(!empty($error)){
            $tmp_status = $error;
        }
        else{
            $tmp_status = 'CONNECTED';
        }
        write_logfile('ADMIN', $user, $host, $port, $tmp_status, "..".$g_path_separator);
    }

    // Wenn $href_string fr Login belegt, Loginmaske nicht mehr anzeigen
    if(!empty($href_string)){
        exit();
    }
}
/* }}} */

include('admin_top.inc.php');

/* {{{ Loginmaske */
echo '
</head>

<body>
<script type="text/javascript">
<!--
/* {{{ JavaScript-Funktion check_input() - Eingaben im Login-Formular berprfen */
// berprft auf fehlende Eingaben im Login-Formular
function check_input(){
    if(!check_input_element(login.user)){
        return false;
    }';
    if($startup_ask_for_server){
        echo '
    if(!check_input_element(login.host)){
        return false;
    }
    if(!check_input_element(login.port)){
        return false;
    }';
    }
    echo '
    if(!check_input_element(login.pwd)){
        return false;
    }
    login.loginbutton.focus();
    return true;
}

// Input-Element auf Inhalt prfen
function check_input_element(element){
    if(trim(element.value) == ""){
        element.focus();
        HighlightInputError(element);
        return false;
    }
    else{
        LowlightInputError(element);
        return true;
    }
}
/* }}} */
//-->
</script>';
/* {{{ HTML-Login-Formular */
echo '
<div align="center" style="margin-top: 50px">
<form name="login" action="',$g_actionfile,'" method="post" onsubmit="return check_input()">

<table class="login" border="0" cellspacing="0" cellpadding="20" width="450" summary="Login Form">
<tr>
    <td class="login" align="center"><img src="login_logo.png" alt="Admin"></td>
</tr><tr>
    <td class="login" style="font-size: 16px; font-weight: bold; color: #ff0000;" align="center">A&nbsp;d&nbsp;m&nbsp;i&nbsp;n</td>
</tr><tr>
    <td class="login" align="center">

    <table class="login_subtable" border="0" cellspacing="0" cellpadding="2" summary="Login Table">
    <tr>
        <td class="login_subtable login_subtable_left login_subtable_top" align="right">',$text_array[$lang_id]['user'],':</td>
        <td class="login_subtable login_subtable_right login_subtable_top">
        <input class="login_subtable" type="text" name="user" value="">
        </td>';
    if($startup_ask_for_server){
    echo '
    </tr><tr>
        <td class="login_subtable login_subtable_left" align="right">',$text_array[$lang_id]['host'],':</td>
        <td class="login_subtable login_subtable_right">
        <input class="login_subtable" type="text" name="host" value="',$host,'">
        </td>
    </tr><tr>
        <td class="login_subtable login_subtable_left" align="right">',$text_array[$lang_id]['port'],':</td>
        <td class="login_subtable login_subtable_right">
        <input class="login_subtable" type="text" name="port" value="',$port,'">
        </td>';
    }
    echo '
    </tr><tr>
        <td class="login_subtable login_subtable_left" align="right">',$text_array[$lang_id]['pwd'],':</td>
        <td class="login_subtable login_subtable_right">
        <input class="login_subtable" type="password" name="pwd" value="">
        </td>
    </tr><tr>
        <td class="login_subtable login_subtable_left login_subtable_bottom" align="right">',$text_array[$lang_id]['lang'],':</td>
        <td class="login_subtable login_subtable_right login_subtable_bottom">
        <select class="login_subtable" name="lang">';
    foreach(array_keys($text_array) as $text_array_key){
        echo '
        <option value="',$text_array_key,'"',($lang_id == $text_array_key?' selected':''),'>'
        ,$text_array[$text_array_key]['self'],'</option>';
    }
        echo '
        </select>
        </td>
    </tr>
    </table>

    </td>
</tr><tr>
    <td class="login" align="center">
    <input type="hidden" name="login" value="1">
    <input type="hidden" name="cpwd">
    <input class="loginbutton" name="loginbutton" type="submit" value="',$text_array[$lang_id]['login'],'">
    <script type="text/javascript">
    <!--
    check_input();
    //-->
    </script>
    </td>
</tr>';
if(!empty($error)){
    echo '
    <tr>
        <td class="login" style="color: ff0000; font-weight: bold;" align="center">
        ',$error,'
        </td>
    </tr>';
}
echo '
</table>

</form>
</div>
</body>';
/* }}} */
/* }}} */

include('admin_bottom.inc.php');

?>
