<?php

// vim: fdm=marker

/* * *************************
 *  Andy Geiss 2009 - 2010  *
 *  Tabulatorweite: 4       *
 * ************************* */

header('Cache-Control: no-cache, must-revalidate');
header('Expires: Mon, 26 Jul 1997 00:00:00 GMT');
header('Content-type: text/html; charset=ISO-8859-1');

ob_start();
require('scalarvis.inc.php');
ob_end_clean();

error_reporting(0);

if (!start_session($sv)) {
    session_no_longer_valid_msg('en', false);
}

if (!$sv->connect()) {
    echo '<br>', get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    exit;
}

switch ($_GET['ajax_action']) {
    /* {{{ delete_diagramarray_index */
    case 'delete_diagramarray_index':
        if (strlen(trim($diagram_index)) && isset($sv->diagramarray[$diagram_index])) {
            $sv->delete_diagramarray_index($diagram_index);
        }
        break;
    /* }}} */

    /* {{{ diagram_refresh */
    case 'diagram_refresh':
        if (isset($_GET['increment']) && is_numeric($_GET['increment'])) {
            $increment = $_GET['increment'];
            $type = (isset($_GET['type']) ? $_GET['type'] : 0);
            if (strlen(trim($diagram_index)) && isset($sv->diagramarray[$diagram_index])) {
                $svsc = $sv->diagramarray[$diagram_index];
                if ($svsc->refresh_busy) {
                    echo false;
                } else {
                    $svsc->time_start += $increment;
                    $svsc->time_end += $increment;
                    $data = null;
                    $AutoScale = array();
                    if ($sv->get_diagram_data($type, $diagram_index, $data)) {
                        $anzval = (isset($data[0][2]) ? (int) $data[0][2] : 0);
                        $AutoScale = getAutoScale($sv, $svsc, $anzval, $type);
                    }
                    $responseText = $svsc->show_timeframe($sv->lang_id, $data);
                    for ($i = 0; $i < $AutoScale['anz_werte']; $i++) {
                        $responseText .= ';';
                        $responseText .= $AutoScale['min_' . $i];
                        $responseText .= ';';
                        $responseText .= $AutoScale['max_' . $i];
                    }
                    echo $responseText;
                }
            }
        }
        break;
    /* }}} */

    /* {{{ diagram_scroll */
    case 'diagram_scroll':
        if (isset($_GET['scroll_factor']) && is_numeric($_GET['scroll_factor'])) {
            $scroll_factor = $_GET['scroll_factor'];
            $type = (isset($_GET['type']) ? $_GET['type'] : 0);
            if (isset($_GET['direction']) && strlen(trim($_GET['direction']))) {
                $direction = $_GET['direction'];
            } else {
                $direction = 'forward';
            }

            if (strlen(trim($diagram_index)) && isset($sv->diagramarray[$diagram_index])) {
                $svsc = $sv->diagramarray[$diagram_index];

                if ($svsc->refresh_busy) {
                    echo false;
                } else {
                    $current_diff = $svsc->time_end - $svsc->time_start;
                    $scroll_diff = (int) round($current_diff / 100 * $scroll_factor);

// Rckwrts scrollen
                    if ($direction == 'back') {
                        $svsc->time_start -= $scroll_diff;
                        $svsc->time_end -= $scroll_diff;
                    }
// Vorwrts scrollen
                    else {
                        $svsc->time_start += $scroll_diff;
                        $svsc->time_end += $scroll_diff;
                    }

                    $current_time = time();
                    if ($svsc->time_end > $current_time) {
                        $future_diff = $svsc->time_end - $current_time;
                        $svsc->time_end = $current_time;
                        $svsc->time_start -= $future_diff;
                    }

                    $data = null;
                    $AutoScale = array();
                    if ($sv->get_diagram_data($type, $diagram_index, $data)) {
                        $anzval = (isset($data[0][2]) ? (int) $data[0][2] : 0);
                        $AutoScale = getAutoScale($sv, $svsc, $anzval, $type);
                    }
                    $responseText = $svsc->show_timeframe($sv->lang_id, $data);
                    for ($i = 0; $i < $AutoScale['anz_werte']; $i++) {
                        $responseText .= ';';
                        $responseText .= $AutoScale['min_' . $i];
                        $responseText .= ';';
                        $responseText .= $AutoScale['max_' . $i];
                    }

                    echo $responseText;
                }
            }
        }
        break;
    /* }}} */

    /* {{{ diagram_zoom */
    case 'diagram_zoom':
        if (isset($_GET['zoom_factor']) && is_numeric($_GET['zoom_factor']) && isset($_GET['zoom_align'])) {
            $zoom_factor = $_GET['zoom_factor'];
            $zoom_align = $_GET['zoom_align'];
            $type = (isset($_GET['type']) ? $_GET['type'] : 0);
            if (isset($_GET['direction']) && strlen(trim($_GET['direction']))) {
                $direction = $_GET['direction'];
            } else {
                $direction = 'in';
            }

            if (strlen(trim($diagram_index)) && isset($sv->diagramarray[$diagram_index])) {
                $svsc = $sv->diagramarray[$diagram_index];

                if ($svsc->refresh_busy) {
                    echo false;
                } else {
// Zoom Out
                    if ($direction == 'out') {
                        $zoom_diff = (int) round($svsc->zoom_org_time_diff / 100 * $zoom_factor);

                        switch ($zoom_align) {
                            case 'left':
                                $svsc->time_end += $zoom_diff;
                                break;
                            case 'right':
                                $svsc->time_start -= $zoom_diff;
                                break;
                            default:
                                $svsc->time_start -= (int) round($zoom_diff / 2);
                                $svsc->time_end += (int) round($zoom_diff / 2);
                                break;
                        }

                        $current_time = time();
                        if ($svsc->time_end > $current_time) {
                            $future_diff = $svsc->time_end - $current_time;
                            $svsc->time_end = $current_time;
                            $svsc->time_start -= $future_diff;
                        }
                    }
// Zoom zurcksetzen
                    else if ($direction == 'org') {
                        $current_diff = $svsc->time_end - $svsc->time_start;
                        $zoom_diff = $current_diff - $svsc->zoom_org_time_diff;

                        switch ($zoom_align) {
                            case 'left':
                                $svsc->time_end -= $zoom_diff;
                                break;
                            case 'right':
                                $svsc->time_start += $zoom_diff;
                                break;
                            default:
                                $svsc->time_start += (int) round($zoom_diff / 2);
                                $svsc->time_end -= (int) round($zoom_diff / 2);
                                break;
                        }

                        $current_time = time();
                        if ($svsc->time_end > $current_time) {
                            $future_diff = $svsc->time_end - $current_time;
                            $svsc->time_end = $current_time;
                            $svsc->time_start -= $future_diff;
                        }
                    }
// Zoom In (nur wenn Start-Zeit dadurch nicht nach Ende-Zeit liegt)
                    else {
                        $zoom_diff = (int) round($svsc->zoom_org_time_diff / 100 * $zoom_factor);

                        if ($svsc->time_start + ($zoom_diff / 2) < $svsc->time_end - ($zoom_diff / 2)) {
                            switch ($zoom_align) {
                                case 'left':
                                    $svsc->time_end -= $zoom_diff;
                                    break;
                                case 'right':
                                    $svsc->time_start += $zoom_diff;
                                    break;
                                default:
                                    $svsc->time_start += (int) round($zoom_diff / 2);
                                    $svsc->time_end -= (int) round($zoom_diff / 2);
                                    break;
                            }
                        }
                    }

                    $data = null;
                    $AutoScale = array();
                    if ($sv->get_diagram_data($type, $diagram_index, $data)) {
                        $anzval = (isset($data[0][2]) ? (int) $data[0][2] : 0);
                        $AutoScale = getAutoScale($sv, $svsc, $anzval, $type);
                    }
                    $responseText = $svsc->show_timeframe($sv->lang_id, $data);
                    for ($i = 0; $i < $AutoScale['anz_werte']; $i++) {
                        $responseText .= ';';
                        $responseText .= $AutoScale['min_' . $i];
                        $responseText .= ';';
                        $responseText .= $AutoScale['max_' . $i];
                    }
                    echo $responseText;
                }
            }
        }
        break;
    /* }}} */

    /* {{{ get_tag_info */
    case 'get_tag_info':
        if (isset($_GET['tag_nr']) && isset($_GET['tag_index'])) {
            $sv->add_tag_to_tagauswahl($_GET['tag_nr'], $_GET['tag_index']);
        }
        break;
    /* }}} */

    /* {{{ get_txt_err_true_false */
    case 'get_txt_err_true_false':
        if (isset($_GET['tag_nr']) && is_numeric($_GET['tag_nr'])) {
            if ($_GET['tag_nr'] != 0) {
                if ($sv->get_tag_info_array($_GET['tag_nr'], $tmp_tag_info_array)) {
                    $tmp_value = $tmp_tag_info_array['wert'];
                    if ($tmp_value == -1.0e38) {
                        $responseText = 'TxtErr';
                    } else if ($tmp_value == 0.0) {
                        $responseText = 'TxtFalse';
                    } else {
                        $responseText = 'TxtTrue';
                    }
                }
            } else {
                $responseText = 'TxtErr';
            }

            echo $responseText;
        }
        break;
    /* }}} */

    /* {{{ get_txt_err_trueX_false */
    case 'get_txt_err_trueX_false':
        if (isset($_GET['tag_nr']) && is_numeric($_GET['tag_nr'])) {
            if ($_GET['tag_nr'] != 0) {
                if ($sv->get_tag_info_array($_GET['tag_nr'], $tmp_tag_info_array)) {
                    $tmp_value = $tmp_tag_info_array['wert'];
                    if ($tmp_value == -1.0e38) {
                        $responseText = 'TxtErr';
                    } else if ($tmp_value == 0.0) {
                        $responseText = 'TxtFalse';
                    } else {
                        $trueNr = 0;
                        $responseText = 'TxtTrue';
                        if (isset($_GET['typ_nr']) && is_numeric($_GET['typ_nr'])) {
                            $trueNr = $_GET['typ_nr'];
                            if ($trueNr == 21) {
                                if (isset($_GET['val1']) && is_numeric($_GET['val1'])) {
                                    $val1 = $_GET['val1'];
                                }
                                if (isset($_GET['val2']) && is_numeric($_GET['val2'])) {
                                    $val2 = $_GET['val2'];
                                }
                                if (isset($_GET['val3']) && is_numeric($_GET['val2'])) {
                                    $val3 = $_GET['val3'];
                                }

                                if ($tmp_value == $val1) {
                                    $responseText = 'TxtTrue1';
                                } else if ($tmp_value == $val2) {
                                    $responseText = 'TxtTrue2';
                                } else if ($tmp_value == $val3) {
                                    $responseText = 'TxtTrue3';
                                }
                            }
                        }
                    }
                }
            } else {
                $responseText = 'TxtErr';
            }

            echo $responseText;
        }
        break;
    /* }}} */

    /* {{{ info_refresh */
    case 'info_refresh':
        if (isset($sv->tagauswahl[$_GET['tag_index']]) && isset($_GET['tag_field'])) {
            switch ($_GET['tag_field']) {
                case 'wert':
                    echo tag_value_format((float) $sv->tagauswahl[$_GET['tag_index']][$_GET['tag_field']], (float) $sv->tagauswahl[$_GET['tag_index']]['nach'] ); //, 'wr';
                    break;
                default:
                    echo $sv->tagauswahl[$_GET['tag_index']][$_GET['tag_field']];
                    break;
            }
        }
        break;
    /* }}} */

    /* {{{ set_and_refresh_tag_info_field */
    case 'set_and_refresh_tag_info_field':
        if (isset($sv->tagauswahl[$_GET['tag_index']]) && isset($_GET['tag_field']) && isset($_GET['tag_field_value'])) {
            $sv->tagauswahl[$_GET['tag_index']][$_GET['tag_field']] = trim($_GET['tag_field_value']);
            echo $sv->tagauswahl[$_GET['tag_index']][$_GET['tag_field']];
        }
        break;
    /* }}} */

    /* {{{ set_tag_info_field */
    case 'set_tag_info_field':
        if (isset($sv->tagauswahl[$_GET['tag_index']]) && isset($_GET['tag_field']) && isset($_GET['tag_field_value'])) {
            $sv->tagauswahl[$_GET['tag_index']][$_GET['tag_field']] = trim($_GET['tag_field_value']);
        }
        break;
    /* }}} */

    /* {{{ switch_refresh (tag_values) */
    case 'switch_refresh':
        if (isset($_GET['checked'])) {
            if ($_GET['checked'] == 'true') {
                $sv->refresh_tag_values = true;
            } else {
                $sv->refresh_tag_values = false;
            }
        }
        break;
    /* }}} */

    /* {{{ switch_refresh_diagram */
    case 'switch_refresh_diagram':
        if (isset($_GET['checked'])) {
            if (strlen(trim($diagram_index)) && isset($sv->diagramarray[$diagram_index])) {
                if ($_GET['checked'] == 'true') {
                    $sv->diagramarray[$diagram_index]->refresh_diagram = true;
                } else {
                    $sv->diagramarray[$diagram_index]->refresh_diagram = false;
                }
            }
        }
        break;
    /* }}} */

    /* {{{ switch_refresh_flowchart */
    case 'switch_refresh_flowchart':
        if (isset($_GET['checked'])) {
            if ($_GET['checked'] == 'true') {
                $sv->refresh_flowchart = true;
            } else {
                $sv->refresh_flowchart = false;
            }
        }
        break;
    /* }}} */

    /* {{{ refresh_servertime */
    case 'refresh_servertime':
        echo (float) $sv->get_server_utc_time();
        break;
    /* }}} */

    /* {{{ switch_tag_checkbox */
    case 'switch_tag_checkbox':
        if (isset($_GET['checked']) && isset($_GET['tag_index'])) {
            if (strlen(trim($diagram_index)) && isset($sv->diagramarray[$diagram_index])) {
                $svsc = $sv->diagramarray[$diagram_index];
                if ($_GET['checked'] == 'true') {
                    $svsc->tagauswahl[$_GET['tag_index']]['hide_tag'] = 0;
                } else {
                    $svsc->tagauswahl[$_GET['tag_index']]['hide_tag'] = 1;
                }
            }
        }
        break;
    /* }}} */

    /* {{{ value_refresh (tag_value) */
    case 'value_refresh':
        if (isset($sv->tagauswahl[$_GET['tag_index']])) {
            if ($sv->actual_value($sv->tagauswahl[$_GET['tag_index']]['nummer'], $value)) {
                $sv->tagauswahl[$_GET['tag_index']]['wert'] = $value;
                if (strlen(trim($value)) && is_numeric($value)) {
                    echo tag_value_format((float) $value, (float) $sv->tagauswahl[$_GET['tag_index']]['nach'] ); //, 'r';
                }
            }
        }
        break;
    /* }}} */

    case 'write_ini_section':
        $params = getParamsFromInput();
        $arrData = array();
        foreach ($params as $paramkey => $paramvalue) {
            if ($paramkey != 'ajax_action' && $paramkey != 'section' && $paramkey != 'session_name') {
                $arrData[$paramkey] = $paramvalue;
            }
        }
        echo writeIniSection($sv, $params['section'], $arrData);
        break;
}

store_session($sv);

/**
 * holt die per POST oder GET bergebenen Daten und screibt sie in ein Array
 * @todo Vailidierung und Suberung der bergebene Parameter, damit keine unerwnschten Dinge bergeben werden (XSS, SQL-Injection)
 *
 * @return array
 */
function getParamsFromInput() {
    $params = array();
// unsicher, die bergebenen Paramater sollten mit einer Filterklasse validiert und gesubert werden
    if (strtolower($_SERVER['REQUEST_METHOD']) == 'post') {
        foreach ($_POST as $postkey => $postvalue) {
            $params[$postkey] = $postvalue;
        }
    } else {
        foreach ($_GET as $getkey => $getvalue) {
            $params[$getkey] = $getvalue;
        }
    }
    return $params;
}
?>