<?php

// vim: fdm=marker

/**********************
*  Andy Geiss 2009    *
*  Tabulatorweite: 4  *
**********************/

// Basis-Funktionen, die auch fr die Fliebild-Editor-Vorschau (scalarvis_ext class) bentigt werden

/* {{{ PHP-Includes */
require_once('crypt.inc.php');
/* }}} */

/* {{{ PHP-Funktion ForeColor2RGB() - Generiert aus einem Integer-Wert ein Array mit RGB-Werten */
function ForeColor2RGB($sv_fore_color){
    if(is_numeric($sv_fore_color) && $sv_fore_color >= 0){
        $tmp_color = sprintf('%06x', $sv_fore_color);
        $retval[2] = hexdec(substr($tmp_color, 0, 2));  // Blau
        $retval[1] = hexdec(substr($tmp_color, 2, 2));  // Grn
        $retval[0] = hexdec(substr($tmp_color, 4, 2));  // Rot
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion localdate() - Formatiert ein(e) angegebene(s) Zeit/Datum (mit Zeitzonen verwendbar/erweiterbar) */
function localdate($format, $timestamp = null){
    global $g_timezone_identifier;
    $retval = '';

    $retval = date($format, $timestamp);

    // DateTime(Zone)-Klasse funzt erst ab PHP-Version >= 5.2.0, besser >= 5.2.6
//    if(!empty($g_timezone_identifier)){
//        $timezone = new DateTimeZone($g_timezone_identifier);
//        $datetime = new DateTime($retval);
//        $datetime->setTimezone($timezone);
//        $retval = $datetime->format($format); 
//    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion localdate_std() - localdate()-Standardformatierung */
function localdate_std($timestamp = null, $german = false){
    if($german){
        $format = 'd.m.Y H:i:s';
    }
    else{
        $format = 'Y-m-d H:i:s';
    }
    $retval = '';

    if(empty($timestamp)){
        $retval = localdate($format);
    }
    else{
        $retval = localdate($format, $timestamp);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion optimum_decimal_places() - Optimale Dezimalstellen einer Zahl ermitteln */
function optimum_decimal_places($value, $addition = 0){
    $retval = 0;

    $value = abs($value);

    if($value < 0.0001){
        $retval = 8;
    }
    else if($value < 0.001){
        $retval = 7;
    }
    else if($value < 0.01){
        $retval = 6;
    }
    else if($value < 0.1){
        $retval = 5;
    }
    else if($value < 1){
        $retval = 4;
    }
    else if($value < 10){
        $retval = 3;
    }
    else if($value < 100){
        $retval = 2;
    }
    else if($value < 1000){
        $retval = 1;
    }

    $retval += $addition;

    if($retval < 0){
        $retval = 0;
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion percent_of_range() - Anteil eines Bereichs ermitteln */
function percent_of_range($start, $end, $percent){
    $retval = 0;
    $range = 0;

    if(is_numeric($start) && is_numeric($end)){
        $range = $end - $start;
    }

    if(is_numeric($percent)){
        $retval = $range / 100 * $percent;
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion socket_write_all() - Socket-Write in Schleife */
function socket_write_all(&$socket, $socket_buffer, $loop = true){
    global $STANDARD_CONFIG; 
    $retval = false;
    $written = false;
    $len = strlen($socket_buffer);
    $offset = 0;

    if(isset($STANDARD_CONFIG['OLD_SOCKET_HANDLING']) 
    && $STANDARD_CONFIG['OLD_SOCKET_HANDLING']){
        $old_socket_handling = true;
    }
    else{
        $old_socket_handling = false;
    }

    if($loop && !$old_socket_handling){
        while($offset < $len){
            $sent = socket_write($socket, substr($socket_buffer, $offset), $len - $offset);
            //echo '<br />sent: ',$sent;
            if($sent === false){
                break;
            }
            $written = true;
            $offset += $sent;
        }

        if($written){
            $retval = $offset;
        }
    }
    else{
        $retval = socket_write($socket, $socket_buffer, $len);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion socket_read_all() - Socket-Read in Schleife */
function socket_read_all(&$socket, $len, $binary = false, $loop = true){
    global $STANDARD_CONFIG; 
    $offset = 0;
    $socket_buffer = '';

    if(isset($STANDARD_CONFIG['OLD_SOCKET_HANDLING']) 
    && $STANDARD_CONFIG['OLD_SOCKET_HANDLING']){
        $old_socket_handling = true;
    }
    else{
        $old_socket_handling = false;
    }

    if($loop && !$old_socket_handling){
        $read = array($socket);
        while($offset < $len){
            if(($data = @socket_read($socket, $len - $offset)) === false){
                break;
            }

            $dataLen = strlen($data);
            $offset += $dataLen;
            $socket_buffer .= $data;
            $write = null;
            $except = null;
            if($dataLen == 0 || (!$binary && stristr($data, "\n") !== false)
            || $offset >= $len || socket_select($read, $write, $except, 1) < 1){
                break; 
            }
        }
    }
    else{
        $socket_buffer = @socket_read($socket, $len);
    }

    return $socket_buffer;
}
/* }}} */

?>
