<?php

/**********************
*  Crypt-Funktionen   *
*  Andy Geiss 2005    *
*  Tabulatorweite: 4  *
**********************/

/**
 * @return string
 * @param string string timestamp
 * @desc Verschlsselt den bergebenen Wert inkl. dem aktuellen Zeitpunkt
 */
function time_encrypt($uncoded_value, $timestamp=''){
    $retval = '';

    // Wenn Zeit nicht bergeben, aktuelle Zeit verwenden
    if($timestamp == ''){
        $timestamp = time();
    }

    // Timestamp mit Nullen fllen, falls ntig
    if(strlen($timestamp)<10){
        $tmp_diff = 10 - strlen($timestamp);
        for($i=0; $i<$tmp_diff; $i++){
            $timestamp = '0'.$timestamp;
        }
    }

    $retval = psgencrypt($timestamp.$uncoded_value);
    $retval = base64_encode($retval);
    return $retval;
}

/**
 * @return array
 * @param string string
 * @desc Entschlsselt den bergebenen Wert inkl. dem darin hinterlegten Zeitpunkt
 */
function time_decrypt($coded_value){
    $retval = array();
    $retval['decoded_timestamp'] = '';
    $retval['decoded_value'] = '';

    $coded_value = base64_decode($coded_value);
    $decoded_value = psgdecrypt($coded_value);
    $retval['decoded_timestamp'] = substr($decoded_value,0,10);
    $retval['decoded_value'] = substr($decoded_value,10);
    return $retval;
}

/**
 * @return string
 * @param string
 * @desc Passwort Verschleierung
 */
function psgencrypt($input){
    if(strlen($input)){
		$a=-1;
	    $output = "";
	    do{
	    	$a ++;
	    	if(($a%2)==0){
	    		$byte=$input{$a/2};
	    		$byte= ord($byte); // String to ASCII
	    		$work=($byte & 0xAA)>>1; // Bitmaske
	    		}
	    	else{
	    		$work=($byte & 0x55); // Bitmaske
	    		}
	    	do  {
	    		srand ((double)microtime()*1000000); //Zufallsgenerator einstellen
	    		$work = ($work & 0x55)| (rand () & 0x2A);
	    		}
	    	while(($work<= 0x21)||($work>= 0x7E)||($work == 58)||($work == 44)||($work == 38)||($work == 61)||($work == 63)); // Abbruchbedingung 1 und 2 Darstellbarer ASCII- Wert, 3 = nicht ":" , 4 = nicht ","
	       	$output{$a} = $work;
	       	$output{$a} = sprintf("%c",$output{$a});}
	    while($a < (strlen($input) * 2) - 1);
	    $output = join("",$output);
	    return $output;
    }
    else
    	return($input);
}

/**
 * @return string
 * @param string
 * @desc Passwort Entschleierung
 */
function psgdecrypt($input){
    for($i=0; $i<strlen($input)/2; $i++){
        $output[$i] = ((ord($input[2 * $i]) & 0x000055) << 1) | (ord($input[(2 * $i) + 1]) & 0x000055);
        $output[$i] = sprintf("%c",$output[$i]);
    }
    $output = join("",$output);
    return $output;
}

/**
 * @return string
 * @param string
 * @desc Wandelt Leerzeichen in Plus-Zeichen um
 */
function convert_spaces_to_plus($string_to_convert){
    $tmp_value = "";
    for($i=0;$i<strlen($string_to_convert);$i++){
        $tmp_substr = substr($string_to_convert,$i,1);
        if($tmp_substr==' '){
            $tmp_value .= '+';
        }
        else{
            $tmp_value .= $tmp_substr;
        }
    }
    return $tmp_value;
}

?>
