<?php

// vim: fdm=marker

/***************************
*  Andy Geiss 2009 - 2010  *
*  Tabulatorweite: 4       *
***************************/


ob_start();
require('scalarvis.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if(!start_session($sv)){
    session_no_longer_valid_msg();
}

if(!$sv->connect()){
    echo '<br />',get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    jsEscWindowClose();
    exit;
}

/* {{{ Variablen festlegen */
if(isset($_GET['type'])){
    $type = trim($_GET['type']);
    switch($type){
    case 'universal':
        $type_text = $text_array[$sv->lang_id]['diagram_universal'];
        break;
    case 'single':
        $type_text = $text_array[$sv->lang_id]['diagram_single'];
        break;
    case 'detail':
        $type_text = $text_array[$sv->lang_id]['diagram_detail'];
        break;
    case 'trend':
        $type_text = $text_array[$sv->lang_id]['diagram_trend'];
        break;
    default:
        $type_text = '';
        break;
    }
}
else{
    jsEscWindowClose();
    exit('No diagram type defined!');
}

if(isset($_GET['zoom_align']) && strlen(trim($_GET['zoom_align']))){
    $zoom_align = $_GET['zoom_align'];
}
else{
    $zoom_align = 'center';
}
//fuer Fliessbild --> "fliess"
$view='';
if(isset($_GET['view'])){
    $view = trim($_GET['view']);
}

if(strlen($view)){
	if(isset($_GET['tagnr']) && strlen(trim($_GET['tagnr']))){
		$tagnr = trim($_GET['tagnr']);
		if(is_numeric($tagnr) && ($tagnr > 0)){
			$sv->add_tag_to_tagauswahl_fliess($tagnr);
		}
		else{
			jsEscWindowClose('No SV_TAG defined!');
			exit('No SV_TAG defined!');
		}
	}
}//nur bei Fliessbild

$colors = array(array(0, 0, 255), array(255, 0, 0), array(0, 100, 100), array(150, 90, 255), array(200, 0, 120), array(200, 100, 0));
//$colors = array(array(0, 0, 0), array(0, 0, 0), array(0, 0, 0), array(0, 0, 0), array(0, 0, 0), array(0, 0, 0));
//wie im messvb1
//$colors = array(array(0, 0, 255), array(255, 0, 0), array(128, 128, 0), array(128, 64, 64), array(255, 255, 0), array(255, 0, 255));

// Diagramm-Instanz erstellen, wenn bergebener Index nicht bereits existiert
if(!strlen(trim($diagram_index)) || !isset($sv->diagramarray[$diagram_index])){
    $diagram_index = $sv->create_diagramarray_index($view);
}
//print_r_formatted($sv->diagramarray);
// Lokale Referenz auf die Scalarvis-Short-Class-Instanz alias Kopie der Hauptinstanz erstellen
$svsc = $sv->diagramarray[$diagram_index];

if(is_numeric($svsc->number_of_tags) && $svsc->number_of_tags > 0){
    $number_of_tags = (int) $svsc->number_of_tags;
}
else{
    $number_of_tags = 0;
}

// Keine Tags ausgewhlt
if(!count($svsc->tagauswahl)){
    jsWindowClose($text_array[$sv->lang_id]['no_tags_selected'].'!');
    exit($text_array[$sv->lang_id]['no_tags_selected'].'!');
}

$anzval = 0;
ksort($svsc->tagauswahl);
$keys = array_keys($svsc->tagauswahl);
$run = count($keys);
/* }}} */

/* {{{ Daten aufbereiten und Darstellung bestimmen */
// Am Ende stehen alle errechneten Werte in $Autoscaling
$data = null;
if($sv->get_diagram_data($type, $diagram_index, $data)){
    $anzval = (int) $data[0][2];

    if($anzval > 0){
        $AutoScale = getAutoScale($sv, $svsc, $anzval, $type);

        for($i = 0; $i < $run; $i++){
            if($svsc->tagauswahl[$keys[$i]]['nummer'] > 0){
                $tmp_col = RGB2ForeColor($colors[$i]);
                $svsc->tagauswahl[$keys[$i]]['linecolor'] = $tmp_col;
            }
        }
        if(isset($svsc->ks_auswahl) && isset($svsc->ks_auswahl[25])){
            for($i = 0; $i < $run; $i++){
                if($svsc->tagauswahl[$keys[$i]]['nummer'] > 0){
                    // Anzahl-Tags-Relevanz -> Offset ks_auswahl
                    $svsc->tagauswahl[$keys[$i]]['linecolor'] = $svsc->ks_auswahl[25 + $i];
                    $tmp_col = ForeColor2RGB($svsc->ks_auswahl[25 + $i]);
                    $colors[$i][0] = $tmp_col[0];
                    $colors[$i][1] = $tmp_col[1];
                    $colors[$i][2] = $tmp_col[2];
                }
            }
        }
    }
}

// Wenn ein Kurvensatz angezeigt werden soll, wird die Bezeichnung in die berschrift gesetzt
(isset($svsc->ks_auswahl)?$ks_bezeichnung = htmlspecialchars($svsc->ks_auswahl[1]):$ks_bezeichnung = '');
$ks_bezeichnung = trim($ks_bezeichnung);
/* }}} */

include('cont_top.inc.php');

echo '
<script type="text/javascript">
<!--
var ajaxRefreshDiagramIsBusy = false;
var refreshInterval;';
if(strlen(trim($type_text))){
    echo '
    document.title = "',trim($type_text.' '.line_breaks2spaces(dotted_if_too_long($ks_bezeichnung, 45))),'";';
}

if(isset($sv->sysinfo['refresh']) && is_numeric($sv->sysinfo['refresh']) && $sv->sysinfo['refresh'] > 0){
    // Inkrement fr Timestamps in Sekunden
    if(isset($data[0][5]) && is_numeric($data[0][5]) && $data[0][5] > $sv->sysinfo['refresh']){
        $increment_refresh = $data[0][5];
    }
    else{
        $increment_refresh = $sv->sysinfo['refresh'];
    }

    $increment_refresh_array = get_interval_array($increment_refresh, 1);
    $increment_refresh_text = fill_zeros($increment_refresh_array['hours'], 2).':';
    $increment_refresh_text .= fill_zeros($increment_refresh_array['minutes'], 2).':';
    $increment_refresh_text .= fill_zeros($increment_refresh_array['seconds'], 2).'&nbsp;(hh:mm:ss)';

    // Intervall fr JavaScript in Millisekunden
    $interval_refresh = $increment_refresh * 1000;
    if($svsc->refresh_diagram){
        echo '
        refreshInterval = window.setInterval("ajaxRefreshDiagram()", ',$interval_refresh,');';
    }
}

/* {{{ JavaScript-Funktion key_down_event() - Key-Event-Handler */
echo '
function key_down_event(event){
    var keyCode;
    if(!event){
        event = window.event;
    }
    if(event.which){
        keyCode = event.which;
    }
    else{
        if(event.keyCode){
            keyCode = event.keyCode;
        }
    }
    //alert("Taste mit Dezimalwert " + keyCode + " gedrckt");

    // Esc
    if(keyCode == 27){
        window.close();
    }

    // Cursor nach links
    if(keyCode == 37){
        ajaxScroll("back");
    }

    // Cursor nach oben
    if(keyCode == 38){
        switch_scroll_factor();
    }

    // Cursor nach rechts
    if(keyCode == 39){
        ajaxScroll("forward");
    }

    // Stern-Taste (Nummernblock)
    if(keyCode == 106){
        ajaxZoom("org");
    }

    // Plus-Tasten
    if(keyCode == 107 || keyCode == 187){
        ajaxZoom("in");
    }

    // Minus-Tasten
    if(keyCode == 109 || keyCode == 189){
        ajaxZoom("out");
    }
}
document.onkeydown = key_down_event;';
/* }}} */

/* {{{ JavaScript-Funktion ajaxDeleteDiagramArrayIndex() - Index (SV-Short-Class-Instanz) im DiagrammArray lschen */
echo '
function ajaxDeleteDiagramArrayIndex(){';
    jsCreateXMLHttpRequest('xmlhttp');
    echo '
    var url = "ajax_actions.php?ajax_action=delete_diagramarray_index";
    url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
    xmlhttp.open("GET", url, false);
    xmlhttp.send(null);
    delete xmlhttp;
    xmlhttp = null;
}';
/* }}} */

/* {{{ JavaScript-Funktion ajaxRefreshDiagram() - Refresh Diagramm */
echo '
function ajaxRefreshDiagram(){
    var url;';
    jsCreateXMLHttpRequest('xmlhttp');
    // N TODO: dto. Fliebild-Refresh
    echo '
    if(!ajaxRefreshDiagramIsBusy && document.imgDiagram.complete){
        ajaxRefreshDiagramIsBusy = true;

        url = "ajax_actions.php?ajax_action=diagram_refresh&increment=',$increment_refresh,'";
        url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
        url += "&type=',$type,'";
        //alert(url);
        xmlhttp.open("GET", url, false);
        xmlhttp.send(null);

        if(xmlhttp.responseText != "false"){
            url = "diag_img.php?type=',$type,'&time=" + time();
            url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
            //alert(url);
            document.imgDiagram.src = url;
            var ResponseText = String(xmlhttp.responseText);
            var ResponseTextArray = ResponseText.split(\';\');
            document.getElementById("timeframe").innerHTML = ResponseTextArray[0];';
        for($i = 0, $j = 1; $i < $run; $i++, $j += 2){
            echo '
            document.getElementById("min_',$i,'").innerHTML = ResponseTextArray[',$j,'];
            document.getElementById("max_',$i,'").innerHTML = ResponseTextArray[',$j + 1,'];';
        }
            echo '
        }

        delete xmlhttp;
        xmlhttp = null;

        ajaxRefreshDiagramIsBusy = false;
    }
}';
/* }}} */

/* {{{ JavaScript-Funktion ajaxScroll() - Diagramm scrollen */
echo '
function ajaxScroll(direction){
    var scroll_factor = 90;
    var url;';
    jsCreateXMLHttpRequest('xmlhttp');
    echo '
    if(!ajaxRefreshDiagramIsBusy && document.imgDiagram.complete){
        ajaxRefreshDiagramIsBusy = true;

        if(document.img_scroll_factor.src.indexOf("scroll_factor_small.gif") != -1){
            scroll_factor = 10;
        }

        url = "ajax_actions.php?ajax_action=diagram_scroll&direction=";
        if(direction == "back"){
            url += direction;
        }
        else{
            url += "forward";
        }
        url += "&scroll_factor=" + scroll_factor;
        url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
        url += "&type=',$type,'";

        //alert(url);
        xmlhttp.open("GET", url, false);
        xmlhttp.send(null);

        if(xmlhttp.responseText != "false"){
            url = "diag_img.php?type=',$type,'&time=" + time();
            url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
            //alert(url);
            document.imgDiagram.src = url;
            var ResponseText = String(xmlhttp.responseText);
            var ResponseTextArray = ResponseText.split(\';\');
            document.getElementById("timeframe").innerHTML = ResponseTextArray[0];';
        for($i = 0, $j = 1; $i < $run; $i++, $j += 2){
            echo '
            document.getElementById("min_',$i,'").innerHTML = ResponseTextArray[',$j,'];
            document.getElementById("max_',$i,'").innerHTML = ResponseTextArray[',$j + 1,'];';
        }
            echo '
        }

        delete xmlhttp;
        xmlhttp = null;

        ajaxRefreshDiagramIsBusy = false;
    }
}';
/* }}} */

/* {{{ JavaScript-Funktion ajaxSwitchRefreshDiagram() - PHP-Member $svsc->refresh_diagram auf true oder false setzen */
echo '
function ajaxSwitchRefreshDiagram(checked){';
    jsCreateXMLHttpRequest('xmlhttp');
    echo '
    var url = "ajax_actions.php?ajax_action=switch_refresh_diagram&checked=" + checked;
    url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
    xmlhttp.open("GET", url, false);
    xmlhttp.send(null);
    delete xmlhttp;
    xmlhttp = null;
}';
/* }}} */

/* {{{ JavaScript-Funktion ajaxSwitchTagCheckbox() - PHP-Member $svsc->tagauswahl[$tag_index]['hide_tag'] auf 1 oder 0 setzen */
echo '
function ajaxSwitchTagCheckbox(tag_index){
    var url;
    var checked;';
    jsCreateXMLHttpRequest('xmlhttp');
    echo '
    eval("checked = document.diagform.display_tag_" + tag_index + ".checked;");
    if(checked){
        checked = true;
    }
    else{
        checked = false;
    }

    url = "ajax_actions.php?ajax_action=switch_tag_checkbox";
    url += "&tag_index=" + tag_index + "&checked=" + checked;
    url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
    //alert(url);
    xmlhttp.open("GET", url, false);
    xmlhttp.send(null);

    url = "diag_img.php?type=',$type,'&time=" + time();
    url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
    //alert(url);
    document.imgDiagram.src = url;

    delete xmlhttp;
    xmlhttp = null;
}';
/* }}} */

/* {{{ JavaScript-Funktion ajaxZoom() - Zoom Diagramm */
echo '
function ajaxZoom(direction){
    var zoom_factor = 10;
    var url;';
    jsCreateXMLHttpRequest('xmlhttp');
    echo '
    if(!ajaxRefreshDiagramIsBusy && document.imgDiagram.complete){
        ajaxRefreshDiagramIsBusy = true;

        url = "ajax_actions.php?ajax_action=diagram_zoom&direction=";
        if(direction == "out" || direction == "org"){
            url += direction;
        }
        else{
            url += "in";
        }
        url += "&zoom_align=" + radioValue(document.diagform.zoom_align);
        url += "&zoom_factor=" + zoom_factor;
        url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
        url += "&type=',$type,'";

        //alert(url);
        xmlhttp.open("GET", url, false);
        xmlhttp.send(null);

        if(xmlhttp.responseText != "false"){
            url = "diag_img.php?type=',$type,'&time=" + time();
            url += "&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'";
            //alert(url);
            document.imgDiagram.src = url;
            var ResponseText = String(xmlhttp.responseText);
            var ResponseTextArray = ResponseText.split(\';\');
            document.getElementById("timeframe").innerHTML = ResponseTextArray[0];';
        for($i = 0, $j = 1; $i < $run; $i++, $j += 2){
            echo '
            document.getElementById("min_',$i,'").innerHTML = ResponseTextArray[',$j,'];
            document.getElementById("max_',$i,'").innerHTML = ResponseTextArray[',$j + 1,'];';
        }
            echo '
        }

        delete xmlhttp;
        xmlhttp = null;

        ajaxRefreshDiagramIsBusy = false;
    }
}';
/* }}} */

/* {{{ JavaScript-Funktion submitting() - onunload-Ereignisprozedur bei Submit deaktivieren */
echo '
function submitting(form){
    window.onunload = null;
    form.submit();
    return false;
}';
/* }}} */

/* {{{ JavaScript-Funktion switch_refresh() - Refresh-Ein-/Ausschalter */
echo '
function switch_refresh(){
    if(document.diagform.refresh_diagram.checked){';
    if(isset($interval_refresh)){
        echo '
        refreshInterval = window.setInterval("ajaxRefreshDiagram()", ',$interval_refresh,');';
    }
    echo '
        ajaxSwitchRefreshDiagram(true);
    }
    else{
        window.clearInterval(refreshInterval);
        ajaxSwitchRefreshDiagram(false);
    }
}';
/* }}} */

/* {{{ JavaScript-Funktion switch_scroll_factor() - Scroll-Schrittweite umschalten */
echo '
function switch_scroll_factor(){
    if(document.img_scroll_factor.src.indexOf("scroll_factor_small.gif") == -1){
        document.img_scroll_factor.src = "scroll_factor_small.gif";
    }
    else{
        document.img_scroll_factor.src = "scroll_factor_big.gif";
    }
}';
/* }}} */
echo '
//-->
</script>
</head>';

/* {{{ HTML-Body */
echo '

<body onunload="ajaxDeleteDiagramArrayIndex()">
<!-- berbau -->
<form name="diagform" method="GET" action="diagram.php" onsubmit="return submitting(this);">
<table border="0" align="center" cellspacing="0" cellpadding="0" summary="Basic Diagram Table">
<tr>
    <td style="padding-top: 10px;" align="center">

    <table border="0" cellspacing="0" cellpadding="0" summary="Headline Diagram Table" width="100%">
    <tr>
        <td rowspan="2" width="40">
        <button class="icon_button_width" name="bt_print" type="button"
            onclick="window.print()" title="',$text_array[$sv->lang_id]['print'],'">
        <img alt="',$text_array[$sv->lang_id]['print'],'" title="',$text_array[$sv->lang_id]['print'],'"
            src="print.gif" width="21" height="21">
        </button>
        </td><td style="font-size: 13px;" align="right" width="130">',$type_text,':</td>
        <td style="font-size: 13px; font-weight: bold;">
        ',line_breaks2spaces(dotted_if_too_long($ks_bezeichnung, 45)),'
        </td><td rowspan="2" align="right" width="300">
        <input style="border-style: none;" type="checkbox" name="refresh_diagram" onclick="switch_refresh()"'
        ,($svsc->refresh_diagram?' checked':''),' />&nbsp;',$text_array[$sv->lang_id]['refresh'],'&nbsp;';
        if(isset($increment_refresh)){
            echo '-&nbsp;',$text_array[$sv->lang_id]['interval'],':&nbsp;';
            echo $increment_refresh_text;
        }
        echo '
        </td>
    </tr><tr>
        <td style="padding-top: 0px;" align="right">
        <span style="font-variant: normal; font-size: 13px;">'
        ,$text_array[$sv->lang_id]['timeframe'],':</span>
        </td><td style="padding-top: 0px;">
        <span id="timeframe" style="font-size: 13px; font-weight: bold;">
        ',$svsc->show_timeframe($sv->lang_id, $data),'
        </span>
        </td>
    </tr>
    </table>

    </td>
</tr><tr>
    <td style="padding-top: 10px;" align="center">';

    if(!isset($data)){
        echo 'No data!';
    }
    else if($data < 0){
        echo 'Invalid data!';
    }
    else{
        // Erstellung der Taginformationen aus der Tagtabelle
        // Paddings: Oben, rechts, unten, links
        echo '
        <table border="0" cellpadding="0" cellspacing="0" summary="Diagram Sub Table 2" width="100%">
        <tr>
            <td style="padding-top: 0px;" valign="top">

            <table border="0" cellpadding="0" cellspacing="0" summary="Diagram Sub Table 3 Left">
            <tr>
                <th colspan="3">',$text_array[$sv->lang_id]['navigation'],'</th>
            </tr><tr>
                <td style="padding: 5px 10px 0px 0px;" align="right">
                <img src="zoom_left.gif" alt="',$text_array[$sv->lang_id]['left_aligned_zoom'],'" />
                </td><td style="padding: 5px 5px 0px 5px;" align="center">
                <img src="zoom_center.gif" alt="',$text_array[$sv->lang_id]['centered_zoom'],'" />
                </td><td style="padding: 5px 0px 0px 10px;" align="left">
                <img src="zoom_right.gif" alt="',$text_array[$sv->lang_id]['right_aligned_zoom'],'" />
                </td>
            </tr><tr>
                <td style="padding: 0px 5px 3px 0px;" align="right" title="',$text_array[$sv->lang_id]['left_aligned_zoom'],'">
                <input type="radio" name="zoom_align" value="left"',($zoom_align == 'left'?' checked':''),' />
                </td><td style="padding: 0px 5px 3px 5px;" align="center" title="',$text_array[$sv->lang_id]['centered_zoom'],'">
                <input type="radio" name="zoom_align" value="center"',($zoom_align == 'center'?' checked':''),' />
                </td><td style="padding: 0px 0px 3px 5px;" align="left" title="',$text_array[$sv->lang_id]['right_aligned_zoom'],'">
                <input type="radio" name="zoom_align" value="right"',($zoom_align == 'right'?' checked':''),' />
                </td>
            </tr><tr>
                <td style="padding-right: 2px;" align="right">
                <button class="diagram_button_width" name="bt_zoom_out" type="button" onclick="ajaxZoom(\'out\')"
                    title="',$text_array[$sv->lang_id]['zoom_out'],' [&minus;]">&nbsp;&minus;&nbsp;</button>
                </td><td style="padding-left: 2px; padding-right: 2px;" align="center">
                <button class="diagram_button_width" name="bt_zoom_org" type="button" onclick="ajaxZoom(\'org\')"
                    title="',$text_array[$sv->lang_id]['original_size'],' [*]">&nbsp;&bull;&nbsp;</button>
                </td><td style="padding-left: 2px;" align="left">
                <button class="diagram_button_width" name="bt_zoom_in" type="button" onclick="ajaxZoom(\'in\')"
                    title="',$text_array[$sv->lang_id]['zoom_in'],' [+]">&nbsp;+&nbsp;</button>
                </td>
            </tr><tr>
                <td style="padding: 7px 2px 0px 0px;" align="right">
                <button class="diagram_button_width" name="bt_scroll_back" type="button" onclick="ajaxScroll(\'back\')"
                    title="',$text_array[$sv->lang_id]['scroll_back'],' [',$text_array[$sv->lang_id]['cursor_left'],']">
                <img name="img_scroll_back" alt="',$text_array[$sv->lang_id]['scroll_back'],' [',$text_array[$sv->lang_id]['cursor_left'],']"
                    src="scroll_back.gif" width="15" height="15"></button>
                </td><td style="padding: 7px 2px 0px 2px;" align="center">
                <button class="diagram_button_width" name="bt_scroll_factor" type="button" onclick="switch_scroll_factor()"
                    title="',$text_array[$sv->lang_id]['switch_scroll_factor'],' [',$text_array[$sv->lang_id]['cursor_up'],']">
                <img name="img_scroll_factor" alt="',$text_array[$sv->lang_id]['switch_scroll_factor'],' [',$text_array[$sv->lang_id]['cursor_up'],']"
                    src="scroll_factor_big.gif" width="15" height="15"></button>
                </td><td style="padding: 7px 0px 0px 2px;" align="left">
                <button class="diagram_button_width" name="bt_scroll_forward" type="button" onclick="ajaxScroll(\'forward\')"
                    title="',$text_array[$sv->lang_id]['scroll_forward'],' [',$text_array[$sv->lang_id]['cursor_right'],']">
                <img name="img_scroll_forward" alt="',$text_array[$sv->lang_id]['scroll_forward'],' [',$text_array[$sv->lang_id]['cursor_right'],']"
                    src="scroll_forward.gif" width="15" height="15"></button>
                </td>
            </tr>
            </table>

            </td>
            <td style="padding-top: 0px; padding-left: 10px;" valign="top">
            <input name="type" type="hidden" value="',$_GET['type'],'">
            <input name="session_name" type="hidden" value="',$svweb_session_name,'">
            <input name="diagram_index" type="hidden" value="',$diagram_index,'">

            <table border="0" cellpadding="0" cellspacing="0" summary="Diagram Sub Table 3" width="670">
            <tr>
                <th>&nbsp;</th>
                <th>',$text_array[$sv->lang_id]['tag_no'],'</th>
                <th style="padding-left: 5px;">',$text_array[$sv->lang_id]['name'],'</th>
                <th style="padding-left: 25px; padding-right: 25px;">',$text_array[$sv->lang_id]['dba'],'</th>
                <th style="padding-left: 25px; padding-right: 25px;">',$text_array[$sv->lang_id]['dbe'],'</th>
                <th style="padding-left: 5px; padding-right: 5px;">',$text_array[$sv->lang_id]['unit'],'</th>
            </tr>';
            for($i = 0; $i < $run; $i++){
                $col = sprintf('color: #%02x%02x%02x;', $colors[$i][0], $colors[$i][1], $colors[$i][2]);
                $checked = $svsc->tagauswahl[$keys[$i]]['hide_tag']?'':'checked';
                if(strlen($svsc->tagauswahl[$keys[$i]]['info']) > 0){
                    $tmp_name_info = htmlspecialchars($svsc->tagauswahl[$keys[$i]]['name'].', '.$svsc->tagauswahl[$keys[$i]]['info']);
                }
                else{
                    $tmp_name_info = htmlspecialchars($svsc->tagauswahl[$keys[$i]]['name']);
                }
                echo '
            <tr>
                <td>
                <input style="border: none;" name="display_tag_',$keys[$i],'" type="checkbox"
                    onclick="ajaxSwitchTagCheckbox(',$keys[$i],');" ',$checked,' />
                </td>
                <td align="center" style="',$col,'">'
                ,htmlspecialchars($svsc->tagauswahl[$keys[$i]]['nummer']),
                '</td>
                <td style="padding-left: 5px; padding-right: 5px; ',$col,'">',$tmp_name_info,'</td>
                <td id="min_',$i,'" align="center" style="',$col,'">'
                ,($svsc->tagauswahl[$keys[$i]]['hide_tag']?'':(isset($AutoScale)?$AutoScale['min_'.$i]:'')),
                '</td>
                <td id="max_',$i,'" align="center" style="',$col,'">'
                ,($svsc->tagauswahl[$keys[$i]]['hide_tag']?'':(isset($AutoScale)?$AutoScale['max_'.$i]:'')),
                '</td>
                <td align="center" style="',$col,'">'
                ,htmlspecialchars($svsc->tagauswahl[$keys[$i]]['einheit']),
                '</td>
            </tr>';
            }
            echo '
            </table>

            </td>
        </tr>
        </table>

        </td>
    </tr><tr>
        <td style="padding-top: 10px;" align="center">';
        if($type == 'universal' || $type == 'single' || $type == 'detail' || $type == 'trend'){
            // Zeit als Cachekiller mitschicken
            echo '
            <img class="diagram_border" name="imgDiagram" alt="',trim($type_text.' '.$ks_bezeichnung),'"
            src="diag_img.php?type=',$type,'&time=',time(),'&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'">';
        }
        else{
            echo 'Error! No diagram type defined!';
        }
    }

    echo '
    </td>
</tr>
</table>
</form>
</body>';
/* }}} */

include('cont_bottom.inc.php');

/* {{{ Logfiles schreiben */
if($STANDARD_CONFIG['WRITE_LOGFILES']){
    $tmp_status = '  PERIOD: '.localdate_std($svsc->time_start).' - '.localdate_std($svsc->time_end);
    $tmp_status .= '  TAGS: ';
    $i = 0;
    foreach($svsc->tagauswahl as $tmp_tag){
        if(!$tmp_tag['hide_tag']){
            if($i > 0){
                $tmp_status .= ', ';
            }
            $tmp_status .= $tmp_tag['nummer'];
            $i++;
        }
    }
    if($_GET['type'] == 'universal'){
        $tmp_type = 'univ';
    }
    else{
        $tmp_type = $_GET['type'];
    }
    write_logfile($tmp_type, $sv->get_user(), $sv->get_host(), $sv->get_port(), $tmp_status);
}
/* }}} */

store_session($sv);

?>

