if ('matchMedia' in window) {
    // Chrome, Firefox, and IE 10 support mediaMatch listeners
    window.matchMedia('print').addListener(function(media) {
        chart.validateNow();
    });
} else {
    // IE and Firefox fire before/after events
    window.onbeforeprint = function () {
        chart.validateNow();
    }
}

var chart;
var gGraphData = [];
var zoomingOut = true;

/**** DiagrammRefresh *******************************************************/
var session;
var refreshInterval = null;
var intervalId = null;
var ajaxRefreshDiagramIsBusy = false;
var refreshIntervalID;
var diagram_type;
var diagram_index;
var increment_refresh = 0;
var gStartTimeMaxSecs = 0;
var gEndTimeMaxSecs = 0;
var gStartTimeOrigMaxSecs = 0;
var gEndTimeOrigMaxSecs = 0;
var sys_archiv_interval = 0;
var sys_refresh_interval = 0;

var newDataRefreash = false;

function setSessionName(sessionName) {
    session = sessionName;
}

function setSystemVar(refreshinterval, archivinterval) {
	sys_archiv_interval = archivinterval;
	sys_refresh_interval = refreshinterval;
}

function setDiagramType(type) {
    diagram_type = type;
}

function setDiagramIndex(diagramIndex) {
    diagram_index = diagramIndex;
}

/**
 * Index (SV-Short-Class-Instanz) im DiagrammArray loeschen
 */
function ajaxDeleteDiagramArrayIndex(){
    var url = "ajax_actionsJS.php?ajax_action=delete_diagramarray_index";
    url += "&session_name=" + session + "&diagram_index=" + diagram_index;
    $.get(url);
}

/**
*	Setzt Timer mit RefresInterval
*/
function setRefreshIntervalTimer() {
    if (refreshInterval !== null && refreshInterval > 0) {
		console.log("setRefreshInterval: " + refreshInterval);
        intervalId = window.setInterval("ajaxRefreshDiagram()", refreshInterval);
    }
}

/**
*	Setzt Refreshinterval fuer Timer
*/
function getRefreshInterval() {
	//var intervalx = new Date((gGraphData[1][0][5])*1000);
	
	increment_refresh = gGraphData[1][0][5];

	if(sys_refresh_interval > 0){
		// Inkrement Timeestamps in Sekunden
		if(increment_refresh < sys_refresh_interval){
			increment_refresh = sys_refresh_interval;
		}
	}
	console.log("getRefreshInterval Increment: " + increment_refresh);
	// Intervall JavaaScript in Millisekunden
	refreshInterval = increment_refresh * 1000;
	console.log("getRefreshInterval : " + refreshInterval);
	
	
	
	var increment_refresh_array = []; 
	increment_refresh_array = get_interval_array(gGraphData[1][0][5], 1);
	var increment_refresh_text = addZero(increment_refresh_array['hours']) + ':';
	increment_refresh_text += addZero(increment_refresh_array['minutes']) + ':';
	increment_refresh_text += addZero(increment_refresh_array['seconds']) + ' (hh:mm:ss)';

	return 'Datenpunkte im Intervall:' + increment_refresh_text;

	//return ( addZero(intervalx.getUTCHours()) + ":" + addZero (intervalx.getUTCMinutes()) + ":" + addZero(intervalx.getUTCSeconds()) + " Inum:" + gGraphData[1][0][8]  );
	//return ( addZero(intervalx.getUTCHours()) + ":" + addZero (intervalx.getUTCMinutes()) + ":" + addZero(intervalx.getUTCSeconds()));
}

/**
 * Elemente in Form nach Erstellung vom Graphen setzen
 */
function setElements(setmax, setoriginal){
	//console.log("Start Element");
	document.getElementById("timeframe").innerHTML = getTimeFrame(setmax, setoriginal); 
	document.getElementById("refreshIntervalHtml").innerHTML = getRefreshInterval();
	//console.log("Ende Element");
}
/**
 * Refresh-Ein-/Ausschalter
 */
function switch_refresh(){
    if ($('#refreshDiagram').prop('checked')) {
        setRefreshIntervalTimer();
        ajaxSwitchRefreshDiagram(true);
        console.log("switch_refresh: Checked  window.SetInterval");
    }
    else{
        window.clearInterval(intervalId);
        console.log("switch_refresh: NOT Checked  window.clearInterval");
        ajaxSwitchRefreshDiagram(false);
    }
}
/**
 * PHP-Member $svsc->refresh_diagram auf true oder false setzen
 */
function ajaxSwitchRefreshDiagram(checked){
    var url = "ajax_actionsJS.php?ajax_action=switch_refresh_diagram&checked=" + checked;
    url += "&session_name=" + session + "&diagram_index=" + diagram_index;
    $.get(url);
}

/**
 * Refresh Diagram
 * @returns
 */
function ajaxRefreshDiagram(){
    var url;
    if(!ajaxRefreshDiagramIsBusy){ // && document.div["chartdiv"].complete){
        ajaxRefreshDiagramIsBusy = true;
        url = "ajax_actionsJS.php?ajax_action=diagram_refresh&session_name=" + session;
        url += "&increment=" + increment_refresh;
        url += "&diagram_index=" + diagram_index;
        url += "&type=" + diagram_type;
        //alert(url);

        $.get(url, function (data) {
        	ret = data;
        	if(data != "false"){
        		console.log("ajaxRefreshDiagram");
        		GraphUpdateData();
				//RS 20150528 Bei Refresh doch eigentlich neu setzen, oder?
				setElements(true, true);//(false, true);
        	}
        });
        ajaxRefreshDiagramIsBusy = false;
    }
}

/**
 * Originalzustand Diagram
 * @returns
 */
function ajaxDiagramOriginal(){
    var url;
    if(!ajaxRefreshDiagramIsBusy){ // && document.div["chartdiv"].complete){
        ajaxRefreshDiagramIsBusy = true;
		console.log(gStartTimeOrigMaxSecs);
		console.log(gEndTimeOrigMaxSecs);
        url = "ajax_actionsJS.php?ajax_action=diagram_original&session_name=" + session;
        url += "&startTime=" + gStartTimeOrigMaxSecs + "&endTime=" + gEndTimeOrigMaxSecs;
        url += "&diagram_index=" + diagram_index + "&type=" + diagram_type;
        console.log(url);

        $.get(url, function (data) {
        	ret = data;
        	if(data != "false"){
        		console.log("ajaxDiagramOriginal");
        		GraphUpdateData();
				zoomChartOut();
				setElements(true, true);
        	}
        });
        ajaxRefreshDiagramIsBusy = false;
    }
}

/**
 *  Diagramm scrollen
 */
function ajaxScroll(direction){
    var scroll_factor = 90;
    var url;
    if(!ajaxRefreshDiagramIsBusy){ // && document.imgDiagram.complete){
        ajaxRefreshDiagramIsBusy = true;

        url = "ajax_actionsJS.php?ajax_action=diagram_scroll&direction=";
        if(direction == "back"){
            url += direction;
        }
        else{
            url += "forward";
        }
        scroll_factor = 100;
        url += "&scroll_factor=" + scroll_factor;
        url += "&session_name=" + session + "&diagram_index=" + diagram_index;
        url += "&type=" + diagram_type;

        //alert(url);
        $.get(url, function (data) {
        	ret = data;
        	if(data != "false"){
	            //GraphUpdateData("diag_imgJS.php?type=',$type,'&time=',time(),'&session_name=',$svweb_session_name,'&diagram_index=',$diagram_index,'");
				console.log("ajaxScroll");
	            GraphUpdateData();
				setElements(true, false);
        	}

        });
        
        ajaxRefreshDiagramIsBusy = false;
    }
}

/**
 * Zoom Diagramm
 */
function ajaxZoomTime(startTime, endTime){
	
    var url;
    
    if(!ajaxRefreshDiagramIsBusy){ // && document.imgDiagram.complete){
        ajaxRefreshDiagramIsBusy = true;

				//Limit zoom time-frame to org time-frame
        if (gStartTimeMaxSecs > startTime) { startTime = gStartTimeMaxSecs; }
        if (gEndTimeMaxSecs < endTime) { endTime = gEndTimeMaxSecs; }
        
        url = "ajax_actionsJS.php?ajax_action=diagram_zoom_toDate";
        url += "&startTime=" + startTime;
        url += "&endTime=" + endTime;
        url += "&session_name=" + session + "&diagram_index=" + diagram_index;
        url += "&type=" + diagram_type;

        //alert(url);
        $.get(url, function (data) {
        	ret = data;
        	if(data != "false"){
	            //document.imgDiagram.src = url;
				console.log("ajaxZoomTime");
	            GraphUpdateData();
	            zoomChartOut();
				setElements(false, false);
  	   }
    });
    ajaxRefreshDiagramIsBusy = false;
    }
}
    
/**
 * Zoom Diagramm, wird nicht verwendet
 */
function ajaxZoom(direction){
		zoomChartOut();
 		//chart.zoomOut();
    var zoom_factor = 10;
    var url;
    if(!ajaxRefreshDiagramIsBusy){ // && document.imgDiagram.complete){
        ajaxRefreshDiagramIsBusy = true;

        url = "ajax_actionsJS.php?ajax_action=diagram_zoom&direction=";
        if(direction == "out" || direction == "org"){
        		
            url += direction;
        }
        else{
            url += "in";
        }
//            url += "&zoom_align=" + radioValue(document.diagform.zoom_align);
        url += "&zoom_factor=" + zoom_factor;
        url += "&session_name=" + session+ "&diagram_index=" + diagram_index;
        url += "&type=" + diagram_type;

         //alert(url);
        $.get(url, function (data) {
        	ret = data;
        	if(data != "false"){
				console.log("ajaxZoomOrg");
	            GraphUpdateData();
	            //zoomChartOut();
				setElements(false, false);
			}
		});

        ajaxRefreshDiagramIsBusy = false;
    }
}

function getTimeFrame(setmax, setoriginal) {
	//var start = new Date(gGraphData[0]["time_start"]*1000);
	//var end = new Date(gGraphData[0]["time_end"]*1000);
	//return ( Date(gGraphData[0]["time_start"]).toLocaleString() + " - " + Date(gGraphData[0]["time_end"]).toLocaleString() );
	var start = new Date(gGraphData[1][0][0]*1000);
	var end = new Date(gGraphData[1][0][0]*1000 + (gGraphData[1][0][4]-1) * gGraphData[1][0][5]*1000);
	
	if (setmax) {
	 gStartTimeMaxSecs = gGraphData[1][0][0];
	 gEndTimeMaxSecs = gGraphData[1][0][0] + (gGraphData[1][0][4]) * gGraphData[1][0][5];
	}
	if (setoriginal) {
	 gStartTimeOrigMaxSecs = gGraphData[1][0][0];
	 gEndTimeOrigMaxSecs = gGraphData[1][0][0] + (gGraphData[1][0][4]) * gGraphData[1][0][5];
	}
	
	return ( start.toLocaleString() + "  -  " + end.toLocaleString() );
	
}

function addZero(i) {
    if (i < 10) {
        i = "0" + i;
    }
    return i;
}

/**
 * Intervall in Tage, Stunden, Minuten und Sekunden aufdroeseln
 */
function get_interval_array( interval, limit) {
    var retarray = [];

    if ($.isNumeric(interval)) {
        seconds_per_day = 86400;
        seconds_per_hour = 3600;
        seconds_per_minute = 60;
        rest = interval;
        if (limit < 1) {
            retarray['days'] = Math.floor(rest / seconds_per_day);
            rest = rest % $seconds_per_day;
        }
        if (limit < 2) {
            retarray['hours'] = Math.floor(rest / seconds_per_hour);
            rest = rest % seconds_per_hour;
        }
        if (limit < 3) {
            retarray['minutes'] = Math.floor(rest / seconds_per_minute);
            rest = rest % seconds_per_minute;
        }
        retarray['seconds'] = rest;
    }

    return retarray;
}

/***********************************************************/

window.addEventListener("beforeunload", function (event) {
	ajaxDeleteDiagramArrayIndex();
});


$(document).ready(function() {
	console.log("document.ready");
    $('#refreshDiagram').on('click', function () {
        switch_refresh();
    });

    $('#bt_scroll_forward').on('click', function () {
    	ajaxScroll('forward');
    });

    $('#bt_scroll_back').on('click', function () {
    	ajaxScroll('back');
    });

    $('#bt_zoom_org').on('click', function () {
    	 //location.reload();
		 ajaxDiagramOriginal();
    });

    $('#bt_print').on('click', function () {
		// if ('matchMedia' in window) {
			//	Chrome, Firefox, and IE 10 support mediaMatch listeners
				// window.matchMedia('print').addListener(function(media) {
				// chart.validateNow();
			// });
		// } else {
		//	IE and Firefox fire before/after events
			// window.onbeforeprint = function () {
			// chart.validateNow();
			// }
		// }
		
    	//chart.validateNow();
    	window.print();
   });
   
   getRefreshInterval();
   switch_refresh();
}
);


(function() {
  var beforePrint = function() {
    for(var i = 0; i < AmCharts.charts.length; i++) {
      var chart = AmCharts.charts[i];
      chart.div.style.width = "1200px";
	  chart.div.style.height = "780px";
      chart.validateNow();
    }
  };
  var afterPrint = function() {
    for(var i = 0; i < AmCharts.charts.length; i++) {
      var chart = AmCharts.charts[i];
      chart.div.style.width = "100%";
	  chart.div.style.height = "100%";
      chart.validateNow();
    }
  };

  if (window.matchMedia) {
    var mediaQueryList = window.matchMedia('print');
    mediaQueryList.addListener(function(mql) {
      if (mql.matches) {
        beforePrint();
      } else {
        afterPrint();
      }
    });
  }

  window.onbeforeprint = beforePrint;
  window.onafterprint = afterPrint;
}());


/******** AmCharts ****************************************/
//var xAxisFormat = "JJ:NN \n DD MMM";

/**
*Erstellt Graphen fuer ein SV_TAG
*/
function createChartGraph(tag, idName, bHilo, valuefield, fillalpha, linealpha, filltograph, tagarray){

	graph = new AmCharts.AmGraph();
	graph.valueAxis = "vA" + (tag + 1); // we have to indicate which value axis should be used
	//graph.title = tagarray.name;
	graph.id = idName + tag;
	graph.valueField = valuefield + (tag + 1);
		graph.lineColor = colorTypeMake(tagarray.linecolor);
	if(bHilo==false){
		graph.title = tagarray.nummer + ", " + tagarray.name + ", " + tagarray.einheit; 
		graph.bullet = "round";
//		graph.lineColor = colorTypeMake(tagarray.linecolor);
		graph.hideBulletsCount = 30;
		graph.bulletBorderThickness = 1;
		//graph.balloonText = "[[value.toFixed(2)]]"; //.toFixed does not work here!
		graph.connect = false;
	}
	else{
		graph.lineAlpha = linealpha;
		graph.showBalloon = false;
		graph.fillAlphas = fillalpha;
		graph.visibleInLegend = false;
		if(filltograph.length > 0){
			graph.fillToGraph = filltograph + (tag);
		}
	}
	return graph;
}

/**
*Erstellt Y-Achse fuer ein SV_TAG
*/
function createValueAxis(tag, tagarray){
	// addd value axises
	console.log("createValueAxis TAG: " + tagarray.nummer);
	var valueAxis = new AmCharts.ValueAxis();
	valueAxis.id = "vA" + (tag + 1);
	valueAxis.axisColor = colorTypeMake(tagarray.linecolor); //"#FF6600";
	valueAxis.color = colorTypeMake(tagarray.linecolor);
	valueAxis.axisThickness = 2;
	
	if (tagarray.dba === ""){
		console.log ("Zero gGraphData[0][tagauswahl][tag].dba: ");
	} else {
	valueAxis.minimum = tagarray.dba;
	//valueAxis.strictMinMax = true;
	console.log (" gGraphData[0][tagauswahl][tag].dba: " + tagarray.dba);
	}
	if (tagarray.dbe === ""){
		console.log ("Zero gGraphData[0][tagauswahl][tag].dbe: ");
	} else {
	valueAxis.maximum = tagarray.dbe;
	//valueAxis.strictMinMax = true;
	console.log (" gGraphData[0][tagauswahl][tag].dbe: " + tagarray.dbe);
	}
	//valueAxis.unit = tagarray.einheit;
	valueAxis.title = tagarray.nummer + ", " + tagarray.name + ", " + tagarray.einheit;
	valueAxis.titleColor = colorTypeMake(tagarray.linecolor);
	//valueAxis.labelRotation = -90;
	valueAxis.labelsEnabled = true;
	//valueAxis.usePrefixes = true;
	//valueAxis.useScientificNotation = true;
	//valueAxis.autoGridCount = true;
	//valueAxis.gridAlpha = 100;
	//valueAxis.labelOffset = 0;
	//valueAxis.totalTextOffset = 100;

	valueAxis.gridAlpha = 0;

	return valueAxis;
}

function setValueAxisPosition(tagarray){
	var len = chart.valueAxes.length;
	console.log("TAGs: " + tagarray.length);
	var ii=0;
	var iii=0;
	for(var i=(len - 1);i >= 0;i--){
		var idA = chart.valueAxes[i].id;
		var idx = idA.substring(2) - 1;
//		console.log("AxisPos: " + chart.valueAxes[i].id);
//		console.log("AxisPos: " + idx);
		if (idx % 2 === 0){
			chart.valueAxes[i].position = "left";
			chart.valueAxes[i].offset = ((ii) * 80);
			ii++;
		}else{
			chart.valueAxes[i].position = "right";
			chart.valueAxes[i].offset = ((iii) * 80);
			iii++;
		}
	}
}

function createChartCursor(){
	// CURSOR
	var chartCursor = new AmCharts.ChartCursor();
		chartCursor.cursorAlpha = 0.5;
		chartCursor.fullWidth = true;
		chartCursor.categoryBalloonDateFormat = "DD MMM JJ:NN:SS"; //the good one
		//chartCursor.categoryBalloonDateFormat = "DD JJ:NN:SS";
		//chartCursor.valueLineBalloonEnabled = true;
		chartCursor.valueLineEnabled = true;
		// Linealanzeige ausschalten, wenn Cursor ausserhalb des Diagramms
		//chartCursor.leaveCursor = true;  
		chartCursor.cursorColor = "#000000";	
		//chartCursor.valueLineAxis = {chart.valueAxes[0], chart.valueAxes[1]};
		//chartCursor.valueLineAxis = chart.valueAxes[1];
	return chartCursor;
}

/**
*Erstellt ScrollLeiste fuer Zoomen
*/
function createChartScrollBar(){

	// SCROLLBAR
	var chartScrollbar = new AmCharts.ChartScrollbar();
	//chartScrollbar.graph = graph[0];
	chartScrollbar.scrollbarHeight = 40;
	chartScrollbar.color = "#000000";
	chartScrollbar.backgroundColor = "#D4D4D4";
	//chartScrollbar.position = "bottom";
	chartScrollbar.offset = 20;
	
	chartScrollbar.autoGridCount = true;

	return chartScrollbar;
}

/**
*Erstellt Legende fuer TAGs
*/
function createLegend(){
	// LEGEND
	var legend = new AmCharts.AmLegend();
	legend.align = "center";
	legend.position = "bottom";//"top";
	legend.maxColumns = 6;
	//legend.borderAlpha = 1;
	//legend.borderColor = "#777700";
	legend.marginLeft = 0;
	legend.valueWidth = 60;
	//legend.width = 100;
	//legend.labelWidth = 250;
	legend.valueAlign = "right";
	legend.useGraphSettings = false;
	legend.useMarkerColorForLabels = true;
	legend.useMarkerColorForValues = true;
	legend.equalWidths = true;//alle gleiche Breite
	legend.addListener("hideItem", hideLines);
	legend.addListener("showItem", showLines);
	

	// LEGEND
  //  var legend = new AmCharts.AmLegend();
   // chart.addLegend(legend, "legenddiv");
	//legend.useGraphSettings = true;
	return legend;
}

/**
*Setzt Eigenschaften fuer X-Achse (Date)
*/
function createCategoryAxis(){
		// AXES
		// category
		var categoryAxis = chart.categoryAxis;
		categoryAxis.parseDates = true; // as our data is date-based, we set parseDates to true
		categoryAxis.boldPeriodBeginning = false;
		var idx=(gGraphData[1][0][5]); //Interval
		if(idx < 60){
			categoryAxis.minPeriod = idx + "ss"; // our data is daily, so we set minPeriod to DD
		}
		else{
			categoryAxis.minPeriod = (idx/60) + "mm";//(gGraphData[1][0][5]) + "ss"; // our data is daily, so we set minPeriod to DD
		}
		categoryAxis.minorGridEnabled = false;
		categoryAxis.axisColor = "#DADADA";
		categoryAxis.twoLineMode = true;
		categoryAxis.equalSpacing = true;
		//categoryAxis.labelRotation = -45; //this works!
		//categoryAxis.connect = false;
		//categoryAxis.position = "top";

		 
		//categoryAxis.title = "Zeit"; 
		
		categoryAxis.dateFormats = 
					[{period:'fff',format:'SS'},
					{period:'ss',format:'NN:SS'},
					//{period:'mm',format: "JJ:NN \n DD MMM"}, //'JJ:NN'},
					{period:'mm',format: "JJ:NN"}, //'JJ:NN'},
					{period:'hh',format: "JJ:NN"}, // \n DD MMM"}, //'JJ:NN'},
					{period:'DD',format: "JJ:NN \n DD MMM"}, //'MMM DD'},
					{period:'WW',format:'MMM DD'},
					{period:'MM',format:'MMM'},
					{period:'YYYY',format:'YYYY'}];
		
		
/*		categoryAxis.labelFunction = function (valueText, value, valueAxis) {
												  var est = new Date(value); 
			 										return AmCharts.formatDate(est, xAxisFormat);
	                        // recalculate to EST (-5 hours)
													//alert(value);
	                        //var est = new Date(value); //+ (60*60*1000)
	                        //est.setHours(est.getHours()-5);
													//est.setHours(est.getHours()+2);
	                        //return AmCharts.formatDate(est, "JJ:NN \n DD MMM");
	                        //return AmCharts.formatDate(est, "JJ:NN \n DD MMM");
													//return valueText + '\n' + AmCharts.formatDate(est, "HH:NN");
	                    }; 
*/
                
/* 	categoryAxis.dateFormats = [{
			period: "fff",
			format: "JJ:NN:SS"
		}, {
			period: "ss",
			format: "JJ:NN:SS"
		}, {
			period: "mm",
			format: "JJ:NN"
		}, {
			period: "hh",
			format: "JJ:NN"
		}, {
			period: "DD",
			format: "DD"
		}, {
			period: "WW",
			format: "DD"
		}, {
			period: "MM",
			format: "MMM"
		}, {
			period: "YYYY",
			format: "YYYY"
	}]; 
*/

}

function setLanguageDate(){
	
	if(chart.language === "de"){
		console.log(chart.language);
		AmCharts.monthNames = [
		  'Januar', 
		  'Februar',
		  'März',
		  'April',
		  'Mai',
		  'Juni',
		  'Juli',
		  'August',
		  'September',
		  'Oktober',
		  'November',
		  'Dezember'];
	  
		AmCharts.shortMonthNames = [
		  'Jan', 
		  'Feb',
		  'Mrz',
		  'Apr',
		  'Mai',
		  'Jun',
		  'Jul',
		  'Aug',
		  'Sep',
		  'Okt',
		  'Nov',
		  'Dez'];
	 }
}

/**
*Erstellt den gesamten Graphen
*/
function makeGraph(){
	var url;
	var time = new Date().getTime();
	
	url = "diag_imgJS.php?type=" + diagram_type;
	url +="&time=" + time + "&session_name=" + session;
	url +="&diagram_index=" + diagram_index;


	gGraphData = AmCharts.loadJSON (url);

	console.log ("gGraphData");
	console.log (gGraphData);	   
		   	   
	// use UTC time
	//AmCharts.useUTC = true;		
		   
	AmCharts.ready( function () {
		console.log ("Start AmCharts.ready");
		var chartData = [];
		chartData = generateChartData();
	
		// SERIAL CHART
		chart = new AmCharts.AmSerialChart();
		//chart.useUTC = true; //seems to have no effect.
		chart.language="de";
		setLanguageDate();
		chart.pathToImages = "./amcharts.free/amcharts/images/";
		chart.dataProvider = chartData;
		chart.type = "serial";
		chart.categoryField = "date";
		//chart.backgroundColor = "#FFFFFF";
		chart.backgroundColor = "#EDEDED";
		chart.backgroundAlpha = 1;
		chart.plotAreaFillColors = "#FFFFFF";
		chart.plotAreaFillAlphas = 0.8;
		//chart.precision = 3;  //pha 20150811
		chart.precision = -1;  // for test
		chart.thousandsSeparator = ".";
		chart.decimalSeparator = ",";
		//chart.connect = false;
		chart.mouseWheelZoomEnabled = true;
		//chart.zoomOutButtonImageSize = 0;
		chart.zoomOutText = "";
//		chart.prefixesOfBigNumbers = [
//				//{number:1e+3,prefix:"k"},
//				{number:1e+6,prefix:"M"},
//				{number:1e+9,prefix:"G"},
//				{number:1e+12,prefix:"T"},
//				{number:1e+15,prefix:"P"},
//				{number:1e+18,prefix:"E"},
//				{number:1e+21,prefix:"Z"},
//				{number:1e+24,prefix:"Y"}]

		chart.addListener("zoomed", handleZoom);
		//chart.addListener("hideItem", hideLines);
	
		// listen for "dataUpdated" event (fired when chart is inited) and call zoomChart method when it happens
		//chart.addListener("dataUpdated", zoomChart);
	
	createCategoryAxis();

	var tagsNum = gGraphData[0]["tagauswahl"].length;
	for (var tag = 0; tag < tagsNum; tag++) {
		if(gGraphData[0]["tagauswahl"][tag].nummer > 0){
			chart.addValueAxis(createValueAxis(tag, gGraphData[0]["tagauswahl"][tag]));
			chart.addGraph(createChartGraph(tag, "valueGraph", false, "tag", 0, 0, "", gGraphData[0]["tagauswahl"][tag]));
			chart.addGraph(createChartGraph(tag, "fromGraph", true, "tagmin", 0, 0, "", gGraphData[0]["tagauswahl"][tag]));
			chart.addGraph(createChartGraph(tag, "toGraph", true, "tagmax", 0.2, 0, "fromGraph", gGraphData[0]["tagauswahl"][tag]));
		}
	}

	setValueAxisPosition(gGraphData[0]["tagauswahl"]);
	chart.addChartCursor(createChartCursor());
		
	chart.addChartScrollbar(createChartScrollBar());

	chart.addLegend(createLegend());
	
	var maxTime = gGraphData[1][0][0] + (gGraphData[1][0][4]) * gGraphData[1][0][5];
	console.log("maxTime: " + maxTime);
	if (maxTime < 1420070400){
	console.log("maxTime: " + maxTime);
		showBulletsAll();
	}
	else{
	if (gGraphData[1][0][8] === 1) { //Schrittweite is 1
			showBullets();
		} else {
			hideBullets();
		}		
	}
	// WRITE
	chart.write("chartdiv");
	setElements(true, true);
		console.log(gStartTimeOrigMaxSecs);
		console.log(gEndTimeOrigMaxSecs);
		
	zoomChartOut();
	
});
}


AmCharts.loadJSON = function(url) {
	var request = null;
	console.log(url);
	// create the request
	if (window.XMLHttpRequest) {
		// IE7+, Firefox, Chrome, Opera, Safari
		request = new XMLHttpRequest();
	} else {
		// code for IE6, IE5
		request = new ActiveXObject('Microsoft.XMLHTTP');
	}

	// load it
	// the last "false" parameter ensures that our code will wait before the
	// data is loaded
	request.open('GET', url, false);
	request.send();
	
	console.log(" Begin request.responseText");
	//console.log(request.responseText);
	console.log(" End request.responseText");

  var res  = request.responseText.replace(/-1.0e.38/ig, "NaN");
	
	// parse adn return the output
	return eval(res);
	//return eval(request.responseText);
};

/*
AmCharts.loadJSON = function(url) {
	var request = null;
	var res = null;
    $.get(url, function (data) {
    	request = data;
		res  = request.replace(/-1.0e.38/ig, "NaN");
    });
	// parse adn return the output
	return eval(res);
	//return eval(request.responseText);
};
*/

function generateChartData() {
               
	console.log("AnzahlWerte: " + gGraphData[1][0][4]);
	console.log("Interval: " + gGraphData[1][0][5] + " Secs");
	console.log("Schrittweite: " + gGraphData[1][0][8] );
	
	var chartData = [];

	// we create date objects here. In your data, you can have date strings
	// and then set format of your dates using chart.dataDateFormat property,
	// however when possible, use date objects, as this will speed up chart rendering.
	// var newDate = new Date((gGraphData[1][0][0]  + (v * gGraphData[1][0][5])) *1000);
	// console.log(newDate);
	// newDate.setDate(newDate.getDate() + i);
	var tags = gGraphData[1][0][9];//Array ueber alle TAGs
	if (gGraphData[1][0][8] === 1) { //Schrittweite is 1
		for (var v = 0; v < gGraphData[1][0][4]; v++) {
			var dtemp = {};
			//dtemp.date = newDate;
			dtemp.date = ((gGraphData[1][0][0]  + (v * gGraphData[1][0][5])) *1000);
			//ueber alle TAGs
			for (var tag = 1; tag <= gGraphData[1][0][1]; tag++) {
				if(tags[tag] > 0){
					var decimalPlace = gGraphData[0]["tagauswahl"][tag-1].nach;
					//dtemp["tag" + tag]  = gGraphData[1][tag][v] ["Wert"];
					if ( (decimalPlace <= -1) || isNaN(decimalPlace) )
					{
						dtemp["tag" + tag]  = gGraphData[1][tag][v] ["Wert"];
					} else {
						if (decimalPlace > 10 ) { decimalPlace = 10; }
						dtemp["tag" + tag]  = gGraphData[1][tag][v] ["Wert"].toFixed(gGraphData[0]["tagauswahl"][tag-1].nach);
					}
				}
			}
			//showBullets();
		chartData.push( dtemp );
		}
	}
	else{
		for (var v = 0; v < gGraphData[1][0][4]; v++) {
			var dtemp = {};
			//dtemp.date = newDate;
			dtemp.date = ((gGraphData[1][0][0]  + (v * gGraphData[1][0][5])) *1000);
			//ueber alle TAGs
			for (var tag = 1; tag <= gGraphData[1][0][1]; tag++) {
				if(tags[tag] > 0){
					var decimalPlace = gGraphData[0]["tagauswahl"][tag-1].nach;
					//dtemp["tag" + tag]  = gGraphData[1][tag][v] ["Avg"];
					if ( (decimalPlace <= -1) || isNaN(decimalPlace) )
					{
						console.log("Here3 Tag:" + tag + " v:" + v + " nach:" + decimalPlace );
						dtemp["tag" + tag]  = gGraphData[1][tag][v] ["Avg"];
					} else {
						if (decimalPlace > 10 ) { decimalPlace = 10; }
						console.log("Here4 Tag:" + tag + " v:" + v + " nach:" + decimalPlace );
						dtemp["tag" + tag]  = gGraphData[1][tag][v] ["Avg"].toFixed(decimalPlace);
					}
					
					dtemp["tagmin" + tag]  = gGraphData[1][tag][v] ["Min"];
					dtemp["tagmax" + tag]  = gGraphData[1][tag][v] ["Max"];
				}
			}
		  //hideBullets();
		chartData.push( dtemp );
		}
	}
	
	addColorToGraphData();
	
	return chartData;
}

function addColorToGraphData() {
	var colors = [ 0xFF, 0xFF0000, 0x006464, 0x965AFF, 0xC80078, 0xC86400];
	//var colors = [ "#0000FF", "#FF0000", "#006464", "#965AFF", "#C80078", "#C86400"]; 
	//$colors = array(array(0, 0, 255), array(255, 0, 0), array(0, 100, 100), array(150, 90, 255), array(200, 0, 120), array(200, 100, 0));
	
	var tagsNum = gGraphData[0]["tagauswahl"].length;
	
	for (var tag = 0; tag < tagsNum; tag++){
		//if (gGraphData[0]["tagauswahl"][tag].nummer > 0 ){
			gGraphData[0]["tagauswahl"][tag]["linecolor"] = colors[tag];
		//}	
	}
	
	if ( (typeof(gGraphData[0]["ks_auswahl"]) != "undefined") && (gGraphData[0]["ks_auswahl"] !== null)
			 && (typeof(gGraphData[0]["ks_auswahl"][25]) != "undefined") && (gGraphData[0]["ks_auswahl"][25] !== null) )
	{
		for (var tag = 0; tag < tagsNum; tag++){
			//if (gGraphData[0]["tagauswahl"][tag].nummer > 0 ){
					gGraphData[0]["tagauswahl"][tag].linecolor = gGraphData[0]["ks_auswahl"][25 + tag];
			//}	
		}
	}
}


// this method is called when chart is first inited as we listen for "dataUpdated" event
function zoomChartOut() {
   // different zoom methods can be used - zoomToIndexes, zoomToDates, zoomToCategoryValues
   chart.zoomToIndexes(3, chart.chartData.length);
   //chart.zoomOut();
   chart.chartCursor.clearSelection();
}

function showBullets(){
	var len = chart.graphs.length / 3;
	console.log("graphs: " + len);
	var ii=0;
	var iii=0;
	for(var i=0;i < len;i++){
		var idg = chart.graphs[i * 3].id;
		console.log("idg: " + idg.substring(0,10) + ", Index: " + idg.substring(10));
		if(idg.substring(0,10) == "valueGraph"){
			var idx = idg.substring(10);

			if(gGraphData[0]["tagauswahl"][idx].nummer > 0){
		 //graph[tag].showBullets();
			// rs graph[tag].hideBulletsCount = 30;
			console.log("showBullets: " + "valueGraph" + idx);
			chart.graphs[i * 3].hideBulletsCount = 100;
		 }
		}
	}
}

function showBulletsAll(){
	var len = chart.graphs.length / 3;
	console.log("graphs: " + len);
	var ii=0;
	var iii=0;
	for(var i=0;i < len;i++){
		var idg = chart.graphs[i * 3].id;
		console.log("idg: " + idg.substring(0,10) + ", Index: " + idg.substring(10));
		if(idg.substring(0,10) == "valueGraph"){
			var idx = idg.substring(10);

			if(gGraphData[0]["tagauswahl"][idx].nummer > 0){
		 //graph[tag].showBullets();
			// rs graph[tag].hideBulletsCount = 30;
			console.log("showBulletsAll: " + "valueGraph" + idx);
			chart.graphs[i * 3].hideBulletsCount = 0;
		 }
		}
	}
}	
function hideBullets(){
	var len = chart.graphs.length / 3;
	console.log("graphs: " + len);
	var ii=0;
	var iii=0;
	for(var i=0;i < len;i++){
		var idg = chart.graphs[i * 3].id;
		console.log("idg: " + idg.substring(0,10) + ", Index: " + idg.substring(10));
		if(idg.substring(0,10) == "valueGraph"){
			var idx = idg.substring(10);

			if(gGraphData[0]["tagauswahl"][idx].nummer > 0){
		 //graph[tag].showBullets();
			// rs graph[tag].hideBulletsCount = 30;
			console.log("hideBullets: " + "valueGraph" + idx);
			chart.graphs[i * 3].hideBulletsCount = 1;
		 }
		}
	}
}	
		   
function colorTypeMake (colorInt ) {
	var pad = "000000";

	var result = String(pad + Number(colorInt).toString(16)).slice(-pad.length);

	var red = result.substring(4, 6);
	var green = result.substring(2, 4);
	var blue = result.substring(0, 2);
	
	resultx = "#" + red + green + blue;
	//console.log("Color: R: " + red + " G: " + green + " B: " + blue + " result: " + result + " (" + colorInt + ")");
	return resultx;
}

function GraphUpdateData(){
	var time = new Date().getTime();
	var url = "diag_imgJS.php?type=" + diagram_type + "&time=" + time;
	url += "&session_name=" + session + "&diagram_index=" + diagram_index;
	//alert(url);
	gGraphData = AmCharts.loadJSON(url);
	console.log(gGraphData);
	//AmCharts.ready( function () {
	var chartData = [];
	chartData = generateChartData();
	//chart.categoryAxis.minPeriod = (gGraphData[1][0][5]) + "ss"; // our data is daily, so we set minPeriod to DD
	var idx=(gGraphData[1][0][5]); //Intervall
	if(idx < 60){
		chart.categoryAxis.minPeriod = idx + "ss"; // our data is daily, so we set minPeriod to DD
	}
	else{
		chart.categoryAxis.minPeriod = (idx/60) + "mm";//(gGraphData[1][0][5]) + "ss"; // our data is daily, so we set minPeriod to DD
	}
	console.log("UpdategGraphData");
	chart.dataProvider = chartData;

	var maxTime = gGraphData[1][0][0] + (gGraphData[1][0][4]) * gGraphData[1][0][5];
	console.log("maxTime: " + maxTime);
	if (maxTime < 1420070400){//1430438400 -->1.5.2015 speziell fuer AlzChem
		console.log("maxTime: " + maxTime);
		showBulletsAll();
	} else{
		if (gGraphData[1][0][8] === 1) { //Schrittweite is 1
			showBullets();
		} else{
			hideBullets();
		}		
	}
	newDataRefreash = true; //PHA 20160128 zoom max bug fix
	chart.validateData(); //PHA 20160128 zoom max bug fix
	chart.validateNow(false,false); //chart.validateNow(true,false); //PHA 20160128 zoom max bug fix
	
	for(var i=0;i<chart.valueAxes.length;i++){
		console.log(i + ": " + chart.valueAxes[i].title); 
	}
	//chart.write("chartdiv");
	//});
	
	zoomChartOut();
}


function handleZoom(event) {
   console.log("handleZoom");
   console.log(event);
   
   //console.log("zoomingOut: " + zoomingOut);
	if (!newDataRefreash){  //PHA 20160128 zoom max bug fix
		newDataRefreash = false; //PHA 20160128 zoom max bug fix

		zoomFactor = 10;

		startIndex = event.startIndex;
		endIndex = event.endIndex;
		endDataIndex = event.chart.chartData.length -1;
		startTime = new Date(event.startDate).getTime()/1000;
		endTime = new Date(event.endDate).getTime()/1000;
		spanTime = endTime - startTime;
		zoomOutSpanTime = spanTime * zoomFactor / 2;
   
		//Object { chart: Object, target: Object, type: "zoomed", startIndex: 551, endIndex: 780, startValue: Date 2015-05-05T16:55:00.000Z, endValue: Date 2015-05-05T20:44:00.000Z, startDate: Date 2015-05-05T16:55:00.000Z, endDate: Date 2015-05-05T20:44:00.000Z }
		if (gGraphData[1][0][8] > 1){ //Schrittweite > 1
		   if ((endIndex - startIndex) < (endDataIndex / zoomFactor) ) {
			   console.log("ZoomInData");
			   ajaxZoomTime(  startTime, endTime);
		   }
		}
		if (zoomingOut){
		   zoomingOut = false;
		   console.log("zoomingout set false");
		}
		else {
		   if ( (startIndex === 0) && (endIndex === endDataIndex) ){
			   console.log("ZoomOutData");
			   ajaxZoomTime(  startTime - zoomOutSpanTime , endTime + zoomOutSpanTime);
			//zoomingOut = true;
		   }
		}
	}   
	newDataRefreash = false; //PHA 20160128 zoom max bug fix
}

function hideLines(event) {
		//var tagsNum = gGraphData[0]["tagauswahl"].length;
		var index = event.dataItem.index;
	   console.log(event);
	   chart.hideGraph(chart.graphs[index + 1]);//tagsNum + (index*2)]);
	   chart.hideGraph(chart.graphs[index + 2]);//graph[tagsNum + (index*2) + 1]);
	}
	
function showLines(event) {
		//var tagsNum = gGraphData[0]["tagauswahl"].length;
		var index = event.dataItem.index;
/*		console.log("Index: " + index);
	   console.log(event);
	   for(var i=0;i<chart.graphs.length;i++){
		console.log("i: " + i);
		console.log("graph.id: " + chart.graphs[i].id);
	   }
*/
	   chart.showGraph(chart.graphs[index + 1]);//graph[tagsNum + (index*2)]);
	   chart.showGraph(chart.graphs[index + 2]);//graph[tagsNum + (index*2) + 1]);
}
