<?php

// vim: fdm=marker

/***************************
*  Andy Geiss 2009 - 2010  *
*  Tabulatorweite: 4       *
***************************/


ob_start();
require('scalarvis.inc.php');
require_once('scalarvis_ext.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if(!start_session($sv)){
    session_no_longer_valid_msg();
}

if(!$sv->connect()){
    echo '<br />',get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    jsEscWindowClose();
    exit;
}
//var_dump($sv->sysinfo);

/* {{{ Variablen festlegen */
if(isset($_GET['type'])){
    $type = trim($_GET['type']);
    switch($type){
    case 'universal':
        $type_text = $text_array[$sv->lang_id]['diagram_universal'];
        $archivinterval = $sv->sysinfo['intervall'];
        break;
    case 'single':
        $type_text = $text_array[$sv->lang_id]['diagram_single'];
        $archivinterval = $sv->sysinfo['intervall'];
        break;
    case 'detail':
        $type_text = $text_array[$sv->lang_id]['diagram_detail'];
        $archivinterval = $sv->sysinfo['stoer_intervall'];
        break;
    case 'trend':
        $type_text = $text_array[$sv->lang_id]['diagram_trend'];
        $archivinterval = 60;
        break;
    default:
        $type_text = '';
        $archivinterval = 60;
        break;
    }
}
else{
    jsEscWindowClose();
    exit('No diagram type defined!');
}

//fuer Fliessbild --> "fliess"
$view='';
if(isset($_GET['view'])){
    $view = trim($_GET['view']);
}

if(strlen($view)){
	if(isset($_GET['tagnr']) && strlen(trim($_GET['tagnr']))){
		$tagnr = trim($_GET['tagnr']);
		if(is_numeric($tagnr) && ($tagnr > 0) && ($tagnr <= $sv->sysinfo['tag_anzahl'])){
			$sv->add_tag_to_tagauswahl_fliess($tagnr);
		}
		else{
			jsEscWindowClose('No SV_TAG defined!');
			exit('No SV_TAG defined!');
		}
	}
	$arctime = time();
	if(isset($_GET['arctime']) && strlen(trim($_GET['arctime']))){
		if(is_numeric(trim($_GET['arctime']))){
			$arctime = trim($_GET['arctime']);
		}
	}
	$arcinterval = 3600;
	if(isset($_GET['arcinterval']) && strlen(trim($_GET['arcinterval']))){
		if(is_numeric(trim($_GET['arcinterval']))){
			$arcinterval = trim($_GET['arcinterval']);
		}
	}
	$sv->set_time_by_int_and_end_fliess($arcinterval, $arctime);
}//nur bei Fliessbild

// Diagramm-Instanz erstellen, wenn �bener Index nicht bereits existiert
if(!strlen(trim($diagram_index)) || !isset($sv->diagramarray[$diagram_index])){
    $diagram_index = $sv->create_diagramarray_indexJS($view);
}

// Lokale Referenz auf die Scalarvis-Short-Class-Instanz alias Kopie der Hauptinstanz erstellen
$svsc = $sv->diagramarray[$diagram_index];
/*
echo "Archiv: ".$archivinterval;
$st= $svsc->time_start;
$en= $svsc->time_end;
echo "Start: ".$st.", End: ".$en;
*/
$svsc->time_start = trimTime($svsc->time_start, $archivinterval);
$svsc->time_end = trimTime($svsc->time_end, $archivinterval);
//var_dump($svsc);

// Keine Tags ausgewaehlt
if(!count($svsc->tagauswahl)){
    jsWindowClose($text_array[$sv->lang_id]['no_tags_selected'].'!');
    exit($text_array[$sv->lang_id]['no_tags_selected'].'!');
}

$countTAG = 0;
for($i=0;$i<count($svsc->tagauswahl);$i++){
	//echo 'TAG: '.$svsc->tagauswahl[$i]['nummer'];
	if($svsc->tagauswahl[$i]['nummer'] > 0){
		$countTAG++;
	}
}
if(!$countTAG){
    jsWindowClose($text_array[$sv->lang_id]['no_tags_selected'].'!');
    exit($text_array[$sv->lang_id]['no_tags_selected'].'!');
}

$anzval = 0;
ksort($svsc->tagauswahl);
$keys = array_keys($svsc->tagauswahl);
$run = count($keys);

// Wenn ein Kurvensatz angezeigt werden soll, wird die Bezeichnung in die ۢerschrift gesetzt
if(strlen($view)){
	$ks_bezeichnung = '';
}
else{
	(isset($svsc->ks_auswahl)?$ks_bezeichnung = htmlspecialchars($svsc->ks_auswahl[1]):$ks_bezeichnung = '');
	$ks_bezeichnung = trim($ks_bezeichnung);
}

$setRefresh = false;
if($svsc->refresh_diagram){
	$setRefresh = true;
}


include('cont_top.inc.php');


?>

<script src="./amcharts.free/amcharts/amcharts.js" type="text/javascript"></script> 
<script src="./amcharts.free/amcharts/serial.js" type="text/javascript"></script>
<script src="js/jquery.js"></script>
<script src="diagramJS.js"></script>
	
<script>
    setSessionName('<?php echo $svweb_session_name; ?>');
</script>

<script>
    setSystemVar('<?php echo $sv->sysinfo['refresh']; ?>', '<?php echo $archivinterval; ?>');
</script>

<script>
    setDiagramType('<?php echo $type; ?>');
</script>

<script>
    setDiagramIndex('<?php echo $diagram_index; ?>');
</script>

<?php if (strlen(trim($type_text))) : ?>
	<script>
	document.title = '<?php echo trim($type_text.' '.line_breaks2spaces(dotted_if_too_long($ks_bezeichnung, 45))); ?>';
	</script>
<?php endif; ?>

<style type="text/css">
    #infosection {align: center; margin-left: 10px; margin-bottom: 5px; margin-top: 5px; font-family: Arial,sans-serif; font-size: 13px; font-weight: bold; }
</style>


</head>


<body style="height: 100%;">
<!-- Ueberbau -->

<div id=infosection>
    <table border="0" width="100%" cellspacing="0" cellpadding="0" summary="Headline Diagram Table" >
    <tr>
        <td rowspan="2" width="40">
        <button class="icon_button_width" name="bt_print" id="bt_print" type="button"
            title="<?php echo $text_array[$sv->lang_id]['print']; ?>">
        <img alt="<?php echo $text_array[$sv->lang_id]['print']; ?>" title="<?php echo $text_array[$sv->lang_id]['print']; ?>"
            src="print.gif" width="21" height="21">
        </button>
        </td>
        <td style="font-size: 13px;" align="right" width="250"><?php echo $type_text.':'; ?></td>
        <td style="font-size: 13px; font-weight: bold; text-decoration: underline;" width=40% align="center">
        <?php echo line_breaks2spaces(dotted_if_too_long($ks_bezeichnung, 80)); ?></td>
 				
 			<td style="padding: 5px 2px 0px 0px;" align="right">
	        <button class="diagram_button_width" name="bt_scroll_back" id="bt_scroll_back" type="button"
	            title="<?php echo $text_array[$sv->lang_id]['scroll_back'].' ['.$text_array[$sv->lang_id]['cursor_left'].']'; ?>">
	        <img name="img_scroll_back" alt="<?php echo $text_array[$sv->lang_id]['scroll_back'].' ['.$text_array[$sv->lang_id]['cursor_left'].']'; ?>"
	            src="scroll_back.gif" width="16" height="16"></button>
	      </td>
			
	      
	      <td style="padding: 5px 2px 0px 2px;" align="center">
                <button class="diagram_button_width" name="bt_zoom_org" id="bt_zoom_org" type="button"
                    title="<?php echo $text_array[$sv->lang_id]['original_size'].' [*]'; ?>">
                <img name="zoom_out" alt="<?php echo $text_array[$sv->lang_id]['original_size']; ?>"
	            src="ZoomFullOut.gif" width="16" height="16"></button>
                </td>
	      
	      
	      <td style="padding: 5px 5px 0px 2px;" align="left">
	        <button class="diagram_button_width" name="bt_scroll_forward" id="bt_scroll_forward" type="button"
	            title="<?php echo $text_array[$sv->lang_id]['scroll_forward'].' ['.$text_array[$sv->lang_id]['cursor_right'].']';?>">
	        <img name="img_scroll_forward" alt="<?php echo $text_array[$sv->lang_id]['scroll_forward'].' ['.$text_array[$sv->lang_id]['cursor_right'].']'; ?>"
	            src="scroll_forward.gif" width="16" height="16"></button>
	      </td>
	      
 				
 		<td rowspan="2" align="left" width="300">
                <input style="border-style: none;" type="checkbox" name="refresh_diagram" id="refreshDiagram" <?php if ($setRefresh) : ?>checked="checked"<?php endif; ?>> <?php echo $text_array[$sv->lang_id]['refresh']; ?>
                <div id="refreshInterval">
				<span style="font-size: 12px; font-weight: bold;" align=center id="refreshIntervalHtml" class="myDate">
                <?php echo '-&nbsp;'.$text_array[$sv->lang_id]['interval'].':&nbsp;'; ?>
                </span>
				</div>
        </td>
       
    </tr>
    <tr>
        <td style="padding-top: 0px;" align="right">
        	<span style="font-variant: normal; font-size: 13px;"><?php echo $text_array[$sv->lang_id]['timeframe'].':'; ?></span>
        </td>
        <td style="padding-top: 0px;" align="center">
        	<span id="timeframe" style="font-size: 13px; font-weight: bold;" align=center>&nbsp;</span>
        </td>
    </tr>
    </table>
</div>

<div id="chartdiv" style="width: 100%; height: 95%;"></div>
<script>
	<?php if($type == 'universal' || $type == 'single' || $type == 'detail' || $type == 'trend'){ ?>
		console.log("P1");
		makeGraph(); 
		//setElements(true);
		//switch_refresh();
		console.log("P2");
	<?php } else {  ?>
	<?php echo 'Error! No diagram type defined!'; ?>
	<?php } ?>
</script>	
</body>

<?php 
include('cont_bottom.inc.php');

/* {{{ Logfiles schreiben */
if($STANDARD_CONFIG['WRITE_LOGFILES']){
    $tmp_status = '  PERIOD: '.localdate_std($svsc->time_start).' - '.localdate_std($svsc->time_end);
    $tmp_status .= '  TAGS: ';
    $i = 0;
    foreach($svsc->tagauswahl as $tmp_tag){
        if(!$tmp_tag['hide_tag']){
            if($i > 0){
                $tmp_status .= ', ';
            }
            $tmp_status .= $tmp_tag['nummer'];
            $i++;
        }
    }
    if($_GET['type'] == 'universal'){
        $tmp_type = 'univ';
    }
    else{
        $tmp_type = $_GET['type'];
    }
    write_logfile($tmp_type, $sv->get_user(), $sv->get_host(), $sv->get_port(), $tmp_status);
}
/* }}} */

store_session($sv);

?>

