<?php

// vim: fdm=marker

/**********************
*  Andy Geiss 2009    *
*  Tabulatorweite: 4  *
**********************/

// L TODO: sv_export.exe unter Linux

ob_start();
require('scalarvis.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if(!start_session($sv)){
    session_no_longer_valid_msg();
}

if(!$sv->connect()){
    echo '<br />',get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    jsEscWindowClose();
    exit;
}

// Keine Tags ausgewhlt
if(!count($sv->tagauswahl)){
    jsWindowClose($text_array[$sv->lang_id]['no_tags_selected'].'!');
    exit($text_array[$sv->lang_id]['no_tags_selected'].'!');
}

/* {{{ Variablen belegen */
// Intervall behandeln
if(isset($_GET['tag_int']) && is_numeric($_GET['tag_int'])){
    $tag_int = (int) $_GET['tag_int'];
}
else{
    $tag_int = 0;
}
if(isset($_GET['std_int']) && is_numeric($_GET['std_int'])){
    $std_int = (int) $_GET['std_int'];
}
else{
    $std_int = 0;
}
if(isset($_GET['min_int']) && is_numeric($_GET['min_int'])){
    $min_int = (int) $_GET['min_int'];
}
else{
    $min_int = 0;
}
$interval = ($tag_int * 86400) + ($std_int * 3600) + ($min_int * 60);
// Intervall muss mindestens Server-Intervall sein
if($interval < $sv->sysinfo['intervall']){
    $interval = $sv->sysinfo['intervall'];
}
// Intervall muss durch Server-Intervall teilbar sein
else if($tmp_rest = $interval % $sv->sysinfo['intervall'] != 0){
    $interval = (int) round($interval / $sv->sysinfo['intervall']) * $sv->sysinfo['intervall'];
}
if($interval >= 86400){     // Wenn mindestens 1 Tag
    $tag_int = (int) floor($interval / 86400);
    $tmp_rest = $interval % 86400;
}
else{
    $tag_int = 0;
    $tmp_rest = $interval;
}
if($tmp_rest >= 3600){      // Wenn mindestens 1 Stunde
    $std_int = (int) floor($tmp_rest / 3600);
    $tmp_rest %= 3600;
}
else{
    $std_int = 0;
}
if($tmp_rest >= 60){        // Wenn mindestens 1 Minute
    $min_int = (int) floor($tmp_rest / 60);
}
else{
    $min_int = 0;
}

if(isset($_GET['from']) && is_numeric($_GET['from'])
&& isset($_GET['to']) && is_numeric($_GET['to'])){
    $from = (int) $_GET['from'];
    $to = (int) $_GET['to'];
}
else{
    $from = 0;
    $to = 0;
    $sv->get_timeframe($from, $to);
}
$from = round_time($from, $interval);
$to = round_time($to, $interval);

foreach($sv->tagauswahl as $tag){
	//echo isset($tag['invalid']);
    if(!isset($tag['invalid']) || $tag['invalid'] == 0){
        $tags[] = $tag['nummer'];
    }
}
//print_r($tags);
if(isset($_GET['separator'])){
    $separator = $_GET['separator'];
}
else{
    $separator = 'comma';
}

$wert_flag_array[0] = 1;
$wert_flag_array[1] = 0;
$wert_flag_array[2] = 0;
$wert_flag_array[3] = 0;
if(isset($_GET['submit_action'])){
    for($i = 0; $i < 4; $i++){
        if(isset($_GET['wert'.$i]) && $_GET['wert'.$i]){
            $wert_flag_array[$i] = 1;
        }
        else{
            $wert_flag_array[$i] = 0;
        }
    }
}
/* }}} */

/* {{{ Submit-Action verarbeiten */
if(!empty($_GET['submit_action'])){
    switch($_GET['submit_action']){
    case 'export':
        $export_retval = $sv->export($from,
                                     $to,
                                     $tags,
                                     $interval,
                                     $separator,
                                     $wert_flag_array);

        // 0 = Erfolg
        // -1 = Export-Logfile zum Auswerten kann nicht gelesen werden
        // -2 = Fehler beim Aufruf der SV_Export.exe
        // -3 = Temporres Export-File kann nicht gelesen werden
        // 87 = Keine Tags ausgewhlt
        // 117 = Keine Werte im angegebenen Zeitraum gelesen
        // 156 = Kein Werteauswahl-Hkchen gesetzt
        // !0 (else) = Datei konnte von SV_Export.exe nicht erzeugt werden
        switch($export_retval){
        case 0:
            $error = '';
            break;
        case -1:
            $error = 'Error reading status file!';
            break;
        case -2:
            $error = 'Error running export program!';
            break;
        case -3:
            $error = 'Export file cannot be read!';
            break;
        case 87:
            $error = $text_array[$sv->lang_id]['no_tags_selected'].'!';
            break;
        case 117:
            $error = $text_array[$sv->lang_id]['no_values_found'].'!';
            break;
        case 156:
            $error = $text_array[$sv->lang_id]['no_value_flag_selected'].'!';
            break;
        default:
            $error = 'Error '.$export_retval;
            break;
        }

        if($STANDARD_CONFIG['WRITE_LOGFILES']){
            $tmp_status = '  PERIOD: '.localdate_std($from).' - '.localdate_std($to);
            $tmp_status .= '  TAGS: ';
            $i = 0;
            foreach($tags as $tag_nr){
                if($i > 0){
                    $tmp_status .= ', ';
                }
                $tmp_status .= $tag_nr;
                $i++;
            }
            $tmp_status .= '  Current: '.$wert_flag_array[0].'  Minimum: '.$wert_flag_array[1]
                .'  Maximum: '.$wert_flag_array[2].'  Mean: '.$wert_flag_array[3];
            if(!empty($error)){
                $tmp_status .= ' - '.$error;
            }
            write_logfile('EXPORT', $sv->get_user(), $sv->get_host(), $sv->get_port(), $tmp_status);
        }

        if(empty($error)){
            exit;
        }
        break;
    }
}
/* }}} */

include('cont_top.inc.php');

echo '
<script type="text/javascript">
<!--
document.title = "Export";';

/* {{{ JavaScript Error-Alert() */
if(!empty($error)){
    echo '
    alert("',$error,'");';
}
/* }}} */

/* {{{ JavaScript-Funktion key_down_event() - Key-Event-Handler */
echo '
function key_down_event(event){
    var keyCode;
    if(!event){
        event = window.event;
    }
    if(event.which){
        keyCode = event.which;
    }
    else{
        if(event.keyCode){
            keyCode = event.keyCode;
        }
    }
    //alert("Taste mit Dezimalwert " + keyCode + " gedrckt");
    
    // Esc
    if(keyCode == 27){
        window.close();
    }
}
document.onkeydown = key_down_event;';
/* }}} */

echo '
//-->
</script>
</head>';

/* {{{ HTML-Body */
echo '
<body style="padding: 5px;">
<form name="exportform" method="GET" action="',$_SERVER["SCRIPT_NAME"],'">
<input type="hidden" name="from" value="',$from,'">
<input type="hidden" name="to" value="',$to,'">
<input type="hidden" name="submit_action" value="export">
<input type="hidden" name="session_name" value="',$svweb_session_name,'">

<table border="0" cellspacing="0" cellpadding="10" width="100%" summary="Timeframe">
<tr>
    <td align="center">
    ',$text_array[$sv->lang_id]['timeframe'],':&nbsp;<span style="font-weight: bold;">'
        ,localdate_std($from),'&nbsp;-&nbsp;',localdate_std($to),'</span>
    </td>
</tr>
</table>

<table border="0" style="border-style: inset; border-width: 4px;" cellspacing="10" cellpadding="3" 
    width="100%" summary="Export Form">
<tr>
    <td align="right" width="40%">',$text_array[$sv->lang_id]['interval'],':&nbsp;</td>
    <td>
    <input class="colored_input" style="text-align: right;" name="tag_int" size="3" maxlength="3" value="',$tag_int,'">&nbsp;:&nbsp;',
    '<input class="colored_input" style="text-align: right;" name="std_int" size="2" maxlength="2" value="',$std_int,'">&nbsp;:&nbsp;',
    '<input class="colored_input" style="text-align: right;" name="min_int" size="2" maxlength="2" value="',$min_int,'">',
    '&nbsp;&nbsp;[dd:hh:mm]&nbsp;&nbsp;&nbsp;
    </td>
</tr><tr>
    <td align="right">',$text_array[$sv->lang_id]['value_selection'],':&nbsp;</td>
    <td>
    <input type="checkbox" name="wert0"',($wert_flag_array[0]?' checked':''),' />&nbsp;'
        ,$text_array[$sv->lang_id]['measured_value'],'<br />
    <input type="checkbox" name="wert1"',($wert_flag_array[1]?' checked':''),' />&nbsp;'
        ,$text_array[$sv->lang_id]['maximum_value'],'<br />
    <input type="checkbox" name="wert2"',($wert_flag_array[2]?' checked':''),' />&nbsp;'
        ,$text_array[$sv->lang_id]['minimum_value'],'<br />
    <input type="checkbox" name="wert3"',($wert_flag_array[3]?' checked':''),' />&nbsp;'
        ,$text_array[$sv->lang_id]['mean_value'],'
    </td>
</tr><tr>
    <td align="right">',$text_array[$sv->lang_id]['data_format'],':&nbsp;</td>
    <td>
    <select class="colored_input" name="separator">
    <option value="comma"',($separator == 'comma'?' selected':''),'>CSV - ',$text_array[$sv->lang_id]['comma'],'</option>
    <option value="semicolon"',($separator == 'semicolon'?' selected':''),'>CSV - ',$text_array[$sv->lang_id]['semicolon'],'</option>
    <option value="tabulator"',($separator == 'tabulator'?' selected':''),'>CSV - ',$text_array[$sv->lang_id]['tabulator'],'</option>
    <option value="excel"',($separator == 'excel'?' selected':''),'>',$text_array[$sv->lang_id]['excel'],'</option>
    </select>
    </td>
</tr><tr>
    <td colspan="2" style="padding-top: 7px;" align="center">
    <input style="width: 70px;" type="submit" value="OK">
    </td>
</tr>
</table>

</form>
</body>';
/* }}} */

include('cont_bottom.inc.php');

store_session($sv);

?>

