<?php

// vim: fdm=marker

/* * *************************
 *  Andy Geiss 2009 - 2010  *
 * 	Geaendert 20150205		*
 *  Tabulatorweite: 4       *
 * ************************* */

// X TODO: Overlay auch in FE-Vorschau?

ob_start();
require_once('../scalarvis.inc.php');
require_once('flowchartfunctions.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if (!start_session($sv)) {
    session_no_longer_valid_msg();
}

if (!$sv->connect()) {
    echo '<br />', get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    exit;
}

/* {{{ Variablen belegen */
$MarginTop = 0;
$MarginLeft = 0;
$TwipsPerPixelX = 15;
$TwipsPerPixelY = 15;
$transparentpixel_file = '../transparentpixel.gif';
$menuUni = "true";
$menuDetail = "true";
$menuTrend = "true";

/* {{{ Menpunkt Universal-Diagramm */
if (isset($sv->USER_CONFIG['NAV_UNIV']) && $sv->USER_CONFIG['NAV_UNIV']) {
    $menuUni = "false";
}
/* }}} */

/* {{{ Menpunkt Detail-Diagramm */
if (isset($sv->USER_CONFIG['NAV_DETAIL']) && $sv->USER_CONFIG['NAV_DETAIL']) {
    $menuDetail = "false";
}
/* }}} */

/* {{{ Menpunkt Trend-Diagramm */
if (isset($sv->USER_CONFIG['NAV_TREND']) && $sv->USER_CONFIG['NAV_TREND']) {
    $menuTrend = "false";
}
/* }}} */

if (isset($sv->USER_CONFIG['FLOWCHART_DIR']) && strlen(trim($sv->USER_CONFIG['FLOWCHART_DIR'])) && trim($sv->USER_CONFIG['FLOWCHART_DIR']) != 'empty') {
    $flowchart_dir = $sv->USER_CONFIG['FLOWCHART_DIR'];
} else {
    $flowchart_dir = '';
}
$flowchart_dir_js = bs2slash($flowchart_dir);

$flowchart_ini_file = $flowchart_dir . 'Fliess.ini';
/* }}} */

/* {{{ Flowchart-INI-File einlesen */
if (is_file($flowchart_ini_file)) {
    $ini_array = get_ini_array($flowchart_ini_file);
} else {
    echo '<br />File ' . $flowchart_ini_file . ' not found!';
    store_session($sv);
    exit;
}

// Fliess-Array ermitteln
$fliess_array = get_fliess_array($ini_array);

// Objekt-Array zum Register ermitteln
$object_array = get_object_array($ini_array, $register);
/* }}} */

$from = 0;
$to = 0;
$sv->get_timeframe($from, $to);
$interval = $sv->sysinfo['intervall'];
$from = round_time($from, $interval);
$to = round_time($to, $interval);
$fromText = localdate_std($from, true);
$toText = localdate_std($to, true);

/* {{{ Margin bestimmen */
if (isset($ini_array['Fliess']['PosTop']) && is_numeric($ini_array['Fliess']['PosTop']) && isset($ini_array['Fliess']['PosLeft']) && is_numeric($ini_array['Fliess']['PosLeft'])) {
    $MarginTop = (int) round($ini_array['Fliess']['PosTop'] / $TwipsPerPixelY);
    $MarginLeft = (int) round($ini_array['Fliess']['PosLeft'] / $TwipsPerPixelX);
}
$MarginTop .= 'px';
$MarginLeft .= 'px';
/* }}} */

/* {{{ Image-Area-Map bestimmen */
// Attribut-Relevanz
$html_area_map = '
<map name="map_flowchartimage">';
foreach (array_reverse($object_array, true) as $object_no => $object_value_array) {
    // Objekte als Hyperlink
    if (isset($object_value_array['HyperLink'])) {
        $hyperlink = complete_hyperlink($object_value_array['HyperLink']);
    } else {
        $hyperlink = '';
    }

    if (strlen($hyperlink)) {
        $x1 = twips2pixels($object_value_array['PosLeft'], $TwipsPerPixelX);
        $y1 = twips2pixels($object_value_array['PosTop'], $TwipsPerPixelY);
        $x2 = $x1 + twips2pixels($object_value_array['PosWidth'], $TwipsPerPixelX);
        $y2 = $y1 + twips2pixels($object_value_array['PosHeight'], $TwipsPerPixelY);
        $html_area_map .= '
        <area shape="rect" coords="' . $x1 . ',' . $y1 . ',' . $x2 . ',' . $y2 . '" href="' . $hyperlink . '" alt="' . $hyperlink . '"';
        // Absolute Hyperlinks
        if (check_for_blank($hyperlink)) {
            $html_area_map .= ' target="_blank"';
        } else {
            $html_area_map .= ' target="main"';
        }
        $html_area_map .= '>';
    }
}
$html_area_map .= '
</map>';
/* }}} */

/* {{{ menu-Objekte bestimmen */
// Attribut-Relevanz
$menu_array = array();
$menu_array_index = 0;
$html_img_menu = "";
foreach ($object_array as $object_no => $object_value_array) {
    if (isset($object_value_array['TagTyp'])) {
        switch ($object_value_array['TagTyp']) {
            case 0:
            case 1:
            case 2:
            case 3:
            case 8:
            case 9:
            case 20:
            case 21:
                if ($object_value_array['TagNummer'] > 0) {
                    $menu_array[$menu_array_index]['TagNummer'] = $object_value_array['TagNummer'];
                    $menu_array[$menu_array_index]['ObjectNo'] = $object_value_array['ObjectNo']; //$object_no;
                    $menu_array[$menu_array_index]['TagTyp'] = $object_value_array['TagTyp'];
                    $menu_array[$menu_array_index]['PosLeftPixel'] = twips2pixels($object_value_array['PosLeft'], $TwipsPerPixelX);
                    $menu_array[$menu_array_index]['PosTopPixel'] = twips2pixels($object_value_array['PosTop'], $TwipsPerPixelY);
                    $menu_array[$menu_array_index]['PosWidthPixel'] = twips2pixels($object_value_array['PosWidth'], $TwipsPerPixelX);
                    $menu_array[$menu_array_index]['PosHeightPixel'] = twips2pixels($object_value_array['PosHeight'], $TwipsPerPixelY);
                }
        }
        $menu_array_index++;
    }
}
/* }}} */

/* {{{ Overlay-Objekte bestimmen */
// Attribut-Relevanz
$giffile_array = array();
$giffile_array_index = 0;
foreach ($object_array as $object_no => $object_value_array) {
    // Overlay-Objekte
    // Erstes Objekt eines Registers muss immer das grundlegende Hintergrundbild sein,
    // deshalb wird dieses in dieser Schleife ausgeschlossen
    if ($object_no != '000') {
        if (isset($object_value_array['HyperLink'])) {
            $hyperlink = complete_hyperlink($object_value_array['HyperLink']);
        } else {
            $hyperlink = '';
        }
        $giffile_array[$giffile_array_index]['TagNummer'] = 0;
        $giffile_array[$giffile_array_index]['TrueNr'] = 0;
        $giffile_array[$giffile_array_index]['TagTyp'] = 0;
        $giffile_array[$giffile_array_index]['ValTrue1'] = 1.0;
        $giffile_array[$giffile_array_index]['ValTrue2'] = 1.0;
        $giffile_array[$giffile_array_index]['ValTrue3'] = 1.0;
        if (isset($giffile)) {
            unset($giffile);
        }
        // Attribut-Relevanz
        // Tag-Typ-Unterscheidung
        switch ($object_value_array['TagTyp']) {
            case 9:
                $giffile_err = GetGIFFile($object_value_array['TxtErr'], $flowchart_dir);
                $giffile_false = GetGIFFile($object_value_array['TxtFalse'], $flowchart_dir);
                $giffile_true = GetGIFFile($object_value_array['TxtTrue'], $flowchart_dir);
                $giffile = $giffile_err;

                if ($object_value_array['TagNummer'] != 0) {
                    if ($sv->get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)) {
                        $tmp_value = $tmp_tag_info_array['wert'];
                        if ($tmp_value == -1.0e38) {
                            $giffile = $giffile_err;
                        } else if ($tmp_value == 0.0) {
                            $giffile = $giffile_false;
                        } else {
                            $giffile = $giffile_true;
                        }
                    }
                }

                //if(isset($giffile)){
                if ((strlen(trim($giffile_err)) || strlen(trim($giffile_false)) || strlen(trim($giffile_true))) && is_numeric($object_value_array['PosLeft']) && is_numeric($object_value_array['PosTop']) && is_numeric($object_value_array['PosWidth']) && is_numeric($object_value_array['PosHeight'])) {
                    $giffile_array[$giffile_array_index]['ObjectNo'] = $object_no;
                    $giffile_array[$giffile_array_index]['TagTyp'] = $object_value_array['TagTyp'];
                    $giffile_array[$giffile_array_index]['TagNummer'] = $object_value_array['TagNummer'];
                    $giffile_array[$giffile_array_index]['FileName'] = $giffile;
                    $giffile_array[$giffile_array_index]['TxtErr'] = $giffile_err;
                    $giffile_array[$giffile_array_index]['TxtFalse'] = $giffile_false;
                    $giffile_array[$giffile_array_index]['TxtTrue'] = $giffile_true;
                    $giffile_array[$giffile_array_index]['PosLeftPixel'] = twips2pixels($object_value_array['PosLeft'], $TwipsPerPixelX);
                    $giffile_array[$giffile_array_index]['PosTopPixel'] = twips2pixels($object_value_array['PosTop'], $TwipsPerPixelY);
                    $giffile_array[$giffile_array_index]['PosWidthPixel'] = twips2pixels($object_value_array['PosWidth'], $TwipsPerPixelX);
                    $giffile_array[$giffile_array_index]['PosHeightPixel'] = twips2pixels($object_value_array['PosHeight'], $TwipsPerPixelY);
                    $giffile_array[$giffile_array_index]['HyperLink'] = $hyperlink;
                    $giffile_array_index++;
                }
                //}
                break;
            // Bild aus Fliess.ini (TxtErr)
            case 21:
                $giffile_err = GetGIFFile($object_value_array['TxtErr'], $flowchart_dir);
                $giffile_false = GetGIFFile($object_value_array['TxtFalse'], $flowchart_dir);
                $giffile_true1 = GetGIFFile($object_value_array['TxtTrue1'], $flowchart_dir);
                $giffile_true2 = GetGIFFile($object_value_array['TxtTrue2'], $flowchart_dir);
                $giffile_true3 = GetGIFFile($object_value_array['TxtTrue3'], $flowchart_dir);
                $giffile = $giffile_err;

                if ($object_value_array['TagNummer'] != 0) {
                    $giffile_array[$giffile_array_index]['TagTyp'] = $object_value_array['TagTyp'];
                    if ($sv->get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)) {
                        $tmp_value = (double) $tmp_tag_info_array['wert'];
                        $tmp_value1 = (double) 1.0;
                        $tmp_value2 = (double) 0.0;
                        $tmp_value3 = (double) 0.0;

                        if (isset($object_value_array['ValTrue1']) && is_numeric($object_value_array['ValTrue1'])) {
                            $tmp_value1 = (double) $object_value_array['ValTrue1'];
                        }
                        if (isset($object_value_array['ValTrue2']) && is_numeric($object_value_array['ValTrue2'])) {
                            $tmp_value2 = (double) $object_value_array['ValTrue2'];
                        }
                        if (isset($object_value_array['ValTrue3']) && is_numeric($object_value_array['ValTrue3'])) {
                            $tmp_value3 = (double) $object_value_array['ValTrue3'];
                        }

                        if ((double) $tmp_value == (double) 0.0) {
                            $giffile = $giffile_false;
                        } else if ((double) $tmp_value == (double) $tmp_value1) {
                            $giffile = $giffile_true1;
                        } else if ((double) $tmp_value == (double) $tmp_value2) {
                            $giffile = $giffile_true2;
                        } else if ((double) $tmp_value == (double) $tmp_value3) {
                            $giffile = $giffile_true3;
                        }
                    }
                }

                // Image in Hauptgrafik einbinden
                if (isset($giffile)) {
                    if (is_numeric($object_value_array['PosLeft']) && is_numeric($object_value_array['PosTop']) && is_numeric($object_value_array['PosWidth']) && is_numeric($object_value_array['PosHeight'])) {
                        $giffile_array[$giffile_array_index]['ObjectNo'] = $object_no;
                        $giffile_array[$giffile_array_index]['TagNummer'] = $object_value_array['TagNummer'];
                        $giffile_array[$giffile_array_index]['FileName'] = $giffile;
                        $giffile_array[$giffile_array_index]['ValTrue1'] = $object_value_array['ValTrue1'];
                        $giffile_array[$giffile_array_index]['ValTrue2'] = $object_value_array['ValTrue2'];
                        $giffile_array[$giffile_array_index]['ValTrue3'] = $object_value_array['ValTrue3'];
                        $giffile_array[$giffile_array_index]['TxtErr'] = $giffile_err;
                        $giffile_array[$giffile_array_index]['TxtFalse'] = $giffile_false;
                        $giffile_array[$giffile_array_index]['TxtTrue1'] = $giffile_true1;
                        $giffile_array[$giffile_array_index]['TxtTrue2'] = $giffile_true2;
                        $giffile_array[$giffile_array_index]['TxtTrue3'] = $giffile_true3;
                        $giffile_array[$giffile_array_index]['PosLeftPixel'] = twips2pixels($object_value_array['PosLeft'], $TwipsPerPixelX);
                        $giffile_array[$giffile_array_index]['PosTopPixel'] = twips2pixels($object_value_array['PosTop'], $TwipsPerPixelY);
                        $giffile_array[$giffile_array_index]['PosWidthPixel'] = twips2pixels($object_value_array['PosWidth'], $TwipsPerPixelX);
                        $giffile_array[$giffile_array_index]['PosHeightPixel'] = twips2pixels($object_value_array['PosHeight'], $TwipsPerPixelY);
                        $giffile_array[$giffile_array_index]['HyperLink'] = $hyperlink;
                        $giffile_array_index++;
                    }
                }
                break;
        }
    }
}
/* }}} */

$codebase = '../';
include('../cont_top.inc.php');

echo '
<link rel="stylesheet" type="text/css" href="contextMenu.css" />
<link rel="stylesheet" href="../taginfo.css" type="text/css">
<style>
.MyButton {cursor: help;}
</style>
<script type="text/javascript" src="../js/jquery.js"></script>
<script type="text/javascript" src="contextMenu.js"></script>
';

/* {{{ CSS-Definitionen */
echo '
<style type="text/css">
';

foreach ($giffile_array as $giffile) {
    if (isset($giffile['ObjectNo'])) {
        echo '
#gif', $giffile['ObjectNo'], '{
    position: absolute;
    left: ', $giffile['PosLeftPixel'] + $MarginLeft, 'px;
    top: ', $giffile['PosTopPixel'] + $MarginTop, 'px;
    width: ', $giffile['PosWidthPixel'], 'px;
    height: ', $giffile['PosHeightPixel'], 'px;
}';
    }
}

foreach ($menu_array as $menufile) {
    if (isset($menufile['ObjectNo'])) {
        echo '
#MyButton', $menufile['ObjectNo'], '{
    position: absolute;
    left: ', $menufile['PosLeftPixel'] + $MarginLeft, 'px;
    top: ', $menufile['PosTopPixel'] + $MarginTop, 'px;
    width: ', $menufile['PosWidthPixel'], 'px;
    height: ', $menufile['PosHeightPixel'], 'px;
}';
    }
}

echo '
    #infowindow {display: none;}
</style>';
/* }}} */


echo '<script src="../js/fliessContextMenu.js"></script>';
echo '<script src="../js/jQuery.print.js"></script>';

/* {{{ JavaScript-Funktionen */
echo '
<script type="text/javascript">
<!--

$(document).ready(function(){

var contextMenuSettings={
	method:"menu",
	option:{
			triggerOn: "click",
			displayAround: "cursor",
			mouseClick: "right",
			verAdjust: 0,
			horAdjust: 0,
			top:"auto",
			left:"auto",
			sizeStyle:"auto",
			position: "auto",
			closeOnClick: false,
			containment:window
		}
	}
var arMenu = new Array();
var menuIdx = 0;
';

// Menu-Diagram
foreach ($menu_array as $menu) {
    if (isset($menu['TagNummer']) && is_numeric($menu['TagNummer']) && ($menu['TagNummer'] > 0)) {
        echo '
    //alert("TAGNr: " + ', $menu['TagNummer'], ' );
	//alert("menuIdx: " + menuIdx);
    if(document.getElementById("MyButton', $menu['ObjectNo'], '")){
			arMenu[menuIdx] = [{
				name: "Universal",
				img: "images/graph05.ico",
				title: "Universal",
				disable: ', $menuUni, ',
				fun: function () {
					//alert("TAGNr: " + ', $menu['TagNummer'], ' );
					javascript:menuItemDiagram(\'universal\',' . $menu['TagNummer'] . ', \'MyButton' . $menu['ObjectNo'] . '\', \'' . $svweb_session_name . '\')
				}
			}, {
				name: "Detail",
				img: "images/graph04.ico",
				title: "Detail",
				disable: ', $menuDetail, ',
				fun: function () {
					javascript:menuItemDiagram(\'detail\',' . $menu['TagNummer'] . ', \'MyButton' . $menu['ObjectNo'] . '\', \'' . $svweb_session_name . '\')
				}
			}, {
				name: "Trend",
				img: "images/graph04.ico",
				title: "Trend",
				disable: ', $menuTrend, ',
				fun: function () {
					javascript:menuItemDiagram(\'trend\',' . $menu['TagNummer'] . ', \'MyButton' . $menu['ObjectNo'] . '\', \'' . $svweb_session_name . '\');
				}
			}, {
				name: "TAG-Info",
				img: "images/Folder06.ico",
				title: "TAG-Info",
				disable: false,
				fun: function () {
					
					javascript:menuItemTAGInfo(' . $menu['TagNummer'] . ', ' . (int) $menu['TagTyp'] . ', ' . (int) $menu['ObjectNo'] . ', ' . (int) $register . ', \'MyButton' . $menu['ObjectNo'] . '\', \'' . $svweb_session_name . '\');
				}
			}];
			//Calling context menu
			$("#MyButton', $menu['ObjectNo'], '").contextMenu(contextMenuSettings.method, arMenu[menuIdx], contextMenuSettings.option);
			menuIdx++;
		}';
    }
}

echo '
});
';


/* {{{ JavaScript-Funktion ajaxRefreshOverlay() - Gif-Files anzeigen */
echo '
function ajaxRefreshOverlay(){
    var imageSrc = "";
    var ResponseText = "";
	
	//location.reload(true); //This fixes the update tag numbers but flashs the flow chart.
';
jsCreateXMLHttpRequest('xmlhttp');


// GIF-Files
foreach ($giffile_array as $giffile) {
    if (isset($giffile['TagNummer']) && is_numeric($giffile['TagNummer']) && ($giffile['TagNummer'] > 0)) {
        echo '
    //alert("TAGNr: " + ', $giffile['TagNummer'], ' );
    if(document.images["gif', $giffile['ObjectNo'], '"]
    && document.images["gif', $giffile['ObjectNo'], '"].complete){
        xmlhttp.open("GET", "../ajax_actions.php?ajax_action=get_txt_err_trueX_false&typ_nr=', $giffile['TagTyp'], '&val1=', $giffile['ValTrue1'], '&val2=', $giffile['ValTrue2'], '&val3=', $giffile['ValTrue3'], '&tag_nr=', $giffile['TagNummer'], '&session_name=', $svweb_session_name, '", false);
        xmlhttp.send(null);
        ResponseText = String(xmlhttp.responseText);
        //alert("ObjectNo: " + ', $giffile['ObjectNo'], ');
        if(ResponseText.indexOf("TxtFalse") != -1){
            imageSrc = "', (strlen(trim($giffile['TxtFalse'])) ? $flowchart_dir_js . $giffile['TxtFalse'] : $transparentpixel_file), '";
        }
        else if(ResponseText.indexOf("TxtTrue1") != -1){
            imageSrc = "', (((isset($giffile['TxtTrue1'])) && (strlen(trim($giffile['TxtTrue1'])))) ? $flowchart_dir_js . $giffile['TxtTrue1'] : $transparentpixel_file), '";
        }
        else if(ResponseText.indexOf("TxtTrue2") != -1){
            imageSrc = "', ( ((isset($giffile['TxtTrue2'])) && (strlen(trim($giffile['TxtTrue2'])))) ? $flowchart_dir_js . $giffile['TxtTrue2'] : $transparentpixel_file), '";
        }
        else if(ResponseText.indexOf("TxtTrue3") != -1){
            imageSrc = "', (((isset($giffile['TxtTrue3'])) && (strlen(trim($giffile['TxtTrue3'])))) ? $flowchart_dir_js . $giffile['TxtTrue3'] : $transparentpixel_file), '";
        }
        else if(ResponseText.indexOf("TxtTrue") != -1){
            imageSrc = "', (((isset($giffile['TxtTrue'])) && (strlen(trim($giffile['TxtTrue'])))) ? $flowchart_dir_js . $giffile['TxtTrue'] : $transparentpixel_file), '";
        }
        else{
            imageSrc = "', (strlen(trim($giffile['TxtErr'])) ? $flowchart_dir_js . $giffile['TxtErr'] : $transparentpixel_file), '";
        }
        if(basename(document.images["gif', $giffile['ObjectNo'], '"].src) != basename(imageSrc)){
            document.images["gif', $giffile['ObjectNo'], '"].src = imageSrc;
        }
    }';
    }
}

echo '
    delete xmlhttp;
    xmlhttp = null;
};
/* }}} */

//-->
</script>
';
/* }}} */

echo '
</head>

<body style="margin-top: ', $MarginTop, '; margin-left: ', $MarginLeft, ';" >
';


echo $html_area_map;

// Fliebild als Hintergrund mit Image-Area-Map darstellen
//echo '
//<img name="flowchartimage" id="flowchartimage" alt="Bild wird geladen." usemap="#map_flowchartimage" border="0"
//    src="flowchartimage.php?register=', $register, '&time=', time(), '&session_name=', $svweb_session_name, '">
//';

echo '
    <canvas id="flowchartCanvas"/>
';

echo '
<script type="text/javascript">

drawFirstCanvas("flowchartimage.php?register=', $register, '&time=', time(), '&session_name=', $svweb_session_name, '");  

</script>
';

//print_r_formatted($giffile_array);
foreach ($giffile_array as $giffile) {
    //break;
    if (!empty($giffile['HyperLink'])) {
        echo '
<a href="', $giffile['HyperLink'], '"';

        if (check_for_blank($giffile['HyperLink'])) {
            echo ' target="_blank"';
        } else {
            echo ' target="main"';
        }

        echo '>';
    }

    if ((!empty($giffile['FileName'])) && (strlen(trim($giffile['FileName'])))) {
        $imageSrc = $flowchart_dir_js . $giffile['FileName'];
    } else {
        $imageSrc = $transparentpixel_file;
    }
    if ((!empty($giffile['FileName'])) && (!empty($giffile['ObjectNo']))) {
        echo '
<img name="gif' . $giffile['ObjectNo'] . '" id="gif' . $giffile['ObjectNo'] . '" alt="' . $giffile['FileName'] . '"
    border="0" src="' . $imageSrc . '"';
        if (!empty($giffile['HyperLink'])) {
            echo ' title="' . $giffile['HyperLink'] . '"';
        }
        echo '>';

        if (!empty($giffile['HyperLink'])) {
            echo '
</a>';
        }
    }
}

foreach ($menu_array as $menufile) {
    if (isset($menufile['ObjectNo'])) {
        echo '
<img name="MyButton' . $menufile['ObjectNo'] . '" class="MyButton" id="MyButton' . $menufile['ObjectNo'] . '">';
    }
}

echo '
    <div id="infowindow"></div>
</body>';

include('../cont_bottom.inc.php');

store_session($sv);

/* {{{ PHP-Funktion check_for_blank() */

function check_for_blank($hyperlink) {
    $retval = false;

    if (strstr($hyperlink, '://')) {
        $retval = true;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion complete_hyperlink() */

function complete_hyperlink($raw_link) {
    global $svweb_session_name;
    $hyperlink = '';

    if (!empty($raw_link)) {
        $hyperlink = trim($raw_link);
        // Relative Hyperlinks (werden generell mit frameset_flowchart.php und href-target "main" verarbeitet)
        if (!strstr($hyperlink, '://') && strstr($hyperlink, '?')) {
//            $hyperlink = 'frameset_flowchart.php' . $hyperlink;
            $hyperlink = 'flowchartmenu.php' . $hyperlink;
            $hyperlink .= '&content=flowchart&session_name=' . $svweb_session_name;
        }
    } else {
        $hyperlink = '';
    }

    return $hyperlink;
}

/* }}} */
?>
