<?php

// vim: fdm=marker

/***************************
*  Andy Geiss 2008 - 2010  *
*  Tabulatorweite: 4       *
***************************/

// N TODO: Pfadbehandlung plattformunabhngig, aber abwrts kompatibel gestalten (Fonts) -> mit Linux testen -> im Zuge der Scalarvis-PHP-Extension-bernahme

ob_start();
// Wenn Fliebild-Editor-Vorschau
if(isset($fci_inc)){
    $tmp_dirname = dirname($fci_inc);
    $tmp_pos = strrpos($tmp_dirname, '/');
    $tmp_dirname = substr($tmp_dirname, 0, $tmp_pos + 1);

    require_once($tmp_dirname.'base_functions.inc.php');
    require_once($tmp_dirname.'scalarvis_ext.inc.php');
    require_once($tmp_dirname.'sv_short_class.php');
    require_once($tmp_dirname.'flowchart/flowchartfunctions.inc.php');
}
else{
	require_once('../scalarvis_ext.inc.php');
}
ob_end_clean();

error_reporting(E_ALL);

/* {{{ Variablen initialisieren */
$offset_x = 0;
$offset_y = 0;
$PixelOffsetX = 0;
$PixelOffsetY = 0;
$ScreenPixelX = 1024;
$ScreenPixelY = 684;
$AnzRegister = 0;
$TitelHeight = 390;
$MenueHeight = 300;
$BorderWidth = 60;
$TabHeight = 300;
$FontSize = 3;
$file_type = 3;
$TwipsPerPixelX = 15;
$TwipsPerPixelY = 15;
$PosLeft = 0;
$PosTop = 0;
$PosWidth = $ScreenPixelX * $TwipsPerPixelX;
$PosHeight = $ScreenPixelY * $TwipsPerPixelY;
$global_gd = 2;
$im = null;
$object_000 = 0;

// In VB werden Positionen im SSTabcontrol, die negativ sind, mit einem Offset von 75000 versehen
$cnstControl = 75000;

$fliess_array = array();
$object_array = array();
$section_array = array();
/* }}} */

/* {{{ PHP-Funktion ContentTypeHeader() */
function ContentTypeHeader($file_type){
    if($file_type == 2){
        header("Content-type: image/jpeg");
    }
    else if($file_type == 3){
        header("Content-type: image/png");
    }
}
/* }}} */

/* {{{ PHP-Funktion convert_commas_to_dots() - Wandelt Kommas in Dezimalpunkte um */
function convert_commas_to_dots($string_to_convert){
    $tmp_value = "";
    for($i=0; $i < strlen($string_to_convert); $i++){
        $tmp_substr = substr($string_to_convert, $i, 1);
        if($tmp_substr == ','){
            $tmp_value .= '.';
        }
        else{
            $tmp_value .= $tmp_substr;
        }
    }
    return $tmp_value;
}
/* }}} */
/**
 * Archivwert lesen ueber TAGs in einem Register
 * @param array $object_array Array mit Objekten eines Registers
 * @param string $archive Archiv lesen oder nicht
 * @param array $data Array mit gelesenen Werten zu den Objekten
 */
function read_archiv_fliess($sv, $object_array, $arctime, $archive = null, &$data){
	$ret = 0;
	if($archive !== null){
		$tags = array();
		foreach($object_array as $object_no => $object_value_array){
			switch($object_value_array['TagTyp']){
				case 0://Wert
				case 2://Indicator
				case 8://Binaerunterscheidung
				case 9://Bildunterscheidung
				case 20://Windrose
				case 21://Werte-Vergleich
					{
						if((isset($object_value_array['TagNummer']))
								&& (is_numeric($object_value_array['TagNummer']))
								&& ($object_value_array['TagNummer'] > 0)){
							$tag = (int)$object_value_array['TagNummer'];
							$ret = false;
							if(count($tags)){
								$ret = array_search($tag, $tags);
								if($ret !== false){
									continue;
								}
							}
							$tags[] = $tag;
							sort($tags);
						}
						break;
					}
			}//switch
		}//end foreach
		 
		if(count($tags) > 0){
			//Archiv lesen
			$ret = get_fliess_data_value($sv, $tags, $arctime, $data);
		}
		/*    echo '<pre>';
		 //print_r($ini_array);
		//print_r($fliess_array);
		print_r($data);
		//print_r($object_array);
		echo '</pre>';
		exit;
		*/
	}//end if $archive
	return $ret;
}

/**
 * get_fliess_data_value() - Daten fr Archhiv-Ansicht fuer einen Zeitstempel im Fliessbild aufbereiten
 * Erstellt RS 20150511 warum das in diese Datei muss, weiss ich nicht
 * woanders findet er die Funktion nicht
 * @param number $tags
 * @param number $arctime
 * @param array reference $data
 * @returns void
 */
function get_fliess_data_value($sv, $tags, $arctime, &$data){
	//global $sv;
	$data = null;
	$anz = 0;
	$erg=null;
	$ergtags=null;
	$ret = 0;

	if(isset($tags)){
		$anztag = count($tags);
		$Max_Aw_Tags = $sv->MAX_AW_TAGS;
		$anzRound = intval($anztag / $Max_Aw_Tags);
		$info = array();
		for($i=0;$i<=$anzRound;$i++){
			if($i < $anzRound){
				$maxAwTagAnz = $Max_Aw_Tags;
			}
			elseif(($anztag % $Max_Aw_Tags) > 0){
				$maxAwTagAnz = $anztag % $Max_Aw_Tags;
			}
			else{
				break;
			}
			$arrtags = array();
			$jj=0;
			for($j = 0; $j < $maxAwTagAnz; $j++){
				$arrtags[] = $tags[$j + ($i * $Max_Aw_Tags)];
			}//end for $j
			//$buf=array(Auslesebeginn,anztag,anzval(server),StartOffset,AnzWerte(zurckgeliefert),Intervall,Blocksize,Blockanz,Schrittweite,Tags[MAXAWTAGS])
			$from = (int)$arctime;
			$to = (int)$arctime;
			//$sv->get_timeframe($from, $to);
			$interval = $sv->sysinfo['intervall'];
			$from = round_time($from, $interval);
			$to = round_time($to, $interval);
			$fromText = localdate_std($from, true);
			$toText = localdate_std($to, true);
				
			
			
			
			$buf = $sv->set_arct($from, $to, $arrtags, true);
			if($buf){
				$anz = intval(substr($buf, 5, strlen($buf) - 24));  // String aufs Wesentliche reduzieren
			}
			if($anz > 0){
				$buf = $sv->get_awt_fliess(1);
				if(isset($buf)){
					if($i==0){
						array_push($info, $buf['index'], $buf['Datum'], $buf['Zeit'], $buf['anz_tags']);
					}
					for($k = 0; $k < (count($buf) - 4); $k++){
						$erg[$k + ($i * $Max_Aw_Tags)] = $buf[$k];
					}
				}
			}
		}//end for anzRound
		if(isset($info) && isset($erg)){
			$data[] = $info;
			$data[] = $tags;
			$data[] = $erg;
			$ret = 1;
		}
	}

	return $ret;
}

/**
 * Groesse des Ausgabebilds bestimmen
 */
function set_size($fliess_array, $cnstControl, &$PosWidth, &$PosHeight, &$PosLeft, $TwipsPerPixelX, $TwipsPerPixelY, $BorderWidth, $valPos){
	if(isset($fliess_array['PosWidth'])){
		$PosWidth = $fliess_array['PosWidth'];
		$PosWidth = $PosWidth - $BorderWidth * 2;
	}
	if($PosWidth < $TwipsPerPixelX){
		$PosWidth = $TwipsPerPixelX;
	}
	if(isset($fliess_array['PosHeight'])){
		$PosHeight = $fliess_array['PosHeight'];
		$PosHeight = $PosHeight - $valPos;
	}
	if($PosHeight < $TwipsPerPixelY){
		$PosHeight = $TwipsPerPixelY;
	}
	if($PosLeft > $PosWidth){
		$PosLeft = $PosLeft - $cnstControl;
	}
}


/*
 $TwipsPerPixelX = $PosWidth / imagesx($im);
$TwipsPerPixelY = $PosHeight / imagesy($im);
$offset_y = $offset_y / $TwipsPerPixelY;
echo '<pre>';
echo "\r\nTwipsPerPixelX: ",$TwipsPerPixelX;
echo "\r\nTwipsPerPixelY: ",$TwipsPerPixelY;
echo "\r\nObjectPosLeft: ",$object_array['000']['PosLeft'];
echo "\r\nObjectPosTop: ",$object_array['000']['PosTop'];
echo "\r\nObjectPosWeite: ",$object_array['000']['PosWidth'];
echo "\r\nPosWeite: ",$PosWidth;
echo "\r\nPosHeight: ",$PosHeight;
echo "\r\nim_X: ",imagesx($im);
echo "\r\nim_Y: ",imagesy($im);
echo "\r\noffset_x: ",$offset_x;
echo "\r\noffset_y: ",$offset_y;
echo "\r\n";
print_r($fliess_array);
//echo "\r\nfiletyp: ",$file_type;
//print_r($ini_array);
//print_r($object_array);
echo '</pre>';
exit;
*/

/**
 * Gibt Archivwert zu TAGNr zurueck
 * @param number $val Wert fuer Fliessbildanzeige 
 * @param number $tagnr
 * @param number $read_archiv
 * @param array $data TAGNummern und Archivwerte
 * @return number
 */
function get_archiv_value(&$val, $tagnr, $read_archiv, $data){
	$ret = 0;
	$val = -1.0e38;
	if(($read_archiv !== 0) && ($data != null)){
		$idx = array_search($tagnr, $data[1]);
		if($idx !== false){
		//TAGNummer hat einen Archivwert, ist im gleichen Index
			$val = $data[2][$idx];
			$ret = 1;
		}
	}
	return $ret;
}



/**
 * 
 * @param unknown $tagtyp
 * @param unknown $object_value_array
 * @param unknown $dst_im
 * @param unknown $TwipsPerPixelX
 * @param unknown $TwipsPerPixelY
 * @param unknown $offset_x
 * @param unknown $offset_y
 * @param unknown $read_archiv
 * @param unknown $data
 * @return number
 */
function set_TagTyp_Picture($tagtyp, $object_value_array, &$dst_im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $read_archiv, $data){
	if(isset($tmp_im)){
		unset($tmp_im);
	}
	$ret = 0;//wird nur als Rueckgabe bei Objekt '000' als Hintergrundbild benoetigt
	if($object_value_array['TagNummer'] != 0){
		switch($tagtyp){
			case 9:
				$val = -1.0e38;
				if(!get_archiv_value($val, $object_value_array['TagNummer'], $read_archiv, $data)){
					if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
						$val = $tmp_tag_info_array['wert'];
					}
				}
				$tmp_value = $val;
				if($tmp_value == -1.0e38){
					$tmp_im = GetImageFromPicture($object_value_array['TxtErr'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
				}
				else if($tmp_value == 0.0){
					$tmp_im = GetImageFromPicture($object_value_array['TxtFalse'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
				}
				else{
					$tmp_im = GetImageFromPicture($object_value_array['TxtTrue'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
				}
				break;				
			case 21:
				$val = -1.0e38;
				if(!get_archiv_value($val, $object_value_array['TagNummer'], $read_archiv, $data)){
					if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
						$val = $tmp_tag_info_array['wert'];
					}
				}
				$tmp_value = (double)$val;
				$tmp_value1 = (double)1.0;
				$tmp_value2 = (double)0.0;
				$tmp_value3 = (double)0.0;

				if(isset($object_value_array['ValTrue1']) && is_numeric($object_value_array['ValTrue1'])){
					$tmp_value1 = (double)$object_value_array['ValTrue1'];
				}
				if(isset($object_value_array['ValTrue2']) && is_numeric($object_value_array['ValTrue2'])){
					$tmp_value2 = (double)$object_value_array['ValTrue2'];
				}
				if(isset($object_value_array['ValTrue3']) && is_numeric($object_value_array['ValTrue3'])){
					$tmp_value3 = (double)$object_value_array['ValTrue3'];
				}

                if((double)$tmp_value == (double)0.0){
					$tmp_im = GetImageFromPicture($object_value_array['TxtFalse'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
				}
                else if((double)$tmp_value == (double)$tmp_value1){
                    $tmp_im = GetImageFromPicture($object_value_array['TxtTrue1'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
                }
                else if((double)$tmp_value == (double)$tmp_value2){
                    $tmp_im = GetImageFromPicture($object_value_array['TxtTrue2'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
				}
				else if((double)$tmp_value == (double)$tmp_value3){
					$tmp_im = GetImageFromPicture($object_value_array['TxtTrue3'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
				}
                else{
					$tmp_im = GetImageFromPicture($object_value_array['TxtErr'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
				}
				break;
			}//end switch
	}
	else{
		$tmp_im = GetImageFromPicture($object_value_array['TxtErr'], $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY);
	}
	
	// Image in Hauptgrafik einbinden
	if(isset($tmp_im)){
		if($tmp_im > 0){
			StdImageCopyResized_new($tmp_im, $dst_im,
			$object_value_array['PosLeft'], $object_value_array['PosTop'],
			$object_value_array['PosWidth'], $object_value_array['PosHeight'],
			$TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y);
			$ret = 1; 
		}
	}
	return $ret;
}

/**
 * Wert (TagTyp=0) schreiben
 * @param array $object_value_array
 * @param image $dst_im			Zielbild
 * @param number $TwipsPerPixelX
 * @param number $TwipsPerPixelY
 * @param number $offset_x
 * @param number $offset_y
 */
function set_TagTyp_00($object_value_array, &$dst_im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $read_archiv, $data){
	//-1.000000000000000e+038 = Ungltig
	$val = -1.0e38;
	$tmp_value = 'NV';
	get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array);
	// Archivwert
	if(!get_archiv_value($val, $object_value_array['TagNummer'], $read_archiv, $data)){
		if(isset($tmp_tag_info_array['wert'])){
			$val = $tmp_tag_info_array['wert'];
		}
	}
		
	if($val == -1.0e38){
		$tmp_value = 'NV';
	}
	else{
		$tmp_value = (double)$val;
		//settype($tmp_value,"double");
		$tmp_unit = '';
		if(isset($object_value_array['TagEinheit'])){
			switch($object_value_array['TagEinheit']){
				case '0':
					$tmp_unit = '';
					break;
				case '1':
					//$tmp_unit = trim(substr($tmp_tag_info_array['name'], strlen($tmp_tag_info_array['name']) - 8));
					$tmp_unit = trim(substr($tmp_tag_info_array['name'], 32 - 8));
					break;
				default:
					$tmp_unit = trim($object_value_array['TagEinheit']);
					break;
			}
		}
		if(isset($object_value_array['Maske'])){
			$tmp_array = explode('.', $object_value_array['Maske'], 2);
			// Format zusammenbasteln
			if(isset($tmp_array[1])){
				$tmp_part1_len = strlen($tmp_array[0]);
				$tmp_part2_len = strlen($tmp_array[1]);

				$tmp_part2_string = 'f';
				if($tmp_part2_len > 0 ){
					$tmp_part2_string = stristr($tmp_array[1], 'e');
					if(strlen($tmp_part2_string) == 0){
						$tmp_part2_string = 'f';
					}
					else{
						$tmp_part2_string = 'e';
					}
				}
				//$tmp_format = '%0'.$tmp_part1_len.'.'.$tmp_part2_len.'f';
//				$tmp_format = '%0'.$tmp_part1_len.'.'.$tmp_part2_len;
				$tmp_part_width = $tmp_part1_len + $tmp_part2_len + 1;
				$tmp_format = '%'.$tmp_part_width.'.'.$tmp_part2_len;
				$tmp_format .= $tmp_part2_string;
				$tmp_value = sprintf($tmp_format, $tmp_value);
				$tmp_value .= ' '.$tmp_unit;
			}
			else{
				// Format zusammenbasteln
				if(isset($tmp_array[0])){
					$tmp_part1_len = strlen($tmp_array[0]);
					if($tmp_part1_len > 0){
						//$tmp_format = '%0'.$tmp_part1_len.'.0f';
						$tmp_format = '%'.$tmp_part1_len.'.0f';
						$tmp_value = sprintf($tmp_format, $tmp_value);
						$tmp_value .= ' '.$tmp_unit;
					}
					else{
						$tmp_value .= ' '.$tmp_unit;
					}
				}
			}
		}
		else{
			//Keine Maske
			$tmp_value .= ' '.$tmp_unit;
		}
	}
	//						$tmp_value = (double)34.6;
	if(strlen($tmp_value) > 0){
		StdImageTTFText_new($dst_im, $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y,
							$tmp_value);
	}
	/*
	 $nTest = (double) "3.12345678901234567890e+22";
	//$nTest2 = sprintf("%07.2e", $nTest);
	
	// 00.00
	$nTest2 = sprintf("%02.2f", $nTest);
	
	echo $nTest2;
	exit;
	*/
}

/**
 * Bezeichnung(TagTyp=1) oder TagText(TagTyp=3) schreiben
 * Binrunterscheidung (TagTyp=1)
 * Wenn Tag-Wert aus Scalarvis 0 -> TxtFalse,
 * wenn Tag-Wert aus Scalarvis 1 -> TxtTrue,
 * ansonsten -> TxtErr
 * Fester Text (TagTyp=11) schreiben
 * @param unknown $tagtyp
 * @param unknown $object_value_array
 * @param unknown $dst_im
 * @param unknown $TwipsPerPixelX
 * @param unknown $TwipsPerPixelY
 * @param unknown $offset_x
 * @param unknown $offset_y
 */
function set_TagTyp($tagtyp, $object_value_array, &$dst_im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $read_archiv, $data){
	$tmp_value = '';

	switch ($tagtyp){
		case 1:
			if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
				$tmp_value = trim($tmp_tag_info_array['info']);
			}
			break;
		case 3:
			if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
				$tmp_value = trim(substr($tmp_tag_info_array['name'], 0, 24));
			}
			break;
		case 8:
			$val = -1.0e38;
			// Archivwert
			if(!get_archiv_value($val, $object_value_array['TagNummer'], $read_archiv, $data)){
				if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
					$val = $tmp_tag_info_array['wert'];
				}
			}
			$tmp_sv_value = $val;
			if($tmp_sv_value == -1.0e38){
				$tmp_value = $object_value_array['TxtErr'];
			}
			else if($tmp_sv_value == 0){
				$tmp_value = $object_value_array['TxtFalse'];
			}
			else{
				$tmp_value = $object_value_array['TxtTrue'];
			}
			break;
		case 11:
			//reiner Text ohne TAG
			if(isset($object_value_array['Caption'])){
				$tmp_value = $object_value_array['Caption'];
			}
			break;
	}
		
	if(strlen($tmp_value) > 0){
		StdImageTTFText_new($dst_im, $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y,
							$tmp_value);
	}
}


/**
 * Indikator-Style zu TagTyp=2
 * @param array $object_value_array
 * @param image $tmp_im
 * @param number $tmp_value
 */
function set_Indikator_Style($object_value_array, &$tmp_im, $tmp_value){

	$tmp_fore_color = set_forecolor_image($object_value_array, $tmp_im);
	
	$tmp_imagesx = imagesx($tmp_im);
	$tmp_imagesy = imagesy($tmp_im);
	$tmp_max = 0;
	$tmp_min = 0;

	$tmp_max = convert_commas_to_dots($object_value_array['Max']);
	if(is_numeric($tmp_max)){
		$tmp_max = $tmp_max;
	}
	else{
		$tmp_max = 0;
	}
	
	$tmp_min = convert_commas_to_dots($object_value_array['Min']);
	if(is_numeric($tmp_min)){
		$tmp_min = $tmp_min;
	}
	else{
		$tmp_min = 0;
	}
	
	set_margin($object_value_array, $tmp_inner_left, $tmp_inner_top, $tmp_inner_right, $tmp_inner_bottom);
	
	switch($object_value_array['Style']){
		// Horizontaler Balken
		case 0:
			// Balkenlnge in Abhngigkeit vom Scalarvis-Tag-Wert
			// und von den Werten Min und Max der Fliess.ini ermitteln
			if(is_numeric($tmp_value) && ($tmp_max - $tmp_min) * $tmp_imagesx != 0){
				//print_r_formatted($object_value_array);
				//$tmp_x2 = abs($tmp_imagesx/($tmp_max - $tmp_min) * $tmp_value);
				//t->Ist = (roh - offset) / (skal - offset) * (mbe - mba) + mba;
				$tmp_x2 = ($tmp_value - $tmp_min) / ($tmp_max - $tmp_min) * $tmp_imagesx;
			}
			else{
				$tmp_x2 = 0;
			}
	
			$tmp_x1 = 0;
			$tmp_y1 = 0;
			$tmp_y2 = $tmp_imagesy;
	
			// Margins bercksichtigen
			$tmp_x_len = $tmp_x2 - $tmp_x1;
			$tmp_y_len = $tmp_y2 - $tmp_y1;
			$tmp_x1 += $tmp_x_len / 100 * $tmp_inner_left;
			$tmp_x2 -= $tmp_x_len / 100 * $tmp_inner_right;
			$tmp_y1 += $tmp_y_len / 100 * $tmp_inner_top;
			$tmp_y2 -= $tmp_y_len / 100 * $tmp_inner_bottom;
			ImageFilledRectangle($tmp_im, $tmp_x1, $tmp_y1, $tmp_x2, $tmp_y2, $tmp_fore_color);
			break;
	
			// Vertikaler Balken
		case 1:
			// Balkenhhe in Abhngigkeit vom Scalarvis-Tag-Wert
			// und von den Werten Min und Max der Fliess.ini ermitteln
			if(is_numeric($tmp_value) && ($tmp_max - $tmp_min) * $tmp_imagesy != 0){
				$tmp_y1 = $tmp_imagesy - ($tmp_value - $tmp_min) / ($tmp_max - $tmp_min) * $tmp_imagesy;
			}
			else{
				$tmp_y1 = $tmp_imagesy;
			}
	
			$tmp_x1 = 0;
			$tmp_x2 = $tmp_imagesx;
			$tmp_y2 = $tmp_imagesy;
	
			// Margins bercksichtigen
			$tmp_x_len = $tmp_x2 - $tmp_x1;
			$tmp_y_len = $tmp_y2 - $tmp_y1;
			$tmp_x1 += $tmp_x_len / 100 * $tmp_inner_left;
			$tmp_x2 -= $tmp_x_len / 100 * $tmp_inner_right;
			$tmp_y1 += $tmp_y_len / 100 * $tmp_inner_top;
			$tmp_y2 -= $tmp_y_len / 100 * $tmp_inner_bottom;
			ImageFilledRectangle($tmp_im, $tmp_x1, $tmp_y1, $tmp_x2, $tmp_y2, $tmp_fore_color);
			break;
	
			// Halbkreis, Vollkreis
		case 2:
		case 3:
			$tmp_indicator_vector = GetIndicatorVector($tmp_value,
									$tmp_min,
									$tmp_max,
									0,
									imagesx($tmp_im),
									0,
									imagesy($tmp_im),
									$tmp_inner_top,
									$tmp_inner_left,
									$tmp_inner_bottom,
									$tmp_inner_right,
									$object_value_array['Style'],
									$object_value_array['NeedleWidth']);
				
			if(!empty($object_value_array['NeedleWidth']) && is_numeric($object_value_array['NeedleWidth'])
					&& $object_value_array['NeedleWidth'] > 0){
				$tmpNeedleWidth = $object_value_array['NeedleWidth'];
			}
			else{
				$tmpNeedleWidth = 1;
			}
	
			imagesetthickness($tmp_im, $tmpNeedleWidth);
			ImageLine($tmp_im,
			$tmp_indicator_vector['x1'],
			$tmp_indicator_vector['y1'],
			$tmp_indicator_vector['x2'],
			$tmp_indicator_vector['y2'],
			$tmp_fore_color);
			imagesetthickness($tmp_im, 1);
			break;
	}
	
}

/**
 * Indikator mit TagTyp=2 zeichnen
 * @param string $flowchart_dir
 * @param array $object_value_array
 * @param image $dst_im
 * @param number $TwipsPerPixelX
 * @param number $TwipsPerPixelY
 * @param number $offset_x
 * @param number $offset_y
 */
function set_TagTyp_02($flowchart_dir, $object_value_array, &$dst_im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $read_archiv, $data){
	$tmp_value = 'NV';
	$val = -1.0e38;

	// Archivwert
	if(!get_archiv_value($val, $object_value_array['TagNummer'], $read_archiv, $data)){
		if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
			$val = $tmp_tag_info_array['wert'];
		}
	}
	$tmp_value = $val;
	if($tmp_value == -1.0e38){
		$tmp_value = 'NV';
	}
	else{
		$tmp_value = (double) $tmp_value;
	}
	if(!is_numeric($tmp_value)){
		$tmp_value = 'NV';
	}
	
	if(isset($tmp_im)){
		unset($tmp_im);
	}
	//Warum nicht so???? RS
	//$tmp_im = GetImageFromPicture($object_value_array['Picture']);
	$tmp_picture = $object_value_array['Picture'];
	$tmp_picture = StripPathAndExtension($tmp_picture);
	$tmp_file_type = GetPictureFileType($flowchart_dir, $tmp_picture);
	if($tmp_file_type){
		$tmp_picture_file = GetPictureFile($flowchart_dir, $tmp_picture, $tmp_file_type);
		// Image erstellen
		if($tmp_file_type == 2){
			$tmp_im = @ImageCreateFromJPEG($tmp_picture_file);
		}
		else if($tmp_file_type == 3){
			$tmp_im = @ImageCreateFromPNG($tmp_picture_file);
		}
		else if($tmp_file_type == 87){ //SVG
			$image = new Imagick();
			$image->readImageBlob(file_get_contents($tmp_picture_file));
			$image->setImageFormat("png"); //$image->setImageFormat("png24");
            //$image->resizeImage(1024, 768, imagick::FILTER_LANCZOS, 1);
			$image->resizeImage($object_value_array['PosWidth'], $object_value_array['PosHeight'], imagick::FILTER_LANCZOS, 1); 
			$image->writeImage($tmp_picture_file . '.png');
			
			
			$tmp_im = @ImageCreateFromPNG($tmp_picture_file . '.png');
		}
	}
	
	if(!isset($tmp_im)){
		//$tmp_im = @ImageCreate(200, 100);
		//Gleich richtige Groesse setzen
		$tmp_im = @ImageCreate($object_value_array['PosWidth'] / $TwipsPerPixelX,
				$object_value_array['PosHeight'] / $TwipsPerPixelY);
		
		$tmp_back_color = set_backcolor_image($object_value_array, $tmp_im);
		ImageFilledRectangle($tmp_im, 0, 0, imagesx($tmp_im), imagesy($tmp_im), $tmp_back_color);
	}
	/*
	 // RS 20110415 warum Resizen, wenn alle Daten gegeben
	// Bild resizen
	$tmp_im2 = $tmp_im;
	$tmp_im = @ImageCreate($object_value_array['PosWidth'] / $TwipsPerPixelX,
			$object_value_array['PosHeight'] / $TwipsPerPixelY);
	ImageCopyResized($tmp_im,
			$tmp_im2,
			0,
			0,
			0,
			0,
			imagesx($tmp_im),
			imagesy($tmp_im),
			imagesx($tmp_im2),
			imagesy($tmp_im2));
	ImageDestroy($tmp_im2);
	unset($tmp_im2);
	*/
	
	// Indikatoranzeige
	set_Indikator_Style($object_value_array, $tmp_im, $tmp_value);
		
	// Image in Hauptgrafik einbinden
	if(isset($tmp_im)){
		/* WARUM ??? RS
		 StdImageCopy($tmp_im,
		 		$object_value_array['PosLeft'],
		 		$object_value_array['PosTop']);
		*/
		StdImageCopyResized_new($tmp_im, $dst_im,
								$object_value_array['PosLeft'],
								$object_value_array['PosTop'],
								$object_value_array['PosWidth'],
								$object_value_array['PosHeight'],
								$TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y);
	}
}

/**
 * Diagramm zeichnen mit TagTyp=5
 * @param unknown $codebase
 * @param unknown $object_value_array
 * @param unknown $dst_im
 * @param unknown $TwipsPerPixelX
 * @param unknown $TwipsPerPixelY
 * @param unknown $offset_x
 * @param unknown $offset_y
 * @param unknown $sv_user
 * @param unknown $sv_port
 * @param unknown $sv_host
 * @param unknown $sv_pwd
 */
function set_TagTyp_05($codebase, $sysinfo, $tz_index = null, $time_is_gmt_only = null, $object_value_array, &$dst_im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y,
						$sv_user, $sv_port, $sv_host, $sv_pwd){
	$tmp_svsc = new sv_short_class();
	
	$tmp_svsc->user = $sv_user;
	$tmp_svsc->port = $sv_port;
	$tmp_svsc->host = $sv_host;
	$tmp_svsc->pwd = $sv_pwd;
	
	$tmp_svsc->USER_CONFIG['HIDE_NEG_AXIS'] = 0;
	$tmp_svsc->USER_CONFIG['DIAG_BZG_INTERVALL'] = 900; // Spielt nur bei Bzglst-Diagramm eine Rolle
	$tmp_svsc->USER_CONFIG['TZ_INDEX'] = -1; //nichts definiert
	$tmp_svsc->USER_CONFIG['TIME_IS_GMT_ONLY'] = 0;
	
	// Anzahl-Tags-Relevanz
	$tmp_svsc->number_of_tags = 16;
	
	if(isset($tz_index)){
		$tmp_svsc->USER_CONFIG['TZ_INDEX'] = $tz_index;
	}
	if(isset($time_is_gmt_only) && $time_is_gmt_only){
		$tmp_svsc->USER_CONFIG['TIME_IS_GMT_ONLY'] = 1;
	}
	
	$tmp_tsLocal = getdate();
	// Diagrammtyp
	if($object_value_array['Archivart'] == 2){
		$tmp_diag_type = 'detail';
		$tmp_now = round_time($tmp_tsLocal[0], $sysinfo["stoer_intervall"]);// + date("Z", $tmp_tsLocal[0]);
	}
	else if($object_value_array['Archivart'] == 1){
		$tmp_diag_type = 'trend';
		$tmp_now = round_time($tmp_tsLocal[0], 60);// + date("Z", $tmp_tsLocal[0]);
	}
	else{
		$tmp_diag_type = 'universal';
		$tmp_now = round_time($tmp_tsLocal[0], $sysinfo["intervall"]);// + date("Z", $tmp_tsLocal[0]);
	}
	$tmp_svsc->time_start = $tmp_now - ($object_value_array['TimeSpan'] * 60);
	$tmp_svsc->time_end = $tmp_now;
	//Hintergrundfarbe fuer Diagramm
	// auf Wunsch von AirLiquide wieder raus
	//if( isset($object_value_array['BackColor']) ) {
	//  $tmp_svsc->BackColor = $object_value_array['BackColor'];
	//}
	// Autoscaling ja/nein
	$AutoScaling = 0;
	if(isset($object_value_array['AutoScaling'])){
		$AutoScaling = $object_value_array['AutoScaling'];
	}
	// Anzahl-Tags-Relevanz
	// erstmal alles ungueltig setzen
	for($i = 0; $i < $tmp_svsc->number_of_tags; $i++){
		$tmp_svsc->tagauswahl[$i]['nummer'] = '';
		$tmp_svsc->tagauswahl[$i]['name'] = '';
		$tmp_svsc->tagauswahl[$i]['einheit'] = '';
		$tmp_svsc->tagauswahl[$i]['info'] = '';
		$tmp_svsc->tagauswahl[$i]['dba'] = '';
		$tmp_svsc->tagauswahl[$i]['dbe'] = '';
		$tmp_svsc->tagauswahl[$i]['wert'] = '';
		$tmp_svsc->tagauswahl[$i]['fkt'] = '';
		$tmp_svsc->tagauswahl[$i]['status'] = '';
		$tmp_svsc->tagauswahl[$i]['hide_tag'] = 1;
		$tmp_svsc->tagauswahl[$i]['linecolor'] = '';
	}
	
	$i = -1;
	$yScale = 0;
	if(isset($object_value_array['TagNummer'])
			&& is_numeric($object_value_array['TagNummer'])
			&& $object_value_array['TagNummer'] > 0){
		$i = 0;
		if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
			$tmp_svsc->tagauswahl[$i]['nummer'] = $tmp_tag_info_array['tag_nr'];
			$tmp_svsc->tagauswahl[$i]['name'] = substr($tmp_tag_info_array['name'], 0, 24);
			$tmp_svsc->tagauswahl[$i]['einheit'] = trim(substr($tmp_tag_info_array['name'], strlen($tmp_tag_info_array['name']) - 8));
			$tmp_svsc->tagauswahl[$i]['info'] = $tmp_tag_info_array['info'];
			$tmp_svsc->tagauswahl[$i]['dba'] = ($AutoScaling?'':$tmp_tag_info_array['dba']);
			$tmp_svsc->tagauswahl[$i]['dbe'] = ($AutoScaling?'':$tmp_tag_info_array['dbe']);
			$tmp_svsc->tagauswahl[$i]['wert'] = '';
			$tmp_svsc->tagauswahl[$i]['fkt'] = '';
			$tmp_svsc->tagauswahl[$i]['status'] = '';
			$tmp_svsc->tagauswahl[$i]['hide_tag'] = 0;
			if(isset($object_value_array['ForeColor'])){
				$tmp_svsc->tagauswahl[$i]['linecolor'] = $object_value_array['ForeColor'];
			}
			if(isset($object_value_array['yScale'])){
				$yScale = $object_value_array['yScale'];
			}
		}
	}
	
	// Anzahl-Tags-Relevanz
	$tmp_yScale_flag = false;
	for($j = 2; $j < $tmp_svsc->number_of_tags + 1; $j++){
		if(isset($object_value_array['TagNr'.$j])
				&& is_numeric($object_value_array['TagNr'.$j])
				&& $object_value_array['TagNr'.$j] > 0){
			if(get_tag_info_array($object_value_array['TagNr'.$j], $tmp_tag_info_array)){
				$i++;
				$tmp_svsc->tagauswahl[$i]['nummer'] = $tmp_tag_info_array['tag_nr'];
				$tmp_svsc->tagauswahl[$i]['name'] = substr($tmp_tag_info_array['name'], 0, 24);
				$tmp_svsc->tagauswahl[$i]['einheit'] = trim(substr($tmp_tag_info_array['name'], strlen($tmp_tag_info_array['name']) - 8));
				$tmp_svsc->tagauswahl[$i]['info'] = $tmp_tag_info_array['info'];
				$tmp_svsc->tagauswahl[$i]['dba'] = ($AutoScaling?'':$tmp_tag_info_array['dba']);
				$tmp_svsc->tagauswahl[$i]['dbe'] = ($AutoScaling?'':$tmp_tag_info_array['dbe']);
				$tmp_svsc->tagauswahl[$i]['wert'] = '';
				$tmp_svsc->tagauswahl[$i]['fkt'] = '';
				$tmp_svsc->tagauswahl[$i]['status'] = '';
				$tmp_svsc->tagauswahl[$i]['hide_tag'] = 0;
				if(isset($object_value_array['LineColor'.$j])){
					$tmp_svsc->tagauswahl[$i]['linecolor'] = $object_value_array['LineColor'.$j];
				}
				if((isset($object_value_array['yScale'.$j])) && ($tmp_yScale_flag == false)){
					if($yScale == $object_value_array['yScale'.$j]){
						$tmp_yScale_flag = true;
						switch ($tmp_diag_type) {
							case 'detail':
								$tmp_diag_type = 'singled';
								break;
							case 'universal':
								$tmp_diag_type = 'single';
								break;
							case 'trend':
								$tmp_diag_type = 'singlet';
								break;
							default:
								$tmp_diag_type = 'single';
								break;
						}
					}
				}
			} // end if tmp_tag_info_array
		} // end if isset
	} // for
	
	// Image erstellen
	if(isset($STANDARD_CONFIG['USE_PECL']) && $STANDARD_CONFIG['USE_PECL']){
		if(extension_loaded('scalarvis')){
			$tmp_im = ImageCreateFromString(scalarvis_graph($tmp_svsc,
					$tmp_diag_type,
					'true',
					$object_value_array['PosWidth'] / $TwipsPerPixelX,
					$object_value_array['PosHeight'] / $TwipsPerPixelY));
		}
		else{
			// Dummy-Image darstellen, falls vorhanden
			$tmp_dummy = 'sv_diagram.png';
			if(is_file($tmp_dummy)){
				$tmp_im = @ImageCreateFromPNG($tmp_dummy);
			}
		}
	}
	else{
		$sve = new scalarvis_ext;
		$tmp_im = $sve->scalarvis_graph($tmp_svsc,
				$tmp_diag_type,
				true,
				$object_value_array['PosWidth'] / $TwipsPerPixelX,
				$object_value_array['PosHeight'] / $TwipsPerPixelY,
				$codebase);
	}
	
	// Image in Hauptgrafik einbinden
	if(isset($tmp_im)){
		StdImageCopy_new($tmp_im, $dst_im,
								$object_value_array['PosLeft'],
								$object_value_array['PosTop'],
								$object_value_array['PosWidth'],
								$object_value_array['PosHeight'],
								$TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y);
	}
	
	unset($tmp_svsc);
	
}

function set_TagTyp_20($flowchart_dir, $object_value_array, &$dst_im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $read_archiv, $data){
	$tmp_value_1 = 'NV';
	if(isset($object_value_array['TagNummer'])){
		$val = -1.0e38;
		// Archivwert
		if(!get_archiv_value($val, $object_value_array['TagNummer'], $read_archiv, $data)){
			if(get_tag_info_array($object_value_array['TagNummer'], $tmp_tag_info_array)){
				$val = $tmp_tag_info_array['wert'];
			}
		}
		$tmp_value_tag = $val;
		if($tmp_value_tag != -1.0e38){
			$tmp_value_1 = (double) $tmp_value_tag;
		}
		if(!is_numeric($tmp_value_1)){
			$tmp_value_1 = 'NV';
		}
	}

	$tmp_value_2 = 'NV';
	if(isset($object_value_array['TagNr2'])){
		$val = -1.0e38;
		// Archivwert
		if(!get_archiv_value($val, $object_value_array['TagNr2'], $read_archiv, $data)){
			if(get_tag_info_array($object_value_array['TagNr2'], $tmp_tag_info_array)){
				$val = $tmp_tag_info_array['wert'];
			}
		}
		$tmp_value_tag = $val;
		if($tmp_value_tag != -1.0e38){
			$tmp_value_2 = (double) $tmp_value_tag;
		}
		if(!is_numeric($tmp_value_2)){
			$tmp_value_2 = 'NV';
		}
	}
	
	$tmp_picture = $object_value_array['Picture'];
	$tmp_picture = StripPathAndExtension($tmp_picture);
	$tmp_file_type = GetPictureFileType($flowchart_dir, $tmp_picture);
	if($tmp_file_type){
		$tmp_picture_file = GetPictureFile($flowchart_dir, $tmp_picture, $tmp_file_type);
		// Image erstellen
		if($tmp_file_type == 2){
			$tmp_im = @ImageCreateFromJPEG($tmp_picture_file);
		}
		else if($tmp_file_type == 3){
			$tmp_im = @ImageCreateFromPNG($tmp_picture_file);
		}
		else if($tmp_file_type == 87){ //SVG
			$image = new Imagick();
			$image->readImageBlob(file_get_contents($tmp_picture_file));
			$image->setImageFormat("png"); //$image->setImageFormat("png24");
            //$image->resizeImage(1024, 768, imagick::FILTER_LANCZOS, 1);
			$image->resizeImage($object_value_array['PosWidth'], $object_value_array['PosHeight'], imagick::FILTER_LANCZOS, 1); 
			$image->writeImage($tmp_picture_file . '.png');
			
			
			$tmp_im = @ImageCreateFromPNG($tmp_picture_file . '.png');
		}
	}
	
	if(!isset($tmp_im)){
		$tmp_im = @ImageCreate(200, 200);
		if(isset($object_value_array['BackColor'])
				&& is_numeric($object_value_array['BackColor'])
				&& $object_value_array['BackColor'] >= 0){
			$tmp_color = sprintf("%06x",$object_value_array['BackColor']);
			$tmp_b = hexdec(substr($tmp_color, 0, 2));
			$tmp_g = hexdec(substr($tmp_color, 2, 2));
			$tmp_r = hexdec(substr($tmp_color, 4, 2));
			$tmp_back_color = ImageColorAllocate($tmp_im, $tmp_r, $tmp_g, $tmp_b);
		}
		else{
			$tmp_back_color = ImageColorAllocate($tmp_im, 255, 255, 255);
		}
	}
	
	// Bild resizen
	$tmp_im2 = $tmp_im;
	$tmp_im = @ImageCreate($object_value_array['PosWidth'] / $TwipsPerPixelX,
			$object_value_array['PosHeight'] / $TwipsPerPixelY);
	ImageCopyResized($tmp_im,
	$tmp_im2,
	0,
	0,
	0,
	0,
	imagesx($tmp_im),
	imagesy($tmp_im),
	imagesx($tmp_im2),
	imagesy($tmp_im2));
	ImageDestroy($tmp_im2);
	unset($tmp_im2);
	
	if(isset($object_value_array['ForeColor'])
			&& is_numeric($object_value_array['ForeColor'])
			&& $object_value_array['ForeColor'] >= 0){
		$tmp_color = sprintf("%06x", $object_value_array['ForeColor']);
		$tmp_b = hexdec(substr($tmp_color, 0, 2));
		$tmp_g = hexdec(substr($tmp_color, 2, 2));
		$tmp_r = hexdec(substr($tmp_color, 4, 2));
		$tmp_fore_color = ImageColorAllocate($tmp_im, $tmp_r, $tmp_g, $tmp_b);
	}
	else{
		$tmp_fore_color = ImageColorAllocate($tmp_im, 255, 255, 255);
	}
	
	$tmp_imagesx = imagesx($tmp_im);
	$tmp_imagesy = imagesy($tmp_im);
	$tmp_max = 0;
	$tmp_max = convert_commas_to_dots($object_value_array['Max']);
	if(is_numeric($tmp_max)){
		$tmp_max = $tmp_max;
	}
	else{
		$tmp_max = 0;
	}
	
	$tmp_min = 0;
	$tmp_min = convert_commas_to_dots($object_value_array['Min']);
	if(is_numeric($tmp_min)){
		$tmp_min = $tmp_min;
	}
	else{
		$tmp_min = 0;
	}
	
	$tmp_inner_top = 0;
	$tmp_inner_left = 0;
	$tmp_inner_right = 0;
	$tmp_inner_bottom = 0;
	if(isset($object_value_array['InnerBottom'])
			&& is_numeric($object_value_array['InnerBottom'])){
		$tmp_inner_bottom = $object_value_array['InnerBottom'];
	}
	if(isset($object_value_array['InnerLeft'])
			&& is_numeric($object_value_array['InnerLeft'])){
		$tmp_inner_left = $object_value_array['InnerLeft'];
	}
	if(isset($object_value_array['InnerRight'])
			&& is_numeric($object_value_array['InnerRight'])){
		$tmp_inner_right = $object_value_array['InnerRight'];
	}
	if(isset($object_value_array['InnerTop'])
			&& is_numeric($object_value_array['InnerTop'])){
		$tmp_inner_top = $object_value_array['InnerTop'];
	}
	$tmp_indicator_polygon = GetIndicatorPolygon($tmp_value_1, // Windstrke
			$tmp_value_2, // Windrichtung
			$tmp_min,
			$tmp_max,
			0,
			imagesx($tmp_im),
			0,
			imagesy($tmp_im),
			$tmp_inner_top,
			$tmp_inner_left,
			$tmp_inner_bottom,
			$tmp_inner_right,
			$object_value_array['NeedleWidth']);
	imagefilledpolygon($tmp_im, $tmp_indicator_polygon, 4, $tmp_fore_color);
	
	// Image in Hauptgrafik einbinden
	if(isset($tmp_im)){
		StdImageCopy($tmp_im,
		$object_value_array['PosLeft'],
		$object_value_array['PosTop']);
	}
	
}


/**
 * 
 * @param unknown $object_value_array
 * @param unknown $left
 * @param unknown $top
 * @param unknown $right
 * @param unknown $bottom
 */
function set_margin($object_value_array, &$left, &$top, &$right, &$bottom){
	
	$left = 0;
	$top = 0;
	$right = 0;
	$bottom = 0;
	if(isset($object_value_array['InnerBottom'])
			&& is_numeric($object_value_array['InnerBottom'])){
		$bottom = $object_value_array['InnerBottom'];
	}
	
	if(isset($object_value_array['InnerLeft'])
			&& is_numeric($object_value_array['InnerLeft'])){
		$left = $object_value_array['InnerLeft'];
	}
	
	if(isset($object_value_array['InnerRight'])
			&& is_numeric($object_value_array['InnerRight'])){
		$right = $object_value_array['InnerRight'];
	}
	
	if(isset($object_value_array['InnerTop'])
			&& is_numeric($object_value_array['InnerTop'])){
		$top = $object_value_array['InnerTop'];
	}
}

/**
 * 
 * @param unknown $object_value_array
 * @return Ambigous <number, unknown>
 */
function set_alignment($object_value_array){
	$ret = 0; //linksbuendig	
	if(isset($object_value_array['Alignment'])){
		$ret = $object_value_array['Alignment'];
	}
	return $ret;
}

/**
 * 
 * @param unknown $object_value_array
 * @param unknown $dst_im
 * @return number
 */
function set_forecolor($object_value_array, $dst_im){
	$ret = ImageColorAllocate($dst_im, 255, 255, 255);
	if(isset($object_value_array['ForeColor'])){
		$ret = StdForeColor($object_value_array['ForeColor']);
	}
	return $ret;
}

/**
 * 
 * @param unknown $object_value_array
 * @param unknown $dst_im
 * @return number
 */
function set_forecolor_image($object_value_array, $dst_im){
	$ret = ImageColorAllocate($dst_im, 255, 255, 255);
	if(isset($object_value_array['ForeColor'])
			&& is_numeric($object_value_array['ForeColor'])
			&& $object_value_array['ForeColor'] >= 0){
		$tmp_color = sprintf("%06x",$object_value_array['ForeColor']);
		$tmp_b = hexdec(substr($tmp_color, 0, 2));
		$tmp_g = hexdec(substr($tmp_color, 2, 2));
		$tmp_r = hexdec(substr($tmp_color, 4, 2));
		$ret = ImageColorAllocate($dst_im, $tmp_r, $tmp_g, $tmp_b);
	}
	return $ret;
}

/**
 * 
 * @param unknown $object_value_array
 * @param unknown $dst_im
 * @return number
 */
function set_backcolor_image($object_value_array, $dst_im){
	
	$ret = ImageColorAllocate($dst_im, 255, 255, 255);
	if(isset($object_value_array['BackColor'])
			&& is_numeric($object_value_array['BackColor'])
			&& $object_value_array['BackColor'] >= 0
	){
		$tmp_color = sprintf("%06x",$object_value_array['BackColor']);
		$tmp_b = hexdec(substr($tmp_color, 0, 2));
		$tmp_g = hexdec(substr($tmp_color, 2, 2));
		$tmp_r = hexdec(substr($tmp_color, 4, 2));
		$ret = ImageColorAllocate($dst_im, $tmp_r, $tmp_g, $tmp_b);
	}

	return $ret;
}

/**
 * 
 * @param unknown $object_value_array
 * @return multitype:string number boolean
 */
function set_font($object_value_array){
	return GetFontFile($object_value_array['Font']);
}

/* {{{ PHP-Funktion flowchartimage() - Klebstoffverarbeitende Hauptfunktion */
function flowchartimage($codebase = '', $sv, $arctime, $archive = null, $flowchart_dir, $tz_index, $time_is_gmt_only, $flowchart_ini_file){
    global $STANDARD_CONFIG;
    global $ini_array;
    global $register;
    global $sv_user;
    global $sv_port;
    global $sv_host;
    global $sv_pwd;
    global $sysinfo;

    global $offset_x;
    global $offset_y;
    global $PixelOffsetX;
    global $PixelOffsetY;
    global $ScreenPixelX;
    global $ScreenPixelY;
    global $AnzRegister;
    global $TitelHeight;
    global $MenueHeight;
    global $BorderWidth;
    global $TabHeight;
    global $FontSize;
    global $file_type;
    global $TwipsPerPixelX;
    global $TwipsPerPixelY;
    global $PosLeft;
    global $PosTop;
    global $PosWidth;
    global $PosHeight;
    global $global_gd;
    global $im;
    global $object_000;
    global $cnstControl;
    global $fliess_array;
    global $object_array;
    global $section_array;

    foreach($ini_array as $section_index => $section_array){
        if(substr($section_index, 0, 8) == 'Register'){
            $AnzRegister++;
        }
    }

    // Fliess-Array ermitteln
    $fliess_array = get_fliess_array($ini_array);

    // Objekt-Array zum Register ermitteln
    $object_array = get_object_array($ini_array, $register);
    
    // Registerzeile bercksichtigen
    //if(isset($fliess_array['TabPerRow']) && $fliess_array['TabPerRow'] > 0){
    //    $tab_row = ceil($AnzRegister / $fliess_array['TabPerRow']);
    //    $offset_y = $tab_row * $TabHeight;
    //}
    
    set_size($fliess_array, $cnstControl, $PosWidth, $PosHeight, $PosLeft, $TwipsPerPixelX, $TwipsPerPixelY, $BorderWidth, $TitelHeight - $MenueHeight - ($BorderWidth * 2) - $offset_y);
    
    // Hauptmaske ermitteln, leeres Bild erstellen
    ContentTypeHeader($file_type);
    $ScreenPixelX = $PosWidth / $TwipsPerPixelX;
    $ScreenPixelY = $PosHeight / $TwipsPerPixelY;

    $im = @imagecreatetruecolor($ScreenPixelX, $ScreenPixelY);
    if(empty($im)){
        $im = ImageCreate($ScreenPixelX, $ScreenPixelY);
        $global_gd = 1;
    }

    if(!empty($im)){
        if($global_gd == 2){
            imagealphablending($im, false);
            $background_color = ImageColorAllocate($im, 208, 208, 208);
            imagefilledrectangle($im, 0, 0, $ScreenPixelX, $ScreenPixelY, $background_color);
            imagealphablending($im, true);
        }
        else{
            $background_color = ImageColorAllocate($im, 208, 208, 208);
        }
        $TwipsPerPixelX = $PosWidth / imagesx($im);
        $TwipsPerPixelY = $PosHeight / imagesy($im);
        $offset_y = $offset_y / $TwipsPerPixelY;

    	// Archiv lesen, falls gefordert $archive != null
    	$ret_read_archiv = 0;
        $ret_read_archiv = read_archiv_fliess($sv, $object_array, $arctime, $archive, $data);
        
        // Picture ermitteln fr Hintergrundbild
        if(isset($object_array['000']) && $object_array['000']['TagTyp'] == 9){
        	$object_000 = set_TagTyp_Picture(9, $object_array['000'], $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $ret_read_archiv, $data);
        }
        // brige Objekte ermitteln
        foreach($object_array as $object_no => $object_value_array){
            if(isset($tmp_im)){
                unset($tmp_im);
            }

            // Erstes Objekt eines Registers muss immer das grundlegende Hintergrundbild sein,
            // deshalb wird dieses in dieser Schleife ausgeschlossen
            if(($object_no != '000') || (($object_no == '000') && ($object_000 == 0)) ){
                // Attribut-Relevanz
                // Tag-Typ-Unterscheidung
                switch($object_value_array['TagTyp']){
                    case 0:// Tag-Wert aus Scalarvis
			set_TagTyp_00($object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $ret_read_archiv, $data);
    	                break;
                    case 1:// Tag-Text aus Scalarvis (Info)
                    	set_TagTyp(1, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, 0, null);
	                    break;
                    case 2:// Indikator mit Hintergrundbild aus Fliess.ini (Picture)
                        // Scalarvis-Tag-Wert ermitteln und in numerischen Wert umwandeln
                    	set_TagTyp_02($flowchart_dir, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $ret_read_archiv, $data);
        	            break;
                    case 3:// Tag-Name aus Scalarvis (Bezeichnung)
                    	set_TagTyp(3, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, 0, null);
	                    break;
                    case 5:// Diagramm aus Scalarvis
                    	//RS 20150513 keine Ahnung, wo das gesetzt wird
                    	set_TagTyp_05($codebase, $sysinfo, $tz_index, $time_is_gmt_only, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y,
									$sv_user, $sv_port, $sv_host, $sv_pwd);

                    	break;
                    case 8:// Binrunterscheidung:
                    	set_TagTyp(8, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $ret_read_archiv, $data);
                    	break;
                    case 9:// Bild aus Fliess.ini (TxtErr)
                    	set_TagTyp_Picture(9, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $ret_read_archiv, $data);
	                    break;
                    case 11:// Text aus Fliess.ini (Caption)
                    	set_TagTyp(11, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, 0, null);
                    	break;
                    case 20:// Windrose mit Hintergrundbild aus Fliess.ini (Picture)
                        // Scalarvis-Tag-Wert ermitteln und in numerischen Wert umwandeln
                    	set_TagTyp_20($flowchart_dir, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $ret_read_archiv, $data);
                    	break;
                    case 21:// Bild aus Fliess.ini (TxtErr)
                    	set_TagTyp_Picture(21, $object_value_array, $im, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $ret_read_archiv, $data);
                    break;
                }
            }
        }
    }

    if(!empty($im)){
        // Image ausgeben
        if($file_type == 2){
            ImageJPEG($im);
        }
        else{
			//ImagePNG($im, "Fliess_20150331/Flowchartouput.png");
			ImagePNG($im);
        }
    }
    else{
        ImageCreateErrorMessage('Image create error!');
    }
}
/* }}} */

/* {{{ PHP-Funktion GetFontFile() */
function GetFontFile($sv_font_value){
    global $global_gd;

    if($global_gd == 1){
        $PointToPixel = 1.33333333;// in Pixel mit Gd1
    }
    else{
        $PointToPixel = 1;
    }

    $retval = Array();
    $retval['FontName'] = '';
    $retval['FontSize'] = 10 * $PointToPixel;

    $tmp_font_ext = ".ttf";
    $Standard_Font = "Arial.ttf";
    $Standard_WinDir = (isset($_SERVER["WINDIR"])?$_SERVER["WINDIR"]:'');
    if(!is_dir($Alternate_Dir = '../fonts/') && !is_dir($Alternate_Dir = 'fonts/')){
        $Alternate_Dir = '';
    }
    $Standard_FontDir = (strlen(trim($Standard_WinDir))?$Standard_WinDir.'\\Fonts\\':$Alternate_Dir);
    if(is_dir($Standard_FontDir)){
        $Standard_Font = $Standard_FontDir.$Standard_Font;
        if(is_file($Standard_Font)){
            $retval["FontName"] = $Standard_Font;
        }
    }
    //$tmp_font_value = Array("Name","Size","Bold","Kursiv","Underline","Crossline");
    $tmp_font_value = explode(";", $sv_font_value, 6);
    $tmp_font_name = $tmp_font_value[0]; //Name
    $tmp_font_character = '';
    if(stristr($tmp_font_value[2],'True')){ //Bold
        $tmp_font_character = "BD";
        if(stristr($tmp_font_value[3],'True')){ //Kursiv
            $tmp_font_character = "BI";
        }
    }
    else{
        if(stristr($tmp_font_value[3],'True')){ //Kursiv
            $tmp_font_character = "I";
        }
    }

//    $temp_font = read_dir($Standard_FontDir, $tmp_font_ext, $tmp_font_character, substr($tmp_font_name,0,4) );
    $temp_font = read_dir('/srv/www/htdocs/svweb/fonts', $tmp_font_ext, $tmp_font_character, substr($tmp_font_name,0,4) );
    if(isset($temp_font[0]) && is_file($Standard_FontDir.$temp_font[0])){
        $retval['FontName'] = $Standard_FontDir.$temp_font[0];
    }
    if($tmp_font_value[1] > 0){ //Size
         $retval['FontSize'] = $tmp_font_value[1] * $PointToPixel;
    }

    if(stristr($tmp_font_value[4],'True')){ //Underline
        $retval['Underline'] = true;
    }
    else{
        $retval['Underline'] = false;
    }

    if(stristr($tmp_font_value[5],'True')){ //Crossline
        $retval['Crossline'] = true;
    }
    else{
        $retval['Crossline'] = false;
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion GetImageFromPicture() */
function GetImageFromPicture($picture_object, $picture_object_array, $TwipsPerPixelX, $TwipsPerPixelY){
    // Picture in Image stellen
    global $flowchart_dir;
    $ret_im = -1;

    $tmp_picture = $picture_object;
    $tmp_picture = StripPathAndExtension($tmp_picture);
    $tmp_file_type = GetPictureFileType($flowchart_dir, $tmp_picture);
    if($tmp_file_type){
        $tmp_picture_file = GetPictureFile($flowchart_dir, $tmp_picture, $tmp_file_type);
        if(strlen($tmp_picture_file)){
            // Image erstellen
            if($tmp_file_type == 2){
                $ret_im = @ImageCreateFromJPEG($tmp_picture_file);
            }
            else if($tmp_file_type == 3){
                $ret_im = @ImageCreateFromPNG($tmp_picture_file);
            }
			else if($tmp_file_type == 87){ //SVG
				$WidthPixel = $picture_object_array['PosWidth'] / $TwipsPerPixelX;
				$HeightPixel = $picture_object_array['PosHeight'] / $TwipsPerPixelY;
				if (file_exists('C:\temp\x'.$tmp_picture.'.'.$WidthPixel.'x'.$HeightPixel.'.svgTo.png')){
					$ret_im = @ImageCreateFromPNG('C:\temp\x'.$tmp_picture.'.'.$WidthPixel.'x'.$HeightPixel.'.svgTo.png');
				}
				else
				{	
					$image = new Imagick();
					$image->setResolution(288,288);
					$image->setBackgroundColor(new ImagickPixel('transparent')); 
					$image->readImageBlob(file_get_contents($tmp_picture_file));
					$image->setImageFormat("png"); //$image->setImageFormat("png24");
					$image->resizeImage($WidthPixel, $HeightPixel, imagick::FILTER_BLACKMAN, 1, false);
					//$image->resizeImage($object_value_array['PosWidth'], $object_value_array['PosHeight'], imagick::FILTER_LANCZOS, 1); 
					$image->writeImage('C:\temp\x'.$tmp_picture.'.'.$WidthPixel.'x'.$HeightPixel.'.svgTo.png');
					$image->clear();
					$image->destroy();
					//$ret_im = @ImageCreateFromPNG('C:\temp\tetstt.png');
					$ret_im = @ImageCreateFromPNG('C:\temp\x'.$tmp_picture.'.'.$WidthPixel.'x'.$HeightPixel.'.svgTo.png');
				}
			}
        }
    }

    return $ret_im;
}
/* }}} */

/* {{{ PHP-Funktion GetIndicatorPolygon() */
function GetIndicatorPolygon($sv_tag_value_1,   // value
                             $sv_tag_value_2,   // Winkel-Richtung
                             $min,              // MinValue =0
                             $max,              // MaxValue
                             $x1,               // X0 von tmp_image
                             $x2,               // X1 --> x_size von tmp_image
                             $y1,               // Y0 von tpm_image
                             $y2,               // Y1 --> Y-Size von tmp_image
                             $inner_top,        // Rand oben
                             $inner_left,       // Rand links
                             $inner_bottom,     // Rand unten
                             $inner_right,      // Rand rechts
                             $needlewidth = 1){ // Strichstrke
    $retval = array();
    $retval[0] = 0;//x0
    $retval[1] = 0;//y0
    $retval[2] = 0;//x1
    $retval[3] = 0;//y1
    $retval[4] = 0;//x2
    $retval[5] = 0;//y2
    $retval[6] = 0;//x3
    $retval[7] = 0;//y3

    if($x1 > $x2 || $y1 > $y2 || !is_numeric($sv_tag_value_1) || !is_numeric($sv_tag_value_2) || (($max - $min) == 0)){
        return $retval;
    }

    if($sv_tag_value_2 >= 360.0){
        $sv_tag_value_2 = $sv_tag_value_2 - 360;
    }

    $x_len = $x2 - $x1;
    $inner_left_pixel = $x_len / 100 * $inner_left;
    $inner_right_pixel = $x_len / 100 * $inner_right;
    $margin_x_len = $x_len - $inner_left_pixel;
    $margin_x_len -= $inner_right_pixel;

    $y_len = $y2 - $y1;
    $inner_top_pixel = $y_len / 100 * $inner_top;
    $inner_bottom_pixel = $y_len / 100 * $inner_bottom;
    $margin_y_len = $y_len - $inner_top_pixel;
    $margin_y_len -= $inner_bottom_pixel;

    $radius_x = $margin_x_len / 2;
    $radius_y = $margin_y_len / 2;
    //Startposition
    $retval[0] = $radius_x; //x0
    $retval[1] = $radius_y; //y0

    $max_angle = 360;
    //t->Ist = (roh - offset) / (skal - offset) * (mbe - mba) + mba;
    $sv_tag_value_1 = sqrt($sv_tag_value_1) * sqrt($max - $min);
    $rel_x2 = ($sv_tag_value_1 - $min) / ($max - $min) * $radius_x;
    $rel_y2 = ($sv_tag_value_1 - $min) / ($max - $min) * $radius_y;
    $rel_r2 = sqrt(pow($rel_x2,2) + pow($rel_y2,2));

    if($sv_tag_value_2 < ($max_angle / 2)){
        $value_angle = $sv_tag_value_2 + ($max_angle / 2);
    }
    else{
        $value_angle = $sv_tag_value_2 - ($max_angle / 2);
    }
    // Point2
    $rel_P2_y = cos(deg2rad($value_angle)) * $rel_y2;
    $rel_P2_x = sin(deg2rad($value_angle)) * $rel_x2;
    $retval[4] = $radius_x + $rel_P2_x;     //x2
    $retval[5] = $radius_y - $rel_P2_y;     //y2

    $angle_p1p3 = 135;
    //$value_angle = ($sv_tag_value - $min) / ($max - $min) * $max_angle;
    $tmp_angle = $value_angle + $angle_p1p3;
    if($tmp_angle > $max_angle){
        $tmp_angle -= $max_angle;
    }
    $rel_x1 = sin(deg2rad($tmp_angle)) * $rel_x2;
    $rel_y1 = cos(deg2rad($tmp_angle)) * $rel_y2;

    $tmp_angle = $value_angle - $angle_p1p3;
    if($tmp_angle < 0){
        $tmp_angle += $max_angle;
    }
    $rel_x3 = sin(deg2rad($tmp_angle)) * $rel_x2;
    $rel_y3 = cos(deg2rad($tmp_angle)) * $rel_y2;

    $rel_x1 /= 2;
    $rel_x3 /= 2;
    $rel_y1 /= 2;
    $rel_y3 /= 2;
    $retval[2] = $radius_x + $rel_x1; //$x_len / 2 + $inner_left_pixel - $inner_right_pixel;
    $retval[6] = $radius_x + $rel_x3; //$rel_x2 + $x_len / 2 + $inner_left_pixel - $inner_right_pixel;// + $needlewidth / 2;
    $retval[3] = $radius_y - $rel_y1; //$y_len / 2 - $inner_bottom_pixel;
    $retval[7] = $radius_y - $rel_y3; //$y_len / 2 - $rel_y2 - $inner_bottom_pixel;

    /*
    echo '<pre>';
    echo "\r\nx_len: ",$x_len;
    echo "\r\ny_len: ",$y_len;
    echo "\r\nmax_angle: ",$max_angle;
    echo "\r\nsv_tag_value: ",$sv_tag_value_2;
    echo "\r\nvalue_angle: ",$value_angle;
    echo "\r\nradius_x x0: ",$radius_x;
    echo "\r\nradius_y y0: ",$radius_y;
    echo "\r\nrel_x2: ",$rel_x2;
    echo "\r\nrel_y2: ",$rel_y2;
    echo "\r\nrel_r2: ",$rel_r2;
    echo "\r\nx_P2: ",$rel_P2_x;
    echo "\r\ny_P2: ",$rel_P2_y;
    echo "\r\nx1: ",$rel_x1;
    echo "\r\ny1: ",$rel_y1;
    echo "\r\nx3: ",$rel_x3;
    echo "\r\ny3: ",$rel_y3;
    print_r_formatted($retval);
    echo '</pre>';
    exit;
    */

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion GetIndicatorVector() */
function GetIndicatorVector($sv_tag_value,
                            $min,
                            $max,
                            $x1,
                            $x2,
                            $y1,
                            $y2,
                            $inner_top,
                            $inner_left,
                            $inner_bottom,
                            $inner_right,
                            $style=2, // 2 = Halbkreis, 3 = Vollkreis
                            $needlewidth = 1){
    $retval = array();
    $retval['x1'] = 0;
    $retval['x2'] = 0;
    $retval['y1'] = 0;
    $retval['y2'] = 0;

    if($x1 > $x2 || $y1 > $y2 || !is_numeric($sv_tag_value)){
        return $retval;
    }

    $x_len = $x2 - $x1;
    $inner_left_pixel = $x_len / 100 * $inner_left;
    $inner_right_pixel = $x_len / 100 * $inner_right;
    $margin_x_len = $x_len - $inner_left_pixel;
    $margin_x_len -= $inner_right_pixel;

    $y_len = $y2 - $y1;
    $inner_top_pixel = $y_len / 100 * $inner_top;
    $inner_bottom_pixel = $y_len / 100 * $inner_bottom;
    $margin_y_len = $y_len - $inner_top_pixel;
    $margin_y_len -= $inner_bottom_pixel;


    $radius = $margin_x_len / 2;

    if($style==3){
        if($radius > $margin_y_len / 2){
            $radius = $margin_y_len / 2;
        }
        $max_angle = 360;
    }
    else{
        if($radius > $margin_y_len){
            $radius = $margin_y_len;
        }
        $max_angle = 180;
    }

    if(($max - $min) != 0){
        //t->Ist = (roh - offset) / (skal - offset) * (mbe - mba) + mba;
        $value_angle = ($sv_tag_value - $min) / ($max - $min) * $max_angle;

    }
    else
    {
        $value_angle = 0;
    }

    $rel_x2 = cos(deg2rad($max_angle - $value_angle)) * $radius;
    $rel_y2 = sin(deg2rad($max_angle - $value_angle)) * $radius;

    if($style==3){
        $rel_x2 *= -1;
        $rel_y2 *= -1;
    }

    $retval['x1'] = $x_len / 2 + $inner_left_pixel - $inner_right_pixel;// - $needlewidth / 2;
    $retval['x2'] = $rel_x2 + $x_len / 2 + $inner_left_pixel - $inner_right_pixel;// + $needlewidth / 2;
    if($style==3){
        $retval['y1'] = $y_len / 2 - $inner_bottom_pixel;
        $retval['y2'] = $y_len / 2 - $rel_y2 - $inner_bottom_pixel;
    }
    else{
        $retval['y1'] = $y_len - $inner_bottom_pixel;
        $retval['y2'] = $y_len - $rel_y2 - $inner_bottom_pixel;
    }

    /*
    echo "\r\nx_len: ",$x_len;
    echo "\r\ny_len: ",$y_len;
    echo "\r\nmax_angle: ",$max_angle;
    echo "\r\nsv_tag_value: ",$sv_tag_value;
    echo "\r\nvalue_angle: ",$value_angle;
    echo "\r\nradius: ",$radius;
    echo "\r\nx2: ",$x2;
    echo "\r\ny2: ",$y2;
    echo "\r\nrel_x2: ",$rel_x2;
    echo "\r\nrel_y2: ",$rel_y2;
    print_r_formatted($retval);
    exit;
    */

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion GetPictureFile() */
function GetPictureFile($flowchart_dir, $picture, $file_type){
    $picture_file = '';
	/*
	echo "flowchart_dir:", $flowchart_dir;
	echo "picture:", $picture; 
echo "file_type:", $file_type; 		*/

    if($file_type == 2){
        $picture_file = $flowchart_dir.$picture.'.jpg';
    }
    else if($file_type == 3){
        $picture_file = $flowchart_dir.$picture.'.png';
    }
	else if($file_type == 87){
        $picture_file = $flowchart_dir.$picture.'.svg';
    }

    return $picture_file;
}
/* }}} */

/* {{{ PHP-Funktion ImageCreateErrorMessage() */
function ImageCreateErrorMessage($error_message){
    header("Content-type: image/png");
    $im = @ImageCreate(700, 50) or die('Error creating image!');
    $background_color = ImageColorAllocate($im, 208, 208, 208);
    $text_color = ImageColorAllocate($im, 255, 0, 0);
    ImageString($im, 3, 10, 10, $error_message, $text_color);
    ImagePNG($im);
}
/* }}} */

/* {{{ PHP-Funktion read_dir() */
function read_dir($dir = ".", $endung = ".ttf", $font_char, $font_search){
    $retval = array();

    if(!is_dir($dir)) return false;

    $verzeichnis = dir($dir);
    $font_search = trim($font_search);
    $font_char = trim($font_char);
    $strlen_font_char = strlen($font_char);
    $strlen_endung = strlen($endung);
    while($datei = $verzeichnis->read()){
        if($datei[0] != "." && substr($datei, $strlen_endung * (-1)) == $endung
        && stristr($datei, $font_search)){
            $datei_ohne_endung = substr($datei, 0, strlen($datei) - $strlen_endung);
            if($strlen_font_char){
                $extracted_font_char = substr($datei_ohne_endung, $strlen_font_char * (-1));
            }
            else{
                $extracted_font_char = '';
            }

            // Wenn $font_char leer, darf $datei_ohne_endung nicht auf BD, BI oder I enden,
            // wenn $font_char definiert, muss $datei_ohne_endung darauf enden
            if((!$strlen_font_char
            && !stristr(substr($datei_ohne_endung, -2), 'BD')
            && !stristr(substr($datei_ohne_endung, -2), 'BI')
            && !stristr(substr($datei_ohne_endung, -1), 'I'))
            || ($strlen_font_char
            && stristr($extracted_font_char, $font_char))){
                // BI ausschlieen, wenn I
                if(strtolower($font_char) != 'i'
                || !stristr(substr($datei_ohne_endung, -2), 'BI')){
                    /*
                    echo "\r\n\r\ndatei_ohne_endung: ",$datei_ohne_endung;
                    echo "\r\nextracted_font_char: ",$extracted_font_char;
                    echo "\r\nfont_char: ",$font_char;
                    */
                    $dateinamen[] = $datei;
                }
            }
        }
    }
    $verzeichnis->close();

    if(isset($dateinamen) && is_array($dateinamen)){
        sort($dateinamen);
        $retval = $dateinamen;
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion StdForeColor() */
function StdForeColor($sv_fore_color){
    global $im;

    $retval = ImageColorAllocate($im, 0, 0, 0);

    if((is_numeric($sv_fore_color)) && ($sv_fore_color >= 0)){
        $tmp_color = sprintf("%06x", $sv_fore_color);
        $tmp_b = hexdec(substr($tmp_color, 0, 2));
        $tmp_g = hexdec(substr($tmp_color, 2, 2));
        $tmp_r = hexdec(substr($tmp_color, 4, 2));
        $retval = ImageColorAllocate($im, $tmp_r, $tmp_g, $tmp_b);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion StdImageCopy() */
function StdImageCopy($src_im, $PosLeft, $PosTop){
    global $im;
    global $TwipsPerPixelX;
    global $TwipsPerPixelY;
    global $offset_x;
    global $offset_y;

    if($src_im){
        $imagesx = imagesx($src_im);
        $imagesy = imagesy($src_im);
        ImageCopy($im,
                  $src_im,
                  $PosLeft / $TwipsPerPixelX + $offset_x, //dest_left
                  $PosTop / $TwipsPerPixelY - $offset_y, //dest_Top
                  0,
                  0,
                  $imagesx,
                  $imagesy);
    }
}
/* }}} */

/* {{{ PHP-Funktion StdImageCopyResized() */
function StdImageCopyResized($src_im, $PosLeft, $PosTop, $PosWidth, $PosHeight){
	global $im;
	global $TwipsPerPixelX;
	global $TwipsPerPixelY;
	global $offset_x;
	global $offset_y;

	if($src_im){
		$imagesx = imagesx($src_im);
		$imagesy = imagesy($src_im);
		$imagedx = imagesx($im);
		$imagedy = imagesy($im);
		//		$x=(($imagedx<($PosWidth / $TwipsPerPixelX))?$imagedx:($PosWidth / $TwipsPerPixelX));//Ziel
		//		$y=(($imagedy<($PosHeight / $TwipsPerPixelY))?$imagedy:($PosHeight / $TwipsPerPixelY));//Ziel
		$x=$PosWidth / $TwipsPerPixelX;//Ziel
		$y=$PosHeight / $TwipsPerPixelY;//Ziel
		ImageCopyResized($im,//Ziel
		$src_im,
		$PosLeft / $TwipsPerPixelX + $offset_x,//Ziel
		$PosTop / $TwipsPerPixelY - $offset_y,//Ziel
		//                         $PosLeft / $TwipsPerPixelX,//Ziel
		//                         $PosTop / $TwipsPerPixelY,//Ziel
		0,
		0,
		$x,
		$y,
		$imagesx,
		$imagesy
		);
	}
	/*
	 echo '<pre>';
	echo "\r\nPosLeft: ",$PosLeft;
	echo "\r\nPosTop: ",$PosTop;
	echo "\r\nPosLeft: ",$PosLeft / $TwipsPerPixelX + $offset_x;
	echo "\r\nPosTop: ",$PosTop / $TwipsPerPixelY + $offset_y;
	echo "\r\nObjectPosWeite: ",$PosWidth;
	echo "\r\nPosHeight: ",$PosHeight;
	echo "\r\nim_X: ",$imagesx;
	echo "\r\nim_Y: ",$imagesy;
	echo "\r\noffset_x: ",$PosWidth / $TwipsPerPixelX;
	echo "\r\noffset_y: ",$PosHeight / $TwipsPerPixelY;
	echo '</pre>';
	exit;
	*/
}

/* {{{ PHP-Funktion StdImageCopy() */
function StdImageCopy_new($src_im, &$dst_im, $PosLeft, $PosTop, $PosWidth, $PosHeight, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y){

    if($src_im){
        $imagesx = imagesx($src_im);
        $imagesy = imagesy($src_im);
        ImageCopy($dst_im,
                  $src_im,
                  $PosLeft / $TwipsPerPixelX + $offset_x, //dest_left
                  $PosTop / $TwipsPerPixelY - $offset_y, //dest_Top
                  0,
                  0,
                  $imagesx,
                  $imagesy);
    }
}
/* }}} */

/**
 * Bild in Hauptbild kopieren
 * @param image $src_im
 * @param image $dst_im
 * @param number $PosLeft
 * @param number $PosTop
 * @param number $PosWidth
 * @param number $PosHeight
 * @param number $TwipsPerPixelX
 * @param number $TwipsPerPixelY
 * @param number $offset_x
 * @param number $offset_y
 */
function StdImageCopyResized_new($src_im, &$dst_im, $PosLeft, $PosTop, $PosWidth, $PosHeight, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y){

    if($src_im){
        $imagesx = imagesx($src_im);
        $imagesy = imagesy($src_im);
        $imagedx = imagesx($dst_im);
        $imagedy = imagesy($dst_im);
//		$x=(($imagedx<($PosWidth / $TwipsPerPixelX))?$imagedx:($PosWidth / $TwipsPerPixelX));//Ziel
//		$y=(($imagedy<($PosHeight / $TwipsPerPixelY))?$imagedy:($PosHeight / $TwipsPerPixelY));//Ziel
		$x=$PosWidth / $TwipsPerPixelX;//Ziel
		$y=$PosHeight / $TwipsPerPixelY;//Ziel
        ImageCopyResized($dst_im,//Ziel
                         $src_im,
                         $PosLeft / $TwipsPerPixelX + $offset_x,//Ziel
                         $PosTop / $TwipsPerPixelY - $offset_y,//Ziel
//                         $PosLeft / $TwipsPerPixelX,//Ziel
//                         $PosTop / $TwipsPerPixelY,//Ziel
                         0,
                         0,
						 $x,
						 $y,
                         $imagesx,
                         $imagesy
						 );
    }
}

/* {{{ PHP-Funktion StdImageTTFText() */
/**
 * Wert in Bild schreiben
 * @param unknown $dst_im
 * @param unknown $TwipsPerPixelX
 * @param unknown $TwipsPerPixelY
 * @param unknown $offset_x
 * @param unknown $offset_y
 * @param unknown $PosLeft
 * @param unknown $PosTop
 * @param unknown $PosWidth
 * @param unknown $sv_value_font
 * @param unknown $sv_value_fore_color
 * @param unknown $sv_value
 * @param unknown $tmp_alignment
 */
function StdImageTTFText_new(&$dst_im, $object_value_array, $TwipsPerPixelX, $TwipsPerPixelY, $offset_x, $offset_y, $sv_value){

	$PosLeft = $object_value_array['PosLeft'];
	$PosTop = $object_value_array['PosTop'];
	$PosWidth = $object_value_array['PosWidth'];
	
	$sv_value_fore_color = set_forecolor($object_value_array, $dst_im);
	$tmp_alignment = set_alignment($object_value_array); 
	$sv_value_font = set_font($object_value_array);
    
	$tmp_im_size = array(0, 0, 0, 0, 0, 0, 0, 0);
    $tmp_im_size2 = array(0, 0, 0, 0, 0, 0, 0, 0);

    $tmp_im_size = @imagettfbbox($sv_value_font['FontSize'], 0, $sv_value_font['FontName'], $sv_value);
    $tmp_im_size2 = @imagettfbbox($sv_value_font['FontSize'], 0, $sv_value_font['FontName'], 'Qg');

    $tmp_x = $PosLeft / $TwipsPerPixelX  + $offset_x;
    // $tmp_alignment = 0 --> linksbndig
    // $tmp_alignment = 1 --> rechtsbndig
    // $tmp_alignment = 2 --> zentriert
    $tmp_value_width = abs($tmp_im_size[2] - $tmp_im_size[0]);
    $tmp_value_height = abs($tmp_im_size[5] - $tmp_im_size[3]);
    if($tmp_alignment == 1){
        $tmp_width = $PosWidth / $TwipsPerPixelX;
        $tmp_x = $tmp_x + ($tmp_width - $tmp_value_width);
    }
    if($tmp_alignment == 2){
        $tmp_width = $PosWidth / $TwipsPerPixelX;
        $tmp_x = $tmp_x + ($tmp_width / 2.0 - $tmp_value_width / 2.0);
    }
    $tmp_y = $PosTop / $TwipsPerPixelY - $offset_y + abs($tmp_im_size2[5] - $tmp_im_size2[1]);

    $Test = @imagettftext($dst_im,
                          $sv_value_font['FontSize'],
                          0,
                          $tmp_x,
                          $tmp_y,
                          $sv_value_fore_color,
                          $sv_value_font['FontName'],
                          $sv_value);

    if(isset($sv_value_font['Underline']) && $sv_value_font['Underline']){
        $tmp_underline_offset = 5;
        ImageLine($dst_im,
                  $tmp_x,
                  $tmp_y + $tmp_underline_offset,
                  $tmp_x + $tmp_value_width,
                  $tmp_y + $tmp_underline_offset,
                  $sv_value_fore_color);
    }

    if(isset($sv_value_font['Crossline']) && $sv_value_font['Crossline']){
        $tmp_crossline_offset = $tmp_value_height / 2;
        ImageLine($dst_im,
                  $tmp_x,
                  $tmp_y - $tmp_crossline_offset,
                  $tmp_x + $tmp_value_width,
                  $tmp_y - $tmp_crossline_offset,
                  $sv_value_fore_color);
    }

    /*
    echo '<pre>';
    echo "\r\nText: ",$sv_value;
    echo "\r\ntmp_x: ",$tmp_x;
    echo "\r\nPosLeft / TwipsPerPixelX: ",$PosLeft / $TwipsPerPixelX;
    echo "\r\nPosTop / TwipsPerPixelY: ",$PosTop / $TwipsPerPixelY;
    echo "\r\noffset_y: ",$offset_y;
    echo "\r\ntmp_y: ",$tmp_y;
    echo "\r\n";
    //echo "\r\nFont: ",$object_value_array['Font'];
    print_r($sv_value_font);
    print_r($tmp_im_size);
    print_r($Test);
    echo '</pre>';
    //exit;
    */
}
/* }}} */

/* {{{ PHP-Funktion StdImageTTFText() */
function StdImageTTFText($PosLeft, $PosTop, $PosWidth, $sv_value_font, $sv_value_fore_color, $sv_value, $tmp_alignment){
    global $im;
    global $TwipsPerPixelX;
    global $TwipsPerPixelY;
    global $offset_x;
    global $offset_y;

    $tmp_im_size = array(0, 0, 0, 0, 0, 0, 0, 0);
    $tmp_im_size2 = array(0, 0, 0, 0, 0, 0, 0, 0);

    $tmp_im_size = @imagettfbbox($sv_value_font['FontSize'], 0, $sv_value_font['FontName'], $sv_value);
    $tmp_im_size2 = @imagettfbbox($sv_value_font['FontSize'], 0, $sv_value_font['FontName'], 'Qg');

    $tmp_x = $PosLeft / $TwipsPerPixelX  + $offset_x;
    // $tmp_alignment = 0 --> linksbndig
    // $tmp_alignment = 1 --> rechtsbndig
    // $tmp_alignment = 2 --> zentriert
    $tmp_value_width = abs($tmp_im_size[2] - $tmp_im_size[0]);
    $tmp_value_height = abs($tmp_im_size[5] - $tmp_im_size[3]);
    if($tmp_alignment == 1){
        $tmp_width = $PosWidth / $TwipsPerPixelX;
        $tmp_x = $tmp_x + ($tmp_width - $tmp_value_width);
    }
    if($tmp_alignment == 2){
        $tmp_width = $PosWidth / $TwipsPerPixelX;
        $tmp_x = $tmp_x + ($tmp_width / 2.0 - $tmp_value_width / 2.0);
    }
    $tmp_y = $PosTop / $TwipsPerPixelY - $offset_y + abs($tmp_im_size2[5] - $tmp_im_size2[1]);

    $Test = @imagettftext($im,
                          $sv_value_font['FontSize'],
                          0,
                          $tmp_x,
                          $tmp_y,
                          $sv_value_fore_color,
                          $sv_value_font['FontName'],
                          $sv_value);

    if(isset($sv_value_font['Underline']) && $sv_value_font['Underline']){
        $tmp_underline_offset = 5;
        ImageLine($im,
                  $tmp_x,
                  $tmp_y + $tmp_underline_offset,
                  $tmp_x + $tmp_value_width,
                  $tmp_y + $tmp_underline_offset,
                  $sv_value_fore_color);
    }

    if(isset($sv_value_font['Crossline']) && $sv_value_font['Crossline']){
        $tmp_crossline_offset = $tmp_value_height / 2;
        ImageLine($im,
                  $tmp_x,
                  $tmp_y - $tmp_crossline_offset,
                  $tmp_x + $tmp_value_width,
                  $tmp_y - $tmp_crossline_offset,
                  $sv_value_fore_color);
    }

    /*
    echo '<pre>';
    echo "\r\nText: ",$sv_value;
    echo "\r\ntmp_x: ",$tmp_x;
    echo "\r\nPosLeft / TwipsPerPixelX: ",$PosLeft / $TwipsPerPixelX;
    echo "\r\nPosTop / TwipsPerPixelY: ",$PosTop / $TwipsPerPixelY;
    echo "\r\noffset_y: ",$offset_y;
    echo "\r\ntmp_y: ",$tmp_y;
    echo "\r\n";
    //echo "\r\nFont: ",$object_value_array['Font'];
    print_r($sv_value_font);
    print_r($tmp_im_size);
    print_r($Test);
    echo '</pre>';
    //exit;
    */
}
/* }}} */

?>
