<?php

// vim: fdm=marker

/* * *************************
 *  Andy Geiss 2009 - 2010  *
 *  Tabulatorweite: 4       *
 * ************************* */

ob_start();
require_once('../scalarvis.inc.php');
require_once('flowchartfunctions.inc.php');
require_once('flowchartimage.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

// L TODO: Smtliche Fehlermeldungen als Grafik generieren
if (!start_session($sv)) {
    session_no_longer_valid_msg();
}

if (!$sv->connect()) {
    //ImageCreateErrorMessage($sv->socket_errorstr);
    echo '<br>', get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    exit;
}

/* {{{ Variablen belegen */
if (isset($sv->USER_CONFIG['FLOWCHART_DIR']) && strlen(trim($sv->USER_CONFIG['FLOWCHART_DIR'])) && trim($sv->USER_CONFIG['FLOWCHART_DIR']) != 'empty') {
    $flowchart_dir = $sv->USER_CONFIG['FLOWCHART_DIR'];
} else {
    $flowchart_dir = '';
}

$flowchart_ini_file = $flowchart_dir . 'Fliess.ini';

$sv_user = $sv->get_user();
$sv_port = $sv->get_port();
$sv_host = $sv->get_host();
$sv_pwd = $sv->get_pwd();
$sysinfo = &$sv->sysinfo;

if (isset($sv->USER_CONFIG['TZ_INDEX'])) {
    $tz_index = $sv->USER_CONFIG['TZ_INDEX'];
} else {
    $tz_index = -1;
}

if (isset($sv->USER_CONFIG['TIME_IS_GMT_ONLY']) && $sv->USER_CONFIG['TIME_IS_GMT_ONLY']) {
    $time_is_gmt_only = 1;
} else {
    $time_is_gmt_only = 0;
}
/* }}} */

/* {{{ Flowchart-INI-File einlesen */
if (is_file($flowchart_ini_file)) {
    $ini_array = get_ini_array($flowchart_ini_file);
} else {
    ImageCreateErrorMessage('File ' . $flowchart_ini_file . ' not found!');
    store_session($sv);
    exit;
}
/* }}} */

$archive = null;
if(isset($_GET['setarc']) && ($_GET['setarc'] === 'archive') ){
	$archive = 'archive';
}

$arctime = time();
if(isset($_GET['arctime']) ){
	$arctime = (int)$_GET['arctime'];
	if($arctime == 0){
		$arctime = time();
	}
}

// Hauptfunktion der flowchartimage.inc.php
flowchartimage('../', $sv, $arctime, $archive, $flowchart_dir, $tz_index, $time_is_gmt_only, $flowchart_ini_file);

store_session($sv);

/**
 * Gibt TAGInfo des aktuellen TAGs zurck
 * @param unknown $tag_nr
 * @param unknown $tag_info_array
 * @return boolean
 */
function get_tag_info_array($tag_nr, &$tag_info_array) {
    global $sv;

    $tag_info_array = array();
    $retval = $sv->get_tag_info_array($tag_nr, $tag_info_array);

    if ($retval) {
        return true;
    } else {
        return false;
    }
}


?>
