<?php
// vim: fdm=marker

/* * *************************
 *  Andy Geiss 2009 - 2010  *
 *  Tabulatorweite: 4       *
 * ************************* */


ob_start();
require_once('../scalarvis.inc.php');
require_once('flowchartfunctions.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if (!start_session($sv)) {
    session_no_longer_valid_msg();
}

/* {{{ Variablen initialisieren */
$TabPerRow = 0;
$base_target = 'flowchartframe';

if (isset($sv->USER_CONFIG['FLOWCHART_DIR']) && strlen(trim($sv->USER_CONFIG['FLOWCHART_DIR'])) && trim($sv->USER_CONFIG['FLOWCHART_DIR']) != 'empty') {
    $flowchart_dir = $sv->USER_CONFIG['FLOWCHART_DIR'];
} else {
    $flowchart_dir = '';
}

$flowchart_ini_file = $flowchart_dir . 'Fliess.ini';
/* }}} */

/* {{{ Flowchart-INI-File einlesen */
if (is_file($flowchart_ini_file)) {
    $ini_array = get_ini_array($flowchart_ini_file);
} else {
    echo '<br />File ', $flowchart_ini_file, ' not found!';
    store_session($sv);
    exit;
}

/* }}} */

/* {{{ Variablen belegen */
$register_no = '000';
$start = 0;//welches Register zuerst angezeigt wird
if(isset($_GET['start'])){
	$start = (int)$_GET['start'];
}
else {
	if(isset($_GET['register'])){
		$register_no = $_GET['register'];
	}
	else if(isset($_GET['Register'])){
		$register_no = $_GET['Register'];
	}
}

$i = 0;
//print_r_formatted($ini_array);
//$datum = date("d.m.Y - H:i:s", time());
//echo '3:'.$datum.'<br/>';

foreach ($ini_array as $section_index => $section_array) {
    if (substr($section_index, 0, 8) == 'Fliess') {
        // TapPerRow ermitteln
        if (isset($section_array['TabPerRow'])) {
            $TabPerRow = $section_array['TabPerRow'];
        } else {
            $TabPerRow = 0;
        }
        if( ($start==1) && (isset($section_array['ErstesRegister'])) ){
            $register_no = sprintf("%03d", $section_array['ErstesRegister']);
        } 
		
    }
    if (substr($section_index, 0, 8) == 'Register') {
        // Caption ermitteln
        if (isset($section_array['Caption'])) {
            $menu_array[$i]['Caption'] = $section_array['Caption'];
        } else {
            $menu_array[$i]['Caption'] = '';
        }

        // Registernummer ermitteln
        $tmp_register = substr($section_index, 8, 3);
        $menu_array[$i]['Register'] = $tmp_register;

        // Picture ermitteln
        $tmp_picture = get_value_from_ini_array($ini_array, 'Objekt' . $tmp_register . '.000', 'TxtErr');
        // Pfadangabe entfernen
        $tmp_pos = strrpos($tmp_picture, '\\');
        if ($tmp_pos) {
            $tmp_picture = substr($tmp_picture, $tmp_pos + 1);
        }
        // Extension entfernen
        $tmp_pos = strrpos($tmp_picture, '.');
        if ($tmp_pos) {
            $tmp_picture = substr($tmp_picture, 0, $tmp_pos);
        }
        $menu_array[$i]['Picture'] = $tmp_picture;

        $i++;
    }
}
/* }}} */

$codebase = '../';
include('../cont_top.inc.php');

$locDate = localdate_std(time(), true);
$setRefresh = false;
if (isset($sv->sysinfo['refresh']) && is_numeric($sv->sysinfo['refresh']) && $sv->sysinfo['refresh'] > 0) {
    $interval_refresh = $sv->sysinfo['refresh'] * 1000;
    if ($sv->refresh_flowchart) {
        $setRefresh = true;
    }
}
?>

<link rel="stylesheet" href="../css/jquery.datetimepicker.css" type="text/css">

<script src="../js/jquery.js"></script>
<script src="../js/jquery.datetimepicker.js"></script>
<script src="../js/flowchart.js"></script>


<script>
    setSessionName('<?php echo $svweb_session_name; ?>');
</script>

<?php if ($setRefresh) : ?>
    <script>
        setRefreshInterval(<?php echo $interval_refresh; ?>);
    </script>
<?php endif; ?>



<style type="text/css">
    a:link{text-decoration: none; color: #000000;}
    a:visited{text-decoration: none; color: #3a3a3a;}
    a:active{text-decoration: none; color: #FF8040;}
    a:hover{text-decoration: none; color: #0000FF;}

    ul.fcMenu {list-style-type: none; display: table-row; font-family: Arial, sans-serif;}
    ul.fcMenu li {list-style-type: none; float: left; padding: 5px;}
    ul.fcMenu li > a {font-size: 16px;}
    ul.fcMenu li:after {content: ' | ';}
    ul.fcMenu li:last-child:after {content: '';}

    #refresh {margin-top: 15px; font-family: Arial,sans-serif; font-size: 13px; display: table-row; }
    #refresh > div {float: left; margin-right: 10px;}
    #refreshCheck {padding-top: 3px;}
    #timeDisplay {padding-top: 5px;}
    #archive, #setdiagramm {height: 25px; width: 90px; text-align: center; font-size: 10px; margin-top: -10px;}
    #date_refresh_hidden {display: none;}
    #dateinput {width: 80px;}
    #timeinput {width: 50px;}
    #diagrammSelection {margin-left: 30px;}
    #diagrammSelection label {margin-right: 5px;}
    #diagrammSelection input {width: 80px;}
</style>

</head>

<body style="margin: 0px;">

    <div id="mymenu" style="position: fixed; z-index: 10; background-color: #CCC; height: 90px; width: 100%; overflow-y: auto;">
        <ul class="fcMenu">
            <?php for ($i = 0; $i < count($menu_array); $i++) : ?>
                <li><a href="javascript:flowchartMenuItem('<?php echo $menu_array[$i]['Register']; ?>', 'flowchart')" tabindex=<?php echo $i+1; ?>><?php echo $menu_array[$i]['Caption']; ?> </a></li>
                <?php if ($i > 0 && (($i + 1) % $TabPerRow) == 0) : ?>
                </ul>
                <ul class="fcMenu">
                <?php endif; ?>
            <?php endfor; ?>
        </ul>
    </div>

    <div id="archiveselection" style="position: fixed; z-index: 10; top: 90px; height: 30px; width: 100%; background-color: #CCC;">
        <div id="refresh">
            <div id="refreshCheck">
                <input type="checkbox" name="refresh_flowchart" id="refresh_flowchart" <?php if ($sv->refresh_flowchart) : ?>checked="checked"<?php endif; ?>> <?php echo $text_array[$sv->lang_id]['refresh']; ?>
            </div>
            <div id="timeDisplay">
                <span id="date_refresh" class="myDate"><?php echo $locDate = localdate_std(time(), true); ?></span>
                </div>
            <div id="datetimeSelection">
            	<input id="date_refresh_hidden" type="text" value="<?php echo $locDateHidden = time(); ?>" >
            	<input id="dateinput" type="text" >
                <input id="timeinput" type="text" >
                <button type="button" id="archive">Archiv lesen</button>
            </div>
            <div id="diagrammSelection">
				<?php $val = $ini_array['Diagramm']['Universal']; ?>
				<?php $val = round($val / 3600); ?>
                <label>Universal (h)</label><input id="universalinput" type="text" value="<?php echo $val; ?>" >
				<?php $val = $ini_array['Diagramm']['Detail']; ?>
				<?php $val = round($val / 60); ?>
                <label>Detail (min)</label><input id="detailinput" type="text"  value="<?php echo $val; ?>">
                <button type="button" id="setdiagramm">bernehmen</button>
            </div>
        </div>
    </div>

	<div id="flowchartimageBox" style="position: absolute; top: 120px;">
 
    <div id="flowchartimage" >
 </div>
 </div>
   
    <script>
		var myBox = document.getElementById("flowchartimageBox");
		var scale = 1;
		var scaleStep = 0.05;
		var scaleStepKby = scaleStep;
		
		if (localStorage.getItem("flowChartScale")){
			scale = localStorage.getItem("flowChartScale")
			if (isNaN(scale)) {scale = 1;}
		}
		myBox.style.transformOrigin = "0 0";
		myBox.style.transform = 'scale('+scale+')';
		console.log("scale" + scale);
		
		document.addEventListener("keydown", keyDownTextField, false);
		
		if (myBox.addEventListener) {
			// IE9, Chrome, Safari, Opera
			myBox.addEventListener("mousewheel", MouseWheelHandler, false);
			// Firefox
			myBox.addEventListener("DOMMouseScroll", MouseWheelHandler, false);
		}
		
		$('a').on( 'keyup', function( e ) {
			if( e.which == 9 ) {
				console.log( e.target.href );
				e.target.click();
			}
		} );
		
		function MouseWheelHandler(e) {
			// cross-browser wheel delta
			var e = window.event || e; // old IE support
			if (e.wheelDelta) {
				if(e.wheelDelta > 0) {
					scale += scaleStep;
				} else if (e.wheelDelta < 0) {
					scale -= scaleStep;
				}
			} else if (e.detail)
				{
				if(e.detail > 0) {
					scale -= scaleStep;
				} else if (e.detail < 0) {
					scale += scaleStep;
				}
			}
			//var delta = Math.max(-1, Math.min(1, (e.wheelDelta || -e.detail)));
			myBox.style.transformOrigin = "0 0";
			myBox.style.transform = 'scale('+scale+')';
			localStorage.setItem("flowChartScale", scale );
			return false;
		}
			
		function keyDownTextField(event) {
			 // 107 Num Key  +
			 // 109 Num Key  -
			// 173 Min Key  hyphen/underscor Hey
			// 171 + on a German kby!
			// 61 Plus key  +/= key
			if (event.which == '107' || event.which == '171' ) {
				scale += scaleStepKby;
			} else if (event.which == '109' || event.which == '173' ) {
				scale -= scaleStepKby;
			} else {
				return false;
			}
			myBox.style.transformOrigin = "0 0";
			myBox.style.transform = 'scale('+scale+')';
			localStorage.setItem("flowChartScale", scale );
			//alert('disabling zooming'); 
			//event.preventDefault();
			return true;
		}
   

		
		
		
		
		flowchartMenuItem(<?php echo $register_no; ?>, 'flowchart');
    </script>
	

</body>
<?php
include('../cont_bottom.inc.php');
store_session($sv);
?>