<?php

// vim: fdm=marker

/* * ********************
 *  PSG 20150427 erstellt  *
 *  Datumsauswahl und Anstoss fuer Fliessbild  *
 * ******************** */

ob_start();
require('../scalarvis.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if (!start_session($sv)) {
    session_no_longer_valid_msg();
}

if (!$sv->connect()) {
    echo '<br />', get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    jsEscWindowClose();
    exit;
}

$base_target = '';

/* {{{ Variablen belegen */
if (isset($_GET['parentwnd'])) {
    $base_target = $_GET['parentwnd'];
}

$registernr = 0;
if (isset($_GET['registernr']) && is_numeric($_GET['registernr'])) {
    $registernr = (int) $_GET['registernr'];
}

if (isset($_GET['datetime']) && is_numeric($_GET['datetime'])) {
    $datetime = (int) $_GET['datetime'];
} else {
    $datetime = time();
}

$date = date("d.m.Y", $datetime);
$std_int = date("H", $datetime);
$min_int = date("i", $datetime);
$sec_int = date("s", $datetime);

$interval = $sv->sysinfo['intervall'];
$from = $datetime;
$to = $datetime;

$from = round_time($from, $interval);
$to = round_time($to, $interval);

/* {{{ Submit-Action verarbeiten */
if (!empty($_GET['submit_action'])) {
    switch ($_GET['submit_action']) {
        case 'timesel':
            break;
    }
}
/* }}} */

$codebase = '../';
include('../cont_top.inc.php');

echo '
<script type="text/javascript">
<!--
document.title = "Zeitauswahl";
var od_p = window.opener.document;

//alert(od_p.title);
';

/* {{{ JavaScript Error-Alert() */
if (!empty($error)) {
    echo '
    alert("', $error, '");';
}
/* }}} */

/* {{{ JavaScript-Funktion key_down_event() - Key-Event-Handler */
echo '
function key_down_event(event){
    var keyCode;
    if(!event){
        event = window.event;
    }
    if(event.which){
        keyCode = event.which;
    }
    else{
        if(event.keyCode){
            keyCode = event.keyCode;
        }
    }
    //alert("Taste mit Dezimalwert " + keyCode + " gedrckt");

    // Esc
    if(keyCode == 27){
        window.close();
    }
}
document.onkeydown = key_down_event;';
/* }}} */

/* {{{ JavaScript-Funktion open_dateselection() - Datums-Auswahl ffnen */
echo '
function open_calender(){
    var i;
    var tag_index = null;
    var tag_nr = null;
    var tmp_tag_nr = null;
    var wwidth = 350;
    var wheight = 300;
    var wleft = screen.availWidth - wwidth - 100;
    var wtop = screen.availHeight - wheight - 150;
    var wlayout = "location=no, menubar=no, resizable=no, scrollbars=auto";
    wlayout += ", status=no, toolbar=no, left=" + wleft + ", top=" + wtop;
    wlayout += ", width=" + wwidth + ", height=" + wheight;

    wndcalender = window.open("calender.php?datetime=ajaxRefreshServerTime() + &session_name=', $svweb_session_name, '", "wndCalender", wlayout);
    wndcalender.focus();
}';
/* }}} */

/* {{{ JavaScript-Funktion OK Button() - Fliessbild mit Datum lesen und befuellen */
echo '
function OK(register){
    var url;
    var svUTC = time();
    var tmpDateUTC = document.selectTimeForm.date_string.value;
    //console.log(tmpDateUTC.toLocaleString());
    od_p.getElementById("date_refresh").innerHTML = tmpDateUTC;
    od_p.getElementById("date_refresh").title = svUTC;
    url = "flowchartimage.php?register=" + register + "&arctime=" + svUTC;
    url += "&time=" + time() + "&session_name=', $svweb_session_name, '";
    window.close();
}';
/* }}} */

/* {{{ JavaScript-Funktion OK Button() - Fliessbild mit Datum lesen und befuellen */
echo '
function Cancel(){

    window.close();
}';
/* }}} */

echo '
//-->
</script>
</head>';

/* {{{ HTML-Body */
echo '
<body style="padding: 5px;">
<form name="selectTimeForm" method="GET" action="', $_SERVER["SCRIPT_NAME"], '">
<input type="hidden" name="from" value="', $from, '">
<input type="hidden" name="to" value="', $to, '">
<input type="hidden" name="submit_action" value="archiv">
<input type="hidden" name="session_name" value="', $svweb_session_name, '">

<table border="0" width="100%" summary="Time Form">
<tr>
    <td align="right" width="20%">Datum:&nbsp;</td>
	<td>
	<input class="colored_input" style="text-align: middle;" name="date_string" size="8" maxlength="10" value="', $date, '">
    <button  name="btDateselection1" type="button" title="Archiv Lesen" onclick="open_calender()">
    <img alt="Archiv" title="Archiv" src="APPTL.ICO" width="15" height="15">
    </button>
    </td>
</tr>
</table>
<table border="0" width="100%" summary="Time Form">
<tr>
    <td align="right" width="20%">Zeit:&nbsp;</td>
	<td>
    <input class="colored_input" style="text-align: right;" name="std_int" size="1" maxlength="2" value="', $std_int, '">&nbsp;:&nbsp;',
 '<input class="colored_input" style="text-align: right;" name="min_int" size="1" maxlength="2" value="', $min_int, '">&nbsp;:&nbsp;',
 '<input class="colored_input" style="text-align: right;" name="sec_int" size="1" maxlength="2" value="', $sec_int, '">',
 '&nbsp;&nbsp;[hh:mm:ss]
	</td>
</tr>
</table>

<table border="0" width="100%" summary="Time Form">
<tr>
	<td align="center">
	<button style="height: 25px; width: 90px; text-align: center; font-size: 12px;" name="btOK" id="okButton" type="button" title="OK" onclick="OK(', $registernr, ')">OK</button>&nbsp;&nbsp;
	<button style="height: 25px; width: 90px; text-align: center; font-size: 12px;" name="btCancel" type="button" title="Abbruch" onclick="Cancel()">Abbruch</button>
	</td>
</tr>
</table>
</form>
</body>';
/* }}} */

include('../cont_bottom.inc.php');

store_session($sv);
?>

