<?php

// vim: fdm=marker

/* * *************************
 *  Andy Geiss 2009 - 2010  *
 *  PSG RS 20150211 geaendert*
 *  Tabulatorweite: 4       *
 * ************************* */

/* {{{ PHP-Includes */
require_once('config.inc.php');
require_once('base_functions.inc.php');
require_once('texts.inc.php');
require_once('flowchart/flowchartfunctions.inc.php');
/* }}} */

/* {{{ Globale PHP-Variablen */
$g_version = '160912';                                      // Version YYMMDD
//$g_version = gmdate("ymd", filemtime("ChangeLog.txt"));
$g_uname_system = php_uname('s');                           // OS ermitteln
$g_actionfile = 'index.php';                                // Action-File fr Form-Submit
$g_user_config_field_array = array('STARTUP_PAGE', // Userabhngige Config-Indizes
    'TIME_SOURCE',
    'HIDE_NEG_AXIS',
    'EXPORT_DATEFORMAT',
    'EXPORT_TIMEFORMAT',
    'EXPORT_DECSEP',
    'NAV_UNIV',
    'NAV_SGL',
    'NAV_DETAIL',
    'NAV_TREND',
    'NAV_FLOWCHART',
    'NAV_FLOWCHART_EDIT',
    'FLOWCHART_DIR',
    'FLOWCHART_EDIT_DIR',
    'NAV_EXPORT');

// Zeilenumbruch fr Mac, Windows oder Unix
if (stristr($g_uname_system, 'Darwin')) {
    $g_line_break = "\r";
    $g_path_separator = "/";
} else if (stristr($g_uname_system, 'Win')) {
    $g_line_break = "\r\n";
    $g_path_separator = "\\";
} else {
    $g_line_break = "\n";
    $g_path_separator = "/";
}

// L TODO: Neuere Zeitzonen-Funktionen funktionieren erst mit PHP >= 5.3.0
if (version_compare(PHP_VERSION, '5.1.0', '>=')) {
    //$g_timezone_identifiers_list = timezone_identifiers_list();   // timezone_identifiers_list() geht erst ab PHP 5.2.0
    // L TODO: Timezone ber $STANDARD_CONFIG/$USER_CONFIG vorbelegen
    // L TODO: $USERCONFIG["TIME_IS_ALL_UTC"] bercksichtigen
    $g_timezone_identifier = 'Europe/Berlin';
    // L TODO: London nur zum Testen
    //$g_timezone_identifier = 'Europe/London';
    date_default_timezone_set($g_timezone_identifier);
} else {
    $g_timezone_identifier = null;
}

// Session-Name muss immer per POST oder GET mitbergeben werden
if (isset($_POST['session_name'])) {
    $svweb_session_name = $_POST['session_name'];
} else if (isset($_GET['session_name'])) {
    $svweb_session_name = $_GET['session_name'];
}

// Content-Schlssel muss immer per POST oder GET mitbergeben werden
if (isset($_POST['content']) && strlen(trim($_POST['content']))) {
    $content = trim($_POST['content']);
} else if (isset($_GET['content']) && strlen(trim($_GET['content']))) {
    $content = trim($_GET['content']);
} else {
    $content = '';
}

// Diagramm-Index muss immer per POST oder GET mitbergeben werden, sofern bentigt
if (isset($_POST['diagram_index']) && strlen(trim($_POST['diagram_index']))) {
    $diagram_index = trim($_POST['diagram_index']);
} else if (isset($_GET['diagram_index']) && strlen(trim($_GET['diagram_index']))) {
    $diagram_index = trim($_GET['diagram_index']);
} else {
    $diagram_index = '';
}

// Register muss per GET bergeben werden, sofern bentigt
if (isset($_GET['register']) && strlen($_GET['register'])) {
    $register = fill_zeros($_GET['register'], 3);
} else {
    $register = '000';
}
/* }}} */

/* {{{ PHP-Funktion __unserialize() - Workaround fr unserialize-Offset-Error */

function __unserialize($sObject) {
    $retval = '';

    $__ret = preg_replace('!s:(\d+):"(.*?)";!e', "'s:'.strlen('$2').':\"$2\";'", $sObject);
    $retval = unserialize($__ret);
    //$retval = unserialize(base64_decode($__ret));

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion adjust_interval() - Korrigiert das Intervall in Sekunden zum gleichen Tag in einem anderen Monat */

function adjust_interval($timestamp, $interval) {
    $retval = $interval;

    if (check_min_interval($interval, 'month')) {
        $target_timestamp = $timestamp + $interval;
        $month_diff = month_diff($timestamp, $target_timestamp);

        $target_timestamp = localadd_month_diff($timestamp, $month_diff);
        $retval = $target_timestamp - $timestamp;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion bs2slash() - Konvertiert Backslashes in Slashes */

function bs2slash($phrase) {
    return str_replace('\\', '/', $phrase);
}

/* }}} */

/* {{{ PHP-Funktion check_max_interval() - Prft anhand eines Intervall-Bezeichners, ob der Maximalwert erreicht ist */

function check_max_interval($interval, $identifier) {
    $retval = false;
    $borderline = 0;
    $seconds_per_unit = 86400;  // Sekunden pro Tag

    switch ($identifier) {
        case '12days':
            $borderline = 12 * $seconds_per_unit;
            break;
    }

    if ($borderline && abs($interval) <= $borderline) {
        $retval = true;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion check_min_interval() - Prft anhand eines Intervall-Bezeichners, ob der Mindestwert erreicht ist */

function check_min_interval($interval, $identifier) {
    $retval = false;
    $borderline = 0;
    $seconds_per_unit = 86400;  // Sekunden pro Tag

    switch ($identifier) {
        case 'day':
            $borderline = 1 * $seconds_per_unit;
            break;
        case 'week':
            $borderline = 7 * $seconds_per_unit;
            break;
        case 'month':
            $borderline = 28 * $seconds_per_unit;
            break;
    }

    if ($borderline && abs($interval) >= $borderline) {
        $retval = true;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion destroy_session() - Session auflsen */

function destroy_session() {
    global $svweb_session_name;
    session_name($svweb_session_name);
    @session_start();
    session_unset();
    @session_destroy();
}

/* }}} */

/* {{{ PHP-Funktion dotted_if_too_long() - Schneidet Text ab einer bestimmten Lnge ab und punktet ihn */

function dotted_if_too_long($text, $maxlen) {
    $retval = '';

    if (strlen($text) > $maxlen) {
        $retval = substr($text, 0, $maxlen) . ' ...';
    } else {
        $retval = $text;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion download_headers() - Header fr Download */

function download_headers($dl_filename, $dl_filesize) {
    session_cache_limiter('');
    header('Content-Type: application/force-download');
    header('Content-Disposition: attachment; filename=' . $dl_filename);
    header('Content-Length: ' . $dl_filesize);
    /* 	RS 20120404 soll wohl ein ganz altes datum stehen, aber nicht 0
      header('Expires: 0'); */
    header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
    header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
    header('Cache-Control: no-store, no-cache, must-revalidate');   // HTTP/1.1
    header('Cache-Control: post-check=0, pre-check=0', false);
    header('Pragma: no-cache');                                     // HTTP/1.0
}

/* }}} */

/* {{{ PHP-Funktion fill_zeros() - Fhrende Nullen ergnzen */

function fill_zeros($number, $digits = 2) {
    $retval = '';
    $number = trim($number);

    if (!is_numeric($number)) {
        $number = 0;
    }

    $strlen_number = strlen($number);
    if ($strlen_number < $digits) {
        $diff = $digits - $strlen_number;
        for ($i = 0; $i < $diff; $i++) {
            $retval .= '0';
        }
        $retval .= $number;
    } else {
        $retval = $number;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion get_interval_array() - Intervall in Tage, Stunden, Minuten und Sekunden aufdrseln */

function get_interval_array($interval, $limit = 0) {
    $retarray = array();

    if (is_numeric($interval)) {
        $seconds_per_day = 86400;
        $seconds_per_hour = 3600;
        $seconds_per_minute = 60;
        $rest = $interval;
        if ($limit < 1) {
            $retarray['days'] = intval($rest / $seconds_per_day);
            $rest = $rest % $seconds_per_day;
        }
        if ($limit < 2) {
            $retarray['hours'] = intval($rest / $seconds_per_hour);
            $rest = $rest % $seconds_per_hour;
        }
        if ($limit < 3) {
            $retarray['minutes'] = intval($rest / $seconds_per_minute);
            $rest = $rest % $seconds_per_minute;
        }
        $retarray['seconds'] = $rest;
    }

    return $retarray;
}

/* }}} */

/* {{{ PHP-Funktion get_sv_socket_errorstr_from_errno() - Mehrsprachige Fehlermeldung fr Scalarvis-Connect erstellen */

function get_sv_socket_errorstr_from_errno($lang_id, $socket_errno, $socket_last_error) {
    global $text_array;
    $retval = '';

    switch ($socket_errno) {
        case 1:
            $retval = $text_array[$lang_id]['login_error'] . '! ' . $text_array[$lang_id]['sv_user_err'] . '!';
            break;
        case 2:
            $retval = $text_array[$lang_id]['login_error'] . '! ' . $text_array[$lang_id]['sv_host_err'] . '!';
            break;
        case 3:
            $retval = $text_array[$lang_id]['login_error'] . '! ' . $text_array[$lang_id]['sv_port_err'] . '!';
            break;
        case 4:
            $retval = $text_array[$lang_id]['login_error'] . '! ' . $text_array[$lang_id]['sv_pwd_err'] . '!';
            break;
        case 5:
            $retval = 'socket_create() - ' . $text_array[$lang_id]['socket_error'] . ' ' . $socket_last_error . ': ' . socket_strerror($socket_last_error);
            break;
        case 6:
            $retval = 'socket_connect() - ' . $text_array[$lang_id]['socket_error'] . ' ' . $socket_last_error . ': ' . socket_strerror($socket_last_error);
            break;
        case 7:
            $retval = $text_array[$lang_id]['connect_error'] . '! ' . $text_array[$lang_id]['sv_no_reply'] . '!';
            break;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion get_var_from_post_or_get() - Wert aus POST oder GET ermitteln */

function get_var_from_post_or_get($index) {
    $retval = '';

    if (isset($_POST[$index])) {
        $retval = $_POST[$index];
    } else if (isset($_GET[$index])) {
        $retval = $_GET[$index];
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion getAutoScale() - AutoScale-Array erstellen */

function getAutoScale(&$sv, &$svsc, $anzval, $type) {
    $AutoScale = array();
    $keys = array_keys($svsc->tagauswahl);
    $run = count($keys);

    if (is_numeric($anzval) && $anzval > 0) {
        // Autoscaling Werte berechnen
        $AutoScale = $sv->get_awt_stat(1);    // Autoscaling-Init
        $AutoScale = $sv->get_awt_stat($anzval);  // Autoscaling-Berechnung
        // Autoscaling verarbeiten
        for ($i = 0, $j = 0; $i < $run; $i++) {  // Autoscaling-Werte einsetzen
            // Negative Skalen erlaubt?
            if ($AutoScale['min_' . $i] < 0 || $svsc->tagauswahl[$keys[$i]]['dba'] < 0) {
                if ($sv->USER_CONFIG['HIDE_NEG_AXIS'] && ($AutoScale['max_' . $i] > 0)) {
                    $svsc->tagauswahl[$keys[$i]]['dba'] = 0;
                }
            }
            // Usereingaben einsetzen oder AutoScale-Polster hinzufgen
            $percent_of_range = percent_of_range($AutoScale['min_' . $i], $AutoScale['max_' . $i], 10);
            if (isset($svsc->tagauswahl[$keys[$i]]['dba']) && (strlen($svsc->tagauswahl[$keys[$i]]['dba']))) {
                $AutoScale['min_' . $i] = $svsc->tagauswahl[$keys[$i]]['dba'];
            } else {
                $AutoScale['min_' . $i] -= $percent_of_range;
                $AutoScale['min_' . $i] = (double) number_format($AutoScale['min_' . $i], optimum_decimal_places($AutoScale['min_' . $i]), '.', '');
            }
            if (isset($svsc->tagauswahl[$keys[$i]]['dbe']) && (strlen($svsc->tagauswahl[$keys[$i]]['dbe']))) {
                $AutoScale['max_' . $i] = $svsc->tagauswahl[$keys[$i]]['dbe'];
            } else {
                $AutoScale['max_' . $i] += $percent_of_range;
                $AutoScale['max_' . $i] = (double) number_format($AutoScale['max_' . $i], optimum_decimal_places($AutoScale['max_' . $i]), '.', '');
            }

            if ($type == 'single') { // Ggf. alle Achsen zusammenfassen
                if ($j) {
                    if ($AutoScale['min_' . $i] < $temp_dba) {
                        $temp_dba = $AutoScale['min_' . $i];
                    }
                    if ($AutoScale['max_' . $i] > $temp_dbe) {
                        $temp_dbe = $AutoScale['max_' . $i];
                    }
                } else {
                    $temp_dba = $AutoScale['min_' . $i];
                    $temp_dbe = $AutoScale['max_' . $i];
                }
                $j++;
            }
        }

        // Post-Processing: Errechnete Werte fr zusammengefasste Skalen einsetzen
        for ($i = 0; $i < $run; $i++) {  // Autoscaling-Werte einsetzen
            if ($type == 'single') {
                $AutoScale['min_' . $i] = $temp_dba;
                $AutoScale['max_' . $i] = $temp_dbe;
            }
            //$AutoScale['max_'.$i] = ceil($AutoScale['max_'.$i]);
            //$AutoScale['min_'.$i] = floor($AutoScale['min_'.$i]);
            //if(strlen($AutoScale['min_'.$i]) > 4) $AutoScale['min_'.$i] = htmlspecialchars(sci($AutoScale['min_'.$i], 2));
            //if(strlen($AutoScale['max_'.$i]) > 4) $AutoScale['max_'.$i] = htmlspecialchars(sci($AutoScale['max_'.$i], 2));
        }
    }

    return $AutoScale;
}

/* }}} */

/* {{{ PHP-Funktion gmadd_month_diff() - Addiert eine Monatsdifferenz zum Timestamp */

function gmadd_month_diff($timestamp, $month_diff) {
    $gmdate_array = array();
    $gmdate_array['hour'] = (int) gmdate('G', $timestamp);
    $gmdate_array['minute'] = (int) gmdate('i', $timestamp);
    $gmdate_array['second'] = (int) gmdate('s', $timestamp);

    // Monatsdifferenz addieren -> gmmktime() verrechnet Jahreswechsel
    $gmdate_array['month'] = (int) gmdate('n', $timestamp) + $month_diff;
    $gmdate_array['day'] = (int) gmdate('j', $timestamp);
    $gmdate_array['year'] = (int) gmdate('Y', $timestamp);

    // Ermitteln des Monatsletzten vom Zielmonat
    $tmp_timestamp = gmmktime(0, 0, 0, $gmdate_array['month'], 15, $gmdate_array['year']);
    $gmdate_array['max_day_of_month'] = (int) gmdate('t', $tmp_timestamp);

    // Auf Monatsletzten begrenzen
    if ($gmdate_array['day'] > $gmdate_array['max_day_of_month']) {
        $gmdate_array['day'] = $gmdate_array['max_day_of_month'];
    }

    $retval = gmmktime($gmdate_array['hour'], $gmdate_array['minute'], $gmdate_array['second'], $gmdate_array['month'], $gmdate_array['day'], $gmdate_array['year']);

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion gmdate_std() - gmdate()-Standardformatierung */

function gmdate_std($timestamp = null) {
    $format = 'Y-m-d H:i:s';
    $retval = '';

    if (empty($timestamp)) {
        $retval = gmdate($format);
    } else {
        $retval = gmdate($format, $timestamp);
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion gmhour() - UTC-Stunde ermitteln */

function gmhour($timestamp = null) {
    $format = 'G';
    $retval = '';

    if (empty($timestamp)) {
        $retval = gmdate($format);
    } else {
        $retval = gmdate($format, $timestamp);
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion gmstrtotime() - strtotime-Funktion, die den Input als UTC-Wert verarbeitet */

function gmstrtotime($time_string) {
    return strtotime($time_string . ' UTC');
}

/* }}} */

/* {{{ PHP-Funktion jsCreateXMLHttpRequest() - JavaScript-Makro zum Erstellen des XMLHttpRequest-Objekts */

function jsCreateXMLHttpRequest_orig($object) {
    echo '
    var ', $object, ' = null;

    try{
        ', $object, ' = new ActiveXObject("MSXML2.XMLHTTP");
    }
    catch(err_MSXML2){
        try{
            ', $object, ' = new ActiveXObject("Microsoft.XMLHTTP");
        }
        catch(err_Microsoft){
            if(typeof XMLHttpRequest != "undefined"){
                ', $object, ' = new XMLHttpRequest;
            }
        }
    }';
}

/* }}} */

/* {{{ PHP-Funktion jsCreateXMLHttpRequest() - JavaScript-Makro zum Erstellen des XMLHttpRequest-Objekts */

function jsCreateXMLHttpRequest($object) {
    echo '
    var ', $object, ' = null;

	if(window.XMLHttpRequest){
	//Google Chrome, Mozilla Firefox, Opera, Safari, IE 10
		', $object, ' = new XMLHttpRequest();
	}
	else if(window.ActiveXObject){
	// Internet Explorer 9 und niedriger
		try{
			', $object, ' = new ActiveXObject("MSXML2.XMLHTTP.6.0");
		}
		catch(e){
			try{
				', $object, ' = new ActiveXObject("MSXML2.XMLHTTP.3.0");
			}
			catch(e){}
		}
    }

	if(', $object, '==null)
		alert("Ihr Browser untersttzt kein Ajax!")	';
}

/* }}} */

/* {{{ PHP-Funktion jsEscWindowClose() - JavaScript-Makro inkl. Script-Container fr das Key-Event zum Schlieen des Fensters per Esc */

function jsEscWindowClose() {
    echo '
    <script type="text/javascript">
    <!--
    function key_down_event(event){
        var keyCode;
        if(!event){
            event = window.event;
        }
        if(event.which){
            keyCode = event.which;
        }
        else{
            if(event.keyCode){
                keyCode = event.keyCode;
            }
        }
        // Esc
        if(keyCode == 27){
            window.close();
        }
    }
    document.onkeydown = key_down_event;
    //-->
    </script>';
}

/* }}} */

/* {{{ PHP-Funktion jsWindowClose() - JavaScript-Makro inkl. Script-Container zum Schlieen des Fensters */

function jsWindowClose($alert_string = '') {
    echo '
    <script type="text/javascript">
    <!--';
    if (strlen(trim($alert_string))) {
        echo '
        alert("', $alert_string, '");';
    }
    echo '
    window.close();
    //-->
    </script>';
}

/* }}} */

/* {{{ PHP-Funktion line_breaks2spaces() - Ersetzt Zeilenumbrche durch Leerzeichen */

function line_breaks2spaces($string) {
    $order = array("\r\n", "\n", "\r");
    $replace = ' ';
    return str_replace($order, $replace, $string);
}

/* }}} */

/* {{{ PHP-Funktion localadd_month_diff() - Addiert eine Monatsdifferenz zum Timestamp in Abhngigkeit der Lokalzeit */

function localadd_month_diff($timestamp, $month_diff) {
    $date_array = array();
    $date_array['hour'] = (int) date('G', $timestamp);
    $date_array['minute'] = (int) date('i', $timestamp);
    $date_array['second'] = (int) date('s', $timestamp);

    // Monatsdifferenz addieren -> mktime() verrechnet Jahreswechsel
    $date_array['month'] = (int) date('n', $timestamp) + $month_diff;
    $date_array['day'] = (int) date('j', $timestamp);
    $date_array['year'] = (int) date('Y', $timestamp);

    // Ermitteln des Monatsletzten vom Zielmonat
    $tmp_timestamp = mktime(0, 0, 0, $date_array['month'], 15, $date_array['year']);
    $date_array['max_day_of_month'] = (int) date('t', $tmp_timestamp);

    // Auf Monatsletzten begrenzen
    if ($date_array['day'] > $date_array['max_day_of_month']) {
        $date_array['day'] = $date_array['max_day_of_month'];
    }

    $retval = mktime($date_array['hour'], $date_array['minute'], $date_array['second'], $date_array['month'], $date_array['day'], $date_array['year']);

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion localmonth_int() - Ermittelt die Dauer des Monats der Lokalzeit in UTC-Sekunden */

function localmonth_int($timestamp = null) {
    $retval = 0;

    if (empty($timestamp)) {
        $timestamp = time();
    }

    $number_of_days_in_month = (int) date('t', $timestamp);
    $retval = $number_of_days_in_month * 86400;

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion localstrtotime() - strtotime-Funktion (mit Zeitzonen verwendbar/erweiterbar) */

function localstrtotime($time_string) {
    $retval = strtotime($time_string);

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion mkinterval() - Intervall aus Tagen, Stunden, Minuten und Sekunden berechnen */

function mkinterval($day_int, $hour_int, $minute_int, $second_int) {
    $retval = 0;

    if (is_numeric($day_int) && is_numeric($hour_int) && is_numeric($minute_int) && is_numeric($second_int)) {
        $seconds_per_day = 86400;
        $seconds_per_hour = 3600;
        $seconds_per_minute = 60;
        $retval = $second_int + ($minute_int * $seconds_per_minute) + ($hour_int * $seconds_per_hour) + ($day_int * $seconds_per_day);
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion month_diff() - Ermittelt die Monatsdifferenz zwischen 2 Timestamps */

function month_diff($timestamp_from, $timestamp_to) {
    $retval = 0;

    $time_from_array['month'] = gmdate('n', $timestamp_from);
    $time_from_array['year'] = gmdate('Y', $timestamp_from);
    $time_to_array['month'] = gmdate('n', $timestamp_to);
    $time_to_array['year'] = gmdate('Y', $timestamp_to);

    if (is_numeric($time_from_array['month']) && is_numeric($time_from_array['year']) && is_numeric($time_to_array['month']) && is_numeric($time_to_array['year'])) {
        $year_diff = $time_to_array['year'] - $time_from_array['year'];
        $retval = ($time_to_array['month'] + ($year_diff * 12)) - $time_from_array['month'];
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion nocache() - Cacheverhinderungs-Header */

function nocache_old() {
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");              // Date in the past
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
    header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
}


function nocache() {
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");              // Date in the past
    header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
    header('Cache-Control: post-check=0, pre-check=0', FALSE);
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
    header('Pragma: no-cache');
}




/* }}} */

/* {{{ PHP-Funktion print_r_formatted() - print_r mit PRE-Tag */

function print_r_formatted($var) {
    echo '<pre>';
    print_r($var);
    echo '</pre>';
}

/* }}} */

/* {{{ PHP-Funktion RGB2ForeColor() - Generiert aus RGB-Werten einen Integer-Wert */

function RGB2ForeColor($tmp_color) {
    $sv_fore_color = sprintf('%02X%02X%02X', ($tmp_color[2]), ($tmp_color[1]), ($tmp_color[0]));
    $sv_fore_color = strtoupper($sv_fore_color);
    $retval = hexdec($sv_fore_color);

    return $retval;
}

/* }}} */

/* {{{ PHP-Klassenfunktion trimTime() - Timestamp(unix) auf Intervallgrenzen gerademachen */
function trimTime($time, $inter){
	$rest = 0;
					
	$rest = $time % $inter;
	if($rest > 0){
		$time = $time - $rest;
	}
	return $time;
}
/* }}} */

/* {{{ PHP-Funktion round_time() - Timestamp anhand von Intervall runden */
function round_time($time, $interval) {
    $sek = date('s', $time);
    $min = date('i', $time);
    $std = date('H', $time);
    $rest = (($std * 3600) + ($min * 60) + $sek) % $interval;

    if ($rest) {
        $time -= $rest;
    }

    return $time;
}

/* }}} */

/* {{{ PHP-Funktion sci() - Funktion zur Berechnung von Autoscale-Min und -Max */

function sci($x, $d = -1) {
    $min = ($x < 0 ? '-' : '');
    $x = abs($x);
    $e = floor(($x != 0 ? log10($x) : 0));
    $x *= pow(10, -$e);
    $fmt = ($d >= 0 ? '.' . $d : '');
    $e = ($e >= 0 ? '+' . sprintf('%02d', $e) : '-' . sprintf('%02d', -$e));
    return sprintf('$min%' . $fmt . 'fe%s', $x, $e);
}

/* }}} */

/* {{{ PHP-Funktion session_no_longer_valid_msg() - Meldung "Session ist nicht mehr gltig" ausgeben und Programm abbrechen */

function session_no_longer_valid_msg($lang_id = 'en', $br = true) {
    global $text_array;

    if ($br) {
        echo '<br />';
    }
    echo $text_array[$lang_id]['session_no_longer_valid'], '! ', $text_array[$lang_id]['please_login_again'], '!';
    exit();
}

/* }}} */

/* {{{ PHP-Funktion start_session() - Klasse in einer Session starten */

function start_session(&$object, $session_existed = true, $class = 'scalarvis', $session_index = 'svweb') {
    global $svweb_session_name;
    $retval = false;

    // Bei Login neuen Session-Namen generieren
    if (!$session_existed) {
        $svweb_session_name = 'svweb_session' . md5(uniqid(rand(), true));
    }

    session_name($svweb_session_name);  // Session-Namen festlegen
    if (session_start()) {
        if (!$session_existed) {
            // Login, Session als neues Objekt erstellen
            switch ($class) {
                case 'scalarvis_admin':
                    $object = new scalarvis_admin;
                    break;
                default:
                    $object = new scalarvis;
                    break;
            }
            $_SESSION[$session_index] = $object;
            $retval = true;
        } else if (isset($_SESSION[$session_index])) {
            // Vorhandene Session zurckspeichern
            $object = $_SESSION[$session_index];
            $retval = true;
        }
    }

    if ($retval && !empty($svweb_session_name)) {
        $retval = $svweb_session_name;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion store_session() - Klasse in Session speichern */

function store_session($object, $session_index = 'svweb') {
    $_SESSION[$session_index] = $object;
}

/* }}} */

/* {{{ PHP-Funktion tag_value_format() - TAG-Wert formatieren */

function tag_value_format($value, $decimals = -1) {
    if (is_numeric($decimals) && $decimals >= 0) {
		if ($decimals > 10) { $decimals = 10; }
		$retval = number_format($value, $decimals, '.', '');
		//$retval .= '-';
		//$retval .= $decimals;
		
        //$retval = number_format($value, 6, '.', '');
		//$retval = number_format($decimals, 9, '.', '');
    } else {
       $retval = $value;
	   //$retval .= 'N';
		 //$retval = number_format($value, 5, '.', '');
    }

    return $retval;
}

/* }}} */

/* {{{PHP-Funktion formatdouble() - FormatDouble wie in svapi.dll */

function formatdouble($value, $width = 7, $precision = 3) {
    if (isset($value)) {
//$formatted = sprintf("%01.2f", $money);
        $format = sprintf("%%%d.%df", $width, $precision);
        $retval = sprintf($format, $value);
    } else {
        $retval = $value;
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion time_from_localmidnight() - UTC-Zeit in Bezug auf 0 Uhr Lokalzeit */

function time_from_localmidnight($timestamp = null) {
    $retval = 0;

    if (empty($timestamp)) {
        $retval = localstrtotime(localdate('Y-m-d'));
    } else {
        $retval = localstrtotime(localdate('Y-m-d', $timestamp));
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion time_from_localmonth_origin() - UTC-Zeit in Bezug auf den Monatsersten 0 Uhr Lokalzeit */

function time_from_localmonth_origin($timestamp = null) {
    $retval = 0;

    if (empty($timestamp)) {
        $timestamp = time();
    }

    $date_array = array();
    $date_array['month'] = (int) date('n', $timestamp);
    $date_array['year'] = (int) date('Y', $timestamp);

    $retval = mktime(0, 0, 0, $date_array['month'], 1, $date_array['year']);

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion time_from_localweek_origin() - UTC-Zeit in Bezug auf den Wochenersten 0 Uhr Lokalzeit */

function time_from_localweek_origin($timestamp = null) {
    $retval = 0;

    if (empty($timestamp)) {
        $timestamp = time();
    }

    $date_array = array();
    $date_array['month'] = (int) date('n', $timestamp);
    $date_array['day'] = (int) date('j', $timestamp);
    $date_array['year'] = (int) date('Y', $timestamp);
    $date_array['day_of_week'] = (int) date('w', $timestamp);

    if ($date_array['day_of_week'] == 0) {
        $date_array['day_of_week'] = 7;
    }
    $date_array['day'] = $date_array['day'] - $date_array['day_of_week'] + 1;

    $retval = mktime(0, 0, 0, $date_array['month'], $date_array['day'], $date_array['year']);

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion time_from_localyear_origin() - UTC-Zeit in Bezug auf den Jahresersten 0 Uhr Lokalzeit */

function time_from_localyear_origin($timestamp = null, $year_diff = 0) {
    $retval = 0;

    if (empty($timestamp)) {
        $timestamp = time();
    }

    $date_array = array();
    $date_array['year'] = (int) date('Y', $timestamp);

    $retval = mktime(0, 0, 0, 1, 1, $date_array['year'] + $year_diff);

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion twips2pixels() - Twips in Pixel umrechnen */

function twips2pixels($TwipValue, $TwipsPerPixel = 15) {
    $retval = 0;

    if (is_numeric($TwipValue) && is_numeric($TwipsPerPixel) && $TwipsPerPixel > 0) {
        $retval = (int) round($TwipValue / $TwipsPerPixel);
    }

    return $retval;
}

/* }}} */

/* {{{ PHP-Funktion write_logfile() - Erstellt Log-Files und -Eintrge */

function write_logfile($action, $user, $host, $port, $status, $codebase = '') {
    global $g_line_break;
    global $g_path_separator;

    $log_dir = 'logfiles';
    $log_filename = 'sv' . date('Ymd') . '.log';
    $separator_string = "\t";
    $head_string = $log_filename . $g_line_break;

    // Wenn es das Logfiles-Verzeichnis nicht gibt, anlegen
    if (!is_dir($codebase . $log_dir)) {
        mkdir($codebase . $log_dir);
    }

    if (isset($_SERVER['REMOTE_ADDR']) && strlen(trim($_SERVER['REMOTE_ADDR']))) {
        $remote_ip = $_SERVER['REMOTE_ADDR'];
    } else if (isset($_SERVER['REMOTE_HOST']) && strlen(trim($_SERVER['REMOTE_HOST']))) {
        $remote_ip = $_SERVER['REMOTE_HOST'];
    } else {
        $remote_ip = '';
    }

    $act_sid = session_id();

    $log_string = date('H:i:s') . $separator_string . $remote_ip . $separator_string . $act_sid
            . $separator_string . $action . $separator_string . $user . $separator_string . $host
            . $separator_string . $port . $separator_string . trim($status) . $g_line_break;

    if (is_file($codebase . $log_dir . $g_path_separator . $log_filename)) {
        $new_file = false;
    } else {
        $new_file = true;
    }
    if ($log_fp = fopen($codebase . $log_dir . $g_path_separator . $log_filename, 'a')) {
        if ($new_file) {
            fwrite($log_fp, $head_string);
        }
        fwrite($log_fp, $log_string);
        fclose($log_fp);
    }
}

/* }}} */

/* {{{ PHP-Funktion year_diff() - Ermittelt die Jahresdifferenz zwischen 2 Timestamps */

function year_diff($timestamp_from, $timestamp_to) {
    $retval = 0;

    $time_from_array['year'] = gmdate('Y', $timestamp_from);
    $time_to_array['year'] = gmdate('Y', $timestamp_to);

    if (is_numeric($time_from_array['year']) && is_numeric($time_to_array['year'])) {
        $retval = $time_to_array['year'] - $time_from_array['year'];
    }

    return $retval;
}

/* }}} */

/**
 * Schreibt die bergebenen Werte in die angegeben Section in die angegebene INI-Datei
 *
 * @param mixed $sv         Session-Werte
 * @param string $section   Name der Section, die geschrieben werden soll
 * @param array $data       assoziatives Array mit den Werten der Section
 * @return integer          1 wenn schreiben erfolgreich, sonst 0
 */
function writeIniSection(&$sv, $section, array $data) {
    // get directory of Fliess.ini
    if (isset($sv->USER_CONFIG['FLOWCHART_DIR']) && strlen(trim($sv->USER_CONFIG['FLOWCHART_DIR'])) && trim($sv->USER_CONFIG['FLOWCHART_DIR']) != 'empty') {
        $flowchart_dir = $sv->USER_CONFIG['FLOWCHART_DIR'];
    } else {
        $flowchart_dir = '';
    }
    // set filename
    $flowchart_dir = str_replace('./', './flowchart/', $flowchart_dir);
    $flowchart_ini_file = $flowchart_dir . 'Fliess.ini';

    // if inifile exists, write data to inifile
    if (is_file($flowchart_ini_file)) {
        $ini_array = get_ini_array($flowchart_ini_file);
        // set new setion data
        foreach ($data as $key => $value) {
            if (key_exists($key, $ini_array[$section])) {
                $ini_array[$section][$key] = $value;
            }
        }
        // write inifile
        write_ini_array_to_file($flowchart_ini_file, $ini_array);
        return 1;
    }
    return 0;
}

?>
