var wndDiagramArray = new Array();
var wndTAGInfo = null;

/**
 * Diagramm oeffnen
 *
 * @param string type
 * @param number tagnr
 * @param string menuId
 * @param string sessionName
 * @returns void
 */
function menuItemDiagram(type, tagnr, menuId, sessionName) {
    var wndDiagramArrayIndex = -1;
    var wwidth = 1180;
    var wheight = 800;
    var wleft = (screen.availWidth - wwidth) / 2;
    var wtop = (screen.availHeight - wheight) / 2;
    var wlayout = "location=no, menubar=no, resizable=yes, scrollbars=yes";
    wlayout += ", status=yes, toolbar=no, left=" + wleft + ", top=" + wtop;
    wlayout += ", width=" + wwidth + ", height=" + wheight;

    $('#' + menuId).contextMenu('close');
    
    var arcinterval = 0;
    
    if(type == 'universal' ){
    	arcinterval = $('#universalinput').val();
		arcinterval = arcinterval * 3600;
    }
    else if(type == 'detail' ){
    	arcinterval = $('#detailinput').val();
		arcinterval = arcinterval * 60;
    }
    else{
    	arcinterval = 3600;
    }
    var arctime = 0;
    arctime = $('#date_refresh_hidden').val();
    //alert(arctime);
    closeAllDiagramWindows();

    // Closed Windows wiederverwenden
    for (var i in wndDiagramArray) {
        if (wndDiagramArray[i] && wndDiagramArray[i].closed) {
            wndDiagramArrayIndex = i;
            break;
        }
    }
    if (wndDiagramArrayIndex < 0) {
        wndDiagramArrayIndex = wndDiagramArray.length;
    }
    wndDiagramArray[wndDiagramArrayIndex] = window.open("../diagramJS.php?view=fliess&tagnr=" + tagnr + "&arctime=" + arctime + "&arcinterval=" + arcinterval + "&type=" + type + "&session_name=" + sessionName, "_blank", wlayout);


    var j = 0;
    for (var i in wndDiagramArray) {
        if (wndDiagramArray[i] && !wndDiagramArray[i].closed) {
            wndDiagramArray[i].focus();
            j++;
        }
    }
    wndDiagramArray[wndDiagramArrayIndex].moveTo(j * 25, j * 25);
    wndDiagramArray[wndDiagramArrayIndex].focus();
}

/**
 * TAGInfo ffnen
 *
 * @param {type} tagnr
 * @param {type} tagtyp
 * @param {type} objectnr
 * @param {type} register
 * @param {type} menuId
 * @param {type} sessionName
 * @returns {undefined}
 */
function menuItemTAGInfo(tagnr, tagtyp, objectnr, register, menuId, sessionName) {
    // Contenxtmenue schlieen
    $('#' + menuId).contextMenu('close');

    var url = "../taginfo.php?register=" + register + "&objectnr=" + objectnr + "&tagtyp=" + tagtyp + "&tagnr=" + tagnr + "&session_name=" + sessionName;
    // Inhalt von url per AJAX holen un diesen in das DIV mit der ID infowindow schreiben und dann infowindow anzeigen
    $.get(url, {}, function (data) {
        $('#infowindow').empty().html(data);
        $('#infowindow').show();
    });

}

/**
 * Smtliche Children alias Diagramm-Fenster schlieen
 *
 * @returns void
 */
function closeAllDiagramWindows() {
    for (var i in wndDiagramArray) {
        if (wndDiagramArray[i] && !wndDiagramArray[i].closed) {
            wndDiagramArray[i].close();
        }
    }
}
