<?php

// vim: fdm=marker

/**********************
*  Andy Geiss 2009    *
*  Tabulatorweite: 4  *
**********************/

// L TODO: periodform.php wird nicht mehr bentigt -> falls doch, betreffende USER_CONFIGs zur Verfgung stellen

ob_start();
require('scalarvis.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if(!start_session($sv)){
    session_no_longer_valid_msg();
}

/* {{{ Variablen initialisieren */
$hour_appendix = ':00:00';

// Definition der Periodenauswahl  -  Pro Datensatz jeweils 8 Werte definierbar
$intervals = array(0 => array('4h'  => 14400,
                              '8h'  => 28800,
                              '12h' => 43200,
                              '24h' => 86400,
                              '1 '.$text_array[$sv->lang_id]['week'] => 604800,
                              '2 '.$text_array[$sv->lang_id]['weeks'] => 1209600,
                              '3 '.$text_array[$sv->lang_id]['weeks'] => 1814400,
                              '4 '.$text_array[$sv->lang_id]['weeks'] => 2678400),
                   1 => array('1 '.$text_array[$sv->lang_id]['day'] => 86400,
                              '1 '.$text_array[$sv->lang_id]['week'] => 604800,
                              '1 '.$text_array[$sv->lang_id]['month'] => 2678400,
                              '3 '.$text_array[$sv->lang_id]['months'] => 7776000,
                              '6 '.$text_array[$sv->lang_id]['months'] => 15552000,
                              '9 '.$text_array[$sv->lang_id]['months'] => 23328000,
                              '1 '.$text_array[$sv->lang_id]['year'] => 31104000,
                              '2 '.$text_array[$sv->lang_id]['years'] => 62208000));

$interval_keys = array_keys($intervals[$sv->USER_CONFIG['PZA_intervall']]);

//print_r_formatted($interval_keys);
//print_r_formatted($intervals);

$actionfile = 'periodform.php';     // Standard-File fr ACTION-Attribut des FORM-TAGs
/* }}} */

if(!$sv->connect()){
    echo '<br>',get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
}
else{
    /* {{{ Zeitraum bestimmen */
    // $sv->pa_int setzen
    if(isset($_GET['pa_int'])){
        $sv->pa_int = $_GET['pa_int'];
    }
    else if(empty($sv->pa_int)){
        if($sv->USER_CONFIG['PZA_intervall']){
            $sv->pa_int = 86400;    // 1 Tag
        }
        else{
            $sv->pa_int = 14400;    // 4 h
        }
    }

    // $sv->time_form_int setzen
    $sv->time_form_int = $sv->pa_int;

    // $sv->pa_hour anhand der Stunde der $sv->time_form_start setzen
    if(is_numeric($sv->time_form_start)){
        $sv->pa_hour = gmhour($sv->time_form_start);
    }
    else{
        $sv->pa_hour = '';
    }

    // Bei nderung der Stunde, $sv->pa_hour setzen
    if(isset($_GET['stunde']) && is_numeric($_GET['stunde'])){
        $sv->pa_hour = $_GET['stunde'];
    }

    // Bei Datumsnderung (durch Datumsauswahl) $sv->time_form_start auf das gewhlte Datum setzen
    if(isset($_GET['tag']) && is_numeric($_GET['tag']) 
    && isset($_GET['monat']) && is_numeric($_GET['monat']) 
    && isset($_GET['jahr']) && is_numeric($_GET['jahr'])){
        if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0){
            $sv->time_form_start = gmstrtotime($_GET['jahr'].'-'.$_GET['monat'].'-'.$_GET['tag']);
        }
        else{
            $tmp_time_string = $_GET['jahr'].'-'.$_GET['monat'].'-'.$_GET['tag'].' '.$sv->pa_hour.$hour_appendix;
            $sv->time_form_start = gmstrtotime($tmp_time_string);
        }
    }

    // Bei Klick auf den Now-Button,
    // $sv->time_form_start und $sv->time_form_end auf null zurcksetzen
    if(isset($_GET['pa_now'])){
        $sv->time_form_start = null;
        $sv->time_form_end = null;
    }

    // Wenn $sv->time_form_start und $sv->time_form_end noch nicht definiert,
    // $sv->time_form_start auf die aktuelle Zeit setzen
    if(!isset($sv->time_form_start) && !isset($sv->time_form_end)){
        $sv->time_form_start = $sv->scalarvis_time();
        $sv->pa_hour = gmhour($sv->time_form_start);
        if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0){
            $sv->time_form_start = time_from_localmidnight($sv->time_form_start);
        }
    }
    // Wenn $sv->time_form_start nicht definiert, aber andere time_form-Variablen belegt,
    // $sv->time_form_start ermitteln
    else if(!isset($sv->time_form_start) && isset($sv->time_form_int)){
        if(isset($sv->time_form_end) && isset($sv->time_form_int)){
            $sv->time_form_start = $sv->time_form_end - $sv->time_form_int;
        }
        else if(isset($sv->time_form_int)){
            $sv->time_form_start = $sv->scalarvis_time() - $sv->time_form_int;
        }
        $sv->pa_hour = gmhour($sv->time_form_start);
        if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0){
            $sv->time_form_start = time_from_localmidnight($sv->time_form_start);
        }
    }

    // $sv->time_form_start in Abhngigkeit der gewhlten Stunde setzen,
    // wenn nicht PREV- oder NEXT-Button gedrckt
    if(!isset($_GET['pa_np'])){
        // L TODO: Nach check_max_interval($sv->pa_int, '12days') unterscheiden? -> an $sv->pa_hour orientieren?
        if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0){
            $sv->time_form_start = time_from_localmidnight($sv->time_form_start);
        }
    }

    // PREV- oder NEXT-Button gedrckt?
    if(isset($_GET['pa_np'])){
        switch($_GET['pa_np']){
        case -1:
            if(check_min_interval($sv->pa_int, 'month')){
                if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0){
                    // L TODO: Ist das korrekt? -> 15. des Monats verwenden?
                    $sv->time_form_start -= 172800; // 24 * 2 * 3600
                }
                else{
                    $sv->time_form_start += adjust_interval($sv->time_form_start, -$sv->pa_int);
                }
            }
            else{
                $sv->time_form_start -= $sv->time_form_int;
            }
            break;
        case 1:
            if(check_min_interval($sv->pa_int, 'month')){
                if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0){
                    $sv->time_form_start += 2851200; // 24 * 33 * 3600
                }
                else{
                    $sv->time_form_start += adjust_interval($sv->time_form_start, $sv->pa_int);
                }
            }
            else{
                $sv->time_form_start += $sv->time_form_int;
            }
            break;
        }
        // L TODO: Nach check_max_interval($sv->pa_int, '12days') unterscheiden?
        $sv->pa_hour = gmhour($sv->time_form_start);
    }

    // Kompletten Zeitraum bercksichtigen bei festem Intervall
    if(check_min_interval($sv->pa_int, 'month')){
        if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0){ // Festes intervall
            $sv->time_form_start = time_from_localmonth_origin($sv->time_form_start);
            $sv->time_form_int = localmonth_int($sv->time_form_start);
        }
        else{
            $sv->time_form_int = adjust_interval($sv->time_form_start, $sv->pa_int);
        }
    }
    else if($sv->USER_CONFIG['FLOWING_PERIOD'] == 0 && check_min_interval($sv->pa_int, 'week')){  // Wenn einer der Wochenbuttons ...
        $sv->time_form_start = time_from_localweek_origin($sv->time_form_start);
    }

    // $sv->time_form_end berechnen
    $sv->time_form_end = $sv->time_form_start + $sv->time_form_int;

    // Wenn Periode in der Zukunft nicht erlaubt ist ...
    if($sv->USER_CONFIG['FUTURE_PERIOD'] != 1){
        $tmp_acttimestamp = $sv->scalarvis_time();
        // Wenn Ende-Zeit in der Zukunft ...
        if($sv->time_form_end > $tmp_acttimestamp){
            if($sv->USER_CONFIG['FLOWING_PERIOD'] != 0){ // Flieendes intervall
                $sv->time_form_end = $tmp_acttimestamp;   // Aktuelle Zeit als Ende-Zeit
                // Wenn Monatsbutton -> Intervall neu berechnen
                if(check_min_interval($sv->pa_int, 'month')){
                    $sv->time_form_int = -adjust_interval($sv->time_form_end, -$sv->pa_int);
                }
                $sv->time_form_start = $sv->time_form_end - $sv->time_form_int;         // Start-Zeit errechnen
            }
            else{
                // Wenn Monatsbutton ...
                if(check_min_interval($sv->pa_int, 'month')){
                    $sv->time_form_start = time_from_localmonth_origin($sv->time_form_start);
                    $sv->time_form_int = localmonth_int($sv->time_form_start);
                }
                // Wenn einer der Wochenbuttons ...
                else if(check_min_interval($sv->pa_int, 'week')){
                    $sv->time_form_start = time_from_localweek_origin($tmp_acttimestamp);
                }
                // Wenn 24h-Button ...
                else if(check_min_interval($sv->pa_int, 'day')){
                    $sv->time_form_start = time_from_localmidnight($tmp_acttimestamp);
                }
                // Wenn einer der Buttons kleiner 24h ...
                else{
                    // L TODO: 12h-, 8h- und 4h-Buttons unterscheiden?
                    $tmp_time_string = gmdate('Y-m-d', $tmp_acttimestamp).' '.gmdate('G', $tmp_acttimestamp).$hour_appendix;
                    $sv->time_form_start = gmstrtotime($tmp_time_string);
                }
                $sv->time_form_end = $sv->time_form_start + $sv->time_form_int;
                // L TODO: Was ist, wenn time_form_end noch immer grer als $tmp_acttimestamp?
            }
            $sv->pa_hour = (int) gmdate('G', $sv->time_form_start);   // Stunde im Formular auf die der Startzeit setzen
        }
    }

    // Form-Variablen an Zeitspanne fr Diagramm bergeben
    $sv->time_start = $sv->time_form_start;
    $sv->time_end = $sv->time_form_end;
    /* }}} */

    $sv->time_form_start = mktime(0, 0, 0, 5, 1, 2009);

    $timestamp_from = $sv->time_form_start;
    $timestamp_to = $timestamp_from + (3600 * 24 * 398);
    $timestamp_diff = $timestamp_to - $timestamp_from;
    echo '<br><br>$timestamp_from local: ',$timestamp_from,' - ',localdate_std($timestamp_from);
    echo '<br>$timestamp_to local: ',$timestamp_to,' - ',localdate_std($timestamp_to);
    echo '<br>$timestamp_diff: ',$timestamp_diff,' - ',$timestamp_diff / 3600 / 24;
    echo '<br>month_diff: ',adjust_interval($timestamp_from, $timestamp_diff),' - ',adjust_interval($timestamp_from, $timestamp_diff) / 3600 / 24;

    echo '<br><br>gmdate_std($sv->time_form_start): ',gmdate_std($sv->time_form_start);
    echo '<br>localdate_std($sv->time_form_start): ',localdate_std($sv->time_form_start);
    $sv->time_form_start += adjust_interval($sv->time_form_start, (3600 * 24 * -45));
    echo '<br>gmdate_std($sv->time_form_start): ',gmdate_std($sv->time_form_start);
    echo '<br>localdate_std($sv->time_form_start): ',localdate_std($sv->time_form_start);
}

include('cont_top.inc.php');

echo '
</head>

<body>';
echo '
</body>';

include('cont_bottom.inc.php');

store_session($sv);

?>

