<?php

// vim: fdm=marker

/***************************
*  Andy Geiss 2009 - 2011  *
*  Tabulatorweite: 4       *
***************************/

require_once('functions.inc.php');
require_once('sv_short_class.php');

class scalarvis{
    /* {{{ Member-Variablen */
    public  $USER_CONFIG = array();         // Konfiguration
    private $session_name;                  // Session-Name
    private $session_id;                    // Session-ID
    public  $user;                          // Scalarvis-User
    public  $port;                          // Scalarvis-Port
    public  $host;                          // Scalarvis-Host
    public  $pwd;                           // Scalarvis-Passwort
    public  $lang_id;                       // Sprachschlssel (de, en, etc.)
    private $socket;                        // TCP/IP-Socketverbindung
    private $socket_errno;                  // Socket-Fehlernummer
    private $socket_last_error;             // Letzter Socket-Fehler aus socket_last_error()
    public  $tagauswahl = array();          // Array, das die 6 Tags enthlt, die der Benutzer ausgewhlt hat
    public  $tagauswahl_fliess = array();   // Array, das die 6 Tags enthlt, die der Benutzer beim Fliessbild uebergibt, normalerweise immer im Index=0
    // Anzahl-Tags-Relevanz
    public  $number_of_tags = 6;            // Anzahl Tags in Tagauswahl
    private $tagarray = array();            // 'nummer', 'name', 'einheit', 'info', 'dba', 'dbe', 'wert', 'fkt', 'status', 'invalid'
    public  $ks_auswahl;                    // Speichert den aktuellen Datensatz eines ausgewhlten Kurvensatzes
    public  $sysinfo = array();             // Scalarvis-Sysinfo-Array
    public  $time_form_start = null;        // Startzeit in Eingabemaske
    public  $time_form_end = null;          // Endezeit in Eingabemaske
    public  $time_form_int = null;          // Intervall in Eingabemaske
    public  $time_start = null;             // Zeitfenster-Start
    public  $time_end = null;               // Zeitfenster-Ende
    public  $time_form_start_fliess = null;        // Startzeit in Fliessbild
    public  $time_form_end_fliess = null;          // Endezeit in Fliessbild
    public  $time_form_int_fliess = null;          // Intervall in Fliessbild
    public  $time_start_fliess = null;             // Zeitfenster-Start Fliessbild
    public  $time_end_fliess = null;               // Zeitfenster-Ende Fliessbild
    public  $pa_int = null;                 // Periodenintervall in Stunden
    public  $pa_hour = null;                // Ausgewhlte Stunde in der Perioden-Eingabemaske
    public $MAX_AW_TAGS = 64;              // Maximale Anzahl an Tags, die gleichzeitig beim Blockdatentransfer angefragt werden knnen
    private $MESSAGE_SIZE = 8192;           // Maximale Paketgre beim Blockdatentransfer
    public  $refresh_tag_values = true;     // Flag fr Tag-Werte-Aktualisieren-Hkchen
    public  $refresh_flowchart = true;      // Flag fr Fliebild-Aktualisieren-Hkchen
    public  $diagramarray = array();        // Array mit MD5-generierten Indizes mit den geffneten Diagrammen
	public	$fliess_tag = array();			// Array mit TAGs eines Registers im Fliess-Runtime 
	public 	$fliess_arctime = null;			// ArchivZeitpunkt, der im Fliessbild ausgewaehlt wird
    public  $client_version = 0.0;			// Anzeige fuer Statistik menue
    /* }}} */

    /* {{{ Konstruktor */
    function __construct(){
        // Session-Info belegen
        $this->session_name = session_name();
        $this->session_id = session_id();

        // Auf erforderliche Extensions prfen
        $extension_array = array();
        $i = 0;
        $extension_array[$i]['name'] = 'sockets';
        $extension_array[$i]['file'] = 'php_sockets.dll';

        // L TODO: OS bercksichtigen
        foreach($extension_array as $extension){
            if(!extension_loaded($extension['name'])){
                if(!dl($extension['file'])){
                    echo '<br />Could not load ',$extension['file'],' dynamicly! <br />Please check your \'extension_dir\' setting in php.ini!';
                }
            }
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion actual_value() - Ermittelt aktuellen Wert und Informationen einer TAG-Nr. */
    public function actual_value($tag_nr, &$value){
        $retval = false;

        if(is_numeric($tag_nr) && $tag_nr > 0 && $tag_nr <= $this->sysinfo['tag_anzahl']){
            $socket_buffer = sprintf('R,,,%d', $tag_nr);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 512);
            if(!strstr($socket_buffer, '~~~')){
                //echo $socket_buffer;
                $explode_array = explode(',', $socket_buffer);
                $value = $explode_array[1];
                $value = doubleval($value);
                if($value == '-1E+038'){
                    $value = null;
                }
                $retval = true;
            }
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion add_ks_to_tagauswahl() - Kurvensatz zur Tagauswahl hinzufgen (Parametersatz laden) */
    public function add_ks_to_tagauswahl($ksnumber, $set_time = true){
        $this->ks_auswahl = $tmp_ks_auswahl = $this->get_ks($ksnumber);

        // Zeitfenster auslesen
        if($set_time){
            $time_to = $time_from = $date_to = $date_from = 0;
            // Wenn eine Zeit gesetzt ist
            if(isset($tmp_ks_auswahl[20]) && $tmp_ks_auswahl[20] != '00.00.00'){
                if($tmp_ks_auswahl[20] != '00.00.00'){
                    $date_from = explode('.', $tmp_ks_auswahl[20]);
                    $date_from = mktime(0, 0, 0, $date_from[1], $date_from[0], $date_from[2]);
                }
                if($tmp_ks_auswahl[21] != '00:00'){
                    $time_from = explode(':', $tmp_ks_auswahl[21]);
                    $time_from = $time_from[0] * 3600 + $time_from[1] * 60;
                }
                if($tmp_ks_auswahl[22] != '00.00.00'){
                    $date_to = explode('.', $tmp_ks_auswahl[22]);
                    $date_to = mktime(0, 0, 0, $date_to[1], $date_to[0], $date_to[2]);
                }
                if($tmp_ks_auswahl[23] != '00:00'){
                    $time_to = explode(':', $tmp_ks_auswahl[23]);
                    $time_to = $time_to[0] * 3600 + $time_to[1] * 60;
                }
                $this->set_time_by_start_and_end($date_from + $time_from, $date_to + $time_to);
            }
            // Wenn eine Spanne gesetzt ist
            else if(isset($tmp_ks_auswahl[24]) && is_numeric($tmp_ks_auswahl[24]) && $tmp_ks_auswahl[24] > 0){
                $this->set_time_by_int($tmp_ks_auswahl[24]);
            }
            // Ansonsten Zeitvariablen auf NULL zurcksetzen
            else{
                $this->set_time_to_null();
            }
        }
        // Anzahl-Tags-Relevanz
        // Tagauswahl auffllen
        // L TODO: Prfen, ob sich $number_of_tags beliebig ndern lsst
        // L TODO: $this->tagauswahl[] vor Belegung auf array() zurcksetzen (ausleeren) statt array_delete()?
        $this->tagauswahl = array();
        if($tmp_ks_auswahl !== false){
            for($i = 0; $i < $this->number_of_tags; $i++){
                if(isset($tmp_ks_auswahl[$i + 2]) && is_numeric($tmp_ks_auswahl[$i + 2]) && $tmp_ks_auswahl[$i + 2] != 0){
                    $this->get_tag_info($tmp_ks_auswahl[$i + 2]);
                    // DBA und DBE aus KS auslesen
                    $this->tagarray['dba'] = ($tmp_ks_auswahl[$i + 8] == '-1.000000000000000e+038'?'':doubleval($tmp_ks_auswahl[$i + 8]));
                    $this->tagarray['dbe'] = ($tmp_ks_auswahl[$i + 14] == '-1.000000000000000e+038'?'':doubleval($tmp_ks_auswahl[$i + 14]));
                    // Tag in die Auswahl bernehmen
                    $this->tagauswahl[$i] = $this->tagarray;
                }
            }
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion add_tag_to_tagauswahl() - Fgt ein Tag in einen bestimmten Index des Tagauswahl-Arrays ein */
    public function add_tag_to_tagauswahl($tag_nr, $index = null){
        // Wenn der Benutzer ein Feld lscht oder keinen numerischen Wert eingibt, wird die Zeile gelscht
        if((!isset($tag_nr) || !is_numeric($tag_nr) || $tag_nr < 1) && isset($index)){
            //echo 'Zeile ',$index,' leeren';
            $this->tagauswahl = $this->array_delete($this->tagauswahl, $index);
        }
        else{
            if(!isset($index)){
                //echo 'Zeile !isset';
                // Tag in die nchste freie Zeile einfgen
                for($i = 0; $i < $this->number_of_tags; $i++){
                    if(!isset($this->tagauswahl[$i])){  // Suche nach nchster freier Zeile
                        break;
                    }
                }
                // L TODO: Prfen, ob $i auch nach Schleifendurchlauf noch korrekt belegt
                $index = $i;
            }

            //echo 'Zeile ',$index,' fllen';
            $this->get_tag_info($tag_nr);
            $this->tagauswahl[$index] = $this->tagarray;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion add_tag_to_tagauswahl() - Fgt ein Tag in einen bestimmten Index des Tagauswahl-Arrays ein */
    public function add_tag_to_tagauswahl_fliess($tag_nr){
        // Wenn der Benutzer ein Feld lscht oder keinen numerischen Wert eingibt, wird die Zeile gelscht
        //$this->tagauswahl_fliess = $this->array_delete($this->tagauswahl_fliess, 0);
		$index = 0;
		//echo 'Zeile ',$index,' fllen';
		//$this->get_tag_info($tag_nr);
		 if($tag_nr < 0 || $tag_nr > $this->sysinfo['tag_anzahl']){
            $tag_nr = 0;
        }
		$this->get_tag_info($tag_nr);
		//if(!$this->get_tag_info($tag_nr)){
		//	$this->get_tag_info(0);
		//}
		$this->tagauswahl_fliess[$index] = $this->tagarray;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion array_delete() - Lscht aus einem Array das Element eines bestimmten Keys */
    public function array_delete($srcarray, $filter){
        $retarray = array();
        foreach($srcarray as $key => $value){
            if($key != $filter){
                $retarray[$key] = $value;
            }
        }
        return $retarray;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion array_to_string() - Hilfsfunktion fr Getblockinfo */
    public function array_to_string($in){
        while(list($k, $v) = each($in)){
            if(isset($out)){
                $out = $out.','.$v;
            }
            else{
                $out = $v;
            }
        }
        return $out;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion connect() - Verbindung zu Scalarvis herstellen */
    public function connect($user = null, $host = null, $port = null, $pwd = null, $cpwd = null){
        if(empty($user) && isset($_POST['user'])) $user = $_POST['user'];
        if(empty($host) && isset($_POST['host'])) $host = $_POST['host'];
        if(empty($port) && isset($_POST['port'])) $port = $_POST['port'];
        if(empty($pwd) && isset($_POST['pwd'])) $pwd = $_POST['pwd'];
        if(empty($cpwd) && isset($_POST['cpwd'])) $cpwd = $_POST['cpwd'];
        $this->socket_errno = 0;
        $this->socket_last_error = 0;

        if(empty($this->user) && empty($this->port)){
            if(empty($user)){
                $this->socket_errno = 1;
                return false;
            }
            else{
                $this->user = $user;
            }

            if(empty($host)){
                $this->socket_errno = 2;
                return false;
            }
            else{
		if ($host == "localhost" ) {
			$this->host = "127.0.0.1";
		} else {
                	$this->host = $host;
		}
            }

            if(empty($port)){
                $this->socket_errno = 3;
                return false;
            }
            else{
                $this->port = $port;
            }

            if(empty($pwd)){
                if(!empty($cpwd)){
                    $decoded_array = time_decrypt($cpwd);
                    if(isset($STANDARD_CONFIG['VALID_DURATION']) && is_numeric($STANDARD_CONFIG['VALID_DURATION'])){
                        $valid_duration = $STANDARD_CONFIG['VALID_DURATION'];
                    }
                    else{
                        $valid_duration = 600;  // standardmig 10 Minuten
                    }
                    // Wenn Passwort noch gltig
                    if($decoded_array['decoded_timestamp'] + $valid_duration > time()){
                        $this->pwd = $decoded_array['decoded_value'];
                    }
                }
                //else{
                //    $this->socket_errno = 4;
                //    return false;
                //}
            }
            else{
                $this->pwd = $pwd;
            }
        }

        $this->socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
        if(!$this->socket){
            $this->socket_errno = 5;
            $this->socket_last_error = socket_last_error();
            return false;
        }

        $prev_error_reporting = error_reporting(0);
        if(!socket_connect($this->socket, $this->host, $this->port)){
            $this->socket_errno = 6;
            $this->socket_last_error = socket_last_error($this->socket);
            socket_close($this->socket);
            return false;
        }
        error_reporting($prev_error_reporting);

        $socket_buffer = 'SYSTAGNR,'.$this->user.','.psgencrypt($this->pwd);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, 512);

        // Prfen, ob die Serververbindung steht
        if(!strlen($socket_buffer) || stristr($socket_buffer, 'ERROR')){
            $this->socket_errno = 7;
            return false;
        }
        else{
            list($this->sysinfo['tag_anzahl'],
                 $this->sysinfo['intervall'],
                 $this->sysinfo['refresh'],
                 $this->sysinfo['bezeichnung'],
                 $this->sysinfo['kurven_anzahl'],
                 $this->sysinfo['stoer_intervall'],
                 $this->sysinfo['rohkanal_anzahl'],
                 $this->sysinfo['version']) = explode(',',$socket_buffer);

            // Wenn kurven_anzahl 0, gilt der Standard 1000
            if($this->sysinfo['kurven_anzahl'] == 0){
                $this->sysinfo['kurven_anzahl'] = 1000;
            }

            $this->sysinfo['bezeichnung'] = trim($this->sysinfo['bezeichnung']);
			
        }

        return true;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion check_ks_for_search() - Prfen, ob der Kurvensatz dem Suchkriterium entspricht (Kurvensatzliste holen) */
    private function check_ks_for_search($ksnumber, $search){
        $retval = false;

        if(isset($this->sysinfo['kurven_anzahl']) && is_numeric($this->sysinfo['kurven_anzahl'])
            && $this->sysinfo['kurven_anzahl'] > 0 && is_numeric($ksnumber)
            && $ksnumber > 0 && $ksnumber <= $this->sysinfo['kurven_anzahl'] + 1){
            $ks_start = $ksnumber - 1;
            $ks = $this->get_next_searched_ks($ks_start, $search);
            // Wenn der erste ermittelte Kurvensatz dem zu prfenden entspricht
            if($ks && $ks[0] == $ksnumber){
                $retval = true;
            }
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion check_tag_for_search() - Prfen, ob die Tag-Nr. dem Suchkriterium entspricht (Tagliste holen) */
    private function check_tag_for_search($tag_nr, $search){
        $retval = false;

        if(isset($this->sysinfo['tag_anzahl']) && is_numeric($this->sysinfo['tag_anzahl'])
            && $this->sysinfo['tag_anzahl'] > 0 && is_numeric($tag_nr)
            && $tag_nr > 0 && $tag_nr <= $this->sysinfo['tag_anzahl'] + 1){
            $tag_start = $tag_nr - 1;
            // Wenn die erste ermittelte Tag-Nr. der zu prfenden Tag-Nr. entspricht
            if($this->get_next_searched_tag($tag_start, $search) && $this->tagarray['nummer'] == $tag_nr){
                $retval = true;
            }
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion create_diagramarray_index() - Diagramm-Array-Index generieren und belegen */
    public function create_diagramarray_index($view, $diagram_index = ''){
        if(!strlen(trim($diagram_index))){
            $diagram_index = 'diagram'.md5(uniqid(rand(), true));
        }

        $this->diagramarray[$diagram_index] = new sv_short_class;

        $this->diagramarray[$diagram_index]->user = $this->user;
        $this->diagramarray[$diagram_index]->port = $this->port;
        $this->diagramarray[$diagram_index]->host = $this->host;
        $this->diagramarray[$diagram_index]->pwd = $this->pwd;

        $this->diagramarray[$diagram_index]->USER_CONFIG['HIDE_NEG_AXIS'] = 0;
        $this->diagramarray[$diagram_index]->USER_CONFIG['TZ_INDEX'] = -1;
        $this->diagramarray[$diagram_index]->USER_CONFIG['TIME_IS_GMT_ONLY'] = 0;

        $this->diagramarray[$diagram_index]->number_of_tags = $this->number_of_tags;

		if(strlen($view)){
		//Fliessbild
			$this->get_timeframe_fliess($this->diagramarray[$diagram_index]->time_start,
                             $this->diagramarray[$diagram_index]->time_end);
		}
		else{
			$this->get_timeframe($this->diagramarray[$diagram_index]->time_start,
                             $this->diagramarray[$diagram_index]->time_end);
		}
		$this->diagramarray[$diagram_index]->zoom_org_time_diff = $this->diagramarray[$diagram_index]->time_end - $this->diagramarray[$diagram_index]->time_start;

        // Bei festem Zeitrahmen standardmig kein Refresh
        if(is_numeric($this->time_form_end) && $this->time_form_end > 0
        && is_numeric($this->time_form_start) && $this->time_form_start > 0){
            $this->diagramarray[$diagram_index]->refresh_diagram = false;
        }

        $this->diagramarray[$diagram_index]->ks_auswahl = $this->ks_auswahl;
        $this->diagramarray[$diagram_index]->tagauswahl = array();

		if(strlen($view)){
		//Fliessbild
			foreach($this->tagauswahl_fliess as $tag){
				if(!isset($tag['invalid']) || $tag['invalid'] == 0){
					$this->diagramarray[$diagram_index]->tagauswahl[] = $tag;
				}
			}
		}
		else{
			foreach($this->tagauswahl as $tag){
				if(!isset($tag['invalid']) || $tag['invalid'] == 0){
					$this->diagramarray[$diagram_index]->tagauswahl[] = $tag;
				}
			}
		}

        foreach($this->diagramarray[$diagram_index]->tagauswahl as &$tag){
            $tag['hide_tag'] = 0;
        }

        return $diagram_index;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion create_diagramarray_indexJS() - Diagramm-Array-Index generieren und belegen */
    public function create_diagramarray_indexJS($view, $diagram_index = ''){
        if(!strlen(trim($diagram_index))){
            $diagram_index = 'diagram'.md5(uniqid(rand(), true));
        }

        $this->diagramarray[$diagram_index] = new sv_short_class;

        $this->diagramarray[$diagram_index]->user = $this->user;
        $this->diagramarray[$diagram_index]->port = $this->port;
        $this->diagramarray[$diagram_index]->host = $this->host;
        $this->diagramarray[$diagram_index]->pwd = $this->pwd;

        $this->diagramarray[$diagram_index]->USER_CONFIG['HIDE_NEG_AXIS'] = 0;
        $this->diagramarray[$diagram_index]->USER_CONFIG['TZ_INDEX'] = -1;
        $this->diagramarray[$diagram_index]->USER_CONFIG['TIME_IS_GMT_ONLY'] = 0;

        $this->diagramarray[$diagram_index]->number_of_tags = $this->number_of_tags;

		if(strlen($view)){
		//Fliessbild
			$this->get_timeframe_fliess($this->diagramarray[$diagram_index]->time_start,
                             $this->diagramarray[$diagram_index]->time_end);
		}
		else{
			$this->get_timeframe($this->diagramarray[$diagram_index]->time_start,
                             $this->diagramarray[$diagram_index]->time_end);
		}
		$this->diagramarray[$diagram_index]->zoom_org_time_diff = $this->diagramarray[$diagram_index]->time_end - $this->diagramarray[$diagram_index]->time_start;

        // Bei festem Zeitrahmen standardmig kein Refresh
        if(is_numeric($this->time_form_end) && $this->time_form_end > 0
        && is_numeric($this->time_form_start) && $this->time_form_start > 0){
            $this->diagramarray[$diagram_index]->refresh_diagram = false;
        }

        $this->diagramarray[$diagram_index]->ks_auswahl = $this->ks_auswahl;
        $this->diagramarray[$diagram_index]->tagauswahl = array();

		if(strlen($view)){
		//Fliessbild
			foreach($this->tagauswahl_fliess as $tag){
				if(!isset($tag['invalid']) || $tag['invalid'] == 0){
					$this->diagramarray[$diagram_index]->tagauswahl[] = $tag;
				}
			}
		}
		else{
			$run = $this->number_of_tags;
			for($ii=0;$ii<$run;$ii++){
				$this->diagramarray[$diagram_index]->tagauswahl[$ii]['nummer'] = 0;
				if((!isset($this->tagauswahl[$ii]['invalid']) || $this->tagauswahl[$ii]['invalid'] == 0) && (isset($this->tagauswahl[$ii]['nummer']))){
					$this->diagramarray[$diagram_index]->tagauswahl[$ii] = $this->tagauswahl[$ii];
				}
			}
		}

        foreach($this->diagramarray[$diagram_index]->tagauswahl as &$tag){
            $tag['hide_tag'] = 0;
        }

        return $diagram_index;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion delete_diagramarray_index() - Diagramm-Array-Index lschen */
    public function delete_diagramarray_index($diagram_index){
        $this->diagramarray[$diagram_index] = null;
        unset($this->diagramarray[$diagram_index]);
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion export() - Scalarvis-Datenexport */
    public function export($from, $to, $tags, $interval, $separator = '', $wert_flag_array = array(1, 1, 1, 1)){
        global $STANDARD_CONFIG;
        global $g_path_separator;

        $tag_string = '';
        $i = 0;
        $tmp_now = time();
        foreach($tags as $tag_nr){
            if($i){
                $tag_string .= ',';
            }
            $tag_string .= $tag_nr;
            $i++;
        }

        $wert_flag_string = '';
        foreach($wert_flag_array as $wert_flag){
            if($wert_flag){
                $wert_flag_string .= '1';
            }
            else{
                $wert_flag_string .= '0';
            }
        }

        // Wenn es das temp-Verzeichnis nicht gibt, anlegen
        $temp_dir = 'export'.$g_path_separator.'temp'.$g_path_separator;
        if(!is_dir($temp_dir)){
            mkdir($temp_dir);
        }

        // $temp_file muss fr CSV-Export die Extension TXT haben, damit Trennzeichen-Type funktioniert
        switch($separator){
        case 'semicolon':
            $tmp_ext = '.txt';
            $file_ext = '.csv';
            $file_type = '2';
            break;
        case 'tabulator':
            $tmp_ext = '.txt';
            $file_ext = '.csv';
            $file_type = '1';
            break;
        case 'excel':
            $tmp_ext = '.xls';
            $file_ext = '.xls';
            $file_type = '3';
            break;
        default:    // comma
            $tmp_ext = '.txt';
            $file_ext = '.csv';
            $file_type = '0';
            break;
        }

        $temp_file = $temp_dir.session_id().$tmp_now.$tmp_ext;

        switch($this->lang_id){
        case 'de':
            $lang_id = 1;
            break;
        default:
            $lang_id = 0;
            break;
        }

        $exec_command =
        'export'.$g_path_separator.'SV_Export.exe'.
        ' /Host='.$this->host.
        ' /Port='.$this->port.
        ' /User='.$this->user.
        ' /Pass='.$this->pwd.
        ' /DateFromUTC='.gmdate('d.m.Y H:i:s', $from).
        ' /DateToUTC='.gmdate('d.m.Y H:i:s', $to).
        ' /Type='.$file_type.
        ' /DataType=3'.                                 // 3 = Universal, 2 = Detail
        ' /Intervall='.$interval.
        ' /Tag='.$tag_string.
        ' /Filename='.$temp_file.
        ' /Output='.$wert_flag_string.'0'.              // Auswahl: Istwert, Min, Max, Avg, Status
        ' /Auto=1'.                                     // Auto = 1, Userinterface = 0
        ' /Lang='.$lang_id.
        ' /TimeZone=TZ';								// Lokale Zeitzone RS 20120416

        // N TODO: Spezialformate testen
        // Spezielles Datums-Format
        if(isset($this->USER_CONFIG['EXPORT_DATEFORMAT'])
        && strlen(trim($this->USER_CONFIG['EXPORT_DATEFORMAT']))){
            $exec_command .= ' /DateFormat='.$this->USER_CONFIG['EXPORT_DATEFORMAT'];
        }

        // Spezielles Zeit-Format
        if(isset($this->USER_CONFIG['EXPORT_TIMEFORMAT'])
        && strlen(trim($this->USER_CONFIG['EXPORT_TIMEFORMAT']))){
            $exec_command .= ' /TimeFormat='.$this->USER_CONFIG['EXPORT_TIMEFORMAT'];
        }

        // Spezielles Dezimaltrennzeichen
        if(isset($this->USER_CONFIG['EXPORT_DECSEP'])
        && strlen(trim($this->USER_CONFIG['EXPORT_DECSEP']))){
            switch($this->USER_CONFIG['EXPORT_DECSEP']){
            case 'POINT':
                $exec_command .= ' /DecSep=.';
                break;
            case 'COMMA':
                $exec_command .= ' /DecSep=,';
                break;
            }
        }

        //echo $exec_command;

		// RS/RU 20121211 solte des Problem Loesung sein
		session_write_close();
        exec($exec_command);
        session_start();

        // Logfile auswerten
        $fp = fopen($temp_file.'.log', 'rb');
        if($fp){
            $status = fgetcsv($fp, filesize($temp_file.'.log'), '=');        // Erste Zeile lesen
            if($status[0] == 'Status' && $status[1] == '1'){        // Datei konnte von SV_Export.exe NICHT erzeugt werden
                $status = fgetcsv($fp, filesize($temp_file.'.log'), '=');    // Zweite Zeile lesen
                fclose($fp);
                unlink($temp_file.'.log');
                return $status[1];
            }
            else if($status[0] == 'Status' && $status[1] == '0'){   // Datei konnte von SV_Export.exe erzeugt werden
                fclose($fp);
                unlink($temp_file.'.log');
            }
            else{       // Sonstiger Fehler
                fclose($fp);
                unlink($temp_file.'.log');
                return -2;
            }
        }
        else{
            return -1;
        }

// RS 20120417
/*        // Logfile OK -> Exportfile einlesen
        $fp = fopen($temp_file, 'rb');
        if($fp){
            $file = fread($fp, filesize($temp_file));
            fclose($fp);
        }
        else{
            return -3;
        }
        unlink($temp_file);

        // Download
        $filename = 'ScalarvisExport'.$file_ext;
        // N TODO: Download unter SSL mit IE8?
        download_headers($filename, strlen($file));
        echo $file;
//
*/

/*        // Logfile OK -> Exportfile einlesen
        // Download
        $filename = 'ScalarvisExport'.$file_ext;
        // N TODO: Download unter SSL mit IE8?
        download_headers($filename, filesize($temp_file));
        readfile($temp_file);
        unlink($temp_file);
*/
// RS 20120418
        // Logfile OK -> Exportfile einlesen
        $fSize = filesize($temp_file);
        $file = file_get_contents($temp_file, $fSize);
        if($file == FALSE){
            return -3;
        }
        unlink($temp_file);

        // Download
        $filename = 'ScalarvisExport'.$file_ext;
        // N TODO: Download unter SSL mit IE8?
        download_headers($filename, $fSize);
        echo $file;

        return 0;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion filter() - Hilfsfunktion fr AWT und AWT_STAT */
    private function filter($tok){
        $tok = doubleval($tok);
        if(!is_numeric($tok) || strstr($tok, '-1E+038')){
            $tok = 'undefined';
        }
        return $tok;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion format_taginfo() - Formatierte Tag-Info */
    private function format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $nach, $status, $info){
        $tagname = '';                                   // Fr den Fall da length(name) = 0
        $einheit = '';
        $dba = doubleval($dba);                          // Format in Realzahl
        $dbe = doubleval($dbe);
        $wert= doubleval($wert);
		$fkt = doubleval($fkt);
		$nach = doubleval($nach);

        if($tag_nr < 1){
            return false;
        }

        if(($length = strlen($name)) > 0){               // Die letzten 8 Zeichen bilden die Einheit
            $einheit = trim(substr($name, $length - 8));
            $tagname = trim(substr($name, 0, $length - 8));
        }
        $info = trim($info);                             // Leerzeichen entfernen
        if(ord($info) == 255){                           // Filter fr undefinierte Bezeichnungen
            $info = '';
        }
        if(($tagname == '........................' &&    // Ist das Tag ungltig
            $einheit == '........' &&
            $dba == '-1E+038' &&
            $dbe == '-1E+038' &&
            $wert == '-1E+038') || ($tag_nr == -1)){
            $dba = ($dba == '-1E+038')?'':$dba;
            $dbe = ($dbe == '-1E+038')?'':$dbe;
            $wert = ($wert == '-1E+038')?'':$wert;
			$nach = ($nach == '-1E+038')?'':$nach;
            $this->tagarray = array('nummer' => $tag_nr,
                                    'name' => $tagname,
                                    'einheit' => $einheit,
                                    'info' => $info,
                                    'dba' => $dba,
                                    'dbe' => $dbe,
                                    'wert' => $wert,
                                    'fkt' => $fkt,
									'nach' => $nach,
                                    'status' => $status,
                                    'invalid' => 1);
            return false;
        }
        else{
            $dba = ($dba == '-1E+038')?'':$dba;
            $dbe = ($dbe == '-1E+038')?'':$dbe;
            $wert = ($wert == '-1E+038')?'':$wert;
			$nach = ($nach == '-1E+038')?'':$nach;
            $this->tagarray = array('nummer' => $tag_nr,
                                    'name' => $tagname,
                                    'einheit' => $einheit,
                                    'info' => $info,
                                    'dba' => $dba,
                                    'dbe' => $dbe,
                                    'wert' => $wert,
                                    'fkt' => $fkt,
									'nach' => $nach,
                                    'status' => $status,
                                    'invalid' => 0);
            return true;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion format_ksinfo() - Formatierte Kurvensatz-Info */
    private function format_ksinfo($socket_buffer){
        $separator_pos = strpos($socket_buffer, ',');                   // Ersten Wert abschneiden
        $ks[] = substr($socket_buffer, 0, $separator_pos);
        $ks[] = substr($socket_buffer, $separator_pos + 1, 80);         // Dann 80 Bit am Stck lesen
        $socket_buffer = substr($socket_buffer, $separator_pos + 82);
        $ks = array_merge($ks, explode(',', $socket_buffer));           // Dann den Rest
        return $ks;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_awt() - Liefert Archivdaten zur Mehrfachauslesung */
    public function get_awt($index){
        $socket_buffer = sprintf('AWT,%d', $index);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, $this->MESSAGE_SIZE);
        if(stristr($socket_buffer, 'ERROR')){
            return 0;
        }
        else{
            $socket_buffer = substr($socket_buffer, 4);     // AWT, abschneiden
            $tok = strtok($socket_buffer, ',');
            $erg['index'] = $tok;     $tok = strtok(',');
            $erg['Datum'] = $tok;     $tok = strtok(',');
            $erg['Zeit'] = $tok;      $tok = strtok(',');
            $erg['anz_werte'] = $tok; $tok = strtok(',');//Anzahl der TAGs

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['wert_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['min_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['max_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['sum_'.$j] = floatval($tok);
                $tok = strtok(',');
            }
        }
        return $erg;
    }
    /* }}} */

    /**
     * Liefert Archivwerte zur Mehrfachauslesung von TAGs
     * @param index Index des Zeitpunktes
     */
    /* {{{ PHP-Klassenfunktion get_awt() -  */
    public function get_awt_fliess($index){
        $socket_buffer = sprintf('AWT,%d', $index);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, $this->MESSAGE_SIZE);
        if(stristr($socket_buffer, 'ERROR')){
            return 0;
        }
        else{
            $socket_buffer = substr($socket_buffer, 4);     // AWT, abschneiden
            $tok = strtok($socket_buffer, ',');
            $erg['index'] = $tok;     $tok = strtok(',');
            $erg['Datum'] = $tok;     $tok = strtok(',');
            $erg['Zeit'] = $tok;      $tok = strtok(',');
            $erg['anz_tags'] = $tok; $tok = strtok(',');//Anzahl der TAGs

            //nur Werte ohne Min, Max, Sum holen
            for($j = 0; $j < $erg['anz_tags']; $j++){
                //$erg['wert_'.$j] = $this->filter($tok);
                $erg[$j] = $this->filter($tok);
                $tok = strtok(',');
            }

        }
        return $erg;
    }
    
    /* {{{ PHP-Klassenfunktion get_awt_stat() - Liefert Archivdaten zur Mehrfachauslesung */
    public function get_awt_stat($index){
        $socket_buffer = sprintf('AWTSTAT,%d', $index);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, $this->MESSAGE_SIZE);
        if(stristr($socket_buffer, 'ERROR')){
            return 0;
        }
        else{
            $socket_buffer = substr($socket_buffer, 4);        // AWT, abschneiden
            $tok = strtok($socket_buffer, ',');
            $erg['index'] = $tok;       $tok = strtok(',');
            $erg['Datum'] = $tok;       $tok = strtok(',');
            $erg['Zeit'] = $tok;        $tok = strtok(',');
            $erg['anz_werte'] = $tok;   $tok = strtok(',');

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['wert_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['min_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['max_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['sum_'.$j] = floatval($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['anz_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // Gltige Datenpunkte im Zeitraum

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['avg_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // Mittelwerte

            for($j = 0; $j < $erg['anz_werte']; $j++){
                $erg['var_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // Varianz
        }

        return $erg;
    }
    /* }}} */

	/**
	 * get_awt_statreg() - Liefert Archivdaten fuer Statistik mit AWTREGSTAT
	 * Erstellt RS 20150219
	 * @param number $index
	 * @returns void
	 */
     public function get_awt_regstat($index){
        $socket_buffer = sprintf('AWTREGSTAT,%d', $index);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, $this->MESSAGE_SIZE);
        if(stristr($socket_buffer, 'ERROR')){
            return null;
        }
        else{
			//echo '<br>$buffer: ',$socket_buffer;
            $socket_buffer = substr($socket_buffer, 4);        // AWT, abschneiden
            $tok = strtok($socket_buffer, ',');
            $erg['index'] = $tok;       $tok = strtok(',');
            $erg['Datum'] = $tok;       $tok = strtok(',');
            $erg['Zeit'] = $tok;        $tok = strtok(',');
            $erg['anz_tags'] = $tok;   $tok = strtok(',');
			$anz = $erg['anz_tags'];//Das sind die Anzahl TAGs
			
            for($j = 0; $j < $anz; $j++){
                $erg['wert_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $anz; $j++){
                $erg['min_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $anz; $j++){
                $erg['max_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $anz; $j++){
                $erg['sum_'.$j] = floatval($tok);
                $tok = strtok(',');
            }

            for($j = 0; $j < $anz; $j++){
                $erg['anz_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // Gltige Datenpunkte im Zeitraum

            for($j = 0; $j < $anz; $j++){
                $erg['avg_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // Mittelwerte

            for($j = 0; $j < $anz; $j++){
                $erg['stdabw_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // Standabweichung

            for($j = 0; $j < $anz; $j++){
                $erg['korr_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // Korrelation

            for($j = 0; $j < $anz; $j++){
                $erg['regb_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // RegB

            for($j = 0; $j < $anz; $j++){
                $erg['rega_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // RegA

            for($j = 0; $j < $anz; $j++){
                $erg['minpos_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // MinPos

            for($j = 0; $j < $anz; $j++){
                $erg['maxpos_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // MaxPos
            for($j = 0; $j < $anz; $j++){
                $erg['firstpos_'.$j] = $this->filter($tok);
                $tok = strtok(',');
            }   // MaxPos
        }

        return $erg;
    }
    /* }}} */
	
    /**
     * get_block_info() - Gibt die ntigen Informationen fr eine Blockdatenbertragung zurck (Archiv lesen)
     * @return array(Auslesebeginn,anztag,anzval,StartOffset,AnzWerte,Intervall,Blocksize,Blockanz,Schrittweite,Tags[MAXAWTAGS])
     * @param sttzstellen integer(=die Menge an Sttzstellen, die zurckgeliefert werden)
     * wenn anzval == 0 dann ist die anfrage zulssig aber enthlt keine Werte
     */
    private function get_block_info($stuetzstellen){
        $retval = 0;

        if(is_numeric($stuetzstellen)){
            $socket_buffer = sprintf('GetBlockInfo,%d', $stuetzstellen);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 304, true);
            if(!strncmp($socket_buffer, 'ERROR', 5)){
                die('Error on GetBlockInfo');
            }

            $temp = unpack('deins', substr($socket_buffer, 0, 8));  // Unpack liefert ein Array ohne Keys - deshalb einen Key 'eins' erstellen
            $erg[] = $this->ole_to_utc($temp['eins']);
            $temp = unpack('l4', substr($socket_buffer, 8, 16));    // Unpack liefert hier ein Array mit 4 Werten, also an erg anhngen...
            $erg = array_merge($erg, $temp);
            //if(!$temp[4]) //Wenn die Taganzahl null ist ...
            //  return 0;
            $temp = unpack('deins', substr($socket_buffer, 24, 8));
            $erg[] = $this->ole_to_utc($temp['eins']);
            $temp = unpack('l3', substr($socket_buffer, 32, 12));
            $erg = array_merge($erg, $temp);
            $temp = unpack('l'.$this->MAX_AW_TAGS, substr($socket_buffer, 44, 8 * $this->MAX_AW_TAGS));
            for($i = 1; $i <= $this->MAX_AW_TAGS; $i++){  // Tagliste durchlaufen
                if(!$temp[$i] == 0){  // und ungltige (=0) lschen
                    $temp1[] = $temp[$i];
                }
            }
            $erg[] = $temp1;
            //Berechnung des Auslesebeginns
            $erg[0] = $erg[0] + $erg[5] * $erg[3];    // Auslesebeginn = DatumVon + Intervall * Startoffset
            //Berechnung des Intervalls
            $erg[5] = $erg[5] * $erg[8];              // Intervall = Intervall * Schrittweite
            $retval = $erg;
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_diagram_data() - Daten fr Diagramm aufbereiten */
    public function get_diagram_data($type, $diagram_index, &$data){
        $retval = false;
        $data = null;

        $svsc = $this->diagramarray[$diagram_index];

        for($i = 0; $i < $svsc->number_of_tags; $i++){
            if(isset($svsc->tagauswahl[$i])){
                $tags[] = $svsc->tagauswahl[$i]['nummer'];
            }
        }

        if(isset($tags)){
            if($type == 'universal' || $type == 'single'){
                $data = $this->read_archiv(round_time($svsc->time_start, $this->sysinfo['intervall']),
                                           round_time($svsc->time_end, $this->sysinfo['intervall']),
                                           $tags,
                                           500);
            }
            if($type == 'detail'){
                $data = $this->read_archiv(round_time($svsc->time_start, $this->sysinfo['stoer_intervall']),
                                           round_time($svsc->time_end, $this->sysinfo['stoer_intervall']),
                                           $tags,
                                           500,
                                           'detail');
            }
            if($type == 'trend'){
                $data = $this->read_archiv(round_time($svsc->time_start, 60),
                                           round_time($svsc->time_end, 60),
                                           $tags,
                                           500,
                                           'trend');
            }
        }

        if(isset($data[0][0])){
            //$svsc->time_start = $data[0][0];
            //$svsc->time_end = $data[0][0] + ($data[0][4] - 1) * $data[0][5];
            $retval = true;
        }

        return $retval;
    }
    /* }}} */

	/**
	 * get_statistic_data() - Daten fr Diagramm aufbereiten
	 * Erstellt RS 20150219
	 * @param number $tags
	 * @param number $from
	 * @param number $to
	 * @param array reference $data
	 * @returns void
	 */
    public function get_statistic_data($tags, $from, $to, &$data){
        $data = null;
		$anz = 0;
		$erg=null;
		
        if(isset($tags)){
			//$buf=array(Auslesebeginn,anztag,anzval(server),StartOffset,AnzWerte(zurckgeliefert),Intervall,Blocksize,Blockanz,Schrittweite,Tags[MAXAWTAGS])
			$buf = $this->set_arct($from, $to, $tags, true);
			if($buf){
				$anz = intval(substr($buf, 5, strlen($buf) - 24));  // String aufs Wesentliche reduzieren
			}
		}
        if($anz > 0){
            //$buf=$this->get_block_info(($to-$from)/$this->sysinfo['intervall']+1); //Zeitintervall durch Systemintervall ergibt die Anzahl an Sttzstellen
			$buf = $this->get_awt_regstat(1);      // Zeitintervall durch Systemintervall ergibt die Anzahl an Sttzstellen
            if(isset($buf)){
				//jetzt MAX_Index lesen
				$erg[] = $buf;
				$buf2[] = $this->get_awt_regstat($anz);      // Zeitintervall durch Systemintervall ergibt die Anzahl an Sttzstellen
				$erg = array_merge($erg, $buf2);
				$data[] = $tags;
				$data = array_merge($data, $erg);      // 
				$retval=true;
			}
        }

        return $anz;
    }

/* {{{ PHP-Klassenfunktion get_flowchart_edit_url() - Men-Link fr Fliebild-Editor generieren */
    public function get_flowchart_edit_url(){
        global $svweb_session_name;
        global $sv;

        if(isset($this->USER_CONFIG['FLOWCHART_EDIT_DIR']) && strlen(trim($this->USER_CONFIG['FLOWCHART_EDIT_DIR']))
        && trim($this->USER_CONFIG['FLOWCHART_EDIT_DIR']) != 'empty'){
            $flowchart_edit_url = trim($this->USER_CONFIG['FLOWCHART_EDIT_DIR']);
        }
        else{
            $flowchart_edit_url = '../flowchartedit/';
        }

        // Ggf. '/' anhngen
        $flowchart_edit_url_last_letter = substr($flowchart_edit_url, strlen($flowchart_edit_url) - 1, 1);
        if($flowchart_edit_url_last_letter != '/' && $flowchart_edit_url_last_letter!= '\\'
            && !stristr(substr($flowchart_edit_url, strlen($flowchart_edit_url) - 6, 6), '.')){
                $flowchart_edit_url .= '/';
            }

        // $img_path generieren und an Flowchart Edit per $_GET bergeben
        if(isset($_SERVER['SCRIPT_NAME']) && strlen(trim($_SERVER['SCRIPT_NAME']))){
            $script_name = trim($_SERVER['SCRIPT_NAME']);
        }
        else if(isset($_SERVER['PHP_SELF']) && strlen(trim($_SERVER['PHP_SELF']))){
            $script_name = trim($_SERVER['PHP_SELF']);
        }
        $img_path = '../';
        if(isset($script_name)){
            $tmp_pos = strpos($script_name, '/');
            if($tmp_pos !== false){
                $tmp_path = substr($script_name, $tmp_pos + 1);
            }
            else{
                $tmp_path = $script_name;
            }
            $tmp_pos = strpos($tmp_path, '/');
            if($tmp_pos !== false){
                $tmp_path = substr($tmp_path, 0, $tmp_pos);
            }
            $img_path .= $tmp_path;
        }
        else{
            $img_path .= 'svweb';
        }
        $img_path .= '/flowchart/';
        if(isset($this->USER_CONFIG['FLOWCHART_DIR']) && strlen(trim($this->USER_CONFIG['FLOWCHART_DIR']))
            && trim($sv->USER_CONFIG['FLOWCHART_DIR']) != 'empty'){
            $tmp_user = trim($this->USER_CONFIG['FLOWCHART_DIR']);
            // Letzten Backslash wegschneiden, wenn dahinter nix mehr kommt
            $tmp_pos = strrpos($tmp_user, '\\');
            if($tmp_pos !== false && $tmp_pos == strlen($tmp_user) - 1){
                $tmp_user = substr($tmp_user, 0, $tmp_pos);
            }
            // Letzten Slash wegschneiden, wenn dahinter nix mehr kommt
            $tmp_pos = strrpos($tmp_user, '/');
            if($tmp_pos !== false && $tmp_pos == strlen($tmp_user) - 1){
                $tmp_user = substr($tmp_user, 0, $tmp_pos);
            }
            // Alles vor dem letzten Backslash wegschneiden
            $tmp_pos = strrpos($tmp_user, '\\');
            if($tmp_pos !== false){
                $tmp_user = substr($tmp_user, $tmp_pos + 1);
            }
            // Alles vor dem letzten Slash wegschneiden
            $tmp_pos = strrpos($tmp_user, '/');
            if($tmp_pos !== false){
                $tmp_user = substr($tmp_user, $tmp_pos + 1);
            }
        }
        else if(isset($this->user) && strlen(trim($this->user))){
            $tmp_user = trim($this->user);
        }
        $img_path .= $tmp_user;
        $flowchart_edit_url .= '?session_name='.$svweb_session_name;
        $flowchart_edit_url .= '&img_path='.$img_path;

        return $flowchart_edit_url;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_host() - Getter fr host */
    public function get_host(){
        return $this->host;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_ks() - Kurvensatz holen */
    private function get_ks($ksnumber){
        if(!is_numeric($ksnumber) || $ksnumber < 0 || $ksnumber > $this->sysinfo['kurven_anzahl']){
            return false;
        }
        else{
            $socket_buffer = '';
            $socket_buffer = sprintf('KSATZ,%d', $ksnumber);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 8096);
            $ks[] = $ksnumber;
            $ks[] = substr($socket_buffer, 0, 80);  // 80 Byte am Stck lesen
            $socket_buffer = substr($socket_buffer, 81);
            $ks = array_merge($ks, explode(',', $socket_buffer));   // Dann den Rest
            return $ks;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_kslist() - Kurvensatzliste holen */
    // Hinweis fr die If-Abfragen:
    // ks[24] enthlt die Zeitspanne, ks[0] die KS nummer
    // ks[24] ist -2 wenn der KS ungltig ist/ nicht ex. und -1 wenn keine Spanne def ist
    public function get_kslist($ks_start,
                               $list_max,
                               &$ks_list_forward,
                               &$ks_list_reverse,
                               &$ksliste,
                               $direction = 'up',
                               $search = 'undefined'){
        $ksliste = array();

        if(!strlen(trim($search))){
            $search = 'undefined';
        }

        if(isset($this->sysinfo['kurven_anzahl']) && is_numeric($this->sysinfo['kurven_anzahl'])
            && $this->sysinfo['kurven_anzahl'] > 0){
            $kurven_anzahl = $this->sysinfo['kurven_anzahl'];
        }
        else{
            $kurven_anzahl = 0;
        }

        if(!is_numeric($ks_start) || $ks_start < 1){
            $ksnumber = 1;
            $direction = 'up';
        }
        else if($ks_start > $kurven_anzahl){
            $ksnumber = $kurven_anzahl;
            $direction = 'down';
        }
        else{
            $ksnumber = $ks_start;
        }

        // Erste/letzte (up/down) $ksnumber bei $search individuell ermitteln,
        // wenn $ksnumber nicht dem Suchkriterium entspricht
        if($search != 'undefined' && !$this->check_ks_for_search($ksnumber, $search)){
            if($direction == 'down'){
                $ks = $this->get_prev_searched_ks($ksnumber, $search);
            }
            else{
                $ks = $this->get_next_searched_ks($ksnumber, $search);
            }
            if(!$ks){
                return false;
            }
            $ksnumber = $ks[0];
            unset($ks);
        }

        $i = 0;
        $ks = $this->get_ks($ksnumber);
        if(!$this->is_ks_valid($ks)){                              // Prfen ob die Startnummer ungltig ist
            if($direction == 'down'){
                if($search == 'undefined'){
                    $ks = $this->get_prev_ks($ksnumber);
                    if(!$this->is_ks_valid($ks)){
                        $direction = 'up';
                        $ks = $this->get_next_ks($ksnumber);
                        if(!$this->is_ks_valid($ks)){
                            return false;
                        }
                    }
                }
                else{
                    $ks = $this->get_prev_searched_ks($ksnumber, $search);
                    if(!$this->is_ks_valid($ks)){
                        $direction = 'up';
                        $ks = $this->get_next_searched_ks($ksnumber, $search);
                        if(!$this->is_ks_valid($ks)){
                            return false;
                        }
                    }
                }
            }
            else{
                if($search == 'undefined'){
                    $ks = $this->get_next_ks($ksnumber);
                    if(!$this->is_ks_valid($ks)){
                        $direction = 'down';
                        $ks = $this->get_prev_ks($ksnumber);
                        if(!$this->is_ks_valid($ks)){
                            return false;
                        }
                    }
                }
                else{
                    $ks = $this->get_next_searched_ks($ksnumber, $search);
                    if(!$this->is_ks_valid($ks)){
                        $direction = 'down';
                        $ks = $this->get_prev_searched_ks($ksnumber, $search);
                        if(!$this->is_ks_valid($ks)){
                            return false;
                        }
                    }
                }
            }
        }

        array_push($ksliste, $ks);                              // Gefundenen Kurvensatz in die Liste bernehmen
        $ksnumber = $ksliste[$i][0];                            // Startwert fr die nchste Abfrage bernehmen
        while($i < $list_max - 1){
            if($direction == 'down'){
                if($search == 'undefined'){
                    $ks = $this->get_prev_ks($ksnumber);
                    if($this->is_ks_valid($ks)){
                        $i++;
                        array_push($ksliste, $ks);
                        $ksnumber = $ksliste[$i][0];
                    }
                    else{
                        break;
                    }
                }
                else{
                    $ks = $this->get_prev_searched_ks($ksnumber, $search);
                    if($this->is_ks_valid($ks)){
                        $i++;
                        array_push($ksliste, $ks);
                        $ksnumber = $ksliste[$i][0];
                    }
                    else{
                        break;
                    }
                }
            }
            else{
                if($search == 'undefined'){
                    $ks = $this->get_next_ks($ksnumber);
                    if($this->is_ks_valid($ks)){
                        $i++;
                        array_push($ksliste, $ks);
                        $ksnumber = $ksliste[$i][0];
                    }
                    else{
                        break;
                    }
                }
                else{
                    $ks = $this->get_next_searched_ks($ksnumber, $search);
                    if($this->is_ks_valid($ks)){
                        $i++;
                        array_push($ksliste, $ks);
                        $ksnumber = $ksliste[$i][0];
                    }
                    else{
                        break;
                    }
                }
            }
        }

        // Prfen ob es noch einen weiteren gltigen Kurvensatz gibt, fr Weiter- bzw. Zurck-Button
        $ks_list_forward = 0;
        $ks_list_reverse = 0;

        if($direction == 'down'){
            $tmp_ks_nr_next = $ks_start;
            $tmp_ks_nr_prev = $ksnumber;
        }
        else{
            $tmp_ks_nr_next = $ksnumber;
            $tmp_ks_nr_prev = $ks_start;
        }

        if($search == 'undefined'){
            $ks = $this->get_next_ks($tmp_ks_nr_next);
            if($this->is_ks_valid($ks)){
                $ks_list_forward = 1;
            }
            $ks = $this->get_prev_ks($tmp_ks_nr_prev);
            if($this->is_ks_valid($ks)){
                $ks_list_reverse = 1;
            }
        }
        else{
            $ks = $this->get_next_searched_ks($tmp_ks_nr_next, $search);
            if($this->is_ks_valid($ks)){
                $ks_list_forward = 1;
            }
            $ks = $this->get_prev_searched_ks($tmp_ks_nr_prev, $search);
            if($this->is_ks_valid($ks)){
                $ks_list_reverse = 1;
            }
        }

        if($direction == 'down'){
            $ksliste = array_reverse($ksliste);
        }

        return true;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_next_ks() - Nchsten Kurvensatz holen (Kurvensatzliste holen) */
    private function get_next_ks($ks_start){
        if($ks_start < 0 || $ks_start > $this->sysinfo['kurven_anzahl']){
            return false;
        }
        else{
            $socket_buffer = sprintf('KSNEXT,%d', $ks_start);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 8096);
            return $this->format_ksinfo($socket_buffer);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_next_searched_ks() - Nchsten gesuchten Kurvensatz holen (Kurvensatzliste holen) */
    private function get_next_searched_ks($ks_start, $search = 'undefined'){
        $socket_buffer = sprintf('KSSEAR,%d,%s', $ks_start, $search);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, 8096);
        $ks = $this->format_ksinfo($socket_buffer);
        if($ks[0] == -1){
            return false;
        }
        else{
            return $ks;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_next_searched_tag() - Nchsten gesuchten Tag holen (Tagliste holen) */
    private function get_next_searched_tag($tag_start, $search){
        $socket_buffer = sprintf('SEARN,%d,%s', $tag_start, $search);
        $explode_array = array();

        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, 8096);
        if(strstr($socket_buffer, '00,~~~,NOT FOUND')
            || strstr($socket_buffer, '00,~~~,PARM ERR')){
                return false;
            }
        else{
            $name = substr($socket_buffer, 0, 32);
            $socket_buffer = substr($socket_buffer, 33);
            $explode_array = explode(',', $socket_buffer);
            list($tag_nr, $wert, $dba, $dbe, $fkt, $nach, $status, $info) = $explode_array;
            $tag_nr = intval($tag_nr);
            return $this->format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $nach, $status, $info);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_next_tag() - Nchsten Tag holen (Tagliste holen) */
    private function get_next_tag($tag_start){
        if($tag_start < 0 || $tag_start > $this->sysinfo['tag_anzahl']){
            return false;
        }
        else{
            $socket_buffer = sprintf('NEXTINFN,%d', $tag_start);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 8096);
            $name = substr($socket_buffer, 0, 32);
            $socket_buffer = substr($socket_buffer, 33);
            list($tag_nr, $wert, $dba, $dbe, $fkt, $nach, $status, $info) = explode(',', $socket_buffer);
            $tag_nr = intval($tag_nr);
            return $this->format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $nach, $status, $info);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_port() - Getter fr port */
    public function get_port(){
        return $this->port;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_prev_ks() - Vorherigen Kurvensatz holen (Kurvensatzliste holen) */
    private function get_prev_ks($ks_start){
        if($ks_start < 0 || $ks_start > $this->sysinfo['kurven_anzahl']){
            return false;
        }
        else{
            $socket_buffer = sprintf('KSPREV,%d', $ks_start);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 8096);
            return $this->format_ksinfo($socket_buffer);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_prev_searched_ks() - Vorherigen gesuchten Kurvensatz holen (Kurvensatzliste holen) */
    private function get_prev_searched_ks($ks_start, $search = 'undefined'){
        $socket_buffer = sprintf('KSSEARB,%d,%s', $ks_start, $search);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, 8096);
        $ks = $this->format_ksinfo($socket_buffer);
        if($ks[0] == -1){
            return false;
        }
        else{
            return $ks;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_prev_searched_tag() - Vorherigen gesuchten Tag holen (Tagliste holen) */
    private function get_prev_searched_tag($tag_start, $search){
        $socket_buffer = sprintf('SEARBN,%d,%s', $tag_start, $search);
        $explode_array = array();

        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, 8096);
        if(strstr($socket_buffer, '00,~~~,NOT FOUND')
            || strstr($socket_buffer, '00,~~~,PARM ERR')){
                return false;
            }
        else{
            $name = substr($socket_buffer, 0, 32);
            $socket_buffer = substr($socket_buffer, 33);
            $explode_array = explode(',', $socket_buffer);
            list($tag_nr, $wert, $dba, $dbe, $fkt, $nach, $status, $info) = $explode_array;
            $tag_nr = intval($tag_nr);
            return $this->format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $nach, $status, $info);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_prev_tag() - Vorherigen Tag holen (Tagliste holen) */
    private function get_prev_tag($tag_start){
        if($tag_start < 0 || $tag_start > $this->sysinfo['tag_anzahl']){
            return false;
        }
        else{
            $socket_buffer = sprintf('PREVINFN,%d', $tag_start);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 8096);
            $name = substr($socket_buffer, 0, 32);
            $socket_buffer = substr($socket_buffer, 33);
            list($tag_nr, $wert, $dba, $dbe, $fkt, $nach, $status, $info) = explode(',', $socket_buffer);
            $tag_nr = intval($tag_nr);
            return $this->format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $nach, $status, $info);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_pwd() - Getter fr pwd */
    public function get_pwd(){
        return $this->pwd;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_server_utc_time() - Gibt die aktuelle UTC-Zeit des Scalarvis-Servers zurck */
    public function get_server_utc_time(){
        socket_write_all($this->socket, 'PSGGetServerUTCTime,');
		$erg=socket_read_all($this->socket, 512, true);
        $socket_buffer = unpack('deins', $erg);
        return $this->ole_to_utc($socket_buffer['eins']);
		//return $erg;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_client_version() - Gibt die aktuelle CLient-Version des Scalarvis-Servers zurck */
	//	wird benoetigt, um Statistik-Funktion einzublenden
    public function get_client_version(){
		$temp=null;
		$version=0.0;
		
		socket_write_all($this->socket, 'GetPsgvisInfo,');
		$erg=socket_read_all($this->socket, 512, true);
        $temp = unpack('dversion', substr($erg, 16, 24));  // Unpack liefert ein Array ohne Keys - deshalb einen Key 'version' erstellen
		if(isset($temp)){
			$version = $temp['version'];
		}
		
        return $version;
	}
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_session_name() - Getter fr session_name */
    public function get_session_name(){
        return $this->session_name;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_socket_errno() - Getter fr socket_errno */
    public function get_socket_errno(){
        return $this->socket_errno;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_socket_last_error() - Getter fr socket_last_error */
    public function get_socket_last_error(){
        return $this->socket_last_error;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_tag_info() - Liefert alle Informationen zur Tagnummer */
    private function get_tag_info($tag_nr){
        if($tag_nr < 0 || $tag_nr > $this->sysinfo['tag_anzahl']){
            return false;
        }
        else{
            $socket_buffer = '';
            $socket_buffer = sprintf('NN,%d', $tag_nr);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 512);
            $name = substr($socket_buffer, 0, 32);
            $socket_buffer = substr($socket_buffer, 33);
            list($wert, $dba, $dbe, $fkt, $nach, $status, $info) = explode(',', $socket_buffer, 7);
            return $this->format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $nach, $status, $info);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_tag_info_array() - Liefert alle Informationen zur Tagnummer in ein Array */
    public function get_tag_info_array($tag_nr, &$tag_info_array){
        if(!is_numeric($tag_nr) || $tag_nr < 0 || $tag_nr > $this->sysinfo['tag_anzahl']){
            return 0;
        }
        else{
            $socket_buffer = sprintf('NN,%d', $tag_nr);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 512);
            $name = substr($socket_buffer, 0, 32);
            $socket_buffer = substr($socket_buffer, 33);
            list($wert, $dba, $dbe, $fkt, $nach, $status, $info) = explode(',', $socket_buffer, 7);
            $tag_info_array['tag_nr'] = $tag_nr;
            $tag_info_array['name'] = $name;
            $tag_info_array['wert'] = $wert;
            $tag_info_array['dba'] = $dba;
            $tag_info_array['dbe'] = $dbe;
            $tag_info_array['fkt'] = $fkt;
			$tag_info_array['nach'] = $nach;
            $tag_info_array['status'] = $status;
            $tag_info_array['info'] = $info;
            return 1;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_tag_info_array() - Liefert alle Informationen zur Tagnummer in ein Array */
    public function get_tag_info_array_formatted($tag_nr, &$tag_info_array){
        if(!is_numeric($tag_nr) || $tag_nr < 0 || $tag_nr > $this->sysinfo['tag_anzahl']){
            return false;
        }
        else{
            $socket_buffer = sprintf('NN,%d', $tag_nr);
            socket_write_all($this->socket, $socket_buffer);
            $socket_buffer = socket_read_all($this->socket, 512);
            $name = substr($socket_buffer, 0, 32);
            $socket_buffer = substr($socket_buffer, 33);
            list($wert, $dba, $dbe, $fkt, $nach, $status, $info) = explode(',', $socket_buffer, 7);
            $this->format_taginfo($tag_nr, $name, $wert, $dba, $dbe, $fkt, $nach, $status, $info);
            $tag_info_array = $this->tagarray;
			return true;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_taglist() - Tagliste holen */
    public function get_taglist($tag_start,
                                $list_max,
                                &$tag_list_forward,
                                &$tag_list_reverse,
                                &$tagliste,
                                $direction = 'up',
                                $search = 'undefined'){
            $tagliste = array();

            if(isset($this->sysinfo['tag_anzahl']) && is_numeric($this->sysinfo['tag_anzahl'])
                && $this->sysinfo['tag_anzahl'] > 0){
                $tag_anzahl = $this->sysinfo['tag_anzahl'];
            }
            else{
                $tag_anzahl = 0;
            }

            if(!strlen(trim($search))){
                $search = 'undefined';
            }

            if(!is_numeric($tag_start) || $tag_start < 1){
                $tag_nr = 1;
                $direction = 'up';
            }
            else if($tag_start > $tag_anzahl){
                $tag_nr = $tag_anzahl;
                $direction = 'down';
            }
            else{
                $tag_nr = $tag_start;
            }

            // Erste/letzte (up/down) $tag_nr bei $search individuell ermitteln,
            // wenn $tag_nr nicht dem Suchkriterium entspricht
            $this->tagarray = array();
            if($search != 'undefined' && !$this->check_tag_for_search($tag_nr, $search)){
                if($direction == 'down'){
                    if(!$this->get_prev_searched_tag($tag_nr, $search)){
                        return false;
                    }
                    $tag_nr = $this->tagarray['nummer'];
                }
                else{
                    if(!$this->get_next_searched_tag($tag_nr, $search)){
                        return false;
                    }
                    $tag_nr = $this->tagarray['nummer'];
                }
            }

            $i = 0;
            $this->tagarray = array();
            //echo 'Test: ',$direction,' - ',$tag_nr;
            if(!$this->get_tag_info($tag_nr)){            // Prfen ob die Startnummer ungltig ist
                //echo '<br>Invalid Tag';
                if($direction == 'down'){
                    if($search == 'undefined'){
                        if(!$this->get_prev_tag($tag_nr)){
                            $direction = 'up';
                            if(!$this->get_next_tag($tag_nr)){
                                return false;
                            }
                        }
                    }
                    else{
                        if(!$this->get_prev_searched_tag($tag_nr, $search)){
                            $direction = 'up';
                            if(!$this->get_next_searched_tag($tag_nr, $search)){
                                return false;
                            }
                        }
                    }
                }
                else{
                    if($search == 'undefined'){
                        if(!$this->get_next_tag($tag_nr)){
                            $direction = 'down';
                            if(!$this->get_prev_tag($tag_nr)){
                                return false;
                            }
                        }
                    }
                    else{
                        if(!$this->get_next_searched_tag($tag_nr, $search)){
                            $direction = 'down';
                            if(!$this->get_prev_searched_tag($tag_nr, $search)){
                                return false;
                            }
                        }
                    }
                }
            }
            array_push($tagliste, $this->tagarray);             // Gefundenes Tag in die Liste bernehmen
            $tag_nr = $tagliste[$i]['nummer'];                  // Startwert fr die nchste Abfrage bernehmen

            while($i < $list_max - 1){
                if($direction == 'down'){
                    if($search == 'undefined'){
                        if($this->get_prev_tag($tag_nr)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                    else{
                        if($this->get_prev_searched_tag($tag_nr, $search)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                }
                else{
                    if($search == 'undefined'){
                        if($this->get_next_tag($tag_nr)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                    else{
                        if($this->get_next_searched_tag($tag_nr, $search)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                }
            }

            // Prfen ob es noch ein weiteres gltiges Tag gibt, fr Weiter- bzw. Zurck-Button
            $tag_list_forward = 0;
            $tag_list_reverse = 0;

            if($direction == 'down'){
                $tmp_tag_nr_next = $tag_start;
                $tmp_tag_nr_prev = $tag_nr;
            }
            else{
                $tmp_tag_nr_next = $tag_nr;
                $tmp_tag_nr_prev = $tag_start;
            }

            if($search == 'undefined'){
                if($this->get_next_tag($tmp_tag_nr_next)){
                    $tag_list_forward = 1;
                }
                if($this->get_prev_tag($tmp_tag_nr_prev)){
                    $tag_list_reverse = 1;
                }
            }
            else{
                if($this->get_next_searched_tag($tmp_tag_nr_next, $search)){
                    $tag_list_forward = 1;
                }
                if($this->get_prev_searched_tag($tmp_tag_nr_prev, $search)){
                    $tag_list_reverse = 1;
                }
            }

            if($direction == 'down'){
                $tagliste = array_reverse($tagliste);
            }

            return true;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_searchtaglist() - Tagliste holen */
    public function get_searchtaglist($tag_start,
                                $list_max,
                                &$tag_list_forward,
                                &$tag_list_reverse,
                                &$tagliste,
                                $direction = 'up',
                                $search = 'undefined'){
            $tagliste = array();

			if($search == 'undefined')
				return;

            if(isset($this->sysinfo['tag_anzahl']) && is_numeric($this->sysinfo['tag_anzahl'])
                && $this->sysinfo['tag_anzahl'] > 0){
                $tag_anzahl = $this->sysinfo['tag_anzahl'];
            }
            else{
                $tag_anzahl = 0;
            }

            if(!strlen(trim($search))){
                $search = 'undefined';
            }

            if(!is_numeric($tag_start) || $tag_start < 1){
                $tag_nr = 1;
                $direction = 'up';
            }
            else if($tag_start > $tag_anzahl){
                $tag_nr = $tag_anzahl;
                $direction = 'down';
            }
            else{
                $tag_nr = $tag_start;
            }

            // Erste/letzte (up/down) $tag_nr bei $search individuell ermitteln,
            // wenn $tag_nr nicht dem Suchkriterium entspricht
            $this->tagarray = array();
            if($search != 'undefined' && !$this->check_tag_for_search($tag_nr, $search)){
                if($direction == 'down'){
                    if(!$this->get_prev_searched_tag($tag_nr, $search)){
                        return false;
                    }
                    $tag_nr = $this->tagarray['nummer'];
                }
                else{
                    if(!$this->get_next_searched_tag($tag_nr, $search)){
                        return false;
                    }
                    $tag_nr = $this->tagarray['nummer'];
                }
            }

            $i = 0;
            $this->tagarray = array();
            //echo 'Test: ',$direction,' - ',$tag_nr;
            if(!$this->get_tag_info($tag_nr)){            // Prfen ob die Startnummer ungltig ist
                //echo '<br>Invalid Tag';
                if($direction == 'down'){
                    if($search == 'undefined'){
                        if(!$this->get_prev_tag($tag_nr)){
                            $direction = 'up';
                            if(!$this->get_next_tag($tag_nr)){
                                return false;
                            }
                        }
                    }
                    else{
                        if(!$this->get_prev_searched_tag($tag_nr, $search)){
                            $direction = 'up';
                            if(!$this->get_next_searched_tag($tag_nr, $search)){
                                return false;
                            }
                        }
                    }
                }
                else{
                    if($search == 'undefined'){
                        if(!$this->get_next_tag($tag_nr)){
                            $direction = 'down';
                            if(!$this->get_prev_tag($tag_nr)){
                                return false;
                            }
                        }
                    }
                    else{
                        if(!$this->get_next_searched_tag($tag_nr, $search)){
                            $direction = 'down';
                            if(!$this->get_prev_searched_tag($tag_nr, $search)){
                                return false;
                            }
                        }
                    }
                }
            }
            array_push($tagliste, $this->tagarray);             // Gefundenes Tag in die Liste bernehmen
            $tag_nr = $tagliste[$i]['nummer'];                  // Startwert fr die nchste Abfrage bernehmen

            while($i < $list_max - 1){
                if($direction == 'down'){
                    if($search == 'undefined'){
                        if($this->get_prev_tag($tag_nr)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                    else{
                        if($this->get_prev_searched_tag($tag_nr, $search)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                }
                else{
                    if($search == 'undefined'){
                        if($this->get_next_tag($tag_nr)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                    else{
                        if($this->get_next_searched_tag($tag_nr, $search)){
                            $i++;
                            array_push($tagliste, $this->tagarray);
                            $tag_nr = $tagliste[$i]['nummer'];
                        }
                        else{
                            break;
                        }
                    }
                }
            }

            // Prfen ob es noch ein weiteres gltiges Tag gibt, fr Weiter- bzw. Zurck-Button
            $tag_list_forward = 0;
            $tag_list_reverse = 0;

            if($direction == 'down'){
                $tmp_tag_nr_next = $tag_start;
                $tmp_tag_nr_prev = $tag_nr;
            }
            else{
                $tmp_tag_nr_next = $tag_nr;
                $tmp_tag_nr_prev = $tag_start;
            }

            if($search == 'undefined'){
                if($this->get_next_tag($tmp_tag_nr_next)){
                    $tag_list_forward = 1;
                }
                if($this->get_prev_tag($tmp_tag_nr_prev)){
                    $tag_list_reverse = 1;
                }
            }
            else{
                if($this->get_next_searched_tag($tmp_tag_nr_next, $search)){
                    $tag_list_forward = 1;
                }
                if($this->get_prev_searched_tag($tmp_tag_nr_prev, $search)){
                    $tag_list_reverse = 1;
                }
            }

            if($direction == 'down'){
                $tagliste = array_reverse($tagliste);
            }

            return true;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_timeframe() - Start- und Endezeit individuell ermitteln */
    public function get_timeframe(&$time_start, &$time_end){
        if(is_numeric($this->time_form_end) && $this->time_form_end > 0
        && is_numeric($this->time_form_start) && $this->time_form_start > 0){
            $time_end = $this->time_form_end;
            $time_start = $this->time_form_start;
        }
        else if(is_numeric($this->time_form_end) && $this->time_form_end > 0
        && is_numeric($this->time_form_int) && $this->time_form_int > 0){
            $time_end = $this->time_form_end;
            $time_start = $time_end - $this->time_form_int;
        }
        else if(is_numeric($this->time_form_int) && $this->time_form_int > 0){
            $time_end = time();
            $time_start = $time_end - $this->time_form_int;
        }
        else{
            $time_end = time();
            $time_start = $time_end - 86400;
        }
    }
    /* }}} */

	/**
	 * Setzt Start und EndZeit fuer Diagramm aus Fliessbild
	 * @param number $time_start
	 * @param number $time_end
	 */
    public function get_timeframe_fliess(&$time_start, &$time_end){
        if(is_numeric($this->time_form_end_fliess) && $this->time_form_end_fliess > 0
        && is_numeric($this->time_form_start_fliess) && $this->time_form_start_fliess > 0){
            $time_end = $this->time_form_end_fliess;
            $time_start = $this->time_form_start_fliess;
        }
        else if(is_numeric($this->time_form_end_fliess) && $this->time_form_end_fliess > 0
        && is_numeric($this->time_form_int_fliess) && $this->time_form_int_fliess > 0){
            $time_end = $this->time_form_end_fliess;
            $time_start = $time_end - $this->time_form_int_fliess;
        }
        else if(is_numeric($this->time_form_int_fliess) && $this->time_form_int_fliess > 0){
            $time_end = time();
            $time_start = $time_end - $this->time_form_int_fliess;
        }
        else{
            $time_end = time();
            $time_start = $time_end - 86400;
        }
    }

    /* {{{ PHP-Klassenfunktion trimTime() - Timestamp(unix) auf Intervallgrenzen gerademachen */
	private function trimTime($time, $inter){
		$rest = 0;
						
		$rest = $time % $inter;
		if($rest > 0){
			$time = $time - $rest;
		}
		return $time;
	}
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_user() - Getter fr user */
    public function get_user(){
        return $this->user;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion get_user_property() - Liefert zum Namen das User-Property vom Scalarvis-Server */
    private function get_user_property($name){
        $socket_buffer = sprintf('GETUSERPROPERTY,%s', $name);
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, $this->MESSAGE_SIZE);
        if(stristr($socket_buffer, 'ERROR')){
            return false;
        }
        else{
            $socket_buffer = substr($socket_buffer, 16); // Getuserproperty abschneiden
            $socket_buffer = substr($socket_buffer, (strpos($socket_buffer, ',') + 1)); // Namen und Komma abschneiden
            if(trim($socket_buffer) == '!'){
                return false;
            }
        }
        return $socket_buffer;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion is_ks_valid() - Prfen, ob Kurvensatz gltig ist */
    private function is_ks_valid($ks){
        $retval = false;

        if(isset($this->sysinfo['kurven_anzahl']) && is_numeric($this->sysinfo['kurven_anzahl'])
            && $this->sysinfo['kurven_anzahl'] > 0){
            $kurven_anzahl = $this->sysinfo['kurven_anzahl'];
        }
        else{
            $kurven_anzahl = 0;
        }

        if(isset($ks[0]) && is_numeric($ks[0]) && $ks[0] >= 1 && $ks[0] <= $kurven_anzahl
            && isset($ks[24]) && $ks[24] != -2){
            $retval = true;
        }
        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion load_user_properties() - Ldt die User-Konfiguration */
    public function load_user_properties(){
        global $STANDARD_CONFIG;
        global $g_path_separator;
        global $g_user_config_field_array;
        $retval = false;

        foreach($g_user_config_field_array as $config_field){
            if(isset($STANDARD_CONFIG[$config_field])){
                $this->USER_CONFIG[$config_field] = $STANDARD_CONFIG[$config_field];
            }
        }

        if(!empty($STANDARD_CONFIG['USER_CONFIG_FILES'])){
            $conf_dir = 'user_config';
            $conf_filename = str_replace('.', '_', strtolower($this->user.'__'.$this->host.'__'.$this->port)).'.conf';

            if(is_file($conf_dir.$g_path_separator.$conf_filename)){
                if($conf_fp = fopen($conf_dir.$g_path_separator.$conf_filename, 'r')){
                    $socket_buffer = fgets($conf_fp, $this->MESSAGE_SIZE);
                    fclose($conf_fp);
                    $retval = true;
                }
            }
        }
        else{
            $socket_buffer = $this->get_user_property('WEB$CONF');
        }

        // Wenn es Daten gibt
        if(!empty($socket_buffer) && strlen(trim($socket_buffer))){
            $socket_buffer = __unserialize($socket_buffer);
            if(is_array($socket_buffer)){
                $keys = array_keys($socket_buffer);
                for($i = 0; $i < count($keys); $i++){
                    $this->USER_CONFIG[$keys[$i]] = $socket_buffer[$keys[$i]];
                }
                $retval = true;
            }
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion ole_to_utc() - Wandelt das Zeitformat OLE (Double) in UTC (Integer) um */
    private function ole_to_utc($ole){
        // 25569 = OLE-Zeitformat (Excel) 01.01.1970
        if($ole > 25569){
            $ole -= 25569;
        }
        return (int) round($ole * 86400);
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion read_archiv() - Archiv lesen */
    /**
     * @return array(Blockinfo, Datenblock(Tag1), Datenblock(Tag2), ...)
     * @desc Liest Archivdaten
     */
    public function read_archiv($from,
                                $to,
                                $tags,
                                $amount = 500,
                                $data_type = 'univ',
                                $selection = 1){
        // Fehlerabfrage ergnzen (< Maxtags)?
        if($data_type == 'detail'){
            $buf = $this->set_arcs($from, $to, $tags);
            if($buf){
                $anz = intval(substr($buf, 5, strlen($buf) - 24));  // String aufs Wesentliche reduzieren
            }
            else{
                return -1;
            }
        }
        else if($data_type == 'trend'){
            $buf = $this->set_trend($from, $to, $tags);
            if($buf){
                $anz = intval(substr($buf, 6, strlen($buf) - 24));  // String aufs Wesentliche reduzieren
            }
            else{
                return -1;
            }
        }
        else{   // universal
            $buf = $this->set_arct($from, $to, $tags);
            if($buf){
                $anz = intval(substr($buf, 5, strlen($buf) - 24));  // String aufs Wesentliche reduzieren
            }
            else{
                return -1;
            }
        }
		
        if($anz == 0){
            return 0;
        }
        else{
            //$buf=array(Auslesebeginn,anztag,anzval(server),StartOffset,AnzWerte(zurckgeliefert),Intervall,Blocksize,Blockanz,Schrittweite,Tags[MAXAWTAGS])
            //$buf=$this->get_block_info(($to-$from)/$this->sysinfo['intervall']+1); //Zeitintervall durch Systemintervall ergibt die Anzahl an Sttzstellen
			$buf = $this->get_block_info($amount);      // Zeitintervall durch Systemintervall ergibt die Anzahl an Sttzstellen
            $erg[] = $buf;      // Blockinfo ist das erste Element des Ergebnisses, gefolgt von jeweils einem Element pro Tag
            return $erg;
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion scalarvis_time() - Gibt in Abhngigkeit der Konfiguration die gewnschte Uhrzeit zurck */
    public function scalarvis_time(){
        if($this->USER_CONFIG['TIME_SOURCE'] == 'SCALARVIS'){
            return $this->get_server_utc_time();
        }
        else{
            // UNIX-Timestamp in UTC
            return time();
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion server_command() - Setzen eines Server Commands */
    // Die Implementierung der Serverbefehle ist zur besseren Orientierung
    // mit Commands an das messvb1.ocx angelehnt und bereinstimmend
    private function server_command($cmd_nbr){
        $retval = false;

        switch($cmd_nbr){
        case 50:    // Server auf Einzelpunkte im Archiv setzen
            socket_write_all($this->socket, 'NOJOIN,');
            $socket_buffer = socket_read_all($this->socket, 512);
            if(stristr($socket_buffer, 'NOJOIN,***DONE***')){
                $retval = true;
            }
            break;
        case 51:    // Server auf UTC setzen
            socket_write_all($this->socket, 'TIMEBASEUTC,');
            $socket_buffer = socket_read_all($this->socket, 512);
            if(stristr($socket_buffer, 'TIMEBASEUTC,***DONE***')){
                $retval = true;
            }
            break;
        case 52:    // Server auf Local time setzen
            socket_write_all($this->socket, 'TIMEBASELOCAL,');
            $socket_buffer = socket_read_all($this->socket, 512);
            if(stristr($socket_buffer, 'TIMEBASELOCAL,***DONE***')){
                $retval = true;
            }
            break;
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_arcs() - Detailauslesen der Archivdaten (Archiv lesen) */
    private function set_arcs($from, $to, $tags){
        if($to <= 0 || $from <= 0){
            return -1;
        }
        else{
            // Server auf UTC-Zeitrechnung setzen
            $this->server_command(51);

            $socket_buffer = sprintf('ARCS,%s,%s,%s,%s,%d,%s,',
                                     gmdate('d.m.y', $from),
                                     gmdate('H:i:s', $from),
                                     gmdate('d.m.y', $to),
                                     gmdate('H:i:s', $to),
                                     count($tags),
                                     $this->array_to_string($tags));
            socket_write_all($this->socket, $socket_buffer);
            return socket_read_all($this->socket, 512);
        }
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_arct() - Universalauslesen der Archivdaten (Archiv lesen) */
	// dotjoin = false --> es werden keine Einzelpunkte gelesen
    public function set_arct($from, $to, $tags, $dotjoin=false){
        $retval = -1;
		$out="";
        if(is_numeric($from) && ($from > 0)
            && is_numeric($to) && ($to > 0) ){
            // Server auf UTC-Zeitrechnung setzen
            $this->server_command(51);
			// Server auf Einzelpunkte setzen
			if($dotjoin == true){
				$this->server_command(50);
				for($ii=0;$ii<count($tags);$ii++)
				{
					$nr = 0;
					if((isset($tags[$ii])) && ($tags[$ii] > 0))
					{
					$nr = $tags[$ii];
					}
					$out .= ($out!==''?",$nr":"$nr");
				}
				$socket_buffer = sprintf('ARCT,%s,%s,%s,%s,%d,%s,',
                                     gmdate('d.m.y', $from),
                                     gmdate('H:i:s', $from),
                                     gmdate('d.m.y', $to),
                                     gmdate('H:i:s', $to),
                                     count($tags),
                                     $out);
			}
			else{
            $socket_buffer = sprintf('ARCT,%s,%s,%s,%s,%d,%s,',
                                     gmdate('d.m.y', $from),
                                     gmdate('H:i:s', $from),
                                     gmdate('d.m.y', $to),
                                     gmdate('H:i:s', $to),
                                     count($tags),
                                     $this->array_to_string($tags));
			}
            socket_write_all($this->socket, $socket_buffer);
            $retval = socket_read_all($this->socket, 512);
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_ks() - Kurvensatz schreiben (Parametersatz speichern) */
    public function set_ks($ksnumber, $ksname){
        $retval = false;

        // $ksnumber von Kommas befreien
        str_replace(',', '', $ksnumber);
        //echo $ksnumber, $ksname;
        $socket_buffer = sprintf('SETKSATZ,%d,%-80.80s', $ksnumber, $ksname);
        for($i = 0; $i < $this->number_of_tags; $i++){ // Tagauswahl fr Tagnummern durchlaufen
            if(isset($this->tagauswahl[$i]['nummer'])){
                $socket_buffer .= ','.$this->tagauswahl[$i]['nummer'];
            }
            else{
                $socket_buffer .= ',0';
            }
        }
        for($i = 0; $i < $this->number_of_tags; $i++){ // Tagauswahl fr DBA durchlaufen
            if(isset($this->tagauswahl[$i]['dba']) && is_numeric($this->tagauswahl[$i]['dba'])){
                $socket_buffer .= ','.$this->tagauswahl[$i]['dba'];
            }
            else{
                $socket_buffer .= ',-1.0e+038';
            }
        }
        for($i = 0; $i < $this->number_of_tags; $i++){ // Tagauswahl fr DBE durchlaufen
            if(isset($this->tagauswahl[$i]['dbe']) && is_numeric($this->tagauswahl[$i]['dbe'])){
                $socket_buffer .= ','.$this->tagauswahl[$i]['dbe'];
            }
            else{
                $socket_buffer .= ',-1.0e+038';
            }
        }

        // Zeit von/bis
        if(isset($this->time_start) && is_numeric($this->time_start)
            && isset($this->time_end) && is_numeric($this->time_end)
            && $this->time_start < $this->time_end){
            $socket_buffer .= ','.localdate('d.m.y,H:i', $this->time_start);
            $socket_buffer .= ','.localdate('d.m.y,H:i', $this->time_end);
            $socket_buffer .= ',-1';
        }
        // Zeit von/bis berspringen und dafr Intervall setzen
        else if(isset($this->time_form_int) && is_numeric($this->time_form_int) && $this->time_form_int > 0){
            $socket_buffer .= ',00.00.00,00:00,00.00.00,00:00,'.sprintf('%d', $this->time_form_int);
        }
        // Ansonsten gar nichts setzen
        else{
            $socket_buffer .= ',00.00.00,00:00,00.00.00,00:00,0';
        }

        //echo '<br>$socket_buffer: ',$socket_buffer;
        socket_write_all($this->socket, $socket_buffer);
        $socket_buffer = socket_read_all($this->socket, 8096);
        //echo '<br>$socket_buffer: ',$socket_buffer;
        if(strstr($socket_buffer, 'OK')){
            $retval = true;
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_time_by_int() - Setzt Intervall auf Wert und Zeitrahmen auf NULL */
    public function set_time_by_int($time_int){
        $retval = false;

        if(is_numeric($time_int)){
            $this->time_form_int = (int) $time_int;
            $this->time_start = $this->time_form_start = null;
            $this->time_end = $this->time_form_end = null;
            $retval = true;
        }
        else{
            $this->set_time_to_null();
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_time_by_int_and_end() - Setzt Zeitrahmen und Intervall anhand von Intervall und Endzeit */
    public function set_time_by_int_and_end($time_int, $time_end){
        $retval = false;

        if(is_numeric($time_int) && is_numeric($time_end)){
            $this->time_form_int = (int) $time_int;
            $this->time_start = $this->time_form_start = $time_end - $this->time_form_int;
            $this->time_end = $this->time_form_end = (int) $time_end;
            $retval = true;
        }
        else{
            $this->set_time_to_null();
        }

        return $retval;
    }
    /* }}} */

    /**
     * Setzt Zeitrahmen und Intervall anhand von Intervall und Endzeit aus Fliessbild heraus
     * @param number $time_int Intervall in sec
     * @param number $time_end Endzeit in sec
     * @return boolean
     */
    public function set_time_by_int_and_end_fliess($time_int, $time_end){
        $retval = false;

        if(is_numeric($time_int) && is_numeric($time_end)){
            $this->time_form_int_fliess = (int) $time_int;
            $this->time_start_fliess = $this->time_form_start_fliess = $time_end - $this->time_form_int_fliess;
            $this->time_end_fliess = $this->time_form_end_fliess = (int) $time_end;
            $retval = true;
        }
        else{
            $this->set_time_to_null_fliess();
        }

        return $retval;
    }

    /* {{{ PHP-Klassenfunktion set_time_by_start_and_end() - Setzt Zeitrahmen und Intervall anhand Start- und Endzeit */
    public function set_time_by_start_and_end($time_start, $time_end){
        $retval = false;

        if(is_numeric($time_start) && is_numeric($time_end)){
            $this->time_start = $this->time_form_start = $time_start;
            $this->time_end = $this->time_form_end = $time_end;
            $this->time_form_int = $this->time_form_end - $this->time_form_start;
            if($this->time_form_int < 0){
                $this->time_form_int = 0;
            }
            $retval = true;
        }
        else if(is_numeric($time_start)){
            $this->time_start = $this->time_form_start = $time_start;
            $this->time_end = $this->time_form_end = null;
            $this->time_form_int = null;
        }
        else if(is_numeric($time_end)){
            $this->time_start = $this->time_form_start = null;
            $this->time_end = $this->time_form_end = $time_end;
            $this->time_form_int = null;
        }
        else{
            $this->set_time_to_null();
        }

        return $retval;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_time_to_null() - Setzt Zeitrahmen und Intervall auf NULL zurck */
    public function set_time_to_null(){
        $this->time_start = $this->time_form_start = null;
        $this->time_end = $this->time_form_end = null;
        $this->time_form_int = null;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_time_to_null() - Setzt Zeitrahmen und Intervall auf NULL zurck */
    public function set_time_to_null_fliess(){
        $this->time_start_fliess = $this->time_form_start_fliess = null;
        $this->time_end_fliess = $this->time_form_end_fliess = null;
        $this->time_form_int_fliess = null;
    }
    /* }}} */

    /* {{{ PHP-Klassenfunktion set_trend() - Informationen fr Archivdaten-Lesen setzen -> entspricht der Detailkurve (Archiv lesen) */
    private function set_trend($from, $to, $tags){
        if($to <= 0 || $from <= 0){
            return -1;
        }
        else{
            // Server auf UTC-Zeitrechnung setzen
            $this->server_command(51);

            $socket_buffer = sprintf('TREND,%s,%s,%s,%s,%d,%s,',
                                     gmdate('d.m.y', $from),
                                     gmdate('H:i:s', $from),
                                     gmdate('d.m.y', $to),
                                     gmdate('H:i:s', $to),
                                     count($tags),
                                     $this->array_to_string($tags));
            socket_write_all($this->socket, $socket_buffer);
            return socket_read_all($this->socket, 512);
        }
    }
    /* }}} */
}

?>
