<?php

// vim: fdm=marker

/************************************************
*  PSG RS 20150213		   						*
*	Zeigt Statistikdaten in einem Formular an	*
*************************************************/

ob_start();
require('scalarvis.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if(!start_session($sv)){
    session_no_longer_valid_msg();
}

if(!$sv->connect()){
    echo '<br />',get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    jsEscWindowClose();
    exit;
}

$type_text = "Statistik";

// Keine Tags ausgewhlt
$version=$sv->get_client_version();
if($version < 1.4){
    jsWindowClose('Server mit Client-Version > \''.$version.'\' erforderlich!!');
    exit('Server mit Client-Version > \''.$version.'\' erforderlich!!');
}

// Keine Tags ausgewhlt
if(!count($sv->tagauswahl)){
    jsWindowClose($text_array[$sv->lang_id]['no_tags_selected'].'!');
    exit($text_array[$sv->lang_id]['no_tags_selected'].'!');
}

$from = 0;
$to = 0;
$sv->get_timeframe($from, $to);
$interval = $sv->sysinfo['intervall'];
$from = round_time($from, $interval);
$to = round_time($to, $interval);
$fromText = localdate_std($from, true);
$toText = localdate_std($to, true);

$anzval = 0;
$data = null;
$run = $sv->number_of_tags;
for($ii=0;$ii<$run;$ii++){
	$tags[$ii] = -1;
    if((!isset($sv->tagauswahl[$ii]['invalid']) || $sv->tagauswahl[$ii]['invalid'] == 0) && (isset($sv->tagauswahl[$ii]['nummer']))){
        $tags[$ii] = $sv->tagauswahl[$ii]['nummer'];
    }
//echo $tags[$ii];
}
/* {{{ Daten aufbereiten und Darstellung bestimmen */
// Am Ende stehen alle errechneten Werte in $Autoscaling
// Hier DAten vom System lesen aus scalarvis.inc.php
//$data=array(Auslesebeginn,anztag,anzval(server),StartOffset,AnzWerte(zurckgeliefert),Intervall,Blocksize,Blockanz,Schrittweite,Tags[MAXAWTAGS])

$anzval = $sv->get_statistic_data($tags, $from, $to, $data);

// Wenn ein Kurvensatz angezeigt werden soll, wird die Bezeichnung in die berschrift gesetzt
(isset($sv->ks_auswahl)?$ks_bezeichnung = htmlspecialchars($sv->ks_auswahl[1]):$ks_bezeichnung = '');
$ks_bezeichnung = trim($ks_bezeichnung);
/* }}} */

include('cont_top.inc.php');

echo '
</head>';

/* {{{ HTML-Body */
echo '
<!-- Ueberbau -->
<body style="padding: 5px;">
<form name="statistikform">
<input type="hidden" name="session_name" value="',$svweb_session_name,'">

<table border="0" align="center" cellspacing="0" cellpadding="0" summary="Basic Statistic Table">
<tr>
    <td style="padding-top: 10px;padding-bottom: 10px;" align="center">

    <table border="0" cellspacing="0" cellpadding="0" summary="Headline Statistic Table">
    <tr>
        <td rowspan="2" width="40">
		<!-- rowspan mehrere Zeilen miteinander verbinden --> 
        <button class="icon_button_width" name="bt_print" type="button"
            onclick="window.print()" title="',$text_array[$sv->lang_id]['print'],'">
        <img alt="',$text_array[$sv->lang_id]['print'],'" title="',$text_array[$sv->lang_id]['print'],'"
            src="print.gif" width="21" height="21">
        </button>
        </td>
		<td style="font-size: 13px; padding-right: 5px;" align="right" width="80">',$type_text,':</td>
        <td style="font-size: 13px; font-weight: bold;">
        ',line_breaks2spaces(dotted_if_too_long($ks_bezeichnung, 45)),'
        </td>
    </tr><tr>
        <td style="padding-top: 0px; padding-right: 5px;" align="right" width="80">
        <span style="font-variant: normal; font-size: 13px;">',$text_array[$sv->lang_id]['timeframe'],':</span>
        </td>
		<td style="padding-top: 0px;">
        <span id="timefrom" style="font-size: 13px; font-weight: bold;">',$fromText,' - ',$toText,'</span>
		</td>
    </tr>
    </table>

    </td>
</tr>
</table>

';

    if(!isset($data)){
        echo 'No data!';
    }
    else if($data < 0){
        echo 'Invalid data!';
    }
    else
	{
	//
	//var_dump($sv->sysinfo);
	//print_r_formatted($data);
	//print_r($run);
	//print_r_formatted($sv->tagauswahl);
	//var_dump($sv->tagauswahl);
        // Erstellung der Taginformationen aus der Tagtabelle
        // Paddings: Oben, rechts, unten, links
		for($i = 0; $i < $run; $i++){
			if( (isset($sv->tagauswahl[$i]['nummer'])) && ($sv->tagauswahl[$i]['nummer'] > 0) 
				&& ((!isset($sv->tagauswahl[$i]['invalid'])) || ($sv->tagauswahl[$i]['invalid'] == 0))
			){
	//print_r($sv->tagauswahl[$i]['dba']!=="");
				if((isset($sv->tagauswahl[$i]['info'])) && (strlen($sv->tagauswahl[$i]['info']) > 0)){
					$tmp_name_info = htmlspecialchars($sv->tagauswahl[$i]['name'].', '.$sv->tagauswahl[$i]['info']);
				}
				else{
					$tmp_name_info = htmlspecialchars($sv->tagauswahl[$i]['name']);
				}
				//print_r(($data[2]['minpos_'.$i] * sv->sysinfo['intervall']);
				$minText = localdate_std($from + ($data[2]['minpos_'.$i] * $sv->sysinfo['intervall']), true);
				$maxText = localdate_std($from + $data[2]['maxpos_'.$i] * $sv->sysinfo['intervall'], true);
				$firstText = localdate_std($from + $data[2]['firstpos_'.$i] * $sv->sysinfo['intervall'], true);
				echo '
			<table style="border-top-style:solid;border-width:thin" width="100%" border="0" align="center" cellspacing="0" cellpadding="2" summary="TAGInhalte">
				<tr style="color: blue; font-weight: bold;">
					<td width="5%">TAG</td>
					<td align="center" width="10%">'
					,htmlspecialchars($sv->tagauswahl[$i]['nummer']),
					'</td>
					<td style="width: 60%; " nowrap>',$tmp_name_info,'</td>
					<td id="db_',$i,'" align="left" >Bereich: '
					,($sv->tagauswahl[$i]['dba']!==""?$sv->tagauswahl[$i]['dba']:$data[2]['min_'.$i]), ' - '
					,($sv->tagauswahl[$i]['dbe']!==""?$sv->tagauswahl[$i]['dbe']:$data[2]['max_'.$i]),
					' ',htmlspecialchars($sv->tagauswahl[$i]['einheit']),
					'</td>
				</tr>
			</table>
			<!-- Die Reihen die durch einen Klick auf das Bild geklappt werden -->
			<table border="0" cellspacing="1" cellpadding="0" width="80%" summary="StatistikWerte aufgeklappt">
				<tr>
				<td width="5%"></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Anzahl/Gesamt:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',$data[2]['anz_'.$i],' / ',$data[2]['index'],'" readonly></td>
				<td width="5%"></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">1. gltiger Wert:</td>
				<td style="padding-left: 5px;" align="right" width="15%">',$firstText,'</td>
				</tr>
				<tr>
				<td width="5%"></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Summe:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',formatdouble($data[2]['sum_'.$i]),'" readonly></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Minimum:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',formatdouble($data[2]['min_'.$i]),'" readonly></td>
			    <td><input class="grayed_input" style="text-align: right;" value="',$minText,'" readonly></td>
				</tr>
				<tr>
				<td width="5%"></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Mittelwert:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',formatdouble($data[2]['avg_'.$i]),'" readonly></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Maximum:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',formatdouble($data[2]['max_'.$i]),'" readonly></td>
			    <td><input class="grayed_input" style="text-align: right;" value="',$maxText,'" readonly></td>
				</tr>
				<tr>
				<td width="5%"></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Stand.-abw:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',formatdouble($data[2]['stdabw_'.$i]),'" readonly></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Korrelation:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',formatdouble($data[2]['korr_'.$i]),'" readonly></td>
				<td></td>
				</tr>
				<tr>
				<td width="5%"></td>
				<td style="padding-right: 5px; font-weight: bold;" align="right" width="15%">Regression:</td>
			    <td><input class="grayed_input" style="text-align: right;" value="',formatdouble($data[2]['regb_'.$i]),' /h * X + ',formatdouble($data[2]['rega_'.$i]),'" readonly></td>
				</tr><tr>
				<td colspan="6" valign="top" style="padding-top: 1px;">&nbsp;</td>
				</tr>
			</table>
				';
			}
		}
		echo '
		</table>';
    }
	echo '

<script type="text/javascript">
<!--
';
if(strlen(trim($type_text))){
    echo '
    document.title = "',trim($type_text.' '.line_breaks2spaces(dotted_if_too_long($ks_bezeichnung, 45))),'";
	';
}
echo '
//-->
</script>
</form>
</body>';
/* }}} */

include('cont_bottom.inc.php');

/* {{{ Logfiles schreiben */
if($STANDARD_CONFIG['WRITE_LOGFILES']){
    $tmp_status = '  PERIOD: '.localdate_std($sv->time_start).' - '.localdate_std($sv->time_end);
    $tmp_status .= '  TAGS: ';
    $i = 0;
    foreach($sv->tagauswahl as $tmp_tag){
		if( (isset($tmp_tag['nummer'])) && ($tmp_tag['nummer'] > 0) 
			&& ((!isset($tmp_tag['invalid'])) || ($tmp_tag['invalid'] == 0))){
            if($i > 0){
                $tmp_status .= ', ';
            }
            $tmp_status .= $tmp_tag['nummer'];
            $i++;
        }
    }
    $tmp_type = 'statistic';
    write_logfile($tmp_type, $sv->get_user(), $sv->get_host(), $sv->get_port(), $tmp_status);
}
/* }}} */

store_session($sv);

?>

