<?php
// vim: fdm=marker

/* * **********************************************
 *  PSG RS 20150317		   						*
 * 	Zeigt TAGInfodaten fuer ein TAG in einem Formular an	*
 * *********************************************** */

ob_start();
require('scalarvis.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if (!start_session($sv)) {
    session_no_longer_valid_msg();
}

if (!$sv->connect()) {
    echo '<br />', get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    jsEscWindowClose();
    exit;
}

$type_text = "TAGInfo";

$typ = -1;
$typname = '';
$objectnr = '';
$register = '';
$tagnr = -1;
$openerid = '';

$error = null;

if (isset($_GET['openerid'])) {
    $openerid = trim($_GET['openerid']);
}

if (isset($_GET['tagnr']) && strlen(trim($_GET['tagnr'])) && is_numeric($_GET['tagnr'])) {
    $tagnr = trim($_GET['tagnr']);
}

if ($tagnr <= 0) {
    //jsEscWindowClose('No SV_TAG defined!');
    $error = 'No SV_TAG defined!';
}

if ($sv->get_tag_info_array_formatted($tagnr, $tagnr_info_array) == 0) {
    //jsEscWindowClose('No SV_TAG_Info defined! ' . $tagnr);
    $error = 'No SV_TAG_Info defined!' . $tagnr;
}

if (isset($_GET['tagtyp']) && strlen(trim($_GET['tagtyp']))) {
    $typ = trim($_GET['tagtyp']);
    $format = sprintf("TT%03s", $typ);
    $typname = $text_array[$sv->lang_id][$format];
}

if (isset($_GET['objectnr']) && strlen(trim($_GET['objectnr']))) {
    $objectnr = trim($_GET['objectnr']);
}

if (isset($_GET['register']) && strlen(trim($_GET['register']))) {
    $register = trim($_GET['register']);
}
$openerid = sprintf("%03s", $objectnr);
$objectnr = sprintf("%03s.%03s", $register, $objectnr);
?>

<?php
if (!is_null($error)) {
    ?>
    <div id="close">
        <div class="btn">x</div>
    </div>
    <div id="errorsection">
        <?php echo $error; ?>
    </div>
    <?php
} else {
    ?>
    <div id="close">
        <div class="btn">x</div>
    </div>
    <div id="topsection">
        <div id="print">
            <button class="icon_button_width print">
                <img src="../print.gif" alt="<?php echo $text_array[$sv->lang_id]['print']; ?>">
            </button>
        </div>
        <div id="tagtitle"><?php echo $text_array[$sv->lang_id]['tag_no'] . ' = ' . $tagnr; ?> </div>
    </div>
    <div id="contentsection">
        <div class="data">
            <div class="label"><?php echo $text_array[$sv->lang_id]['name']; ?></div>
            <div class="tagdata"><?php echo utf8_encode($tagnr_info_array['name']); ?></div>
        </div>
        <div class="data">
            <div class="label"><?php echo $text_array[$sv->lang_id]['unit']; ?></div>
            <div class="tagdata"><?php echo utf8_encode($tagnr_info_array['einheit']); ?></div>
        </div>
        <div class="data">
            <div class="label"><?php echo $text_array[$sv->lang_id]['function']; ?></div>
            <div class="tagdata"><?php echo utf8_encode($tagnr_info_array['fkt']); ?></div>
        </div>
        <div class="data">
            <div class="label"><?php echo $text_array[$sv->lang_id]['curr_value']; ?></div>
            <div class="tagdata"><?php echo utf8_encode($tagnr_info_array['wert']); ?></div>
        </div>
        <div class="data">
            <div class="label"><?php echo $text_array[$sv->lang_id]['info']; ?></div>
            <div class="tagdata"><?php echo utf8_encode($tagnr_info_array['info']); ?></div>
        </div>
        <div class="data">
            <div class="label"><?php echo $text_array[$sv->lang_id]['dba']; ?></div>
            <div class="tagdata"><?php echo $tagnr_info_array['dba']; ?></div>
        </div>
        <div class="data">
            <div class="label"><?php echo $text_array[$sv->lang_id]['dbe']; ?></div>
            <div class="tagdata"><?php echo $tagnr_info_array['dbe']; ?></div>
        </div>
        <div class="data">
            <div class="label">Status</div>
            <div class="tagdata"><?php echo utf8_encode($tagnr_info_array['status']); ?></div>
        </div>
        <div class="data">
            <div class="label">Object</div>
            <div class="tagdata"><?php echo $objectnr; ?></div>
        </div>
        <div class="data">
            <div class="label">TagTyp</div>
            <div class="tagdata"><?php echo utf8_encode($typ . ' ' . $typname); ?></div>
        </div>
		<div class="data">
			<div class="version">v&nbsp<?php echo $g_version; ?>a</div>
        </div>
    </div>
<?php } ?>
<script>
    $(function () {
        $("#infowindow").find('.print').on('click', function () {
            $.print("#infowindow");
        });

        $('.btn').on('click', function () {
            $('#infowindow').hide();
        });
    });
</script>