<?php

// vim: fdm=marker

/**********************
*  Andy Geiss 2009    *
*  Tabulatorweite: 4  *
**********************/

ob_start();
require('scalarvis.inc.php');
ob_end_clean();
nocache();

error_reporting(E_ALL);

if(!start_session($sv)){
    session_no_longer_valid_msg();
}

if(!$sv->connect()){
    echo '<br>',get_sv_socket_errorstr_from_errno($sv->lang_id, $sv->get_socket_errno(), $sv->get_socket_last_error());
    exit;
}

/* {{{ Variablen initialisieren */
$actionfile = 'timeform.php';                   // Standard-File fr ACTION-Attribut des FORM-TAGs
// L TODO: Werden $prev_time_form_start und $prev_time_form_end auch wirklich gebraucht?
$prev_time_form_start = $sv->time_form_start;   // time_form_start merken, bevor er mit den Submit-Werten berschrieben wird
$prev_time_form_end = $sv->time_form_end;       // time_form_end merken, bevor es mit den Submit-Werten berschrieben wird
$check_partial_time_form_start = check_partial_time_form('start');
$check_partial_time_form_end = check_partial_time_form('end');
/* }}} */

include('cont_top.inc.php');

/* {{{ Werte ermitteln/Variablen belegen */
// submit_action verarbeiten
if(!empty($_GET['submit_action'])){
    switch($_GET['submit_action']){
    case 'change_hour_from':
    case 'change_minute_from':
    case 'change_second_from':
    case 'change_month_from':
    case 'change_day_from':
    case 'change_year_from':
        $tmp_time_start = get_time_from_get_submit('from', (isset($prev_time_form_start)?false:true));
        $tmp_time_end = get_time_from_get_submit('to', false);
        $sv->set_time_by_start_and_end($tmp_time_start, $tmp_time_end);
        break;
    case 'change_hour_to':
    case 'change_minute_to':
    case 'change_second_to':
    case 'change_month_to':
    case 'change_day_to':
    case 'change_year_to':
        $tmp_time_start = get_time_from_get_submit('from', false);
        $tmp_time_end = get_time_from_get_submit('to', (isset($prev_time_form_end)?false:true));
        $sv->set_time_by_start_and_end($tmp_time_start, $tmp_time_end);
        break;
    case 'change_day_int':
    case 'change_hour_int':
    case 'change_minute_int':
    case 'change_second_int':
        $tmp_time_int = get_time_int_from_get_submit();
        $tmp_time_end = get_time_from_get_submit('to', false);
        if(is_numeric($tmp_time_end)){
            $sv->set_time_by_int_and_end($tmp_time_int, $tmp_time_end);
        }
        else{
            $sv->set_time_by_int($tmp_time_int);
        }
        break;
    case 'empty_timeform':
        $sv->set_time_to_null();
        break;
    }
}
/* }}} */

//print_r_formatted($_GET);
//echo '<br>$prev_time_form_start: ',$prev_time_form_start;
//echo '<br>$sv->time_form_start: ',$sv->time_form_start;
//echo '<br>$prev_time_form_end: ',$prev_time_form_end;
//echo '<br>$sv->time_form_end: ',$sv->time_form_end;
//echo '<br>$check_partial_time_form_start: ',($check_partial_time_form_start?'true':'false');
//echo '<br>$check_partial_time_form_end: ',($check_partial_time_form_end?'true':'false');

/* {{{ JavaScript-Funktionen */
echo '
<script type="text/javascript">
<!--

function change_timeframe(submit_action){
    document.timeform.submit_action.value = submit_action;
    document.timeform.submit();
}

function change_timespan(submit_action){
    document.timeform.submit_action.value = submit_action;
    document.timeform.submit();
}

function empty_timeform(){
    document.timeform.submit_action.value = "empty_timeform";
    document.timeform.submit();
}

//-->
</script>';
/* }}} */

echo '
</head>

<body>
<div align="center" style="margin-top: 10px;">
<form name="timeform" action="',$actionfile,'" method="GET">';
/* {{{ Zeitauswahl-HTML-Tabelle */
echo '
<input type="hidden" name="content" value="',$content,'">
<input type="hidden" name="session_name" value="',$svweb_session_name,'">
<input type="hidden" name="submit_action" value="change_day_int">
<table style="border-style: inset; border-width: 4px;" border="0" cellspacing="0" cellpadding="5" summary="Time Form">
<tr>
<td>&nbsp;</td>
<td>',$text_array[$sv->lang_id]['date'],'</td>
<td>',$text_array[$sv->lang_id]['time'],'</td>
<td style="text-align: center; font-weight: bold;">',$text_array[$sv->lang_id]['timeframe'],'</td>
<td style="text-align: right;">',$text_array[$sv->lang_id]['date'],'</td>
<td style="text-align: right;">',$text_array[$sv->lang_id]['time'],'</td>
<td>&nbsp;</td>
<td colspan="2" style="font-weight: bold;">',$text_array[$sv->lang_id]['timespan'],'</td>
</tr><tr>
<td style="text-align: right;">',$text_array[$sv->lang_id]['from'],'</td>
<td>

<table border="0" cellspacing="0" cellpadding="0" summary="Date-From Table">
<tr>
<td>
<select class="colored_input" name="day_from" onchange="change_timeframe(\'change_day_from\')">';
// L TODO: Obergrenze in Abhngigkeit von Monat und (Schalt-)Jahr beschrnken? -> Standardobergrenze per PHP und aber mit JavaScript-OnChange ndern
// L TODO: Hkchen "Zeitraum beibehalten" (Zeitraum wird bei Parametersatzwechsel beibehalten)
$tmp_selected = get_tmp_selected($check_partial_time_form_start, 'day_from', 'j', $sv->time_form_start, $prev_time_form_start);
show_select_options($tmp_selected, 1, 31);
echo '
</select>
</td><td>
<select class="colored_input" name="month_from" onchange="change_timeframe(\'change_month_from\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_start, 'month_from', 'n', $sv->time_form_start, $prev_time_form_start);
show_select_options($tmp_selected, 1, 12, 'month');
echo '
</select>
</td><td>
<select class="colored_input" name="year_from" onchange="change_timeframe(\'change_year_from\')">';
// L TODO: Jahreszahlen variabel in Abhngigkeit des ausgewhlten Jahres darstellen?
$tmp_selected = get_tmp_selected($check_partial_time_form_start, 'year_from', 'Y', $sv->time_form_start, $prev_time_form_start);
show_select_options($tmp_selected, 1990, 2099, 'year');
echo '
</select>
</td>
</tr>
</table>

</td><td>

<table border="0" cellspacing="0" cellpadding="0" summary="Time-From Table">
<tr>
<td>
<select class="colored_input" name="hour_from" onchange="change_timeframe(\'change_hour_from\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_start, 'hour_from', 'G', $sv->time_form_start, $prev_time_form_start);
show_select_options($tmp_selected, 0, 23);
echo '
</select>
</td><td>
<select class="colored_input" name="minute_from" onchange="change_timeframe(\'change_minute_from\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_start, 'minute_from', 'i', $sv->time_form_start, $prev_time_form_start);
show_select_options($tmp_selected, 0, 59);
echo '
</select>
</td><td>
<select class="colored_input" name="second_from" onchange="change_timeframe(\'change_second_from\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_start, 'second_from', 's', $sv->time_form_start, $prev_time_form_start);
show_select_options($tmp_selected, 0, 59);
echo '
</select>
</td>
</tr>
</table>

</td>
<td style="text-align: right;">',$text_array[$sv->lang_id]['to'],'</td>
<td>

<table border="0" cellspacing="0" cellpadding="0" summary="Date-To Table">
<tr>
<td style="text-align: right;">
<select class="colored_input" name="day_to" onchange="change_timeframe(\'change_day_to\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_end, 'day_to', 'j', $sv->time_form_end, $prev_time_form_end);
show_select_options($tmp_selected, 1, 31);
echo '
</select>
</td><td>
<select class="colored_input" name="month_to" onchange="change_timeframe(\'change_month_to\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_end, 'month_to', 'n', $sv->time_form_end, $prev_time_form_end);
show_select_options($tmp_selected, 1, 12, 'month');
echo '
</select>
</td><td>
<select class="colored_input" name="year_to" onchange="change_timeframe(\'change_year_to\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_end, 'year_to', 'Y', $sv->time_form_end, $prev_time_form_end);
show_select_options($tmp_selected, 1990, 2099, 'year');
echo '
</select>
</td>
</tr>
</table>

</td><td>

<table border="0" cellspacing="0" cellpadding="0" summary="Time-To Table">
<tr>
<td style="text-align: right;">
<select class="colored_input" name="hour_to" onchange="change_timeframe(\'change_hour_to\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_end, 'hour_to', 'G', $sv->time_form_end, $prev_time_form_end);
show_select_options($tmp_selected, 0, 23);
echo '
</select>
</td><td>
<select class="colored_input" name="minute_to" onchange="change_timeframe(\'change_minute_to\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_end, 'minute_to', 'i', $sv->time_form_end, $prev_time_form_end);
show_select_options($tmp_selected, 0, 59);
echo '
</select>
</td><td>
<select class="colored_input" name="second_to" onchange="change_timeframe(\'change_second_to\')">';
$tmp_selected = get_tmp_selected($check_partial_time_form_end, 'second_to', 's', $sv->time_form_end, $prev_time_form_end);
show_select_options($tmp_selected, 0, 59);
echo '
</select>
</td>
</tr>
</table>';

$interval_array = get_interval_array($sv->time_form_int); 
// L TODO: Als Input nur numerische Werte zulassen
echo '
</td><td>
<button style="font-size: 11px;" name="bt_empty_timeform" type="button" onclick="empty_timeform()" 
    title="',$text_array[$sv->lang_id]['empty_timeform'],'">&nbsp;X&nbsp;</button>
</td><td>
<input class="colored_input" style="text-align: right;" type="text" name="day_int" size="3" maxlength="5" value="'
    ,(isset($interval_array['days'])?$interval_array['days']:0),'" onblur="change_timespan(\'change_day_int\')" /></td>
<td>

<table border="0" cellspacing="0" cellpadding="0" summary="Interval-Hour/-Minute Table">
<tr>
<td>
<select class="colored_input" name="hour_int" onchange="change_timespan(\'change_hour_int\')">';
$tmp_selected = (isset($interval_array['hours'])?$interval_array['hours']:0);
for($i = 0; $i <= 23; $i++){
    echo '
    <option value="',$i,'"';
    if($i == $tmp_selected){
        echo ' selected';
    }
    echo '>',fill_zeros($i, 2),'</option>';
}
echo '
</select>
</td><td>
<select class="colored_input" name="minute_int" onchange="change_timespan(\'change_minute_int\')">';
$tmp_selected = (isset($interval_array['minutes'])?$interval_array['minutes']:0);
for($i = 0; $i <= 59; $i++){
    echo '
    <option value="',$i,'"';
    if($i == $tmp_selected){
        echo ' selected';
    }
    echo '>',fill_zeros($i, 2),'</option>';
}
echo '
</select>
</td><td>
<select class="colored_input" name="second_int" onchange="change_timespan(\'change_second_int\')">';
$tmp_selected = (isset($interval_array['seconds'])?$interval_array['seconds']:0);
for($i = 0; $i <= 59; $i++){
    echo '
    <option value="',$i,'"';
    if($i == $tmp_selected){
        echo ' selected';
    }
    echo '>',fill_zeros($i, 2),'</option>';
}
echo '
</select>
</td>
</tr>
</table>

</td>
</tr>
</table>';
/* }}} */
//echo '<br>$sv->time_form_start: ',$sv->time_form_start,' - ',localdate_std($sv->time_form_start);
//echo '<br>$sv->time_form_end: ',$sv->time_form_end,' - ',localdate_std($sv->time_form_end);
echo '
</form>
</div>
</body>';

include('cont_bottom.inc.php');

store_session($sv);

/* {{{ PHP-Funktion check_partial_time_form() - Prfen, ob per $_GET nur ein Teil eines Zeitpunkts bertragen wurde */
function check_partial_time_form($start_or_end){
    $retval = false;
    $time_form_array = array();
    $true_count = 0;
    $is_all_true = false;

    // Wenn ALLE numerisch sind oder ALLE NICHT numerisch sind, ist KEINE partielle Belegung vorhanden
    switch($start_or_end){
    case 'start':
        push_time_form_array_for_partial_check('hour_from', $time_form_array);
        push_time_form_array_for_partial_check('minute_from', $time_form_array);
        push_time_form_array_for_partial_check('second_from', $time_form_array);
        push_time_form_array_for_partial_check('month_from', $time_form_array);
        push_time_form_array_for_partial_check('day_from', $time_form_array);
        push_time_form_array_for_partial_check('year_from', $time_form_array);
        break;
    case 'end':
        push_time_form_array_for_partial_check('hour_to', $time_form_array);
        push_time_form_array_for_partial_check('minute_to', $time_form_array);
        push_time_form_array_for_partial_check('second_to', $time_form_array);
        push_time_form_array_for_partial_check('month_to', $time_form_array);
        push_time_form_array_for_partial_check('day_to', $time_form_array);
        push_time_form_array_for_partial_check('year_to', $time_form_array);
        break;
    }

    foreach($time_form_array as $value){
        if($value){
            $true_count++;
        }
    }

    if($true_count == count($time_form_array)){
        $is_all_true = true;
    }

    if($true_count && !$is_all_true){
        $retval = true;
    }
    //print_r_formatted($time_form_array);

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_time_int_from_get_submit() - Intervall in Sekunden aus $_GET generieren */
function get_time_int_from_get_submit(){
    $retval = null;

    if(is_numeric($_GET['day_int']) && is_numeric($_GET['hour_int']) 
        && is_numeric($_GET['minute_int']) && is_numeric($_GET['second_int'])){
        $retval = mkinterval((int) $_GET['day_int'], 
                             (int) $_GET['hour_int'], 
                             (int) $_GET['minute_int'], 
                             (int) $_GET['second_int']);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_time_from_get_submit() - Timestamp aus $_GET generieren */
function get_time_from_get_submit($from_or_to, $fill_by_now = false){
    $retval = null;
    $timestamp = time();

    if(is_numeric($_GET['hour_'.$from_or_to])){
        $hour = (int) $_GET['hour_'.$from_or_to];
    }
    else if($fill_by_now){
        $hour = (int) localdate('G', $timestamp);
    }
    if(is_numeric($_GET['minute_'.$from_or_to])){
        $minute = (int) $_GET['minute_'.$from_or_to];
    }
    else if($fill_by_now){
        $minute = (int) localdate('i', $timestamp);
    }
    if(is_numeric($_GET['second_'.$from_or_to])){
        $second = (int) $_GET['second_'.$from_or_to];
    }
    else if($fill_by_now){
        $second = (int) localdate('s', $timestamp);
    }
    if(is_numeric($_GET['month_'.$from_or_to])){
        $month = (int) $_GET['month_'.$from_or_to];
    }
    else if($fill_by_now){
        $month = (int) localdate('n', $timestamp);
    }
    if(is_numeric($_GET['day_'.$from_or_to])){
        $day = (int) $_GET['day_'.$from_or_to];
    }
    else if($fill_by_now){
        $day = (int) localdate('j', $timestamp);
    }
    if(is_numeric($_GET['year_'.$from_or_to])){
        $year = (int) $_GET['year_'.$from_or_to];
    }
    else if($fill_by_now){
        $year = (int) localdate('Y', $timestamp);
    }

    if(isset($hour) && isset($minute) && isset($second) && isset($month) && isset($day) && isset($year)){
        $retval = mktime($hour, $minute, $second, $month, $day, $year);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_tmp_selected() - Selected-Value fr Select-Option ermitteln */
// tmp_selected NICHT aus Timestamp ermitteln, wenn nur ein Teil der betreffenden time_form-GET-Komponenten belegt ist und der vorherige Timestamp leer ist
function get_tmp_selected($check_partial_time_form, $get_index, $date_param, $timestamp, $prev_time_form = null){
    $retval = null;

    // L TODO: Kann $check_partial_time_form und dessen Ermittlung inkl. push_time_form_array_for_partial_check() wegfallen?
    //if($check_partial_time_form && !isset($prev_time_form)){
    if(empty($timestamp) && !isset($prev_time_form)){
        $retval = get_tmp_selected_from_get_submit($get_index);
    }
    else{
        $retval = get_tmp_selected_from_timestamp($date_param, $timestamp);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_tmp_selected_from_get_submit() - Selected-Value fr Select-Option aus $_GET ermitteln */
function get_tmp_selected_from_get_submit($get_index){
    $retval = null;

    if(isset($_GET[$get_index]) && is_numeric($_GET[$get_index])){
        $retval = (int) $_GET[$get_index];
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion get_tmp_selected_from_timestamp() - Selected-Value fr Select-Option aus Timestamp ermitteln */
function get_tmp_selected_from_timestamp($date_param, $timestamp){
    $retval = null;

    if(isset($timestamp) && is_numeric($timestamp)){
        $retval = (int) localdate($date_param, $timestamp);
    }

    return $retval;
}
/* }}} */

/* {{{ PHP-Funktion push_time_form_array_for_partial_check() - Unterfunktion von check_partial_time_form() zum Belegen des $time_form_array */
function push_time_form_array_for_partial_check($get_index, &$time_form_array){
    $value = null;

    if(isset($_GET[$get_index])){
        $value = $_GET[$get_index];
    }
    //echo '<br>$value: ',$value;
    //echo '<br>is_numeric($value): ',is_numeric($value);

    if(is_numeric($value)){
        $time_form_array[$get_index] = true;
    }
    else{
        $time_form_array[$get_index] = false;
    }
}
/* }}} */

/* {{{ PHP-Funktion show_select_options() - Ausgabe der Select-Options */
function show_select_options($tmp_selected, $min_val, $max_val, $displayflag = ''){
    global $sv, $text_array;

    echo '
    <option value="null"';
    if(is_null($tmp_selected)){
        echo ' selected';
    }
    echo '>&nbsp;</option>';

    for($i = $min_val; $i <= $max_val; $i++){
        echo '
        <option value="',$i,'"';
        if($i === $tmp_selected){
            echo ' selected';
        }
        echo '>';
        switch($displayflag){
        case 'month':
            echo $text_array[$sv->lang_id]['month_array'][$i];
            break;
        case 'year':
            echo $i;
            break;
        default:
            echo fill_zeros($i, 2);
            break;
        }
        echo '</option>';
    }
}
/* }}} */

?>

